C Fichier prod_mat_c.f
c
C
c******************************************************************
      SUBROUTINE IAmul_c(ns,aa,ia,ja,x,b)
c******************************************************************
c
C Ce sous-programme calcule le produit de la matrice
C A, stockee sous forme Morse dans les tableaux 
C (aa,ia,ja), par le vecteur x; le resultat est dans le
C tableau b.
C Le calcul se fait d"abord en calculant la contribution
C associee a la partie triangulaire inferieure de la 
C matrice (qui est celle stockee dans le tableau aa),
C puis celle associee a la partie triangulaire superieure
C stricte.

      implicit none
      INTEGER ns,i,k,jak,ia,ja
      REAL*8  aa,x,xi,b,somme

      DIMENSION x(ns),b(ns)
      DIMENSION aa(*),ia(*),ja(*)

      DO  i=1,ns
        somme=0.d0
        DO  k=ia(i),ia(i+1)-1
          somme=somme+aa(k)*x(ja(k))
        enddo
        b(i)=somme
      enddo
      DO  i=1,ns
        xi=x(i)
        DO  k=ia(i),ia(i+1)-2
          jak=ja(k)
          b(jak)=b(jak)+aa(k)*xi
        enddo
      enddo

      RETURN
      END


