c  Fichier 2mb_hex_c.f
c
c**************************************************************
      real*8 function INTEGRPQ_C(nbr1,N1,N2,N3,N4,N5,N6,N7,N8)
c**************************************************************
c
c  Cette fonction calcule l'approximation de l'integrale de
c  (f*fonction de base) sur un hexaedre.
c  On utilise la formule p.??? du  livre 'PRESENTATION DE LA METHODE
c  DES ELEMENTS FINIS' (T.Touzot) 19??.
c
c  N1,N2,N3,N4,N5,N6,N7,N8: contient les numeros, ainsi que les 
c             coordonnees  des huit points qui constituent l' hexaedre.
c  nbr1: numero designant la nbr1ieme fonction de base de
c        l'hexaedre.

      implicit none

      integer   nbr1
      real*8    somme1,somme2,BASEC,N1,N2,N3,N4,N5,N6,N7,N8
      real*8    FONCT_C,det,a,b,p1,p2,x,y,z
      dimension BASEC(8)
      dimension N1(4),N2(4),N3(4),N4(4),N5(4),N6(4),N7(4),N8(4)

c points d'integration

      a=SQRT((19.d0/30.d0))
      b=SQRT((19.d0/33.d0))
      p1=(320.d0/361.d0)
      p2=(121.d0/361.d0)

c integration numerique

      call FBASEC_C(BASEC,det,N1,N2,N3,N4,N5,N6,N7,N8,-a,0.d0,0.d0,
     @              x,y,z)
      somme1=FONCT_C(x,y,z)*BASEC(nbr1)      
      call FBASEC_C(BASEC,det,N1,N2,N3,N4,N5,N6,N7,N8,+a,0.d0,0.d0,
     @              x,y,z)
      somme1=somme1+FONCT_C(x,y,z)*BASEC(nbr1)  
      call FBASEC_C(BASEC,det,N1,N2,N3,N4,N5,N6,N7,N8,0.d0,-a,0.d0,
     @              x,y,z) 
      somme1=somme1+FONCT_C(x,y,z)*BASEC(nbr1) 
      call FBASEC_C(BASEC,det,N1,N2,N3,N4,N5,N6,N7,N8,0.d0,+a,0.d0,
     @              x,y,z) 
      somme1=somme1+FONCT_C(x,y,z)*BASEC(nbr1)
      call FBASEC_C(BASEC,det,N1,N2,N3,N4,N5,N6,N7,N8,0.d0,0.d0,-a,
     @              x,y,z) 
      somme1=somme1+FONCT_C(x,y,z)*BASEC(nbr1)
      call FBASEC_C(BASEC,det,N1,N2,N3,N4,N5,N6,N7,N8,0.d0,0.d0,+a,
     @              x,y,z) 
      somme1=somme1+FONCT_C(x,y,z)*BASEC(nbr1) 
      somme1=somme1*ABS(det)*p1

      call FBASEC_C(BASEC,det,N1,N2,N3,N4,N5,N6,N7,N8,+b,+b,+b,x,y,z) 
      somme2=FONCT_C(x,y,z)*BASEC(nbr1)           
      call FBASEC_C(BASEC,det,N1,N2,N3,N4,N5,N6,N7,N8,-b,-b,-b,x,y,z) 
      somme2=somme2+FONCT_C(x,y,z)*BASEC(nbr1)   
      call FBASEC_C(BASEC,det,N1,N2,N3,N4,N5,N6,N7,N8,+b,-b,+b,x,y,z) 
      somme2=somme2+FONCT_C(x,y,z)*BASEC(nbr1)  
      call FBASEC_C(BASEC,det,N1,N2,N3,N4,N5,N6,N7,N8,+b,-b,-b,x,y,z) 
      somme2=somme2+FONCT_C(x,y,z)*BASEC(nbr1)   
      call FBASEC_C(BASEC,det,N1,N2,N3,N4,N5,N6,N7,N8,-b,+b,+b,x,y,z) 
      somme2=somme2+FONCT_C(x,y,z)*BASEC(nbr1)  
      call FBASEC_C(BASEC,det,N1,N2,N3,N4,N5,N6,N7,N8,-b,+b,-b,x,y,z) 
      somme2=somme2+FONCT_C(x,y,z)*BASEC(nbr1)   
      call FBASEC_C(BASEC,det,N1,N2,N3,N4,N5,N6,N7,N8,-b,-b,+b,x,y,z) 
      somme2=somme2+FONCT_C(x,y,z)*BASEC(nbr1)   
      call FBASEC_C(BASEC,det,N1,N2,N3,N4,N5,N6,N7,N8,+b,+b,-b,x,y,z) 
      somme2=somme2+FONCT_C(x,y,z)*BASEC(nbr1)  
      somme2=somme2*ABS(det)*p2

      INTEGRPQ_C=somme1+somme2     

      RETURN
      end


