c  Fichier grad_hex_tot_c.f
c
c********************************************************************
      subroutine  GRAD_TOTAL_C(GRAD1,GRAD2,GRAD3,GRAD4,GRAD5,
     @                 GRAD6,GRAD7,GRAD8,GRAD9,GRAD10,GRAD11,GRAD12,
     @                 GRAD13,GRAD14,det1,det2,det3,det4,det5,det6,
     @                 det7,det8,det9,det10,det11,det12,det13,det14,
     @                 N1,N2,N3,N4,N5,N6,N7,N8)
c********************************************************************
c
c   Cette fonction calcule les gradiants ppur les huit points
c   det: jacobien de la transformation: cube de reference --> hexaedre

      implicit none

      real*8    N1,N2,N3,N4,N5,N6,N7,N8
      real*8    GRAD1,GRAD2,GRAD3,GRAD4,GRAD5,GRAD6,GRAD7,GRAD8
      real*8    GRAD9,GRAD10,GRAD11,GRAD12,GRAD13,GRAD14
      real*8    a,b,det1,det2,det3,det4,det5,det6,det7,det8
      real*8    det9,det10,det11,det12,det13,det14
c      integer   iii
      dimension GRAD1(8,*),GRAD2(8,*),GRAD3(8,*),GRAD4(8,*)
      dimension GRAD5(8,*),GRAD6(8,*),GRAD7(8,*),GRAD8(8,*)
      dimension GRAD9(8,*),GRAD10(8,*)
      dimension GRAD11(8,*),GRAD12(8,*),GRAD13(8,*),GRAD14(8,*)
      dimension N1(*),N2(*),N3(*),N4(*),N5(*),N6(*),N7(*),N8(*)

c points d'integration

      a=SQRT((19.d0/30.d0))
      b=SQRT((19.d0/33.d0))

c integration numerique
      
      call GRADIANT_C(GRAD1,det1,N1,N2,N3,N4,N5,N6,N7,N8,-a,0.d0,0.d0) 
      call GRADIANT_C(GRAD2,det2,N1,N2,N3,N4,N5,N6,N7,N8,+a,0.d0,0.d0) 
      call GRADIANT_C(GRAD3,det3,N1,N2,N3,N4,N5,N6,N7,N8,0.d0,-a,0.d0) 
      call GRADIANT_C(GRAD4,det4,N1,N2,N3,N4,N5,N6,N7,N8,0.d0,+a,0.d0) 
      call GRADIANT_C(GRAD5,det5,N1,N2,N3,N4,N5,N6,N7,N8,0.d0,0.d0,-a) 
      call GRADIANT_C(GRAD6,det6,N1,N2,N3,N4,N5,N6,N7,N8,0.d0,0.d0,+a) 

      call GRADIANT_C(GRAD7,det7,N1,N2,N3,N4,N5,N6,N7,N8,+b,+b,+b) 
      call GRADIANT_C(GRAD8,det8,N1,N2,N3,N4,N5,N6,N7,N8,-b,-b,-b) 
      call GRADIANT_C(GRAD9,det9,N1,N2,N3,N4,N5,N6,N7,N8,+b,-b,+b) 
      call GRADIANT_C(GRAD10,det10,N1,N2,N3,N4,N5,N6,N7,N8,+b,-b,-b) 
      call GRADIANT_C(GRAD11,det11,N1,N2,N3,N4,N5,N6,N7,N8,-b,+b,+b) 
      call GRADIANT_C(GRAD12,det12,N1,N2,N3,N4,N5,N6,N7,N8,-b,+b,-b) 
      call GRADIANT_C(GRAD13,det13,N1,N2,N3,N4,N5,N6,N7,N8,-b,-b,+b) 
      call GRADIANT_C(GRAD14,det14,N1,N2,N3,N4,N5,N6,N7,N8,+b,+b,-b) 
      
      RETURN
      end


