      program main
c
c all values store in a two dimensional array - note that this does not work
c for three dimensional maps
c
      real a(40,40,9)
c
c values of the tensor stored in separate arrays - the values are ordered
c lexicographically in the coordinates
      real kxx(1600),kxy(1600),kxz(1600)
      real kyx(1600),kyy(1600),kyz(1600)
      real kzx(1600),kzy(1600),kzz(1600)
c
c values of the tensor stored in an array that is ordered lexicographically in
c the spatial part of things and then the second index keeps track o the entry
c in the tensor 
c
      real tns(1600,9)
c
      real zeros(1600) 
      real ones(1600) 
      do 1 i=1,1600
        zeros(i) = 0.0
        ones(i) = 1.0
    1 continue
  
c
c set up the dimensions for the first examples
c
      nx = 30
      ny = 30
      nz = 1
      nnp = nx * ny * nz
c
c isotropic tensor example
c
c note: the following loops show the relationship between methods of storing
c the array values. the two dimensional and one dimensional examples are shown
c and used to output the data.
c
      do 2 j=1,ny
         j2 = ( j - 1 ) * nx
      do 2 i=1,nx
         ind = i + j2
c
         a(i,j,1) = ran3(ind)
         kxx(ind) = a(i,j,1)
         tns(ind,1) = a(i,j,1)
         a(i,j,2) = 0.0
         kxy(ind) = a(i,j,2)
         tns(ind,2) = a(i,j,2)
         a(i,j,3) = 0.0
         kxz(ind) = a(i,j,3)
         tns(ind,3) = a(i,j,3)
c
         a(i,j,4) = 0.0
         kyx(ind) = a(i,j,4)
         tns(ind,4) = a(i,j,4)
         a(i,j,5) = a(i,j,1)
         kyy(ind) = a(i,j,5)
         tns(ind,5) = a(i,j,5)
         a(i,j,6) = 0.0
         kyz(ind) = a(i,j,6)
         tns(ind,6) = a(i,j,6)
c
         a(i,j,7) = 0.0
         kzx(ind) = a(i,j,7)
         tns(ind,7) = a(i,j,7)
         a(i,j,8) = 0.0
         kzy(ind) = a(i,j,8)
         tns(ind,8) = a(i,j,8)
         a(i,j,9) = a(i,j,1)
         kzz(ind) = a(i,j,9)
         tns(ind,9) = a(i,j,9)
c
    2 continue
c
c output the isotropic tensor
c
c this is the correct format for the map file
c
      open(unit=11,file='isotropic30.map')
      write(11,*) nx
      write(11,*) ny
      write(11,*) nz
      write(11,10) (kxx(i),i=1,nnp)
      write(11,10) (zeros(i),i=1,nnp)
      write(11,10) (zeros(i),i=1,nnp)
      write(11,10) (zeros(i),i=1,nnp)
      write(11,10) (kyy(i),i=1,nnp)
      write(11,10) (zeros(i),i=1,nnp)
      write(11,10) (zeros(i),i=1,nnp)
      write(11,10) (zeros(i),i=1,nnp)
      write(11,10) (kzz(i),i=1,nnp)
      close(unit=11)
c
c the next is the format that lists the tensor values one value on each line
c using a lexicographical ordering
c
      open(unit=11,file='isotropic30.dat1')
      write(11,*) nx
      write(11,*) ny
      write(11,*) nz
      do 3 i=1,nnp
         write(11,*) (tns(i,l),l=1,9)
    3 continue
      close(unit=11)
c
c formats
c
   10 format(5(e14.8,2x))
      stop
      end
      function ran3(idum)
      parameter (mbig=1000000000,mseed=161803398,mz=0,fac=1.e-9)
      dimension ma(55)
      data iff /0/
c
      if(idum.lt.0.or.iff.eq.0)then
        iff=1
        mj=mseed-iabs(idum)
        mj=mod(mj,mbig)
        ma(55)=mj
        mk=1
c
        do 11 i=1,54
          ii=mod(21*i,55)
          ma(ii)=mk
          mk=mj-mk
          if(mk.lt.mz)mk=mk+mbig
          mj=ma(ii)
11      continue
c
        do 13 k=1,4
          do 12 i=1,55
            ma(i)=ma(i)-ma(1+mod(i+30,55))
            if(ma(i).lt.mz)ma(i)=ma(i)+mbig
12        continue
13      continue
c
        inext=0
        inextp=31
        idum=1
c
      endif
c
      inext=inext+1
      if(inext.eq.56)inext=1
c
      inextp=inextp+1
      if(inextp.eq.56)inextp=1
c
      mj=ma(inext)-ma(inextp)
      if(mj.lt.mz)mj=mj+mbig
c
      ma(inext)=mj
      ran3=mj*fac
c
      return
      end
