import java.awt.*;
import java.awt.event.*;

public class MapNameInputDialog extends PositionalDialog implements
 ActionListener {

  public MapNameInputDialog(Frame parent) {

    // set up the dialog box
    super(parent, "Map Name Input Dialog", true, WIDTH, HEIGHT);
    setBackground(color);
    state = UNSELECTED;

    setLayout(new BorderLayout());

    Panel p1 = new Panel();
    p1.setLayout(new GridLayout(0,1));

    p1.add(new Label("Map Name"));
    p1.add(mapNameTextField);
      mapNameTextField.setBackground(Color.white);
      mapNameTextField.setForeground(Color.black);
      mapNameTextField.addActionListener(this);

    Panel p2 = new Panel();
    p2.setLayout(new GridLayout(1,0));
      okay = new Button("Okay");
      okay.addActionListener(this);
      cancel = new Button("Cancel");
      cancel.addActionListener(this);
    p2.add(okay);
    p2.add(cancel);

    add("Center", p1);
    add("South", p2);

    setSize(WIDTH, HEIGHT);

    requestFocus();

  }

  public boolean getState () {
    if (state == OK_RESPONSE) return true;
    else return false;
  }

  public String getMapName() {
    return mapName;
  }

  public void setData() {
    mapName = mapNameTextField.getText();
  }

  public void actionPerformed (ActionEvent event) {
    Object source = event.getSource();
    if (source == okay) {
      state = OK_RESPONSE;
      setData();
      setVisible(false);
    } else if (source == cancel) {
      state = CANCEL_RESPONSE;
      setVisible(false);
    }
    if(source.equals(mapNameTextField)) {
      state = OK_RESPONSE;
      setData();
      setVisible(false);
    }
  }

  public static void main(String args[]) {
    Frame f = new Frame("MapNameInput Object Test Frame");
    f.setSize(500,500);
    MapNameInputDialog sfv = new MapNameInputDialog(f);
    sfv.pack();
    sfv.show();
    // get the data from the object upon return
    System.out.println("State: " + sfv.getState()); 
    System.out.println("Map Name: " + sfv.getMapName()); 
    sfv.dispose();
    System.exit(0);
  }

  // local variables

  // variables used to store user input
  private String mapName;

  // selection defaults
  private final int UNSELECTED = -1;
  private final int OK_RESPONSE = 1;
  private final int CANCEL_RESPONSE = 0;

  private static final int WIDTH = 300;
  private static final int HEIGHT = 115;

  private Color color = new Color(96, 128, 255);
  private TextField mapNameTextField = new TextField(2);

  // stuff for ending the function of the object
  private Button           okay, cancel;
  private int              state;

}
