import java.awt.*;
import java.awt.event.*;

public class MapSaveInputDialog extends PositionalDialog implements
 ActionListener {

  public MapSaveInputDialog(Frame parent, String name) {

    // set up the dialog box
    super(parent, "Map Save Dialog", true, WIDTH, HEIGHT);
    setBackground(color);
    state = UNSELECTED;

    setLayout(new BorderLayout());

    Panel p1 = new Panel();
    p1.setLayout(new GridLayout(1,0));

    p1.add(new Label("Map Name: "));
    p1.add(new Label(name));

    Panel p2 = new Panel();
    p2.setLayout(new GridLayout(1,0));
      saveOne = new Button("Save");
      saveOne.addActionListener(this);
      saveAll = new Button("Save All");
      saveAll.addActionListener(this);
      cancel = new Button("Cancel");
      cancel.addActionListener(this);
      saveNo = new Button("Don't Save");
      saveNo.addActionListener(this);
    p2.add(saveOne);
    p2.add(saveAll);
    p2.add(cancel);
    p2.add(saveNo);

    add("Center", p1);
    add("South", p2);

    setSize(WIDTH, HEIGHT);

  }

  public boolean saveAll() {
    if(state == SAVE_ALL_RESPONSE) return true;
    return false;
  }

  public boolean getExitState() {
    if(state == CANCEL_RESPONSE) return false;
    return true;
  }

  public boolean getState() {
    if(state == SAVE_ONE_RESPONSE) return true;
    if(state == SAVE_ALL_RESPONSE) return true;
    return false;
  }

  public void actionPerformed (ActionEvent event) {
    Object source = event.getSource();
    if (source == saveOne) {
      state = SAVE_ONE_RESPONSE;
      setVisible(false);
    } else if (source == saveAll) {
      state = SAVE_ALL_RESPONSE;
      setVisible(false);
    } else if (source == saveNo) {
      state = SAVE_NOT_RESPONSE;
      setVisible(false);
    } else {
      state = CANCEL_RESPONSE;
      setVisible(false);
    }
  }

  public static void main(String args[]) {
    Frame f = new Frame("MapSaveInput Object Test Frame");
    f.setSize(500,500);
    MapSaveInputDialog sfv = new MapSaveInputDialog(f, "filename");
    sfv.pack();
    sfv.show();
    // get the data from the object upon return
    System.out.println("State:    " + sfv.getState()); 
    System.out.println("Save All: " + sfv.saveAll()); 
    sfv.dispose();
    System.exit(0);
  }

  // local variables

  // selection defaults
  private final int UNSELECTED = -1;
  private final int SAVE_NOT_RESPONSE = 0;
  private final int SAVE_ONE_RESPONSE = 1;
  private final int SAVE_ALL_RESPONSE = 2;
  private final int CANCEL_RESPONSE = 3;

  private static final int WIDTH = 350;
  private static final int HEIGHT = 115;

  private Color color = new Color(96, 128, 255);
  private TextField mapNameTextField = new TextField(2);

  // stuff for ending the function of the object
  private Button saveOne;
  private Button saveAll;
  private Button cancel;
  private Button saveNo;
  private int state;

}
