c
c this common block contains the information about the bedform parameters
c
c parameters
c
c   nsed - the number of entries in xsed an the following two arrays, yb and
c          yt
c   nb the number of values that will be used to define the bottom of the
c      formation
c   xb - the coordinates of the values of the bottom of the formation
c   yb - the array of values that define the bottom of the formation at the
c        locations in xsed
c   nt the number of values that will be used to define the bottom of the
c      formation
c   xt - the coordinates of the values of the bottom of the formation
c   yt - the array of values that define the top of the formation at the
c        locations in xsed
c   nsed - the total number of values in the composite of the top and bottom
c          definition of the formation
c   xsed - grid used to define the points where the bedform coordinates are
c          defined
c   nbed - the number of bed forms including the top and bottom of the formation
c   ybed - the final set of bedforms computed by the routine
c   depspmin - minimum spacing between bedforms
c   depspmax - maximum spacing between bedforms
c   deplenmin - the minimum extent of a bedform - this defines the
c            distance in x where the majority of the change in the form occurs
c   deplenmax - the maximum extent of a bedform - this defines the
c            distance in x where the majority of the change in the form occurs
c   thkmax - the maximum thickness allowed in the generation at the end of
c            the bedform
c   xlinmin - the minimum extent of the linear part of a bedform
c   xlinmax - the maximum extent of the linear part of a bedform
c   slpmax - the maximum magnitude iof the slope of the bedform at the top
c
      parameter(nodes=1000,nbedmax=50)
c
c the formation domain information
c --------------------------------
c
      common /beds/ nb,xb(5*nodes),yb(5*nodes),nt,xt(5*nodes)
     1,yt(5*nodes)
c
c the computed bedforms including the top and bottom of the formation
c -------------------------------------------------------------------
c
     1,nsed,xsed(5*nodes),nbed,ybed(5*nodes,0:nbedmax+2)
c
c the bedform information
c -----------------------
c
     1,deplenmin,deplenmax,thkmax,xlinmin,xlinmax,slpmax,ndpst
