c
c  this common block contains the flags for doing input and output in the
c pressure interface. the values are read in from a data set provided by
c the user.
c
c output flags
c ------------
c
c   these flags tell the code whether or not to write data for a given variable
c   in the simulation. if iflag is one of the flags defined below, then the
c   following rules are followed:
c
c     0. if iflag=-1, output is done only for the initial condition
c     1. if iflag=0, no output is done
c     2. if iflag=1, output is done each time this routine is called
c     3. if iflag=n, output is done each nth time this routine is called
c
c   ioprstp - print out the total pressure variable
c   ioprspp - print out the phase pressures variable
c   ioprstv - print out the total velocity variable
c   ioprspv - print out the phase velocity variable
c   ioprstvcc - print out the cell centered total velocity variable
c   ioprspvcc - print out the cell centered phase velocity variable
c   ioprss - print out the saturation variables
c   ioprsprd - print out the saturation variables
c
      common /ioprs/ ioprstp,ioprspp,ioprstv,ioprspv,ioprstvcc
     1,ioprspvcc,ioprss,ioprsprd
c
c variables that control the number of steps between output
c
c   nprstpsperio - the number of steps between outputs
c
     1,nprstpsperio
      data nprsout / 50 /
