c
c numerical scheme common block
c
c   this common block contains the definition of the numerical scheme to be
c used on the problem to be solved.
c
c   igr - numerical gridding flag
c         igr=1; use the initial data set with uniform grid in all coordinate
c                directions
c         igr=2; read the nodal locations and place grid lines half way between
c         igr=3; read the grid line locations and place the nodes half way
c                between
c   igref - flag to tell the simulator whether to refine the grid to the
c           permeability or porosity grid or to average these parameters on the
c           computational grid
c           igref = 1; average the values on the computational grid
c           igref = 2; refine the computational grid to match
c   iprsol - pressure solver flag
c            iprsol=-2; solve via 9 point finite difference method
c            iprsol=-1; solve via 5 point finite difference method
c            iprsol=1; solve via lowest order mixed finite element method
c            iprsol=2; solve via lowest order mixed finite element method with
c                    cell refinement by a factor of 2
c            iprsol=3; solve via lowest order mixed finite element method with
c                    cell refinement by a factor of 3
c            iprsol=4; solve via next to lowest order mixed finite element
c   iprstdy - steady state pressure flag
c             iprstdy=0; use input values
c             iprstdy=1; iterate the pressure to steeady state before simulation
c   nprstp - the number of time steps between pressure solves in the time
c            loop. this is a forced value by the user to save time.
c   cgeps - the error tolerance used in the conjugate gradient method
c   cgthrshl - the lower threshold on the error in the iteration - this triggers
c              the activation of the upper threshold which can be used for
c              breaking out of the conjugate gradient solvers. to avoid the
c              imposition of this stuff set the upper threshold to a very large
c              number
c   cgthrshu - the upper threshold on the error in the iteration - this can be
c              used to kill the iterative scheme if the residual norm has gotten
c              too large after being reduced below the lower threshold.
c   theta - implicit weighting in the pressure discretization
c   beta = 1.0 - theta
c   isatsol - saturation solver flag
c          isatsol=0; do not solve for saturations
c          isatsol=1; solve via explicit method with polynomial framework
c   nrich - size of richardson extrapolation table
c
      common /numerical/ igr,igref,iprsol,iprstdy,nprstp,isatsol
     1,                  cgeps,cgthrshl,cgthrshu,theta,beta,nrich
