c
c fluid property common block
c
c  this common block contains information on the fluid properties used in the
c simulator. the values are as follows:
c
c General comments about the data structure:
c
c  1. the data in this is sort of a global data set keeping track of fluid
c     properties independent of the saturation, pressure, and other variables
c     that need the fluid properties at possibly differing grid locations
c
c   ivsctyp - array containing the type of viscosity evaluation to perform
c   irltyp - the type of evaluation to use for the relative permeability
c            functional evaluation
c            irltyp(l)=0; use data input in data sets
c            irltyp(l)>0; use an analytic evaluation in the routine anarprm
c   nrelpts - array containing the number of relative permeability data points
c             for all the phases
c   relsdat - array containing the saturation data where the relative
c             permebailities are given for the phases
c   relprm - array containing the relative permeability for all the phases
c   satirr - the irreducible saturation for the phases
c   idiffch - diffusion choice for the phase. there are several ways to add an
c             artifical or physical diffusion to the phase equation
c   diffcoe - the magnitude of the diffusion added in the choice idiffch
c   displ - coefficients of longitudinal dispersion
c   dispt2 - coefficients of first transverse dispersion
c   dispt3 - coefficients of second transverse dispersion
c   idspflg - flag to tell the code whether or not the dispersion term is to be
c             added. this is determined by rddat after reading in the dispersion
c             values
c             idspflg=0; no dispersion
c             idspflg=1; add in the rotationally invariant dispersion
c   gvrgm - ?

c
c parameter delcaration for the arrays here
c
c   nfldph - the number of fluid phases
c
      parameter(nfldph=20)
c
c number of phases along with some other integer parameters
c
c   nphase - number of phases in the simulation
c   nphm1 - number of phases minus 1
c
      common /fldprop/ nphase,nphm1
c
c density and viscosity variables for all possible phases
c
c   dens - array containing the reference density of the phases
c   visc - array containing the reference viscosity values for the phases.
c          this may be modified as in the case of miscible displacement
c
     1,dens(nfldph),visc(nfldph)
c
c relative permeability data
c
     1,ivsctyp(nfldph)
     1,irltyp(nrpts),nrelpts(nrpts),relsdat(nrpts,nfldph)
     1,relprm(nrpts,nfldph)
     1,satirr(nfldph)
     1,idiffch(nfldph),diffcoe(nfldph),displ(nfldph),dispt2(nfldph)
     1,dispt3(nfldph),idspflg,grvgm
