      PROGRAM prepro
C     ##############
      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'flags.h'
      INCLUDE 'gloGisementF.h'
      INCLUDE 'gloTableauxF.h'

      REAL SG(DIMTABG),PCTG(DIMTABG)
      REAL phiG(NUMMG)
      REAL  Acorr,Bcorr,seuil

      INTEGER entreG(NUMTABG+1),IndxG(NUMMG)
      INTEGER io,i,j,k,l,ii,IndxFG(NUMMF),FtoG,ordF

      CHARACTER*128 title,str
      CHARACTER*128 outIndxG,outEntreG,outPcG,outPhiG
C      CHARACTER*128 outIndxFG,outDims,outSirrG
      CHARACTER*3 countCh, int2ch
      CHARACTER*32 intFich

C  --------------------
      INTEGER CallCont
      COMMON /notImpotrant/ CallCont
 
      CallCont=0 ! compteur de nombre d'appel de la routine 
                 ! ecriHOMOG (pour affichage des WARNINGS.)
C  --------------------

C >>> Reading of command line params and setting some vars

      CALL Init()

C >>> Lecture du fichier d'entre.

      CALL EntreDon(title, Acorr,Bcorr,seuil)
      
C >>>  This call is setting the following variables:
C >>>        title, dims,  longfx, longfy, longfz,  diml=dims
C >>>        DimF, npp, ngros, agregx, agregy, agregz, complet,  
C >>>        pcflag, nomSim
C >>>  and the following file names:
C >>>         DirTmp, inphi, swof, satnm, basew, baseo 



C >>> Make folders for permeability (maps in Joe's format)
C >>> for the files containing K krw(S) and K kro(S) and 
C >>> also temporary folder. 
 
      CALL MakeTmpFolders()

C >>> Temporary files that the two programmes share

      ii=index(DirTmp,' ')-1
      outEntreG=DirTmp(1:ii)//'EntreG '
      outIndxG =DirTmp(1:ii)//'IndxG  '
      outPhiG  =DirTmp(1:ii)//'PhiG   '
      outPcG   =DirTmp(1:ii)//'PcG    '

C  >>> Reading permeabilities and porosity.
 
      CALL lirePermF(title)     ! this fills permX, permY, permZ
      CALL lirePA(phi,inphi)    ! read porosity.

C >>> This is an leftover of some formerly existing possibility.  

         DO k=1,diml(3)
         DO j=1,diml(2)
         DO i=1,diml(1)
           l=ordF(i,j,k)
           dz(l)=longfz(k)
         END DO
         END DO
         END DO

C >>> Calculate homogenized  phi (phiG) (this is just arithmetic mean)

      CALL phiHom(phiG,phi)
      CALL ecrireR(outPhiG,DimG,phiG,title)

C >>> Lecture de tableaux des fonctions sur le maillage fin.

      CALL lireTabl()

C >>> Calcul principale:
C     Ici on calcule les fonctions de la pression capillaire 
C     homogeneisees, et prepare les donnees pour HOMOG 

      CALL satDistr(SG,PCTG,entreG,IndxG,phiG)

C >>> Ecriture de pressions capillaires homogeneisees

      CALL ecrireI(outEntreG,DimG+1,entreG,title)
      CALL ecrireI(outIndxG,DimG,IndxG,title)
      CALL ecrirePcG(entreG,SG,PCTG,title,outPcG,phiG)

C >>> We don't need this if don't want to write homogenized satnum on 
C >>> fine grid.
C >>> Ecriture de IndxG distribue sur le maillage fin.
C
C     DO i=1,DimF
C       j=FtoG(i)
C       IndxFG(i)=IndxG(j)
C     END DO
C     CALL ecrireI(outIndxFG,DimF,IndxFG,title)

      PRINT *,'Done (prepro).'
      STOP
      END
