*** fichier  homogab2_disp.f
c\begin{verbatim}

      subroutine homogab2_disp(nv,nm,v1,v2,kvf1,kvf2,dx,dxy,dyx,dy,x,
     *y,xx,yy,nxh,nyh,nxhf,nyhf,nxhr,nyhr,zcx,zcxy,zcyx,zcy,zx,zy,iopt)
      
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c crit par : joe koebbe 
c et modifie par : benedicte VIDAL
c
c   Cette procedure permet de calculer pour un MILIEU POREUX FRACTURE 
c le tenseur homogeneise.
c
c Le tenseur contenant les diffusions est de la forme :
c
c                 [  dx    dxy  ]
c             D = [             ]
c                 [  dyx    dy  ]
c
c  Le tenseur homogeneise est donne en sortie sous la forme de la matrice D**
c                          **   [  zcx    zcxy  ] 
c                         D  = [               ]
c                              [  zcyx   zcy   ]
c
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      
      implicit none

c     declaration des variables
c-------------------------------
      integer nxh,nyh,nxhf,nyhf,nxhr,nyhr,iopt,ntot,nv,nm
      integer n1,n2,n1r,n2r
      real xvalm,xvalp,yvalm,yvalp,supval
      real dx(*),dxy(*),dyx(*),dy(*),v1(*),v2(*)   
      real x(*),y(*),xx(*),yy(*)
      real zcx,zcxy,zcyx,zcy
******************
      real zcx1,zcxy1,zcyx1,zcy1
**************************
      real rcx,rcxy,rcyx,rcy
      real zx,zy
      real cgeps,eps,constant,rv1,rv2
      real sum,cellsize,term1,term2,term3,term4
      real termm1,termm2,termm3,termm4
      real delx,dely,del
      integer n1f,n2f,nvalfx,nvalfy,ntotf,ntotv,nvar,nmat,nvarf
      integer nvalx,nvaly
      integer nfxr,nfyr,nmorse
      integer kmax,i,j2,j,ind1,ind2,ind3,ind4,indx,indy,indif

*     variables pour le stockage morse  
*     vecteur pour la matrice morse
      integer mia(nv),mja(nm)                     
      real maa(nm)
      real hrhs(nv,2),hx(nv,2)
      integer first,place,bool

*     variables vitesse et moyenne
      real v01,v02
      real kvf1,kvf2
   
*     variables pour les fonctions tests
*  peij et peik pour le peclet sur cotes ij et ik resp (cotes ind1-ind2, ind1-ind3)
*   prodscij et prodscik pour v.n sur cotes ij et ik resp   
      real pe12,pe34,pe13,pe24
      real alpha12,alpha34,alpha13,alpha24
      real prodsc12,prodsc34,prodsc13,prodsc24

*     constantes pour l approximation des integrales
      real x1,x2,y1,y2
      real a,b,ab,b2,a2,det
*     fonctions
      real ft1_1,ft2_1,ft3_1,ft4_1
      real ft1_2,ft2_2,ft3_2,ft4_2
      real ft1_3,ft2_3,ft3_3,ft4_3
      real ft1_4,ft2_4,ft3_4,ft4_4
      real fb1_1,fb2_1,fb3_1,fb4_1
      real fb1_2,fb2_2,fb3_2,fb4_2
      real fb1_3,fb2_3,fb3_3,fb4_3
      real fb1_4,fb2_4,fb3_4,fb4_4
      real dfb1dx_1,dfb2dx_1,dfb3dx_1,dfb4dx_1,dft1dx_1,
     *     dft2dx_1,dft3dx_1,dft4dx_1
      real dfb1dx_2,dfb2dx_2,dfb3dx_2,dfb4dx_2,dft1dx_2,
     *     dft2dx_2,dft3dx_2,dft4dx_2
      real dfb1dx_3,dfb2dx_3,dfb3dx_3,dfb4dx_3,dft1dx_3,
     *     dft2dx_3,dft3dx_3,dft4dx_3
      real dfb1dx_4,dfb2dx_4,dfb3dx_4,dfb4dx_4,dft1dx_4,
     *     dft2dx_4,dft3dx_4,dft4dx_4
      real dfb1dy_1,dfb2dy_1,dfb3dy_1,dfb4dy_1,dft1dy_1,
     *     dft2dy_1,dft3dy_1,dft4dy_1
      real dfb1dy_2,dfb2dy_2,dfb3dy_2,dfb4dy_2,dft1dy_2,
     *     dft2dy_2,dft3dy_2,dft4dy_2
      real dfb1dy_3,dfb2dy_3,dfb3dy_3,dfb4dy_3,dft1dy_3,
     *     dft2dy_3,dft3dy_3,dft4dy_3
      real dfb1dy_4,dfb2dy_4,dfb3dy_4,dfb4dy_4,dft1dy_4,
     *     dft2dy_4,dft3dy_4,dft4dy_4
*     approximation
      real apxb11,apxb12,apxb13,apxb14
      real apxb21_1,apxb21_2,apxb21_3,apxb21_4
      real apxb22_1,apxb22_2,apxb22_3,apxb22_4
      real apxd11,apxd12,apxd13,apxd14
      real apxd21_1,apxd21_2,apxd21_3,apxd21_4
      real apxd22_1,apxd22_2,apxd22_3,apxd22_4
      real apxm11_1,apxm11_2,apxm11_3,apxm11_4
      real apxm12_1,apxm12_2,apxm12_3,apxm12_4
      real apxm13_1,apxm13_2,apxm13_3,apxm13_4
      real apxm14_1,apxm14_2,apxm14_3,apxm14_4
      real apxm21_1,apxm21_2,apxm21_3,apxm21_4
      real apxm22_1,apxm22_2,apxm22_3,apxm22_4
      real apxm23_1,apxm23_2,apxm23_3,apxm23_4
      real apxm24_1,apxm24_2,apxm24_3,apxm24_4
      real apxa11_1,apxa11_2,apxa11_3,apxa11_4
      real apxa12_1,apxa12_2,apxa12_3,apxa12_4
      real apxa13_1,apxa13_2,apxa13_3,apxa13_4
      real apxa14_1,apxa14_2,apxa14_3,apxa14_4
      real apxa21_1,apxa21_2,apxa21_3,apxa21_4
      real apxa22_1,apxa22_2,apxa22_3,apxa22_4
      real apxa23_1,apxa23_2,apxa23_3,apxa23_4
      real apxa24_1,apxa24_2,apxa24_3,apxa24_4
      real apxa31_1,apxa31_2,apxa31_3,apxa31_4
      real apxa32_1,apxa32_2,apxa32_3,apxa32_4 
      real apxa33_1,apxa33_2,apxa33_3,apxa33_4
      real apxa34_1,apxa34_2,apxa34_3,apxa34_4 
      real apxa41_1,apxa41_2,apxa41_3,apxa41_4
      real apxa42_1,apxa42_2,apxa42_3,apxa42_4
      real apxa43_1,apxa43_2,apxa43_3,apxa43_4
      real apxa44_1,apxa44_2,apxa44_3,apxa44_4

*     pour appel des fonctions
      real ft1,ft2,ft3,ft4,fb1,fb2,fb3,fb4
      real dfb1dx,dfb2dx,dfb3dx,dfb4dx
      real dfb1dy,dfb2dy,dfb3dy,dfb4dy
      real dft1dx,dft2dx,dft3dx,dft4dx
      real dft1dy,dft2dy,dft3dy,dft4dy
      real approx


* pour gmres nkr = dimension de l espace de krylov
      integer nkr

*  frac booleen =0 si dans matrice et 1 si dans fracture      
      integer frac


      common /morse/ nmat,nmorse
      common/morse1/nvalx,nvaly,nvalfx,nvalfy
      common/morse2/ntot,ntotf,ntotv,nvar,nvarf
      common/morse3/nfxr,nfyr

      
c     
c     definition de parametres utilises dans la suite
c -----------------------------------------------------
c     
      data cgeps / 0.00000001/
      
c
c     definition du nombre d'iteration maximum
c ----------------------------------------------
c
      nkr = 2
      kmax = nmat+2
      
c     
c     si le nombre d'elements ou le raffinement selon un axe 
c     est nul le mettre a 1
c -----------------------------------------------------------
c     
      if(nxh .le. 0) nxh = 1
      if(nyh .le. 0) nyh = 1
      if(nxhr .le. 0) nxhr = 1
      if(nyhr .le. 0) nyhr = 1
c     
c     posons des variables pour la suite
c --------------------------------------
c     
      n1 = nxh
      n2 = nyh
      n1r = nxhr
      n2r = nyhr
      n1f = nxhf
      n2f = nyhf

c
c     calcul de la taille de la cellule de base 
c     pour une utilisation ulterieure
c -----------------------------------------------
c     
      if(nxh .eq. 1) then
         xvalm = 0.0
         xvalp = 1.0
      else
         xvalm = 1.5 * x(1) - 0.5 * x(2)
         xvalp = 1.5 * x(nxh) - 0.5 * x(nxh-1)
      end if
      if(nyh .eq. 1) then
         yvalm = 0.0
         yvalp = 1.0
      else
         yvalm = 1.5 * y(1) - 0.5 * y(2)
         yvalp = 1.5 * y(nyh) - 0.5 * y(nyh-1)
      end if
      cellsize = ( xvalp - xvalm ) * ( yvalp - yvalm )
      
c     
c     calcul des coordonnees du nouveau centre de la cellule
c -----------------------------------------------------------
c
      zx = 0.5 * ( xvalp + xvalm )
      zy = 0.5 * ( yvalp + yvalm )
      
c     
c     recherche du maximum dans les vecteurs
c -------------------------------------------
c
      supval = 0.0
      do 1 i=1,ntotv
         if(abs(dx(i)) .gt. supval)  supval = dx(i)
         if(abs(dxy(i)) .gt. supval) supval = dxy(i)
         if(abs(dyx(i)) .gt. supval) supval = dyx(i)
         if(abs(dy(i)) .gt. supval)  supval = dy(i)
    1 continue

c
c     verification des valeurs nulles sur la diagonale en entree
c ---------------------------------------------------------------
c
      constant = 0.000001 * supval
      do 2 i=1,ntotv
c     
c     somme en valeur absolue des entrees
c -------------------------------------------
c     
         sum = abs(dx(i))  + abs(dxy(i))
     1        + abs(dyx(i)) + abs(dy(i))
c     
c     verification de la somme
c --------------------------------
c
         if(sum .lt. constant) then
            dx(i) = constant
            dy(i) = constant
         end if
         
 2    continue
      
c
c     initialisation de la matrice et du second membre
c ----------------------------------------------------
c
      do 3 i=1,nmat
         hrhs(i,1) = 0.0
         hrhs(i,2) = 0.0
         maa(i)=0.0
         mja(i)=0
         mia(i)=0  
 3    continue
      
      do 31 i=nmat+1,nmorse
         maa(i)=0.0
         mja(i)=0
 31   continue
      mia(nmat+1)=nmorse+1
      
c
c     calcul du vecteur MIA pour ZONE 1
c---------------------------------------
c
      mia(1)=1
      do 32 i=2,nmat
         mia(i)=9+mia(i-1)
 32   continue
      
c
c     boucles sur les noeuds
c ---------------------------
c   
      do 4 j=1,nvaly
         j2 = ( j - 1 ) * nvalx
c
c     recherche de la seconde coordonnee dans la grille de permeabilite
c -------------------------------------------------------------------------
c
         indy = ( j + nyhr - 1 ) / nyhr
c
c     calcul de la taille d'un element selon y
c ------------------------------------------------
c
         if(nyh .eq. 1) then
            yvalm = 0.0
            yvalp = 1.0
         else
            if(indy .eq. 1) then
               yvalm = 1.5 * y(1) - 0.5 * y(2)
               yvalp = 0.5 * ( y(indy) + y(indy+1) )
            end if
            if(indy .gt. 1 .and. indy .lt. nyh) then
               yvalm = 0.5 * ( y(indy-1) + y(indy) )
               yvalp = 0.5 * ( y(indy) + y(indy+1) )
            end if
            if(indy .eq. nyh) then
               yvalm = 0.5 * ( y(indy-1) + y(indy) )
               yvalp = 1.5 * y(indy) - 0.5 * y(indy-1)
            end if
         end if
         dely = ( yvalp - yvalm ) / float(nyhr)
         
         do 4 i=1,nvalx
c
c     recherche de la premiere coordonnee dans la grille de permeabilite
c --------------------------------------------------------------------------
c     
            indx = ( i + nxhr - 1 ) / nxhr
c
c     calcul de la taille d'un element selon x
c ------------------------------------------------
c     
            if (nxh .eq. 1) then
               xvalm = 0.0
               xvalp = 1.0
            else
               if(indx .eq. 1) then
                  xvalm = 1.5 * x(1) - 0.5 * x(2)
                  xvalp = 0.5 * ( x(indx) + x(indx+1) )
               end if
               if(indx .gt. 1 .and. indx .lt. nxh) then
                  xvalm = 0.5 * ( x(indx-1) + x(indx) )
                  xvalp = 0.5 * ( x(indx) + x(indx+1) )
               end if
               if(indx .eq. nxh) then
                  xvalm = 0.5 * ( x(indx-1) + x(indx) )
                  xvalp = 1.5 * x(indx) - 0.5 * x(indx-1)
               end if
            end if
            delx = ( xvalp - xvalm ) / float(nxhr)

*     constantes
            a=delx/2
            b=dely/2
            ab=delx*dely/4
            a2=a*a
            b2=b*b
            det=1./ab
c     
c     attribution de la diffusion
c -------------------------------------
c
            indif = indx + ( indy - 1 ) * nxh
            rcx = dx(indif)
            rcxy = dxy(indif)
            rcyx = dyx(indif)
            rcy = dy(indif)
            v01=v1(indif)
            v02=v2(indif)

c
c     calcul de la contribution de la diagonale pour l'element
c
c     calcul des indices des 4 sommets de l'element 
c     en utilisant la propriete de la periodicite
c --------------------------------------------------------------
c

            ind1 = i + j2
            if(i .eq. nvalx) then
               ind2 = 1 + j2
            else
               ind2 = ind1 + 1
            end if
            if( j .eq. nvaly) then
               ind3 = i
            else
               ind3 = ind1 + nvalx
            end if
            if(j .eq. nvaly) then
               if(i .eq. nvalx) then
                  ind4 = 1
               else
                  ind4 = i + 1
               end if
            else
               ind4 = ind2 + nvalx
            end if
            
*     si dans la matrice 
            
            if (((j .ge. nfyr+1) .and. (j .le. nvaly-nfyr)) 
     *           .and. ((i .ge. nfxr+1) .and. (i .le. nvalx-nfxr))) then        
               frac=0
            else
               frac=1
            end if
*********************************************************************************************
**********************************************************************************
************************************************************************           
c
c     calcul des alphaij et ik pour les fonctions tests
c     
*     produits scalaires selon les abscisses
            prodsc12 = - v02
            prodsc34 =   v02
*     produits scalaires selon les ordonnees
            prodsc13 = - v01
            prodsc24 =   v01
            
            pe12=delx*(prodsc12/rcx)
            pe34=delx*(prodsc34/rcx)
            pe13=dely*(prodsc13/rcx)
            pe24=dely*(prodsc24/rcx)
            
            if (prodsc12 .eq. 0.0) then
               alpha12=0.0
            else
               alpha12=1./tanh(pe12/2)-2/pe12
               alpha12=sign(alpha12,-prodsc12)
            end if
            
            if (prodsc34 .eq. 0.0) then
               alpha34=0.0
            else
               alpha34=1./tanh(pe34/2)-2/pe34
               alpha34=sign(alpha34,-prodsc34)
            end if
            
            if (prodsc13 .eq. 0.0) then
               alpha13=0.0
            else
               alpha13=1./tanh(pe13/2)-2/pe13
               alpha13=sign(alpha13,-prodsc13)
            end if
            
            if (prodsc24 .eq. 0.0) then
               alpha24=0.0
            else
               alpha24=1./tanh(pe24/2)-2/pe24
               alpha24=sign(alpha24,-prodsc24)
            end if

*     points pour l approximation
            x1=-1./sqrt(3.)
            y1=-1./sqrt(3.)
            x2=1./sqrt(3.)
            y2=1./sqrt(3.)
            ft1_1=ft1(x1,y1,alpha12,alpha13)
            ft1_2=ft1(x1,y2,alpha12,alpha13)
            ft1_3=ft1(x2,y1,alpha12,alpha13)
            ft1_4=ft1(x2,y2,alpha12,alpha13)

            ft2_1=ft2(x1,y1,alpha12,alpha24)
            ft2_2=ft2(x1,y2,alpha12,alpha24)
            ft2_3=ft2(x2,y1,alpha12,alpha24)
            ft2_4=ft2(x2,y2,alpha12,alpha24)

            ft3_1=ft3(x1,y1,alpha34,alpha13)
            ft3_2=ft3(x1,y2,alpha34,alpha13)
            ft3_3=ft3(x2,y1,alpha34,alpha13)
            ft3_4=ft3(x2,y2,alpha34,alpha13)

            ft4_1=ft4(x1,y1,alpha34,alpha24)
            ft4_2=ft4(x1,y2,alpha34,alpha24)
            ft4_3=ft4(x2,y1,alpha34,alpha24)
            ft4_4=ft4(x2,y2,alpha34,alpha24)
            
            dfb1dx_1=dfb1dx(x1,y1)
            dfb1dx_2=dfb1dx(x1,y2)
            dfb1dx_3=dfb1dx(x2,y1)
            dfb1dx_4=dfb1dx(x2,y2)

            dfb2dx_1=dfb2dx(x1,y1)
            dfb2dx_2=dfb2dx(x1,y2)
            dfb2dx_3=dfb2dx(x2,y1)
            dfb2dx_4=dfb2dx(x2,y2)

            dfb3dx_1=dfb3dx(x1,y1)
            dfb3dx_2=dfb3dx(x1,y2)
            dfb3dx_3=dfb3dx(x2,y1)
            dfb3dx_4=dfb3dx(x2,y2)

            dfb4dx_1=dfb4dx(x1,y1)
            dfb4dx_2=dfb4dx(x1,y2)
            dfb4dx_3=dfb4dx(x2,y1)
            dfb4dx_4=dfb4dx(x2,y2)

            dfb1dy_1=dfb1dy(x1,y1)
            dfb1dy_2=dfb1dy(x1,y2)
            dfb1dy_3=dfb1dy(x2,y1)
            dfb1dy_4=dfb1dy(x2,y2)

            dfb2dy_1=dfb2dy(x1,y1)
            dfb2dy_2=dfb2dy(x1,y2)
            dfb2dy_3=dfb2dy(x2,y1)
            dfb2dy_4=dfb2dy(x2,y2)

            dfb3dy_1=dfb3dy(x1,y1)
            dfb3dy_2=dfb3dy(x1,y2)
            dfb3dy_3=dfb3dy(x2,y1)
            dfb3dy_4=dfb3dy(x2,y2)

            dfb4dy_1=dfb4dy(x1,y1)
            dfb4dy_2=dfb4dy(x1,y2)
            dfb4dy_3=dfb4dy(x2,y1)
            dfb4dy_4=dfb4dy(x2,y2)

            dft1dx_1=dft1dx(x1,y1,alpha12,alpha13)
            dft1dx_2=dft1dx(x1,y2,alpha12,alpha13)
            dft1dx_3=dft1dx(x2,y1,alpha12,alpha13)
            dft1dx_4=dft1dx(x2,y2,alpha12,alpha13)

            dft2dx_1=dft2dx(x1,y1,alpha12,alpha24)
            dft2dx_2=dft2dx(x1,y2,alpha12,alpha24)
            dft2dx_3=dft2dx(x2,y1,alpha12,alpha24)
            dft2dx_4=dft2dx(x2,y2,alpha12,alpha24)

            dft3dx_1=dft3dx(x1,y1,alpha34,alpha13)
            dft3dx_2=dft3dx(x1,y2,alpha34,alpha13)
            dft3dx_3=dft3dx(x2,y1,alpha34,alpha13)
            dft3dx_4=dft3dx(x2,y2,alpha34,alpha13)

            dft4dx_1=dft4dx(x1,y1,alpha34,alpha24)
            dft4dx_2=dft4dx(x1,y2,alpha34,alpha24)
            dft4dx_3=dft4dx(x2,y1,alpha34,alpha24)
            dft4dx_4=dft4dx(x2,y2,alpha34,alpha24)

            dft1dy_1=dft1dy(x1,y1,alpha12,alpha13)
            dft1dy_2=dft1dy(x1,y2,alpha12,alpha13)
            dft1dy_3=dft1dy(x2,y1,alpha12,alpha13)
            dft1dy_4=dft1dy(x2,y2,alpha12,alpha13)

            dft2dy_1=dft2dy(x1,y1,alpha12,alpha24)
            dft2dy_2=dft2dy(x1,y2,alpha12,alpha24)
            dft2dy_3=dft2dy(x2,y1,alpha12,alpha24)
            dft2dy_4=dft2dy(x2,y2,alpha12,alpha24)

            dft3dy_1=dft3dy(x1,y1,alpha34,alpha13)
            dft3dy_2=dft3dy(x1,y2,alpha34,alpha13)
            dft3dy_3=dft3dy(x2,y1,alpha34,alpha13)
            dft3dy_4=dft3dy(x2,y2,alpha34,alpha13)

            dft4dy_1=dft4dy(x1,y1,alpha34,alpha24)
            dft4dy_2=dft4dy(x1,y2,alpha34,alpha24)
            dft4dy_3=dft4dy(x2,y1,alpha34,alpha24)
            dft4dy_4=dft4dy(x2,y2,alpha34,alpha24)         

*     termes d approximation qui intervient dans b1
            apxb11=approx(ft1_1,ft1_2,ft1_3,ft1_4)
            apxb12=approx(ft2_1,ft2_2,ft2_3,ft2_4)
            apxb13=approx(ft3_1,ft3_2,ft3_3,ft3_4)
            apxb14=approx(ft4_1,ft4_2,ft4_3,ft4_4)

*     termes d approximation qui intervient dans b2
            apxb21_1=approx(dft1dx_1,dft1dx_2,dft1dx_3,dft1dx_4)
            apxb21_2=approx(dft2dx_1,dft2dx_2,dft2dx_3,dft2dx_4)
            apxb21_3=approx(dft3dx_1,dft3dx_2,dft3dx_3,dft3dx_4)
            apxb21_4=approx(dft4dx_1,dft4dx_2,dft4dx_3,dft4dx_4)
            apxb22_1=approx(dft1dy_1,dft1dy_2,dft1dy_3,dft1dy_4)
            apxb22_2=approx(dft2dy_1,dft2dy_2,dft2dy_3,dft2dy_4)
            apxb22_3=approx(dft3dy_1,dft3dy_2,dft3dy_3,dft3dy_4)
            apxb22_4=approx(dft4dy_1,dft4dy_2,dft4dy_3,dft4dy_4)

*     termes d approximation qui intervient dans M
            apxm11_1=approx(dfb1dx_1*ft1_1,dfb1dx_2*ft1_2,dfb1dx_3*ft1_3
     *           ,dfb1dx_4*ft1_4)
            apxm11_2=approx(dfb2dx_1*ft1_1,dfb2dx_2*ft1_2,dfb2dx_3*ft1_3
     *           ,dfb2dx_4*ft1_4)
            apxm11_3=approx(dfb3dx_1*ft1_1,dfb3dx_2*ft1_2,dfb3dx_3*ft1_3
     *           ,dfb3dx_4*ft1_4)
            apxm11_4=approx(dfb4dx_1*ft1_1,dfb4dx_2*ft1_2,dfb4dx_3*ft1_3
     *           ,dfb4dx_4*ft1_4)
            apxm12_1=approx(dfb1dx_1*ft2_1,dfb1dx_2*ft2_2,dfb1dx_3*ft2_3
     *           ,dfb1dx_4*ft2_4)
            apxm12_2=approx(dfb2dx_1*ft2_1,dfb2dx_2*ft2_2,dfb2dx_3*ft2_3
     *           ,dfb2dx_4*ft2_4)
            apxm12_3=approx(dfb3dx_1*ft2_1,dfb3dx_2*ft2_2,dfb3dx_3*ft2_3
     *           ,dfb3dx_4*ft2_4)
            apxm12_4=approx(dfb4dx_1*ft2_1,dfb4dx_2*ft2_2,dfb4dx_3*ft2_3
     *           ,dfb4dx_4*ft2_4)
            apxm13_1=approx(dfb1dx_1*ft3_1,dfb1dx_2*ft3_2,dfb1dx_3*ft3_3
     *           ,dfb1dx_4*ft3_4)
            apxm13_2=approx(dfb2dx_1*ft3_1,dfb2dx_2*ft3_2,dfb2dx_3*ft3_3
     *           ,dfb2dx_4*ft3_4)
            apxm13_3=approx(dfb3dx_1*ft3_1,dfb3dx_2*ft3_2,dfb3dx_3*ft3_3
     *           ,dfb3dx_4*ft3_4)
            apxm13_4=approx(dfb4dx_1*ft3_1,dfb4dx_2*ft3_2,dfb4dx_3*ft3_3
     *           ,dfb4dx_4*ft3_4)
            apxm14_1=approx(dfb1dx_1*ft4_1,dfb1dx_2*ft4_2,dfb1dx_3*ft4_3
     *           ,dfb1dx_4*ft4_4)
            apxm14_2=approx(dfb2dx_1*ft4_1,dfb2dx_2*ft4_2,dfb2dx_3*ft4_3
     *           ,dfb2dx_4*ft4_4)
            apxm14_3=approx(dfb3dx_1*ft4_1,dfb3dx_2*ft4_2,dfb3dx_3*ft4_3
     *           ,dfb3dx_4*ft4_4)
            apxm14_4=approx(dfb4dx_1*ft4_1,dfb4dx_2*ft4_2,dfb4dx_3*ft4_3
     *           ,dfb4dx_4*ft1_4)
********
            apxm21_1=approx(dfb1dy_1*ft1_1,dfb1dy_2*ft1_2,dfb1dy_3*ft1_3
     *           ,dfb1dy_4*ft1_4)
            apxm21_2=approx(dfb2dy_1*ft1_1,dfb2dy_2*ft1_2,dfb2dy_3*ft1_3
     *           ,dfb2dy_4*ft1_4)
            apxm21_3=approx(dfb3dy_1*ft1_1,dfb3dy_2*ft1_2,dfb3dy_3*ft1_3
     *           ,dfb3dy_4*ft1_4)
            apxm21_4=approx(dfb4dy_1*ft1_1,dfb4dy_2*ft1_2,dfb4dy_3*ft1_3
     *           ,dfb4dy_4*ft1_4)
            apxm22_1=approx(dfb1dy_1*ft2_1,dfb1dy_2*ft2_2,dfb1dy_3*ft2_3
     *           ,dfb1dy_4*ft2_4)
            apxm22_2=approx(dfb2dy_1*ft2_1,dfb2dy_2*ft2_2,dfb2dy_3*ft2_3
     *           ,dfb2dy_4*ft2_4)
            apxm22_3=approx(dfb3dy_1*ft2_1,dfb3dy_2*ft2_2,dfb3dy_3*ft2_3
     *           ,dfb3dy_4*ft2_4)
            apxm22_4=approx(dfb4dy_1*ft2_1,dfb4dy_2*ft2_2,dfb4dy_3*ft2_3
     *           ,dfb4dy_4*ft2_4)
            apxm23_1=approx(dfb1dy_1*ft3_1,dfb1dy_2*ft3_2,dfb1dy_3*ft3_3
     *           ,dfb1dy_4*ft3_4)
            apxm23_2=approx(dfb2dy_1*ft3_1,dfb2dy_2*ft3_2,dfb2dy_3*ft3_3
     *           ,dfb2dy_4*ft3_4)
            apxm23_3=approx(dfb3dy_1*ft3_1,dfb3dy_2*ft3_2,dfb3dy_3*ft3_3
     *           ,dfb3dy_4*ft3_4)
            apxm23_4=approx(dfb4dy_1*ft3_1,dfb4dy_2*ft3_2,dfb4dy_3*ft3_3
     *           ,dfb4dy_4*ft3_4)
            apxm24_1=approx(dfb1dy_1*ft4_1,dfb1dy_2*ft4_2,dfb1dy_3*ft4_3
     *           ,dfb1dy_4*ft4_4)
            apxm24_2=approx(dfb2dy_1*ft4_1,dfb2dy_2*ft4_2,dfb2dy_3*ft4_3
     *           ,dfb2dy_4*ft4_4)
            apxm24_3=approx(dfb3dy_1*ft4_1,dfb3dy_2*ft4_2,dfb3dy_3*ft4_3
     *           ,dfb3dy_4*ft4_4)
            apxm24_4=approx(dfb4dy_1*ft4_1,dfb4dy_2*ft4_2,dfb4dy_3*ft4_3
     *           ,dfb4dy_4*ft1_4)

*     termes d approximation qui intervient dans A
            apxa11_1=approx(dfb1dx_1*dft1dx_1,dfb1dx_2*dft1dx_2,dfb1dx_3
     *           *dft1dx_3,dfb1dx_4*dft1dx_4)
            apxa11_2=approx(dfb2dx_1*dft1dx_1,dfb2dx_2*dft1dx_2,dfb2dx_3
     *           *dft1dx_3,dfb2dx_4*dft1dx_4)
            apxa11_3=approx(dfb3dx_1*dft1dx_1,dfb3dx_2*dft1dx_2,dfb3dx_3
     *           *dft1dx_3,dfb3dx_4*dft1dx_4)
            apxa11_4=approx(dfb4dx_1*dft1dx_1,dfb4dx_2*dft1dx_2,dfb4dx_3
     *           *dft1dx_3,dfb4dx_4*dft1dx_4)
            apxa12_1=approx(dfb1dx_1*dft2dx_1,dfb1dx_2*dft2dx_2,dfb1dx_3
     *           *dft2dx_3,dfb1dx_4*dft2dx_4)
            apxa12_2=approx(dfb2dx_1*dft2dx_1,dfb2dx_2*dft2dx_2,dfb2dx_3
     *           *dft2dx_3,dfb2dx_4*dft2dx_4)
            apxa12_3=approx(dfb3dx_1*dft2dx_1,dfb3dx_2*dft2dx_2,dfb3dx_3
     *           *dft2dx_3,dfb3dx_4*dft2dx_4)
            apxa12_4=approx(dfb4dx_1*dft2dx_1,dfb4dx_2*dft2dx_2,dfb4dx_3
     *           *dft2dx_3,dfb4dx_4*dft2dx_4) 
            apxa13_1=approx(dfb1dx_1*dft3dx_1,dfb1dx_2*dft3dx_2,dfb1dx_3
     *           *dft3dx_3,dfb1dx_4*dft3dx_4)
            apxa13_2=approx(dfb2dx_1*dft3dx_1,dfb2dx_2*dft3dx_2,dfb2dx_3
     *           *dft3dx_3,dfb2dx_4*dft3dx_4)
            apxa13_3=approx(dfb3dx_1*dft3dx_1,dfb3dx_2*dft3dx_2,dfb3dx_3
     *           *dft3dx_3,dfb3dx_4*dft3dx_4)
            apxa13_4=approx(dfb4dx_1*dft3dx_1,dfb4dx_2*dft3dx_2,dfb4dx_3
     *           *dft3dx_3,dfb4dx_4*dft3dx_4) 
            apxa14_1=approx(dfb1dx_1*dft4dx_1,dfb1dx_2*dft4dx_2,dfb1dx_3
     *           *dft4dx_3,dfb1dx_4*dft4dx_4)
            apxa14_2=approx(dfb2dx_1*dft4dx_1,dfb2dx_2*dft4dx_2,dfb2dx_3
     *           *dft4dx_3,dfb2dx_4*dft4dx_4)
            apxa14_3=approx(dfb3dx_1*dft4dx_1,dfb3dx_2*dft4dx_2,dfb3dx_3
     *           *dft4dx_3,dfb3dx_4*dft4dx_4)
            apxa14_4=approx(dfb4dx_1*dft4dx_1,dfb4dx_2*dft4dx_2,dfb4dx_3
     *           *dft4dx_3,dfb4dx_4*dft4dx_4) 
*********
            apxa21_1=approx(dfb1dy_1*dft1dx_1,dfb1dy_2*dft1dx_2,dfb1dy_3
     *           *dft1dx_3,dfb1dy_4*dft1dx_4)
            apxa21_2=approx(dfb2dy_1*dft1dx_1,dfb2dy_2*dft1dx_2,dfb2dy_3
     *           *dft1dx_3,dfb2dy_4*dft1dx_4)
            apxa21_3=approx(dfb3dy_1*dft1dx_1,dfb3dy_2*dft1dx_2,dfb3dy_3
     *           *dft1dx_3,dfb3dy_4*dft1dx_4)
            apxa21_4=approx(dfb4dy_1*dft1dx_1,dfb4dy_2*dft1dx_2,dfb4dy_3
     *           *dft1dx_3,dfb4dy_4*dft1dx_4)
            apxa22_1=approx(dfb1dy_1*dft2dx_1,dfb1dy_2*dft2dx_2,dfb1dy_3
     *           *dft2dx_3,dfb1dy_4*dft2dx_4)
            apxa22_2=approx(dfb2dy_1*dft2dx_1,dfb2dy_2*dft2dx_2,dfb2dy_3
     *           *dft2dx_3,dfb2dy_4*dft2dx_4)
            apxa22_3=approx(dfb3dy_1*dft2dx_1,dfb3dy_2*dft2dx_2,dfb3dy_3
     *           *dft2dx_3,dfb3dy_4*dft2dx_4)
            apxa22_4=approx(dfb4dy_1*dft2dx_1,dfb4dy_2*dft2dx_2,dfb4dy_3
     *           *dft2dx_3,dfb4dy_4*dft2dx_4)
            apxa23_1=approx(dfb1dy_1*dft3dx_1,dfb1dy_2*dft3dx_2,dfb1dy_3
     *           *dft3dx_3,dfb1dy_4*dft3dx_4)
            apxa23_2=approx(dfb2dy_1*dft3dx_1,dfb2dy_2*dft3dx_2,dfb2dy_3
     *           *dft3dx_3,dfb2dy_4*dft3dx_4)
            apxa23_3=approx(dfb3dy_1*dft3dx_1,dfb3dy_2*dft3dx_2,dfb3dy_3
     *           *dft3dx_3,dfb3dy_4*dft3dx_4)
            apxa23_4=approx(dfb4dy_1*dft3dx_1,dfb4dy_2*dft3dx_2,dfb4dy_3
     *           *dft3dx_3,dfb4dy_4*dft3dx_4) 
            apxa24_1=approx(dfb1dy_1*dft4dx_1,dfb1dy_2*dft4dx_2,dfb1dy_3
     *           *dft4dx_3,dfb1dy_4*dft4dx_4)
            apxa24_2=approx(dfb2dy_1*dft4dx_1,dfb2dy_2*dft4dx_2,dfb2dy_3
     *           *dft4dx_3,dfb2dy_4*dft4dx_4)
            apxa24_3=approx(dfb3dy_1*dft4dx_1,dfb3dy_2*dft4dx_2,dfb3dy_3
     *           *dft4dx_3,dfb3dy_4*dft4dx_4)
            apxa24_4=approx(dfb4dy_1*dft4dx_1,dfb4dy_2*dft4dx_2,dfb4dy_3
     *           *dft4dx_3,dfb4dy_4*dft4dx_4) 
**********
            apxa31_1=approx(dfb1dx_1*dft1dy_1,dfb1dx_2*dft1dy_2,dfb1dx_3
     *           *dft1dy_3,dfb1dx_4*dft1dy_4)
            apxa31_2=approx(dfb2dx_1*dft1dy_1,dfb2dx_2*dft1dy_2,dfb2dx_3
     *           *dft1dy_3,dfb2dx_4*dft1dy_4)
            apxa31_3=approx(dfb3dx_1*dft1dy_1,dfb3dx_2*dft1dy_2,dfb3dx_3
     *           *dft1dy_3,dfb3dx_4*dft1dy_4)
            apxa31_4=approx(dfb4dx_1*dft1dy_1,dfb4dx_2*dft1dy_2,dfb4dx_3
     *           *dft1dy_3,dfb4dx_4*dft1dy_4)
            apxa32_1=approx(dfb1dx_1*dft2dy_1,dfb1dx_2*dft2dy_2,dfb1dx_3
     *           *dft2dy_3,dfb1dx_4*dft2dy_4)
            apxa32_2=approx(dfb2dx_1*dft2dy_1,dfb2dx_2*dft2dy_2,dfb2dx_3
     *           *dft2dy_3,dfb2dx_4*dft2dy_4)
            apxa32_3=approx(dfb3dx_1*dft2dy_1,dfb3dx_2*dft2dy_2,dfb3dx_3
     *           *dft2dy_3,dfb3dx_4*dft2dy_4)
            apxa32_4=approx(dfb4dx_1*dft2dy_1,dfb4dx_2*dft2dy_2,dfb4dx_3
     *           *dft2dy_3,dfb4dx_4*dft2dy_4) 
            apxa33_1=approx(dfb1dx_1*dft3dy_1,dfb1dx_2*dft3dy_2,dfb1dx_3
     *           *dft3dy_3,dfb1dx_4*dft3dy_4)
            apxa33_2=approx(dfb2dx_1*dft3dy_1,dfb2dx_2*dft3dy_2,dfb2dx_3
     *           *dft3dy_3,dfb2dx_4*dft3dy_4)
            apxa33_3=approx(dfb3dx_1*dft3dy_1,dfb3dx_2*dft3dy_2,dfb3dx_3
     *           *dft3dy_3,dfb3dx_4*dft3dy_4)
            apxa33_4=approx(dfb4dx_1*dft3dy_1,dfb4dx_2*dft3dy_2,dfb4dx_3
     *           *dft3dy_3,dfb4dx_4*dft3dy_4) 
            apxa34_1=approx(dfb1dx_1*dft4dy_1,dfb1dx_2*dft4dy_2,dfb1dx_3
     *           *dft4dy_3,dfb1dx_4*dft4dy_4)
            apxa34_2=approx(dfb2dx_1*dft4dy_1,dfb2dx_2*dft4dy_2,dfb2dx_3
     *           *dft4dy_3,dfb2dx_4*dft4dy_4)
            apxa34_3=approx(dfb3dx_1*dft4dy_1,dfb3dx_2*dft4dy_2,dfb3dx_3
     *           *dft4dy_3,dfb3dx_4*dft4dy_4)
            apxa34_4=approx(dfb4dx_1*dft4dy_1,dfb4dx_2*dft4dy_2,dfb4dx_3
     *           *dft4dy_3,dfb4dx_4*dft4dy_4) 
**********
            apxa41_1=approx(dfb1dy_1*dft1dy_1,dfb1dy_2*dft1dy_2,dfb1dy_3
     *           *dft1dy_3,dfb1dy_4*dft1dy_4)
            apxa41_2=approx(dfb2dy_1*dft1dy_1,dfb2dy_2*dft1dy_2,dfb2dy_3
     *           *dft1dy_3,dfb2dy_4*dft1dy_4)
            apxa41_3=approx(dfb3dy_1*dft1dy_1,dfb3dy_2*dft1dy_2,dfb3dy_3
     *           *dft1dy_3,dfb3dy_4*dft1dy_4)
            apxa41_4=approx(dfb4dy_1*dft1dy_1,dfb4dy_2*dft1dy_2,dfb4dy_3
     *           *dft1dy_3,dfb4dy_4*dft1dy_4)
            apxa42_1=approx(dfb1dy_1*dft2dy_1,dfb1dy_2*dft2dy_2,dfb1dy_3
     *           *dft2dy_3,dfb1dy_4*dft2dy_4)
            apxa42_2=approx(dfb2dy_1*dft2dy_1,dfb2dy_2*dft2dy_2,dfb2dy_3
     *           *dft2dy_3,dfb2dy_4*dft2dy_4)
            apxa42_3=approx(dfb3dy_1*dft2dy_1,dfb3dy_2*dft2dy_2,dfb3dy_3
     *           *dft2dy_3,dfb3dy_4*dft2dy_4)
            apxa42_4=approx(dfb4dy_1*dft2dy_1,dfb4dy_2*dft2dy_2,dfb4dy_3
     *           *dft2dy_3,dfb4dy_4*dft2dy_4)
            apxa43_1=approx(dfb1dy_1*dft3dy_1,dfb1dy_2*dft3dy_2,dfb1dy_3
     *           *dft3dy_3,dfb1dy_4*dft3dy_4)
            apxa43_2=approx(dfb2dy_1*dft3dy_1,dfb2dy_2*dft3dy_2,dfb2dy_3
     *           *dft3dy_3,dfb2dy_4*dft3dy_4)
            apxa43_3=approx(dfb3dy_1*dft3dy_1,dfb3dy_2*dft3dy_2,dfb3dy_3
     *           *dft3dy_3,dfb3dy_4*dft3dy_4)
            apxa43_4=approx(dfb4dy_1*dft3dy_1,dfb4dy_2*dft3dy_2,dfb4dy_3
     *           *dft3dy_3,dfb4dy_4*dft3dy_4) 
            apxa44_1=approx(dfb1dy_1*dft4dy_1,dfb1dy_2*dft4dy_2,dfb1dy_3
     *           *dft4dy_3,dfb1dy_4*dft4dy_4)
            apxa44_2=approx(dfb2dy_1*dft4dy_1,dfb2dy_2*dft4dy_2,dfb2dy_3
     *           *dft4dy_3,dfb2dy_4*dft4dy_4)
            apxa44_3=approx(dfb3dy_1*dft4dy_1,dfb3dy_2*dft4dy_2,dfb3dy_3
     *           *dft4dy_3,dfb3dy_4*dft4dy_4)
            apxa44_4=approx(dfb4dy_1*dft4dy_1,dfb4dy_2*dft4dy_2,dfb4dy_3
     *           *dft4dy_3,dfb4dy_4*dft4dy_4) 
         
c     
c     calcul du meme terme pour tous les elements de la diagonale 
c ---------------------------------------------------------------
c     
           term1=det*(b2*rcx*apxa11_1+ab*rcxy*apxa21_1
     *           +ab*rcyx*apxa31_1+a2*rcy*apxa41_1)
           term2=det*(b2*rcx*apxa12_2+ab*rcxy*apxa22_2
     *           +ab*rcyx*apxa32_2+a2*rcy*apxa42_2)
           term3=det*(b2*rcx*apxa13_3+ab*rcxy*apxa23_3
     *           +ab*rcyx*apxa33_3+a2*rcy*apxa43_3)
           term4=det*(b2*rcx*apxa14_4+ab*rcxy*apxa24_4
     *          +ab*rcyx*apxa34_4+a2*rcy*apxa44_4)


**********************************************************************************************************
            
*     si dans la fracture     
            if (( frac .ne. 0) .and. ((v01 .ne. 0.0) 
     *           .or. (v02 .ne. 0.0)))then        
               termm1=b*v01*apxm11_1+a*v02*apxm21_1
               term1=termm1+term1
               termm2=b*v01*apxm12_2+a*v02*apxm22_2
               term2=termm2+term2
               termm3=b*v01*apxm13_3+a*v02*apxm23_3
               term3=termm3+term3
               termm4=b*apxm14_4+a*v02*apxm24_4
               term4=termm4+term4
            end if
            
            maa(mia(ind1+1)-1)=maa(mia(ind1+1)-1)+term1
            maa(mia(ind2+1)-1)=maa(mia(ind2+1)-1)+term2
            maa(mia(ind3+1)-1)=maa(mia(ind3+1)-1)+term3
            maa(mia(ind4+1)-1)=maa(mia(ind4+1)-1)+term4
            
c     calcul du vecteur mja
            mja(mia(ind1+1)-1)=ind1
            mja(mia(ind2+1)-1)=ind2
            mja(mia(ind3+1)-1)=ind3
            mja(mia(ind4+1)-1)=ind4
c     
c     premiere diagonale
c     -----------------------
c     
*     cas mat(ind2,ind1)
            call remplissage_maa(ind1,ind2,mia,mja,bool,place,first)
            term1=det*(b2*rcx*apxa12_1+ab*rcxy*apxa22_1
     *           +ab*rcyx*apxa32_1+a2*rcy*apxa42_1)
            if ( frac .ne. 0) then
               termm1=b*v01*apxm12_1+a*v02*apxm22_1
               term1=termm1+term1
            end if
            if (bool .eq. 1) then           
               maa(place)=maa(place) + term1          
            else
               maa(first)=maa(first) + term1             
               mja(first)=ind2
            end if
            
*     cas mat(ind1,ind2)
            call remplissage_maa(ind2,ind1,mia,mja,bool,place,first)
            term1=det*(b2*rcx*apxa11_2+ab*rcxy*apxa21_2
     *           +ab*rcyx*apxa31_2+a2*rcy*apxa41_2)
            if ( frac .ne. 0) then
               termm1=b*v01*apxm11_2+a*v02*apxm21_2
               term1=termm1+term1
            end if
            if (bool .eq. 1) then
               maa(place)=maa(place) + term1
            else
               maa(first)=maa(first) + term1
               mja(first)=ind1
            end if
            
*     cas mat(ind4,ind3)
            call remplissage_maa(ind3,ind4,mia,mja,bool,place,first)
            term1=det*(b2*rcx*apxa14_3+ab*rcxy*apxa24_3
     *           +ab*rcyx*apxa34_3+a2*rcy*apxa44_3) 
            if ( frac .ne. 0) then
               termm1=b*v01*apxm14_3+a*v02*apxm24_3
               term1=termm1+term1
            end if          
            if (bool .eq. 1) then
               maa(place)=maa(place) + term1
            else
               maa(first)=maa(first) + term1
               mja(first)=ind4
            end if
            
*     cas mat(ind3,ind4)
            call remplissage_maa(ind4,ind3,mia,mja,bool,place,first)
            term1=det*(b2*rcx*apxa13_4+ab*rcxy*apxa23_4
     *           +ab*rcyx*apxa33_4+a2*rcy*apxa43_4)    
            if ( frac .ne. 0) then
               termm1=b*v01*apxm13_4+a*v02*apxm23_4
               term1=termm1+term1
            end if
            if (bool .eq. 1) then
               maa(place)=maa(place) + term1
            else
               maa(first)=maa(first) + term1
               mja(first)=ind3
            end if
            
c     
c     secondes diagonales
c -------------------------
c
*     cas mat(ind3,ind2) 
            call remplissage_maa(ind2,ind3,mia,mja,bool,place,first)
            term1=det*(b2*rcx*apxa13_2+ab*rcxy*apxa23_2
     *           +ab*rcyx*apxa33_2+a2*rcy*apxa43_2) 
            if ( frac .ne. 0) then
               termm1=b*v01*apxm13_2+a*v02*apxm23_2
               term1=termm1+term1
            end if    
            if (bool .eq. 1) then
               maa(place)=maa(place) + term1
            else
               maa(first)=maa(first) + term1
               mja(first)=ind3
            end if
            
*     cas mat(ind2,ind3)
            callremplissage_maa(ind3,ind2,mia,mja,bool,place,first)
            term1=det*(b2*rcx*apxa12_3+ab*rcxy*apxa22_3
     *           +ab*rcyx*apxa32_3+a2*rcy*apxa42_3)
            if ( frac .ne. 0) then
               termm1=b*v01*apxm12_3+a*v02*apxm22_3
               term1=termm1+term1
            end if   
            if (bool .eq. 1) then
               maa(place)=maa(place) + term1
            else
               maa(first)=maa(first) + term1
               mja(first)=ind2
            end if
c     
c     troisiemes diagonales
c ---------------------------
c
*     cas mat(ind3,ind1)
            call remplissage_maa(ind1,ind3,mia,mja,bool,place,first)
            term1=det*(b2*rcx*apxa13_1+ab*rcxy*apxa23_1
     *           +ab*rcyx*apxa33_1+a2*rcy*apxa43_1) 
            if ( frac .ne. 0) then
               termm1=b*v01*apxm13_1+a*v02*apxm23_1
               term1=termm1+term1
            end if
            if (bool .eq. 1) then
               maa(place)=maa(place) + term1
            else
               maa(first)=maa(first) + term1
               mja(first)=ind3
            end if
            
*     cas mat(ind1,ind3)
            call remplissage_maa(ind3,ind1,mia,mja,bool,place,first)
            term1=det*(b2*rcx*apxa11_3+ab*rcxy*apxa21_3
     *           +ab*rcyx*apxa31_3+a2*rcy*apxa41_3) 
            if ( frac .ne. 0) then
               termm1=b*v01*apxm11_3+a*v02*apxm21_3
               term1=termm1+term1
            end if
            if (bool .eq. 1) then
               maa(place)=maa(place) + term1
            else
               maa(first)=maa(first) + term1
               mja(first)=ind1
            end if
            
*     cas mat(ind4,ind2)         
            call remplissage_maa(ind2,ind4,mia,mja,bool,place,first)
            term1=det*(b2*rcx*apxa14_2+ab*rcxy*apxa24_2
     *           +ab*rcyx*apxa32_4+a2*rcy*apxa44_2) 
            if ( frac .ne. 0) then
               termm1=b*v01*apxm14_2+a*v02*apxm24_2
               term1=termm1+term1
            end if
            if (bool .eq. 1) then
               maa(place)=maa(place) + term1
            else
               maa(first)=maa(first) + term1
               mja(first)=ind4
            end if
            
*     cas mat(ind2,ind4)
            call remplissage_maa(ind4,ind2,mia,mja,bool,place,first)
            term1=det*(b2*rcx*apxa12_4+ab*rcxy*apxa22_4
     *           +ab*rcyx*apxa32_4+a2*rcy*apxa42_4) 
            if ( frac .ne. 0) then
               termm1=b*v01*apxm12_4+a*v02*apxm22_4
               term1=termm1+term1
            end if 
            if (bool .eq. 1) then
               maa(place)=maa(place) + term1
            else
               maa(first)=maa(first) + term1
               mja(first)=ind2
            end if
            
c     
c     quatrieme diagonale
c ---------------------------
c     
*     cas mat(ind4,ind1)
            call remplissage_maa(ind1,ind4,mia,mja,bool,place,first)
            term1=det*(b2*rcx*apxa14_1+ab*rcxy*apxa24_1
     *           +ab*rcyx*apxa34_1+a2*rcy*apxa44_1) 
            if ( frac .ne. 0) then
               termm1=b*v01*apxm14_1+a*v02*apxm24_1
               term1=termm1+term1
            end if
            if (bool .eq. 1) then
               maa(place)=maa(place) + term1
            else
               maa(first)=maa(first) + term1
               mja(first)=ind4
            end if
            
*     cas mat(ind1,ind4)
            callremplissage_maa(ind4,ind1,mia,mja,bool,place,first)
            term1=det*(b2*rcx*apxa11_4+ab*rcxy*apxa21_4
     *           +ab*rcyx*apxa31_4+a2*rcy*apxa41_4) 
            if ( frac .ne. 0) then
               termm1=b*v01*apxm11_4+a*v02*apxm21_4
               term1=termm1+term1
            end if
            if (bool .eq. 1) then
               maa(place)=maa(place) + term1
            else
               maa(first)=maa(first) + term1
               mja(first)=ind1
            end if
            
c     
c     calcul du second membre pour chaque probleme avec formule des trapezes
c ---------------------------------------------------------------------------
c     
            hrhs(ind1,1) = hrhs(ind1,1)
     1           + b*rcx*apxb21_1+a*rcyx*apxb22_1
            hrhs(ind1,2) = hrhs(ind1,2)
     1           + b*rcxy*apxb21_1+a*rcy*apxb22_1
c     
            hrhs(ind2,1) = hrhs(ind2,1)
     1           + b*rcx*apxb21_2+a*rcyx*apxb22_2
            hrhs(ind2,2) = hrhs(ind2,2)
     1           + b*rcxy*apxb21_2+a*rcy*apxb22_2
c     
            hrhs(ind3,1) = hrhs(ind3,1)
     1           + b*rcx*apxb21_3+a*rcyx*apxb22_3
            hrhs(ind3,2) = hrhs(ind3,2)
     1           + b*rcxy*apxb21_3+a*rcy*apxb22_3
c     
            hrhs(ind4,1) = hrhs(ind4,1)
     1           + b*rcx*apxb21_4+a*rcyx*apxb22_4
            hrhs(ind4,2) = hrhs(ind4,2)
     1           + b*rcxy*apxb21_4+a*rcy*apxb22_4

*     si dans la matrice     
            if ( frac .eq. 0 ) then           
               
               hrhs(ind1,1) = hrhs(ind1,1)
     *              - ab*kvf1*apxb11         
               hrhs(ind1,2) = hrhs(ind1,2)
     1              - ab*kvf2*apxb11   
c     
               hrhs(ind2,1) = hrhs(ind2,1)
     1              - ab*kvf1*apxb12 
               hrhs(ind2,2) = hrhs(ind2,2)
     1              - ab*kvf2*apxb12   
c     
               hrhs(ind3,1) = hrhs(ind3,1)
     1              - ab*kvf1*apxb13  
               hrhs(ind3,2) = hrhs(ind3,2)
     1              - ab*kvf2*apxb13
c     
               hrhs(ind4,1) = hrhs(ind4,1)
     1              - ab*kvf1*apxb14  
               hrhs(ind4,2) = hrhs(ind4,2)
     1              - ab*kvf2*apxb14    
               
            else               
               hrhs(ind1,1) = hrhs(ind1,1)
     1              + ab*(-v01 + kvf1)*apxb11         
               hrhs(ind1,2) = hrhs(ind1,2)
     1              + ab*(-v02 + kvf2)*apxb11
c     
               hrhs(ind2,1) = hrhs(ind2,1)
     1              + ab*(-v01 + kvf1)*apxb12
               hrhs(ind2,2) = hrhs(ind2,2)
     1              + ab*(-v02 + kvf2)*apxb12
c     
               hrhs(ind3,1) = hrhs(ind3,1)
     1              + ab*(-v01 + kvf1)*apxb13
               hrhs(ind3,2) = hrhs(ind3,2)
     1              + ab*(-v02 + kvf2)*apxb13
c     
               hrhs(ind4,1) = hrhs(ind4,1)
     1              + ab*(-v01 + kvf1)*apxb14
               hrhs(ind4,2) = hrhs(ind4,2)
     1              + ab*(-v02 + kvf2)*apxb14
                          
            end if             
c     

 4    continue

c     
c     tri des indices
c -------------------
c     
      do 5 i=1,nmat
         call Tri(mja(mia(i)),maa(mia(i)),mia(i+1)-mia(i))
 5    continue



c
c     initialisation des solutions initiales 
c -------------------------------------------
c

      do 6 i=1,nmat
         hx(i,1) = 0.001
 6    continue

c     
c     resolution du premier probleme
c ------------------------------
c    

      eps=cgeps
      write(*,*)'precision : ',eps
      write(*,*)'Kmax=',kmax
      call gmres(nmat,maa,mia,mja,hx(1,1),eps,nkr,kmax,hrhs(1,1))
         
c     
c     reinitialisation
c ------------------------
c     
      do 7 i=1,nmat
         hx(i,2)= 0.001
 7    continue
c     
c     resolution du second probleme
c ---------------------------------
c
      eps=cgeps
      call gmres(nmat,maa,mia,mja,hx(1,2),eps,nkr,kmax,hrhs(1,2))

c
c     retour au programme principal sans calcul du tenseur 
c --------------------------------------------------------
c
      if(iopt .ne. 0) return
c     
c     calcul final de la moyenne basee sur les elements finis
c
c     initialisation des valeurs
c ------------------------------
c
      zcx = 0.0
      zcxy = 0.0
      zcyx = 0.0
      zcy = 0.0
c     
c     boucles sur les noeuds
c --------------------------
c     
      do 8 j=1,nvaly
         j2 = ( j - 1 ) * nvalx
c     
c     recherche de la seconde coordonnee dans la grille de permeabilite
c ---------------------------------------------------------------------
c     
         indy = ( j + nyhr - 1 ) / nyhr
c     
c     calcul de la taille d'un element selon y
c --------------------------------------------
c     
         if(nyh .eq. 1) then
            yvalm = 0.0
            yvalp = 1.0
         else
            if(indy .eq. 1) then
               yvalm = 1.5 * y(1) - 0.5 * y(2)
               yvalp = 0.5 * ( y(indy) + y(indy+1) )
            end if
            if(indy .gt. 1 .and. indy .lt. nyh) then
               yvalm = 0.5 * ( y(indy-1) + y(indy) )
               yvalp = 0.5 * ( y(indy) + y(indy+1) )
            end if
            if(indy .eq. nyh) then
               yvalm = 0.5 * ( y(indy-1) + y(indy) )
               yvalp = 1.5 * y(indy) - 0.5 * y(indy-1)
            end if
         end if
         dely = ( yvalp - yvalm ) / float(nyhr)
         
         
         do 8 i=1,nvalx
c
c     recherche de la premiere coordonnee dans la grille de permeabilite
c ----------------------------------------------------------------------
c
            indx = ( i + nxhr - 1 ) / nxhr
c     
c     calcul de la taille d'un element selon x
c --------------------------------------------
c
            if(nxh .eq. 1) then
               xvalm = 0.0
               xvalp = 1.0
            else
               if(indx .eq. 1) then
                  xvalm = 1.5 * x(1) - 0.5 * x(2)
                  xvalp = 0.5 * ( x(indx) + x(indx+1) )
               end if
               if(indx .gt. 1 .and. indx .lt. nxh) then
                  xvalm = 0.5 * ( x(indx-1) + x(indx) )
                  xvalp = 0.5 * ( x(indx) + x(indx+1) )
               end if
               if(indx .eq. nxh) then
                  xvalm = 0.5 * ( x(indx-1) + x(indx) )
                  xvalp = 1.5 * x(indx) - 0.5 * x(indx-1)
               end if
            end if
            delx = ( xvalp - xvalm ) / float(nxhr)
*     constantes
            a=delx/2
            b=dely/2
            ab=delx*dely/4
            a2=a*a
            b2=b*b
c     
c     calcul du volume de la sous cellule en cours
c ------------------------------------------------
c     
            del = delx * dely
c
c     attribution de la permeabilite
c ----------------------------------
c     
            indif = indx + ( indy - 1 ) * nxh
            rcx = dx(indif)
            rcxy = dxy(indif)
            rcyx = dyx(indif)
            rcy = dy(indif)
            rv1 = v1(indif)
            rv2 = v2(indif)
c     
c     calcul des indices des 4 sommets de l'element 
c     en utilisant la propriete de la periodicite
c --------------------------------------------------------------
c     
            ind1 = i + j2
            if(i .eq. nvalx) then
               ind2 = 1 + j2
            else
               ind2 = ind1 + 1
            end if
            if( j .eq. nvaly) then
               ind3 = i
            else
               ind3 = ind1 + nvalx
            end if
            if(j .eq. nvaly) then
               if(i .eq. nvalx) then
                  ind4 = 1
               else
                  ind4 = i + 1
               end if
            else
               ind4 = ind2 + nvalx
            end if

*     points pour l approximation
            x1=-1./sqrt(3.)
            y1=-1./sqrt(3.)
            x2=1./sqrt(3.)
            y2=1./sqrt(3.)
            fb1_1=fb1(x1,y1)
            fb1_2=fb1(x1,y2)
            fb1_3=fb1(x2,y1)
            fb1_4=fb1(x2,y2)

            fb2_1=fb2(x1,y1)
            fb2_2=fb2(x1,y2)
            fb2_3=fb2(x2,y1)
            fb2_4=fb2(x2,y2)

            fb3_1=fb3(x1,y1)
            fb3_2=fb3(x1,y2)
            fb3_3=fb3(x2,y1)
            fb3_4=fb3(x2,y2)

            fb4_1=fb4(x1,y1)
            fb4_2=fb4(x1,y2)
            fb4_3=fb4(x2,y1)
            fb4_4=fb4(x2,y2)
            
            dfb1dx_1=dfb1dx(x1,y1)
            dfb1dx_2=dfb1dx(x1,y2)
            dfb1dx_3=dfb1dx(x2,y1)
            dfb1dx_4=dfb1dx(x2,y2)

            dfb2dx_1=dfb2dx(x1,y1)
            dfb2dx_2=dfb2dx(x1,y2)
            dfb2dx_3=dfb2dx(x2,y1)
            dfb2dx_4=dfb2dx(x2,y2)

            dfb3dx_1=dfb3dx(x1,y1)
            dfb3dx_2=dfb3dx(x1,y2)
            dfb3dx_3=dfb3dx(x2,y1)
            dfb3dx_4=dfb3dx(x2,y2)

            dfb4dx_1=dfb4dx(x1,y1)
            dfb4dx_2=dfb4dx(x1,y2)
            dfb4dx_3=dfb4dx(x2,y1)
            dfb4dx_4=dfb4dx(x2,y2)

            dfb1dy_1=dfb1dy(x1,y1)
            dfb1dy_2=dfb1dy(x1,y2)
            dfb1dy_3=dfb1dy(x2,y1)
            dfb1dy_4=dfb1dy(x2,y2)

            dfb2dy_1=dfb2dy(x1,y1)
            dfb2dy_2=dfb2dy(x1,y2)
            dfb2dy_3=dfb2dy(x2,y1)
            dfb2dy_4=dfb2dy(x2,y2)

            dfb3dy_1=dfb3dy(x1,y1)
            dfb3dy_2=dfb3dy(x1,y2)
            dfb3dy_3=dfb3dy(x2,y1)
            dfb3dy_4=dfb3dy(x2,y2)

            dfb4dy_1=dfb4dy(x1,y1)
            dfb4dy_2=dfb4dy(x1,y2)
            dfb4dy_3=dfb4dy(x2,y1)
            dfb4dy_4=dfb4dy(x2,y2)

*     termes d approximation qui intervient le tenseur effectif
            apxd11=approx(fb1_1,fb1_2,fb1_3,fb1_4)
            apxd12=approx(fb2_1,fb2_2,fb2_3,fb2_4)
            apxd13=approx(fb3_1,fb3_2,fb3_3,fb3_4)
            apxd14=approx(fb4_1,fb4_2,fb4_3,fb4_4)

            apxd21_1=approx(dfb1dx_1,dfb1dx_2,dfb1dx_3,dfb1dx_4)
            apxd21_2=approx(dfb2dx_1,dfb2dx_2,dfb2dx_3,dfb2dx_4)
            apxd21_3=approx(dfb3dx_1,dfb3dx_2,dfb3dx_3,dfb3dx_4)
            apxd21_4=approx(dfb4dx_1,dfb4dx_2,dfb4dx_3,dfb4dx_4)
            apxd22_1=approx(dfb1dy_1,dfb1dy_2,dfb1dy_3,dfb1dy_4)
            apxd22_2=approx(dfb2dy_1,dfb2dy_2,dfb2dy_3,dfb2dy_4)
            apxd22_3=approx(dfb3dy_1,dfb3dy_2,dfb3dy_3,dfb3dy_4)
            apxd22_4=approx(dfb4dy_1,dfb4dy_2,dfb4dy_3,dfb4dy_4)

c     
c     ajout du terme respectif
c ----------------------------
c
            zcx = zcx + ( ab*4*rcx +
     *           + rcx*b*2*(hx(ind1,1)*apxd21_1+hx(ind2,1)*apxd21_2
     *           + hx(ind3,1)*apxd21_3+hx(ind4,1)*apxd21_4)
     *           + rcxy*a*2*(hx(ind1,1)*apxd22_1+hx(ind2,1)*apxd22_2
     *           + hx(ind3,1)*apxd22_3+hx(ind4,1)*apxd22_4)
     *           - ab*(apxd11*hx(ind1,1)+apxd12*hx(ind2,1)
     *           + apxd13*hx(ind3,1)+apxd14*hx(ind4,1))*rv1)

            zcxy = zcxy + ( ab*4*rcxy +
     *           + rcx*b*2*(hx(ind1,2)*apxd21_1+hx(ind2,2)*apxd21_2
     *           + hx(ind3,2)*apxd21_3+hx(ind4,2)*apxd21_4)
     *           + rcxy*a*2*(hx(ind1,2)*apxd22_1+hx(ind2,2)*apxd22_2
     *           + hx(ind3,2)*apxd22_3+hx(ind4,2)*apxd22_4)
     *           - ab*(apxd11*hx(ind1,2)+apxd12*hx(ind2,2)
     *           + apxd13*hx(ind3,2)+apxd14*hx(ind4,2))*rv1)

            zcyx = zcyx + ( ab*4*rcyx +
     *           + rcyx*b*2*(hx(ind1,1)*apxd21_1+hx(ind2,1)*apxd21_2
     *           + hx(ind3,1)*apxd21_3+hx(ind4,1)*apxd21_4)
     *           + rcy*a*2*(hx(ind1,1)*apxd22_1+hx(ind2,1)*apxd22_2
     *           + hx(ind3,1)*apxd22_3+hx(ind4,1)*apxd22_4)
     *           - ab*(apxd11*hx(ind1,1)+apxd12*hx(ind2,1)
     *           + apxd13*hx(ind3,1)+apxd14*hx(ind4,1))*rv2)

            zcy = zcy + ( ab*4*rcy +
     *           + rcyx*b*2*(hx(ind1,2)*apxd21_1+hx(ind2,2)*apxd21_2
     *           + hx(ind3,2)*apxd21_3+hx(ind4,2)*apxd21_4)
     *           + rcy*a*2*(hx(ind1,2)*apxd22_1+hx(ind2,2)*apxd22_2
     *           + hx(ind3,2)*apxd22_3+hx(ind4,2)*apxd22_4)
     *           - ab*(apxd11*hx(ind1,2)+apxd12*hx(ind2,2)
     *           + apxd13*hx(ind3,2)+apxd14*hx(ind4,2))*rv2)

********************************



          zcx1 = zcx1 + del
     *         * ( rcx + rcx * 0.5 * ( hx(ind2,1) - hx(ind1,1) 
     *         + hx(ind4,1) - hx(ind3,1) ) + rcxy * 0.5 * ( hx(ind3,1)
     *         - hx(ind1,1) + hx(ind4,1) - hx(ind2,1) )
     *         - 0.25 * rv1 * ( hx(ind2,1) + hx(ind1,1) + hx(ind4,1) 
     *         + hx(ind3,1)))
c
c     
            zcxy1 = zcxy1 + del
     *           * ( rcxy + rcx * 0.5 * ( hx(ind2,2) - hx(ind1,2)
     *           + hx(ind4,2) - hx(ind3,2) ) + rcxy * 0.5 * ( hx(ind3,2)
     *           - hx(ind1,2) + hx(ind4,2) - hx(ind2,2) )
     *           - 0.25 * rv1 * ( hx(ind2,2) + hx(ind1,2) + hx(ind4,2) 
     *           + hx(ind3,2) )  )
c     
            zcyx1 = zcyx1 + del
     *           * ( rcyx + rcyx * 0.5 * ( hx(ind2,1) - hx(ind1,1)
     *           + hx(ind4,1) - hx(ind3,1) ) + rcy * 0.5 * ( hx(ind3,1)
     *           - hx(ind1,1) + hx(ind4,1) - hx(ind2,1) )
     *           - 0.25 * rv2 * ( hx(ind2,1) + hx(ind1,1) + hx(ind4,1) 
     *              + hx(ind3,1) ) )
c     
            zcy1 = zcy1 + del
     *           * ( rcy + rcyx * 0.5 * ( hx(ind2,2) - hx(ind1,2) 
     *           + hx(ind4,2) - hx(ind3,2) ) + rcy * 0.5 * ( hx(ind3,2)
     *           - hx(ind1,2) + hx(ind4,2) - hx(ind2,2) )
     *           - 0.25 * rv2 * ( hx(ind2,2) + hx(ind1,2) + hx(ind4,2) 
     *           + hx(ind3,2) ) )

 8    continue
c
c     division par la taille de la cellule
c ---------------------------------------
c
      zcx =   zcx / cellsize
      zcxy =  zcxy / cellsize
      zcyx =  zcyx / cellsize
      zcy =   zcy / cellsize

      zcx1 =   zcx1 / cellsize
      zcxy1 =  zcxy1 / cellsize
      zcyx1 =  zcyx1 / cellsize
      zcy1 =   zcy1 / cellsize

      write(*,*)
      write(*,*)'TENSEUR HOMCOD'
      write(*,*)zcx1,'\t',zcxy1
      write(*,*)zcxy1,'\t',zcy1
      pause

      return
      end
c\end{verbatim}


