*******************************************************
******                  IAmul.f                ********
*
C Ce sous-programme calcule le produit de la matrice
C A, stockee sous forme Morse dans les tableaux 
C (aa,ia,ja), par le vecteur x; le resultat est dans le
C tableau b.
C Le calcul se fait d"abord en calculant la contribution
C associee a la partie triangulaire inferieure de la 
C matrice (qui est celle stockee dans le tableau aa),
C puis celle associee a la partie triangulaire superieure
C stricte.
C
*	de 'INTRODUCTION AU CALCUL SCIENTIFIQUE' 
*	B. LUCQUIN
*	O. PIRONNEAU
*	MASSON, 1996



      subroutine IAmul(ns,aa,ia,ja,x,b)
      
      implicit none
      
      integer ns
      real x(ns),b(ns),aa(*)
      integer ia(*),ja(*)
      integer i,k,jak
      real somme,xi

      do 1 i=1,ns
         somme=0.
         do 2 k=ia(i),ia(i+1)-1
            somme=somme+aa(k)*x(ja(k))
 2       continue
         b(i)=somme
 1    continue
      
      do 3 i=1,ns
         xi=x(i)
         do 3 k=ia(i),ia(i+1)-2
            jak=ja(k)
            b(jak)=b(jak)+aa(k)*xi
 3    continue

      return
      end




