c Fichier quadrila_c.f
c
c*********************************************************************
c                 FICHIERS NECESSAIRES A LA SUBROUTINE CALCULQ1
c*********************************************************************

      INCLUDE'grad_qua_c.f'
      INCLUDE'prod_qua_c.f'
      INCLUDE'rige_qua_c.f'
      INCLUDE'base_qua_c.f'
      INCLUDE'2mb_qua_c.f'
      INCLUDE'aire2_c.f'

c*******************************************************************
      subroutine CALCULQ1_2D_c(ELEMENTBIS,INDICE,bb,ib,jb,aa,ia,ja,
     @           SMinter,N1,N2,N3,N4,K,cc,ic,jc,aire,poro,poroh)
c*******************************************************************
c
c  Cette procedure calcule et assemble les differentes contributions amenees
c  par un element de type quadrilatere dans le tableau aa. Deplus 
c  certains resultats necessaire en vue du calcul du tenseur homogeneise
c  sont sauvegardes dans les tableaux bb et cc.
c
c  ELEMENTBIS: tableau qui permet de dire si un noeud de l'element est 
c              sur le bord ou non.
c  INDICE:  tableau donnant le rang d'un noeud appartenant a VECTI ou VECTF
c  bb: tableau contenant les contributions bord-bord
c  aa: tableau contenant les contributions int-int (c'est la matrice A
c      du systeme lineaire) 
c  cc: tableau contenant les contributions bord-int
c  ia(k): indice dans le tableau aa du premier element
c        de la i eme ligne de A stocke dans aa,
c  ja(k): indice j de colonne de l"element Aij stocke
c         dans le tableau aa a l"indice k
c  ib,jb: idem que ia et ja pour le tableau bb
c  ic,jc: idem que ia et ja pour le tableau cc
c  SMinter:vecteur contenant le second membre du systeme lineaire
c            sans les conditions aux limites
c   N1,N2,N3,N4: contient les numeros, ainsi que les coordonnees des
c                quatre points qui constituent le quadrilatere
c   K: tableau contenant le tenseur des permeabilites
c
c
      implicit none           

      integer   ele,l,nbr1,INDICE,ia,ja,ib,jb,ic,jc,nbr2,k1,k2,ent  
      real*8    K,N1,N2,N3,N4,GRAD,det,aa,bb,cc,SMinter,aire0,aire1 
      real*8    INTEGRALE_2D_c,som1,aire,poro,poroh !,INTEGRPQ_c
      logical   ELEMENTBIS,log1,log2
      dimension N1(*),N2(*),N3(*),N4(*),K(2,*),GRAD(4,2)  
      dimension ELEMENTBIS(*),INDICE(*),bb(*),ib(*),jb(*)  
      dimension aa(*),ia(*),ja(*),SMinter(*),cc(*),ic(*),jc(*)  
     
      call AIRE_ELE2_c(aire0,N1,N2,N3)
      call AIRE_ELE2_c(aire1,N3,N4,N1)
      aire=aire+(aire0+aire1)
      poroh=poroh+(poro*(aire0+aire1))

 
       do ele=2,5
         nbr1=ele-1
         log2=.not.ELEMENTBIS(ele)
         do l=ele,5
            k1=INDICE(ele)
            k2=INDICE(l)
            nbr2=l-1
            log1=.not.ELEMENTBIS(l)
c
c calcul de la contribution
c
            som1=INTEGRALE_2D_c(GRAD,N1,N2,N3,N4,K,det,nbr1,nbr2)
c
c assemblage
c            
            if (log1.and.log2) then     
                  if (k2.ge.k1) then                         
                           ent=k1
                           k1=k2
                           k2=ent
                  endif
                  call ASSEMBLAGE_c(bb,ib,jb,k1,k2,som1)
                               else
    
            if (ELEMENTBIS(ele).and.ELEMENTBIS(l)) then
                  if (k2.ge.k1) then                         
                           ent=k1
                           k1=k2
                           k2=ent
                  endif
                  call ASSEMBLAGE_c(aa,ia,ja,k1,k2,som1)
                  else

            log1=.not.ELEMENTBIS(l)
        if (ELEMENTBIS(ele).and.log1) then
                   call ASSEMBLAGEbis_c(cc,ic,jc,k2,k1,som1)
                else

          if (ELEMENTBIS(l)) then               
                     k1=INDICE(l)
                     K2=INDICE(ele)
                     call ASSEMBLAGEbis_c(cc,ic,jc,k2,k1,som1) 
            endif
           endif
         endif
        endif
       enddo
c
c calcul de la contribution du second membre et assemblage
c
c       if (ELEMENTBIS(ele)) then
c            k1=INDICE(ele)
c            SMinter(k1)=SMinter(k1)+INTEGRPQ(nbr1,N1,N2,N3,N4)
c       endif
      enddo

      RETURN
      end
         
