c  Fichier rige_hex_c.f
c
c********************************************************************
      real*8 function INTEGRALE_C(GRAD,N1,N2,N3,N4,N5,N6,N7,N8,K,det,
     @                          nbr1,nbr2)           
c********************************************************************
c
c   Cette fonction calcule l'approxiamtion de l'integrale de
c   [K(x)GRAD(u).GRAD(v)] sur un hexaedre.
c    u et v designant deux fonctions de base quelconque
c   de l'hexaedre  .
c   On utilise la formule p.??? du  livre 'PRESENTATION DE LA METHODE
c   DES ELEMENTS FINIS' (T.Touzot) 19??.
c
c   N1,N2,N3,N4,N5,N6,N7,N8: contient les numeros, ainsi que les coordonnees 
c                des  points qui constituent l'hexaedre
c   K: tableau contenant le tenseur des permeabilites
c   GRAD: tableau contenant les valeurs des  gradiants
c         des fonctions de base
c   nbr1,nbr2: numero designant la nbr1ieme et la nbr2ieme
c              fonction de base
c   det: jacobien de la transformation: cube de reference --> hexaedre

      implicit none

      integer   nbr1,nbr2          
      real*8    somme1,somme2,GRAD,N1,N2,N3,N4,N5,N6,N7,N8
      real*8    det,a,b,p1,p2,K,PRODUIT_C
      dimension GRAD(8,*),K(3,*)
      dimension N1(*),N2(*),N3(*),N4(*),N5(*),N6(*),N7(*),N8(*)

c points d'integration

      a=SQRT((19.d0/30.d0))
      b=SQRT((19.d0/33.d0))
      p1=(320.d0/361.d0)
      p2=(121.d0/361.d0)

c integration numerique
      
      call GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,-a,0.d0,0.d0) 
      somme1=PRODUIT_C(K,GRAD,nbr1,nbr2)
      call GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,+a,0.d0,0.d0) 
      somme1=somme1+PRODUIT_C(K,GRAD,nbr1,nbr2)
      call GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,0.d0,-a,0.d0) 
      somme1=somme1+PRODUIT_C(K,GRAD,nbr1,nbr2)
      call GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,0.d0,+a,0.d0) 
      somme1=somme1+PRODUIT_C(K,GRAD,nbr1,nbr2)
      call GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,0.d0,0.d0,-a) 
      somme1=somme1+PRODUIT_C(K,GRAD,nbr1,nbr2)
      call GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,0.d0,0.d0,+a) 
      somme1=somme1+PRODUIT_C(K,GRAD,nbr1,nbr2)
      somme1=somme1*ABS(det)*p1

      call GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,+b,+b,+b) 
      somme2=PRODUIT_C(K,GRAD,nbr1,nbr2)
      call GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,-b,-b,-b) 
      somme2=somme2+PRODUIT_C(K,GRAD,nbr1,nbr2)
      call GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,+b,-b,+b) 
      somme2=somme2+PRODUIT_C(K,GRAD,nbr1,nbr2)
      call GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,+b,-b,-b) 
      somme2=somme2+PRODUIT_C(K,GRAD,nbr1,nbr2)
      call GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,-b,+b,+b) 
      somme2=somme2+PRODUIT_C(K,GRAD,nbr1,nbr2)
      call GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,-b,+b,-b) 
      somme2=somme2+PRODUIT_C(K,GRAD,nbr1,nbr2)
      call GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,-b,-b,+b) 
      somme2=somme2+PRODUIT_C(K,GRAD,nbr1,nbr2)
      call GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,+b,+b,-b) 
      somme2=somme2+PRODUIT_C(K,GRAD,nbr1,nbr2)
      somme2=somme2*ABS(det)*p2
      
      INTEGRALE_C=somme1+somme2     

      RETURN
      end


