      program main
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c   this is a dummy driver routine
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/homog_common.h'
      include 'include/prm_common.h'
      include 'include/iounit.h'
c
c call the routine
c ----------------
c
      call homprminit
c
      stop
      end
      subroutine homprminit
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c   this routine will homogenize the permeability field from an input
c permeability data set
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hom_common.h'
      include 'include/homog_common.h'
      include 'include/prm_common.h'
      include 'include/iounit.h'
      real zkxx(nperm),zkxy(nperm),zkxz(nperm)
     1    ,zkyx(nperm),zkyy(nperm),zkyz(nperm)
     1    ,zkzx(nperm),zkzy(nperm),zkzz(nperm)
      real txx(nperm),txy(nperm),txz(nperm)
     1    ,tyx(nperm),tyy(nperm),tyz(nperm)
     1    ,tzx(nperm),tzy(nperm),tzz(nperm)
      real xx(nodeprm),yy(nodeprm),zz(nodeprm)
      real sx(nodeprm),sy(nodeprm),sz(nodeprm)
      real sgx(nodeprm),sgy(nodeprm),sgz(nodeprm)
c
c set a cutoff for 0 - here it is set at 6 orders of magnitude less than the
c largest entry in the original array
c -----------------------------------
c
      data zerocutoff / 0.00000001 /
c
c first bring the the basic input data set for the permeability
c -------------------------------------------------------------
c
      call prmrddat
c
c read in the homogenization data
c -------------------------------
c
      call homrddat
c
c check the dimensions against the current simulator parameters
c -------------------------------------------------------------
c
      if(mod(nxprm,nxhom) .ne. 0) then
        print *,' '
        print *,' ----- inside homprminit'
        print *,' '
        print *,' ***** number of blocks and nodes in the first'
        print *,' ***** coordinate are not consistent'
        print *,' ***** simulator value - nxprm = ',nxprm
        print *,' ***** number of blocks - nxhom = ',nxhom
        print *,' '
        print *,' ----- exiting the simulation'
        print *,' '
        stop
      end if
c
      if(mod(nyprm,nyhom) .ne. 0) then
        print *,' '
        print *,' ----- inside homprminit'
        print *,' '
        print *,' ***** number of blocks and nodes in the second'
        print *,' ***** coordinate are not consistent'
        print *,' ***** simulator value - nyprm = ',nyprm
        print *,' ***** number of blocks - nyhom = ',nyhom
        print *,' '
        print *,' ----- exiting the simulation'
        print *,' '
        stop
      end if
c
      if(mod(nzprm,nzhom) .ne. 0) then
        print *,' '
        print *,' ----- inside homprminit'
        print *,' '
        print *,' ***** number of blocks and nodes in the third'
        print *,' ***** coordinate are not consistent'
        print *,' ***** simulator value - nzprm = ',nzprm
        print *,' ***** number of blocks - nzhom = ',nzhom
        print *,' '
        print *,' ----- exiting the simulation'
        print *,' '
        stop
      end if
c
c this is the file where the current permeabilities are resident
c --------------------------------------------------------------
c
      open(unit=iunit,file='prmprminit.inp')
c
c copy the original file to a new location
c ----------------------------------------
c
      read(iunit,*,end=1) nx
      read(iunit,*,end=1) ny
      read(iunit,*,end=1) nz
c
c check the dimensions against the current simulator parameters
c -------------------------------------------------------------
c
      if(nx .ne. nxprm) then
        print *,' '
        print *,' ----- inside homprminit'
        print *,' '
        print *,' ***** number of nodes in the first coordinate are not'
        print *,' ***** consistent in prmprminit.inp'
        print *,' ***** pressure input file - nx = ',nx
        print *,' ***** simulator value - nxprm = ',nxprm
        print *,' '
        print *,' ----- exiting the simulation'
        print *,' '
        stop
      end if
c
      if(ny .ne. nyprm) then
        print *,' '
        print *,' ----- inside homprminit'
        print *,' '
        print *,' ***** number of nodes in the first coordinate are not'
        print *,' ***** consistent in prmprminit.inp'
        print *,' ***** pressure input file - ny = ',ny
        print *,' ***** simulator value - nyprm = ',nyprm
        print *,' '
        print *,' ----- exiting the simulation'
        print *,' '
        stop
      end if
c
      if(nz .ne. nzprm) then
        print *,' '
        print *,' ----- inside homprminit'
        print *,' '
        print *,' ***** number of nodes in the first coordinate are not'
        print *,' ***** consistent in prmprminit.inp'
        print *,' ***** pressure input file - nz = ',nz
        print *,' ***** simulator value - nzprm = ',nzprm
        print *,' '
        print *,' ----- exiting the simulation'
        print *,' '
        stop
      end if
c
c compute the total number of values
c ----------------------------------
c
      nnprm = nxprm * nyprm * nzprm
c
c read in the rest of the data
c ----------------------------
c
      read(iunit,*,end=1) (permxx(i),i=1,nnprm)
      read(iunit,*,end=1) (permxy(i),i=1,nnprm)
      read(iunit,*,end=1) (permxz(i),i=1,nnprm)
      read(iunit,*,end=1) (permyx(i),i=1,nnprm)
      read(iunit,*,end=1) (permyy(i),i=1,nnprm)
      read(iunit,*,end=1) (permyz(i),i=1,nnprm)
      read(iunit,*,end=1) (permzx(i),i=1,nnprm)
      read(iunit,*,end=1) (permzy(i),i=1,nnprm)
      read(iunit,*,end=1) (permzz(i),i=1,nnprm)
c
c close the copy file and go on with the homogenization
c -----------------------------------------------------
c
      close(unit=iunit)
c
c this file is where the original data gets moved
c -----------------------------------------------
c
      open(unit=iunit,file='prmprminit.orig')
c
c write the data to save file
c ---------------------------
c
      nnprm = nx * ny * nz
      write(iunit,*) nx
      write(iunit,*) ny
      write(iunit,*) nz
      write(iunit,10) (permxx(i),i=1,nnprm)
      write(iunit,10) (permxy(i),i=1,nnprm)
      write(iunit,10) (permxz(i),i=1,nnprm)
      write(iunit,10) (permyx(i),i=1,nnprm)
      write(iunit,10) (permyy(i),i=1,nnprm)
      write(iunit,10) (permyz(i),i=1,nnprm)
      write(iunit,10) (permzx(i),i=1,nnprm)
      write(iunit,10) (permzy(i),i=1,nnprm)
      write(iunit,10) (permzz(i),i=1,nnprm)
c
c close the copy file and go on with the homogenization
c -----------------------------------------------------
c
      close(unit=iunit)
c
c this is the grid file for the data - if no file is found the user will need
c to generate one
c ---------------
c
      open(unit=iunit,file='prmgrdinit.inp')
c
c read in the grid information - this code expects that a grid file has been
c created
c -------
c
      read(iunit,*,end=2) nx
      read(iunit,*,end=2) ny
      read(iunit,*,end=2) nz     
c
c check the dimensions against the current simulator parameters
c -------------------------------------------------------------
c
      if(nx .ne. nxprm) then
        print *,' '
        print *,' ----- inside homprminit'
        print *,' '
        print *,' ***** number of nodes in the first coordinate are not'
        print *,' ***** consistent in prmgrdinit.inp'
        print *,' ***** pressure input file - nx = ',nx
        print *,' ***** simulator value - nxprm = ',nxprm
        print *,' '
        print *,' ----- exiting the simulation'
        print *,' '
        stop
      end if
c
      if(ny .ne. nyprm) then
        print *,' '
        print *,' ----- inside homprminit'
        print *,' '
        print *,' ***** number of nodes in the first coordinate are not'
        print *,' ***** consistent in prmgrdinit.inp'
        print *,' ***** pressure input file - ny = ',ny
        print *,' ***** simulator value - nyprm = ',nyprm
        print *,' '
        print *,' ----- exiting the simulation'
        print *,' '
        stop
      end if
c
      if(nz .ne. nzprm) then
        print *,' '
        print *,' ----- inside homprminit'
        print *,' '
        print *,' ***** number of nodes in the first coordinate are not'
        print *,' ***** consistent in prmgrdinit.inp'
        print *,' ***** pressure input file - nz = ',nz
        print *,' ***** simulator value - nzprm = ',nzprm
        print *,' '
        print *,' ----- exiting the simulation'
        print *,' '
        stop
      end if
c
c read in the grid data
c ---------------------
c
      read(iunit,*,end=2) (xgrprm(i),i=0,nxprm)
      read(iunit,*,end=2) (ygrprm(i),i=0,nyprm)
      read(iunit,*,end=2) (zgrprm(i),i=0,nzprm)
c
c this file is where the original data gets moved
c -----------------------------------------------
c
      open(unit=iunit,file='prmgrdinit.orig')
c
c write the old data to a new file
c --------------------------------
c
      write(iunit,*) nx
      write(iunit,*) ny
      write(iunit,*) nz     
      write(iunit,*) (xgrprm(i),i=0,nxprm)
      write(iunit,*) (ygrprm(i),i=0,nyprm)
      write(iunit,*) (zgrprm(i),i=0,nzprm)
c
c close the copy file and go on with the homogenization
c -----------------------------------------------------
c
      close(unit=iunit)
c
c now compute the rest of the permeability mesh parameters
c --------------------------------------------------------
c
      call prmmesh
c
c compute the number of heterogeneous blocks in each cell
c -------------------------------------------------------
c
      nxhet = nxprm / nxhom
      nyhet = nyprm / nyhom
      nzhet = nzprm / nzhom
c
c check this value against the storage allowed in the routine
c -----------------------------------------------------------
c
      if(nnprm .gt. nodhom) then
        print *,' ***** insufficient storage in prm2hom *****'
        return
      end if
c
c loop over the homogenization blocks
c -----------------------------------
c
      nnhet = nxhet * nyhet
      nnhom = nxhom * nyhom
      do 3 k=1,nzhom
         k2 = ( k - 1 ) * nnhom
c
c put in the z locations for use in the routine below
c ---------------------------------------------------
c
         kshft = ( k - 1 ) * nzhet
         do 4 kk=1,nzhet
            zz(kk) = zprm(kk+kshft)
    4    continue
c
c compute the boundaries of the block
c -----------------------------------
c
         if(nzhet .eq. 1) then
           zvalm = 0.0
           zvalp = 1.0
         else
           zvalm = 1.5 * zz(1) - 0.5 * zz(2)
           zvalp = 1.5 * zz(nzhet) - 0.5 * zz(nzhet-1)
         end if
c
c compute the next grid line in the coarse grid
c ---------------------------------------------
c
         sgz(k) = zvalp
c
      do 3 j=1,nyhom
         j2 = ( j - 1 ) * nxhom + k2
c
c put in the y locations for use in the routine below
c ---------------------------------------------------
c
         jshft = ( j - 1 ) * nyhet
         do 5 jj=1,nyhet
            yy(jj) = yprm(jj+jshft)
    5    continue
c
c compute the boundaries of the block
c -----------------------------------
c
         if(nyhet .eq. 1) then
           yvalm = 0.0
           yvalp = 1.0
         else
           yvalm = 1.5 * yy(1) - 0.5 * yy(2)
           yvalp = 1.5 * yy(nyhet) - 0.5 * yy(nyhet-1)
         end if
c
c compute the next grid line in the coarse grid
c ---------------------------------------------
c
         sgy(j) = yvalp
c
      do 3 i=1,nxhom
         indblk = i + j2
c
c put in the x locations for use in the routine below
c ---------------------------------------------------
c
         ishft = ( i - 1 ) * nxhet
         do 6 ii=1,nxhet
            xx(ii) = xprm(ii+ishft)
    6    continue
c
c compute the boundaries of the block
c -----------------------------------
c
         if(nxhet .eq. 1) then
           xvalm = 0.0
           xvalp = 1.0
         else
           xvalm = 1.5 * xx(1) - 0.5 * xx(2)
           xvalp = 1.5 * xx(nxhet) - 0.5 * xx(nxhet-1)
         end if
c
c compute the next grid line in the coarse grid
c ---------------------------------------------
c
         sgx(i) = xvalp
c
c loop over the cells that are included in this block and store them in a
c temporary array
c ---------------
c
         valmax = 0.0
         do 7 kk=1,nzhet
            k2het = ( kk - 1 ) * nnhet
            k2prm = ( kk - 1 + ( k - 1 ) * nzhet ) * nxprm * nyprm
         do 7 jj=1,nyhet
            j2het = ( jj - 1 ) * nxhet + k2het
            j2prm = ( jj - 1 + ( j - 1 ) * nyhet ) * nxprm + k2prm
         do 7 ii=1,nxhet
            indhet = ii + j2het
            indprm = ii + ( i - 1 ) * nxhet + j2prm
c
c set the value into the temporary array
c --------------------------------------
c
            txx(indhet) = permxx(indprm)
            txy(indhet) = permxy(indprm)
            txz(indhet) = permxz(indprm)
            tyx(indhet) = permyx(indprm)
            tyy(indhet) = permyy(indprm)
            tyz(indhet) = permyz(indprm)
            tzx(indhet) = permzx(indprm)
            tzy(indhet) = permzy(indprm)
            tzz(indhet) = permzz(indprm)
c
c check the maximum and minimum values
c ------------------------------------
c
            if(valmax .lt. abs(txx(indhet)))
     1                     valmax = abs(txx(indhet))
            if(valmax .lt. abs(txy(indhet)))
     1                     valmax = abs(txy(indhet))
            if(valmax .lt. abs(txz(indhet)))
     1                     valmax = abs(txz(indhet))
            if(valmax .lt. abs(tyx(indhet)))
     1                     valmax = abs(tyx(indhet))
            if(valmax .lt. abs(tyy(indhet)))
     1                     valmax = abs(tyy(indhet))
            if(valmax .lt. abs(tyz(indhet)))
     1                     valmax = abs(tyz(indhet))
            if(valmax .lt. abs(tzx(indhet)))
     1                     valmax = abs(tzx(indhet))
            if(valmax .lt. abs(tzy(indhet)))
     1                     valmax = abs(tzy(indhet))
            if(valmax .lt. abs(tzz(indhet)))
     1                     valmax = abs(tzz(indhet))
c
    7    continue
c
c perform the averaging that has been requested
c ---------------------------------------------
c
         call avgswtch3(iavgtyp,txx,txy,txz
     1                         ,tyx,tyy,tyz
     1                         ,tzx,tzy,tzz
     1                         ,xx,yy,zz
     1                         ,nxhet,nyhet,nzhet
     1                         ,nxhref,nyhref,nzhref
     1                         ,zkxx(indblk),zkxy(indblk),zkxz(indblk)
     1                         ,zkyx(indblk),zkyy(indblk),zkyz(indblk)
     1                         ,zkzx(indblk),zkzy(indblk),zkzz(indblk)
     1                         ,sx(i),sy(j),sz(k)
     1                         ,0)
c
c process out any "close" to zero values
c --------------------------------------
c
         cutoff = zerocutoff * valmax
         icutflag = 0
         if(abs(zkxx(indblk)) .lt. cutoff) then
           zkxx(indblk) = 0.0
           icutflag = 1
         end if
         if(abs(zkxy(indblk)) .lt. cutoff) then
           zkxy(indblk) = 0.0
           icutflag = 1
         end if
         if(abs(zkxz(indblk)) .lt. cutoff) then
           zkxz(indblk) = 0.0
           icutflag = 1
         end if
         if(abs(zkyx(indblk)) .lt. cutoff) then
           zkyx(indblk) = 0.0
           icutflag = 1
         end if
         if(abs(zkyy(indblk)) .lt. cutoff) then
           zkyy(indblk) = 0.0
           icutflag = 1
         end if
         if(abs(zkyz(indblk)) .lt. cutoff) then
           zkyz(indblk) = 0.0
           icutflag = 1
         end if
         if(abs(zkzx(indblk)) .lt. cutoff) then
           zkzx(indblk) = 0.0
           icutflag = 1
         end if
         if(abs(zkzy(indblk)) .lt. cutoff) then
           zkzy(indblk) = 0.0
           icutflag = 1
         end if
         if(abs(zkzz(indblk)) .lt. cutoff) then
           zkzz(indblk) = 0.0
           icutflag = 1
         end if
         if(icutflag .eq. 1) then
           print *,' '
           print *,' ----- inside homprminit'
           print *,' '
           print *,' ***** small values have been truncated in the'
           print *,' ***** cell'
           print *,' ***** value - icutflag = ',icutflag
           print *,' ***** value - zerocutoff = ',zerocutoff
           print *,' ***** homogenization block - i,j,k = ',i,j,k
           print *,' '
           print *,' '
         end if
c
c make the tensor symmetric - this should only happen if the difference between
c the symmetric elements in the tensor is small
c ---------------------------------------------
c
         isymmflag = 0
         if(zkxy(indblk) .ne. zkyx(indblk)) then
           value = 0.5 * ( zkxy(indblk) + zkyx(indblk) )
           diffxy = abs(zkxy(indblk) - value)
           zkxy(indblk) = value
           zkyx(indblk) = value
           isymmflag = 1
         end if
c
         if(zkxz(indblk) .ne. zkzx(indblk)) then
           value = 0.5 * ( zkxz(indblk) + zkzx(indblk) )
           diffxz = abs(zkxz(indblk) - value)
           zkxz(indblk) = value
           zkzx(indblk) = value
           isymmflag = 1
         end if
c
         if(zkyz(indblk) .ne. zkzy(indblk)) then
           value = 0.5 * ( zkyz(indblk) + zkzy(indblk) )
           diffyz = abs(zkyz(indblk) - value)
           zkyz(indblk) = value
           zkzy(indblk) = value
           isymmflag = 1
         end if
         if(isymmflag .eq. 1) then
           print *,' '
           print *,' ----- inside homprminit'
           print *,' '
           print *,' ***** symmetry has been enforced in the cell'
           print *,' ***** value - diffxy = ',diffxy
           print *,' ***** value - diffxz = ',diffzy
           print *,' ***** value - diffyz = ',diffyz
           print *,' ***** homogenization block - i,j,k = ',i,j,k
           print *,' '
           print *,' '
         end if
c
c      print *,i,j,k,indblk
c      print *,zkxx(indblk),zkxy(indblk),zkxz(indblk)
c      print *,zkyx(indblk),zkyy(indblk),zkyz(indblk)
c      print *,zkzx(indblk),zkzy(indblk),zkzz(indblk)
c      print *,'after averaging'
c      read(5,*)
c
    3 continue
c
c set the new values
c ------------------
c
      nxprm = nxhom
      nyprm = nyhom
      nzprm = nzhom
c
c compute the new grid parameters
c -------------------------------
c
      do 8 i=1,nxprm
         xgrprm(i) = sgx(i)
    8 continue
      do 9 j=1,nyprm
         ygrprm(j) = sgy(j)
    9 continue
      do 11 i=1,nzprm
         zgrprm(k) = sgz(k)
   11 continue
c
      call prmgrdout
c
c set the new values of the permeability
c --------------------------------------
c
      nnprm = nxprm * nyprm * nzprm
      do 12 i=1,nnprm
         permxx(i) = zkxx(i)
         permxy(i) = zkxy(i)
         permxz(i) = zkxz(i)
         permyx(i) = zkyx(i)
         permyy(i) = zkyy(i)
         permyz(i) = zkyz(i)
         permzx(i) = zkzx(i)
         permzy(i) = zkzy(i)
         permzz(i) = zkzz(i)
   12 continue
c
      call prmprmout
c
c this file is where the original data gets moved
c -----------------------------------------------
c
      open(unit=iunit,file='prm3d.orig')
c
c write the old data to a new file
c --------------------------------
c
      write(iunit,*) nx
      write(iunit,*) ny
      write(iunit,*) nz
      write(iunit,*) xgrprm(0)
      write(iunit,*) xgrprm(nxprm)
      write(iunit,*) ygrprm(0)
      write(iunit,*) ygrprm(nyprm)
      write(iunit,*) zgrprm(0)
      write(iunit,*) zgrprm(nzprm)
c
c close the copy file and go on with the homogenization
c -----------------------------------------------------
c
      close(unit=iunit)
c
c set the new basic data set
c --------------------------
c
      call prmdatout
c
      return
c
c in the case of no data found in permeability file
c -------------------------------------------------
c
    1 continue
      print *,' '
      print *,' ----- inside homprminit'
      print *,' '
      print *,' ***** the data set ended before necessary data could'
      print *,' ***** could be read in - check the file prmprminit.inp'
      print *,' '
      print *,' ----- exiting the simulation'
      print *,' '
      stop
c
c in the case of no data found in permeability grid file
c ------------------------------------------------------
c
    2 continue
      print *,' '
      print *,' ----- inside homprminit'
      print *,' '
      print *,' ***** the data set ended before necessary data could'
      print *,' ***** could be read in - check the file prmgrdinit.inp'
      print *,' '
      print *,' ----- exiting the simulation'
      print *,' '
      stop
c
c formats
c -------
c
   10 format(5e16.8)
c
      end
      subroutine avgswtch3(iavgtyp,kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz
     1,x,y,z,nxh,nyh,nzh,nxhr,nyhr,nzhr,zkxx,zkxy,zkxz,zkyx
     1,zkyy,zkyz,zkzx,zkzy,zkzz,zx,zy,zz,iopt)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe 
c
c  this routine is just a swtich for the four type of averaging. the routine 
c calls the routine determined by the value of the first argument. the default 
c value is the homogenization routine. the arguments are just passed on through c to the routine 
c
c input  
c
c   iavgtype - the type of averaging routine to use 
c              iavgtyp = 1; homogenization (default) 
c              iavgtyp = 2; arithmethic 
c              iavgtyp = 3; harmonic
c              iavgtyp = 4; geometric
c              iavgtyp = 5; new homogenization
c   kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz - one-dimensional tensors (in x first)
c                   giving the values of the tensor at the centers of the cells
c                   in the region considered.
c   x,y,z - the coordinates of the cell centers.
c   nxh,nyh,nzh - the number of grid blocks in the coordinate directions
c   nxhr,nyhr,nzhr - the number of refinements to take on each grid block
c
c output
c
c   zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz - real values that are the
c                   effective or homogenized values in a constant tensor
c                   defined over the entire region
c
c                              [  zkxx    zkxy  zkxz  ]
c                          #   [                      ]
c                         K  = [  zkyx   zkyy   zkyz  ]
c                              [                      ]
c                              [  zkzx   zkzy   zkzz  ]
c
c                   where # is used as in the literature to denote the
c                   homogenized tensor.
c   zx,zy,zz - real values with the center of the homogenized cell returned.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/homog_common.h'
      real kxx(*),kxy(*),kxz(*)
      real kyx(*),kyy(*),kyz(*)
      real kzx(*),kzy(*),kzz(*)
      real x(*),y(*),z(*)
      real zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz
      real zx,zy,zz
c
c make sure the choice parameter is ok
c ------------------------------------
c
      if(iavgtyp .lt. 1 .or. iavgtyp .gt. 7) then
c 
        print *,' '
        print *,' ----- inside avgswtch3'
        print *,' '
        print *,' ***** averaging type flag is out of range and has'
        print *,' ***** been set to 1'
        print *,' ***** iavgtyp = ',iavgtyp 
        print *,' '    
c 
        iavgtyp = 1
c 
      end if 
c 
c check the four types of averaging 
c --------------------------------- 
c 
      if(iavgtyp .eq. 1) call homogab3(kxx,kxy,kxz
     1                                ,kyx,kyy,kyz
     1                                ,kzx,kzy,kzz
     1                                ,x,y,z
     1                                ,nxh,nyh,nzh
     1                                ,nxhr,nyhr,nzhr
     1                                ,zkxx,zkxy,zkxz
     1                                ,zkyx,zkyy,zkyz
     1                                ,zkzx,zkzy,zkzz
     1                                ,zx,zy,zz,iopt)
      if(iavgtyp .eq. 2) call arithavg3(kxx,kxy,kxz
     1                                 ,kyx,kyy,kyz
     1                                 ,kzx,kzy,kzz
     1                                ,x,y,z
     1                                ,nxh,nyh,nzh
     1                                ,zkxx,zkxy,zkxz
     1                                ,zkyx,zkyy,zkyz
     1                                ,zkzx,zkzy,zkzz
     1                                ,zx,zy,zz)
      if(iavgtyp .eq. 3) call hrmncavg3(kxx,kxy,kxz
     1                                 ,kyx,kyy,kyz
     1                                 ,kzx,kzy,kzz
     1                                 ,x,y,z
     1                                 ,nxh,nyh,nzh
     1                                 ,zkxx,zkxy,zkxz
     1                                 ,zkyx,zkyy,zkyz
     1                                 ,zkzx,zkzy,zkzz
     1                                 ,zx,zy,zz)
      if(iavgtyp .eq. 4) call geomavg3(kxx,kxy,kxz
     1                                ,kyx,kyy,kyz
     1                                ,kzx,kzy,kzz
     1                                ,x,y,z
     1                                ,nxh,nyh,nzh
     1                                ,zkxx,zkxy,zkxz
     1                                ,zkyx,zkyy,zkyz
     1                                ,zkzx,zkzy,zkzz
     1                                ,zx,zy,zz)
      if(iavgtyp .eq. 5) call homogba3(kxx,kxy,kxz
     1                                ,kyx,kyy,kyz
     1                                ,kzx,kzy,kzz
     1                                ,x,y,z
     1                                ,nxh,nyh,nzh
     1                                ,nxhr,nyhr,nzhr
     1                                ,zkxx,zkxy,zkxz
     1                                ,zkyx,zkyy,zkyz
     1                                ,zkzx,zkzy,zkzz
     1                                ,zx,zy,zz,iopt)
      if(iavgtyp .eq. 6) call hommfe3(kxx,kxy,kxz
     1                               ,kyx,kyy,kyz
     1                               ,kzx,kzy,kzz
     1                               ,x,y,z
     1                               ,nxh,nyh,nzh
     1                               ,nxhr,nyhr,nzhr
     1                               ,zkxx,zkxy,zkxz
     1                               ,zkyx,zkyy,zkyz
     1                               ,zkzx,zkzy,zkzz
     1                               ,zx,zy,zz,iopt)
      if(iavgtyp .eq. 7) call hommfeap3(kxx,kxy,kxz
     1                                 ,kyx,kyy,kyz
     1                                 ,kzx,kzy,kzz
     1                                 ,x,y,z
     1                                 ,nxh,nyh,nzh
     1                                 ,nxhr,nyhr,nzhr
     1                                 ,zkxx,zkxy,zkxz
     1                                 ,zkyx,zkyy,zkyz
     1                                 ,zkzx,zkzy,zkzz
     1                                 ,zx,zy,zz,iopt)
c
      return
      end
      subroutine geomavg3(kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz,x,y,z
     1,nxh,nyh,nzh,zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz
     1,zx,zy,zz)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine is a black box routine that takes evenly spaced values of
c the arrays kxx, kxy, kxz, kyx, kyy, kyz, kzx, kzy, and kzz that are defined
c in some rectangular region in three-dimensional space and returns the
c geometic average value in the region.
c
c the arrays are tensor values in the 3-d tensor
c
c                 [  kxx    kxy   kxz  ]
c                 [                    ]  
c             K = [  kyx    kyy   kyz  ]
c                 [                    ]  
c                 [  kzx    kzy   kzz  ]
c
c input  
c
c   kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz - one-dimensional tensors (in x first)
c                   giving the values of the tensor at the centers of the cells
c                   in the region considered.
c   x,y,z - the coordinates of the cell centers.
c
c output 
c
c   zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz - real values that are the
c                   effective or geometic average values in a constant tensor
c                   defined over the entire region
c
c                              [  zkxx    zkxy  zkxz  ]
c                          A   [                      ]   
c                         K  = [  zkyx   zkyy   zkyz  ]
c                              [                      ]   
c                              [  zkzx   zkzy   zkzz  ]
c
c                   where # is used as in the literature to denote the
c                   averaged tensor.
c   zx,zy,zz - real values with the center of the homogenized cell returned.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/homog_common.h'
      real kxx(*),kxy(*),kxz(*)
      real kyx(*),kyy(*),kyz(*)
      real kzx(*),kzy(*),kzz(*)
      real x(*),y(*),z(*)
      real zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz
      real zx,zy,zz
c
c set some factors for later use
c ------------------------------
c
      facxx = 1.0
      facxy = 1.0
      facxz = 1.0
      facyx = 1.0
      facyy = 1.0
      facyz = 1.0
      faczx = 1.0
      faczy = 1.0
      faczz = 1.0
c
c check the number of heterogeneous grid blocks and set to at least one
c ---------------------------------------------------------------------
c
      if(nxh .le. 0) nxh = 1
      if(nyh .le. 0) nyh = 1
      if(nzh .le. 0) nzh = 1
c
c compute the 2-d shifts for the 3-d case
c ---------------------------------------
c
      nvtemp = nxh * nyh
c
c compute the overall block size for use below
c --------------------------------------------
c
      if(nxh .eq. 1) then
        xvalm = 0.0
        xvalp = 1.0
      else
        xvalm = 1.5 * x(1) - 0.5 * x(2)
        xvalp = 1.5 * x(nxh) - 0.5 * x(nxh-1)
      end if
      if(nyh .eq. 1) then
        yvalm = 0.0
        yvalp = 1.0
      else
        yvalm = 1.5 * y(1) - 0.5 * y(2)
        yvalp = 1.5 * y(nyh) - 0.5 * y(nyh-1)
      end if
      if(nzh .eq. 1) then
        zvalm = 0.0
        zvalp = 1.0
      else
        zvalm = 1.5 * z(1) - 0.5 * z(2)
        zvalp = 1.5 * z(nzh) - 0.5 * z(nzh-1)
      end if
      cellsize = ( xvalp - xvalm ) * ( yvalp - yvalm )
     1               * ( zvalp - zvalm )
c
c compute the new cell center location
c ------------------------------------
c
      zx = 0.5 * ( xvalp + xvalm )
      zy = 0.5 * ( yvalp + yvalm )
      zz = 0.5 * ( zvalp + zvalm )
c
c add up the values
c -----------------
c
      sumxx = 0.0
      sumxy = 0.0
      sumxz = 0.0
      sumyx = 0.0
      sumyy = 0.0
      sumyz = 0.0
      sumzx = 0.0
      sumzy = 0.0
      sumzz = 0.0
c
c loop over the nodes in the third coordinate direction
c -----------------------------------------------------
c
      do 1 k=1,nzh
         k2 = ( k - 1 ) * nvtemp
c
c compute the grid block size for the computational cell in z
c -----------------------------------------------------------
c
         if(nzh .eq. 1) then
           zvalm = 0.0
           zvalp = 1.0
         else
           if(k .eq. 1) then
             zvalm = 1.5 * z(1) - 0.5 * z(2)
             zvalp = 0.5 * ( z(k) + z(k+1) )
           end if
           if(k .gt. 1 .and. k .lt. nzh) then
             zvalm = 0.5 * ( z(k-1) + z(k) )
             zvalp = 0.5 * ( z(k) + z(k+1) )
           end if
           if(k .eq. nzh) then
             zvalm = 0.5 * ( z(k-1) + z(k) )
             zvalp = 1.5 * z(k) - 0.5 * z(k-1)
           end if
         end if
         delz = ( zvalp - zvalm )
c
      do 1 j=1,nyh
         j2 = ( j - 1 ) * nxh + k2
c
c compute the grid block size for the computational cell in y
c -----------------------------------------------------------
c
         if(nyh .eq. 1) then
           yvalm = 0.0
           yvalp = 1.0
         else
           if(j .eq. 1) then
             yvalm = 1.5 * y(1) - 0.5 * y(2)
             yvalp = 0.5 * ( y(j) + y(j+1) )
           end if
           if(j .gt. 1 .and. j .lt. nyh) then
             yvalm = 0.5 * ( y(j-1) + y(j) )
             yvalp = 0.5 * ( y(j) + y(j+1) )
           end if
           if(j .eq. nyh) then
             yvalm = 0.5 * ( y(j-1) + y(j) )
             yvalp = 1.5 * y(j) - 0.5 * y(j-1)
           end if
         end if
         dely = ( yvalp - yvalm )
c
      do 1 i=1,nxh
         ind = i + j2
c
c compute the grid block size for the computational cell in x
c -----------------------------------------------------------
c
         if(nxh .eq. 1) then
           xvalm = 0.0
           xvalp = 1.0
         else
           if(i .eq. 1) then
             xvalm = 1.5 * x(1) - 0.5 * x(2)
             xvalp = 0.5 * ( x(i) + x(i+1) )
           end if
           if(i .gt. 1 .and. i .lt. nxh) then
             xvalm = 0.5 * ( x(i-1) + x(i) )
             xvalp = 0.5 * ( x(i) + x(i+1) )
           end if
           if(i .eq. nxh) then
             xvalm = 0.5 * ( x(i-1) + x(i) )
             xvalp = 1.5 * x(i) - 0.5 * x(i-1)
           end if
         end if
         delx = ( xvalp - xvalm )
c
c compute the cell block size
c ---------------------------
c
         blksize = delx * dely * delz
c
c check for zero values
c ---------------------
c
         if(kxx(ind) .gt. 0.0) then
           sumxx = sumxx + alog(kxx(ind)) * blksize
         else
           facxx = 0.0
         end if
c
         if(kxy(ind) .gt. 0.0) then
           sumxy = sumxy + alog(kxy(ind)) * blksize
         else
           facxy = 0.0
         end if
c
         if(kxz(ind) .gt. 0.0) then
           sumxz = sumxz + alog(kxz(ind)) * blksize
         else
           facxz = 0.0
         end if
c          
         if(kyx(ind) .gt. 0.0) then
           sumyx = sumyx + alog(kyx(ind)) * blksize
         else
           facyx = 0.0
         end if
c          
         if(kyy(ind) .gt. 0.0) then
           sumyy = sumyy + alog(kyy(ind)) * blksize
         else
           facyy = 0.0
         end if
c          
         if(kyz(ind) .gt. 0.0) then
           sumyz = sumyz + alog(kyz(ind)) * blksize
         else
           facyz = 0.0
         end if
c          
         if(kzx(ind) .gt. 0.0) then
           sumzx = sumzx + alog(kzx(ind)) * blksize
         else
           faczx = 0.0
         end if
c          
         if(kzy(ind) .gt. 0.0) then
           sumzy = sumzy + alog(kzy(ind)) * blksize
         else
           faczy = 0.0
         end if
c          
         if(kzz(ind) .gt. 0.0) then
           sumzz = sumzz + alog(kzz(ind)) * blksize
         else
           faczz = 0.0
         end if
c
    1 continue
c
c compute the value using the given sum
c -------------------------------------
c
      zkxx = facxx * exp( sumxx / cellsize )
      zkxy = facxy * exp( sumxy / cellsize )
      zkxz = facxz * exp( sumxz / cellsize )
      zkyx = facyx * exp( sumyx / cellsize )
      zkyy = facyy * exp( sumyy / cellsize )
      zkyz = facyz * exp( sumyz / cellsize )
      zkzx = faczx * exp( sumzx / cellsize )
      zkzy = faczy * exp( sumzy / cellsize )
      zkzz = faczz * exp( sumzz / cellsize )
c
      return
      end
      subroutine prmrddat
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine will read in the problem information , do some calculations,
c and form the common blocks for use in other routines. the informnation is
c passed back to the main routine via the common blocks below.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c common blocks
c -------------
c
      include 'include/ioprm_common.h'
      include 'include/physical_constants.h'
      include 'include/prm_common.h'
      include 'include/iounit.h'
c
c open the default input file
c ---------------------------
c
      open(unit=iunit,file='prm3d.inp')
c
c read the number of nodes in each coordinate direction in the permeability grid
c ------------------------------------------------------------------------------
c
      read(iunit,*,end=1) nxprm
      read(iunit,*,end=1) nyprm
      read(iunit,*,end=1) nzprm
c
c get the domain bounds
c ---------------------
c
      read(iunit,*,end=1) xgrprm(0)
      read(iunit,*,end=1) xgrprm(nxprm)
      read(iunit,*,end=1) ygrprm(0)
      read(iunit,*,end=1) ygrprm(nyprm)
      read(iunit,*,end=1) zgrprm(0)
      read(iunit,*,end=1) zgrprm(nzprm)
c
c close the input file
c --------------------
c
      close(unit=iunit)
c
      return
c
c if the end of the file is reached for any reason the code will die. the info
c in this file must be present in order to get things going
c ---------------------------------------------------------
c
    1 continue
      print *,' '
      print *,' ----- inside prmrddat'
      print *,' '
      print *,' ***** the data set ended before necessary data could'
      print *,' ***** could be read in - check the file prm3d.inp'
      print *,' '
      print *,' ----- exiting the simulation'
      print *,' '
      stop
c
      end
      subroutine arithavg3(kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz,x,y,z
     1,nxh,nyh,nzh,zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz,zx,zy
     1,zz)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine is a black box routine that takes evenly spaced values of
c the arrays kxx, kxy, kxz, kyx, kyy, kyz, kzx, kzy, and kzz that are defined
c in some rectangular region in three-dimensional space and returns the
c arithmetic average value in the region.
c
c the arrays are tensor values in the 3-d tensor
c
c                 [  kxx    kxy   kxz  ]
c                 [                    ]  
c             K = [  kyx    kyy   kyz  ]
c                 [                    ]  
c                 [  kzx    kzy   kzz  ]
c
c input  
c
c   kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz - one-dimensional tensors (in x first)
c                   giving the values of the tensor at the centers of the cells
c                   in the region considered.
c   x,y,z - the coordinates of the cell centers.
c
c output 
c
c   zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz - real values that are the
c                   effective or arithmetic average values in a constant tensor
c                   defined over the entire region
c
c                              [  zkxx    zkxy  zkxz  ]
c                          A   [                      ]   
c                         K  = [  zkyx   zkyy   zkyz  ]
c                              [                      ]   
c                              [  zkzx   zkzy   zkzz  ]
c
c                   where # is used as in the literature to denote the
c                   averaged tensor.
c   zx,zy,zz - real values with the center of the homogenized cell returned.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/homog_common.h'
      real kxx(*),kxy(*),kxz(*)
      real kyx(*),kyy(*),kyz(*)
      real kzx(*),kzy(*),kzz(*)
      real x(*),y(*),z(*)
      real zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz
      real zx,zy,zz
c
c check the number of heterogeneous grid blocks and set to at least one
c ---------------------------------------------------------------------
c
      if(nxh .le. 0) nxh = 1
      if(nyh .le. 0) nyh = 1
      if(nzh .le. 0) nzh = 1
c
c compute the 2-d shifts for the 3-d case
c ---------------------------------------
c
      nvtemp = nxh * nyh
c
c compute the overall block size for use below
c --------------------------------------------
c
      if(nxh .eq. 1) then
        xvalm = 0.0
        xvalp = 1.0
      else
        xvalm = 1.5 * x(1) - 0.5 * x(2)
        xvalp = 1.5 * x(nxh) - 0.5 * x(nxh-1)
      end if
      if(nyh .eq. 1) then
        yvalm = 0.0
        yvalp = 1.0
      else
        yvalm = 1.5 * y(1) - 0.5 * y(2)
        yvalp = 1.5 * y(nyh) - 0.5 * y(nyh-1)
      end if
      if(nzh .eq. 1) then
        zvalm = 0.0
        zvalp = 1.0
      else
        zvalm = 1.5 * z(1) - 0.5 * z(2)
        zvalp = 1.5 * z(nzh) - 0.5 * z(nzh-1)
      end if
      cellsize = ( xvalp - xvalm ) * ( yvalp - yvalm )
     1               * ( zvalp - zvalm )
c
c compute the new cell center location
c ------------------------------------
c
      zx = 0.5 * ( xvalp + xvalm )
      zy = 0.5 * ( yvalp + yvalm )
      zz = 0.5 * ( zvalp + zvalm )
c
c add up the values
c -----------------
c
      sumxx = 0.0
      sumxy = 0.0
      sumxz = 0.0
      sumyx = 0.0
      sumyy = 0.0
      sumyz = 0.0
      sumzx = 0.0
      sumzy = 0.0
      sumzz = 0.0
c
c loop over the nodes in the third coordinate direction
c -----------------------------------------------------
c
      do 1 k=1,nzh
         k2 = ( k - 1 ) * nvtemp
c
c compute the grid block size for the computational cell in z
c -----------------------------------------------------------
c
         if(nzh .eq. 1) then
           zvalm = 0.0
           zvalp = 1.0
         else
           if(k .eq. 1) then
             zvalm = 1.5 * z(1) - 0.5 * z(2)
             zvalp = 0.5 * ( z(k) + z(k+1) )
           end if
           if(k .gt. 1 .and. k .lt. nzh) then
             zvalm = 0.5 * ( z(k-1) + z(k) )
             zvalp = 0.5 * ( z(k) + z(k+1) )
           end if
           if(k .eq. nzh) then
             zvalm = 0.5 * ( z(k-1) + z(k) )
             zvalp = 1.5 * z(k) - 0.5 * z(k-1)
           end if
         end if
         delz = ( zvalp - zvalm )
c
      do 1 j=1,nyh
         j2 = ( j - 1 ) * nxh + k2
c
c compute the grid block size for the computational cell in y
c -----------------------------------------------------------
c
         if(nyh .eq. 1) then
           yvalm = 0.0
           yvalp = 1.0
         else
           if(j .eq. 1) then
             yvalm = 1.5 * y(1) - 0.5 * y(2)
             yvalp = 0.5 * ( y(j) + y(j+1) )
           end if
           if(j .gt. 1 .and. j .lt. nyh) then
             yvalm = 0.5 * ( y(j-1) + y(j) )
             yvalp = 0.5 * ( y(j) + y(j+1) )
           end if
           if(j .eq. nyh) then
             yvalm = 0.5 * ( y(j-1) + y(j) )
             yvalp = 1.5 * y(j) - 0.5 * y(j-1)
           end if
         end if
         dely = ( yvalp - yvalm )
c
      do 1 i=1,nxh
         ind = i + j2
c
c compute the grid block size for the computational cell in x
c -----------------------------------------------------------
c
         if(nxh .eq. 1) then
           xvalm = 0.0
           xvalp = 1.0
         else
           if(i .eq. 1) then
             xvalm = 1.5 * x(1) - 0.5 * x(2)
             xvalp = 0.5 * ( x(i) + x(i+1) )
           end if
           if(i .gt. 1 .and. i .lt. nxh) then
             xvalm = 0.5 * ( x(i-1) + x(i) )
             xvalp = 0.5 * ( x(i) + x(i+1) )
           end if
           if(i .eq. nxh) then
             xvalm = 0.5 * ( x(i-1) + x(i) )
             xvalp = 1.5 * x(i) - 0.5 * x(i-1)
           end if
         end if
         delx = ( xvalp - xvalm )
c
c compute the cell block size
c ---------------------------
c
         blksize = delx * dely * delz
c
c compute the additional term for the integral
c --------------------------------------------
c
         sumxx = sumxx + kxx(ind) * blksize
         sumxy = sumxy + kxy(ind) * blksize
         sumxz = sumxz + kxz(ind) * blksize
         sumyx = sumyx + kyx(ind) * blksize
         sumyy = sumyy + kyy(ind) * blksize
         sumyz = sumyz + kyz(ind) * blksize
         sumzx = sumzx + kzx(ind) * blksize
         sumzy = sumzy + kzy(ind) * blksize
         sumzz = sumzz + kzz(ind) * blksize
c
    1 continue
c
c compute the averages
c --------------------
c
      zkxx = sumxx / cellsize
      zkxy = sumxy / cellsize
      zkxz = sumxz / cellsize
      zkyx = sumyx / cellsize
      zkyy = sumyy / cellsize
      zkyz = sumyz / cellsize
      zkzx = sumzx / cellsize
      zkzy = sumzy / cellsize
      zkzz = sumzz / cellsize
c
      return
      end
      subroutine prmdatout
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine overwrites the default input file for the permeability portion
c of the simulator input
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c common blocks
c -------------
c
      include 'include/ioprm_common.h'
      include 'include/prm_common.h'
      include 'include/iounit.h'
c
c open the default input file
c ---------------------------
c
      open(unit=iunit,file='prm3d.inp')
c
c write the number of nodes in each coordinate direction in the pressure grid
c ---------------------------------------------------------------------------
c
      write(iunit,10) nxprm
      write(iunit,20) nyprm
      write(iunit,30) nzprm
c
c get the domain bounds
c ---------------------
c
      write(iunit,40) xgrprm(0)
      write(iunit,50) xgrprm(nxprm)
      write(iunit,60) ygrprm(0)
      write(iunit,70) ygrprm(nyprm)
      write(iunit,80) zgrprm(0)
      write(iunit,90) zgrprm(nzprm)
c
c formats
c -------
c
   10 format(i6,10x,'*** number of nodes in the first coordinate')
   20 format(i6,10x,'*** number of nodes in the second coordinate')
   30 format(i6,10x,'*** number of nodes in the third coordinate')
   40 format(e12.4,4x,'*** left end of boundary in first coordinate')
   50 format(e12.4,4x,'*** right end of boundary in first coordinate')
   60 format(e12.4,4x,'*** left end of boundary in second coordinate')
   70 format(e12.4,4x,'*** right end of boundary in second coordinate')
   80 format(e12.4,4x,'*** left end of boundary in third coordinate')
   90 format(e12.4,4x,'*** right end of boundary in third coordinate')
c
      return
      end
      subroutine prmprmout
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine overwrites the default permeability input file for the
c simulator
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c common blocks
c -------------
c
      include 'include/ioprm_common.h'
      include 'include/prm_common.h'
      include 'include/iounit.h'
c
c open the default input file
c ---------------------------
c
      open(unit=iunit,file='prmprminit.inp')
c
c rewind the file
c ---------------
c
      rewind iunit
c
c write the number of nodes in each coordinate direction in the pressure grid
c ---------------------------------------------------------------------------
c
      write(iunit,10) nxprm
      write(iunit,20) nyprm
      write(iunit,30) nzprm
c
c get the domain bounds
c ---------------------
c
      write(iunit,40) (permxx(i),i=1,nnprm)
      write(iunit,40) (permxy(i),i=1,nnprm)
      write(iunit,40) (permxz(i),i=1,nnprm)
      write(iunit,40) (permyx(i),i=1,nnprm)
      write(iunit,40) (permyy(i),i=1,nnprm)
      write(iunit,40) (permyz(i),i=1,nnprm)
      write(iunit,40) (permzx(i),i=1,nnprm)
      write(iunit,40) (permzy(i),i=1,nnprm)
      write(iunit,40) (permzz(i),i=1,nnprm)
c
c close the unit
c --------------
c
      close(unit=iunit)
c
c formats
c -------
c
   10 format(i6,10x,'*** number of grid block in first coordinate')
   20 format(i6,10x,'*** number of grid block in second coordinate')
   30 format(i6,10x,'*** number of grid block in third coordinate')
   40 format(5e16.8)
c
      return
      end
      subroutine prmmesh
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine computes parameters and the grid for the pressure solution
c code.
c
c the code expects that the domain extent in each dimension, the number of
c grid blocks in each direction, and the grid lines are input from the data
c files provided by the user. this routine just computes the auxiliary
c parameters associated with the grid.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/prm_common.h'
c
c compute the cell centered nodes
c -------------------------------
c
        xprm(0) = xgrprm(0)
        do 1 i=1,nxprm
           xprm(i) = 0.5 * ( xgrprm(i) + xgrprm(i-1) )
    1   continue
        xprm(nxprm+1) = xgrprm(nxprm)
c
        yprm(0) = ygrprm(0)
        do 2 j=1,nyprm
           yprm(j) = 0.5 * ( ygrprm(j) + ygrprm(j-1) )
    2   continue
        yprm(nyprm+1) = ygrprm(nyprm)
c
        zprm(0) = zgrprm(0)
        do 3 k=1,nzprm
           zprm(k) = 0.5 * ( zgrprm(k) + zgrprm(k-1) )
    3   continue
        zprm(nzprm+1) = zgrprm(nzprm)
c
c compute the interval lengths
c ----------------------------
c
        do 4 i=1,nxprm
           dxprm(i) = xgrprm(i) - xgrprm(i-1)
    4   continue
        do 5 j=1,nyprm
           dyprm(j) = ygrprm(j) - ygrprm(j-1)
    5   continue
        do 6 k=1,nzprm
           dzprm(k) = zgrprm(k) - zgrprm(k-1)
    6   continue
c
c compute some integer grid parameters
c ------------------------------------
c
      nxprmp1 = nxprm + 1
      nyprmp1 = nyprm + 1
      nzprmp1 = nzprm + 1
      nxprmm1 = nxprm - 1
      nyprmm1 = nyprm - 1
      nzprmm1 = nzprm - 1
      nnprm = nxprm * nyprm * nzprm
      nnprmvx = nxprmp1 * nyprm * nzprm
      nnprmvy = nxprm * nyprmp1 * nzprm
      nnprmvz = nxprm * nyprm * nzprmp1
      nprmtot = nnvx + nnvy + nnvz + nnprm
      nprmvx2d = nxprmp1 * nyprm
      nprmvy2d = nyprmp1 * nzprm
      nprmvz2d = nxprm * nzprmp1
c
      return
      end
      subroutine homrddat
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine will read in the homogenization problem information
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c common blocks
c -------------
c
      include 'include/hom_common.h'
      include 'include/iounit.h'
c
c open the default input file
c ---------------------------
c
      open(unit=iunit,file='hom3d.inp')
c
c read the number of nodes in each coordinate direction in the permeability grid
c ------------------------------------------------------------------------------
c
      read(iunit,*,end=1) iavgtyp
      read(iunit,*,end=1) nxhom
      read(iunit,*,end=1) nyhom
      read(iunit,*,end=1) nzhom
      read(iunit,*,end=1) nxhref
      read(iunit,*,end=1) nyhref
      read(iunit,*,end=1) nzhref
c
c close the input file
c --------------------
c
      close(unit=iunit)
c
      return
c
c if the end of the file is reached for any reason the code will die. the info
c in this file must be present in order to get things going
c ---------------------------------------------------------
c
    1 continue
      print *,' '
      print *,' ----- inside homrddat'
      print *,' '
      print *,' ***** the data set ended before necessary data could'
      print *,' ***** could be read in - check the file hom3d.inp or'
      print *,' ***** prm3d.inp'
      print *,' '
      print *,' ----- exiting the simulation'
      print *,' '
      stop
c
      end
      subroutine hommfe3(kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz,x,y,z
     1,nxh,nyh,nzh,nxhr,nyhr,nzhr,zkxx,zkxy,zkxz,zkyx
     1,zkyy,zkyz,zkzx,zkzy,zkzz,zx,zy,zz,iopt)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c this the the mixed finite element method version of the homogenization
c stuff. the mfe code is used to handle internal boundary conditions where
c fluxes can be specified.
c
c written by: joe koebbe
c
c   this routine is a black box routine that takes nodal values of the arrays
c kxx, kxy, kxz, kyx, kyy, kyz, kzx, kzy, and kzz that are defined in some
c rectangular region in three-dimensional space and returns the homogenized
c value in the region.
c
c the arrays are tensor values in the 3-d tensor
c
c                 [  kxx    kxy   kxz  ]
c                 [                    ] 
c             K = [  kyx    kyy   kyz  ]
c                 [                    ] 
c                 [  kzx    kzy   kzz  ]
c
c the homogenization is that used in papers by Amaziane and Bourgeat
c
c input
c
c   kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz - one-dimensional tensors (in x first)
c                   giving the values of the tensor at the centers of the cells
c                   in the region considered.
c   x,y,z - the coordinates of the cell centers.
c   nxh,nyh,nzh - the number of grid blocks in the coordinate directions
c   nxhr,nyhr,nzhr - the number of refinements to take on each grid block
c
c output
c
c   zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz - real values that are the
c                   effective or homogenized values in a constant tensor
c                   defined over the entire region
c
c                              [  zkxx    zkxy  zkxz  ]
c                          #   [                      ]  
c                         K  = [  zkyx   zkyy   zkyz  ]
c                              [                      ]  
c                              [  zkzx   zkzy   zkzz  ]
c
c                   where # is used as in the literature to denote the
c                   homogenized tensor.
c   zx,zy,zz - real values with the center of the homogenized cell returned.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
c
c set up the local storage for the block of permeabilities
c --------------------------------------------------------
c
      real kxx(*),kxy(*),kxz(*)
      real kyx(*),kyy(*),kyz(*)
      real kzx(*),kzy(*),kzz(*)
      real x(*),y(*),z(*)
      real zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz
      real zx,zy,zz
c
c declare the external matrix multiplication routine
c --------------------------------------------------
c
      external hommfemmm
c
c translate the input information into the common blocks - the grid, refinements
c etc...
c
c number of grid blocks
c ---------------------
c
      nxhommfe = nxh
      nyhommfe = nyh
      nzhommfe = nzh
c
c compute the total number of homogenization blocks for temporary use here
c ------------------------------------------------------------------------
c
      nnhommfe = nxh * nyh * nzh
c
c cell centers
c ------------
c
      do 1 i=1,nxh
         xhommfe(i) = x(i)
    1 continue
      do 2 j=1,nyh
         yhommfe(j) = y(j)
    2 continue
      do 3 k=1,nzh
         zhommfe(k) = z(k)
    3 continue
c
c perm values
c -----------
c
      do 4 i=1,nnhommfe
         hommfekxx(i) = kxx(i)
         hommfekxy(i) = kxy(i)
         hommfekxz(i) = kxz(i)
         hommfekyx(i) = kyx(i)
         hommfekyy(i) = kyy(i)
         hommfekyz(i) = kyz(i)
         hommfekzx(i) = kzx(i)
         hommfekzy(i) = kzy(i)
         hommfekzz(i) = kzz(i)
    4 continue
c
c set up the grid for the cell
c ----------------------------
c
      call hommfemesh
c
c check for a refinement in one of the coordinate directions
c ----------------------------------------------------------
c
      if(nxhr .gt. 1 .or. nyhr .gt. 1 .or. nzhr .gt. 1)
     1                           call hommferef(nxhr,nyhr,nzhr)
c
c compute the fixed locations in the grid to be mapped out of the calculation
c ---------------------------------------------------------------------------
c
      call hommfefixed
c
c compute the matrix for the homogenization equations - note that as in the
c previous code using standard finite element methods the matrix only needs to
c be computed once.
c -----------------
c
      call hommfematrix
c
c go through each of the three solutions
c
c compute the right hand side for the first system of equations
c -------------------------------------------------------------
c
      call hommferhs
c
c initialize the solution arrays
c ------------------------------
c
      do 5 i=1,nnhommfe
         w(i,1) = 0.0
         w(i,2) = 0.0
         w(i,3) = 0.0
    5 continue
      do 6 i=1,nnhommfevx
         hommfevelx(i,1) = 0.0
         hommfevelx(i,2) = 0.0
         hommfevelx(i,3) = 0.0
    6 continue
      do 7 i=1,nnhommfevy
         hommfevely(i,1) = 0.0
         hommfevely(i,2) = 0.0
         hommfevely(i,3) = 0.0
    7 continue
      do 8 i=1,nnhommfevz
         hommfevelz(i,1) = 0.0
         hommfevelz(i,2) = 0.0
         hommfevelz(i,3) = 0.0
    8 continue
c
c call the homogenization solution routine for the systems of equations
c ---------------------------------------------------------------------
c
      if(nxhommfe .gt. 1) call hommfesoln(1)
      if(nyhommfe .gt. 1) call hommfesoln(2)
      if(nzhommfe .gt. 1) call hommfesoln(3)
c
c check for breaking out of the code before computing the averages
c ----------------------------------------------------------------
c
      if(iopt .ne. 0) return
c
c compute the average of the values using the energy method
c ---------------------------------------------------------
c
      call hommfeavg(zkxx,zkxy,zkxz
     1              ,zkyx,zkyy,zkyz
     1              ,zkzx,zkzy,zkzz)
c
      return
      end
      subroutine homogab3(kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz,x,y,z
     1,nxh,nyh,nzh,nxhr,nyhr,nzhr,zkxx,zkxy,zkxz,zkyx
     1,zkyy,zkyz,zkzx,zkzy,zkzz,zx,zy,zz,iopt)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine is a black box routine that takes nodal values of
c the arrays kxx, kxy, kxz, kyx, kyy, kyz, kzx, kzy, and kzz that are defined
c in some rectangular region in three-dimensional space and returns the
c homogenized value in the region.
c
c the arrays are tensor values in the 3-d tensor
c
c                 [  kxx    kxy   kxz  ]
c                 [                    ]
c             K = [  kyx    kyy   kyz  ]
c                 [                    ]
c                 [  kzx    kzy   kzz  ]
c
c the homogenization is that used in papers by Amaziane and Bourgeat
c
c input
c
c   kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz - one-dimensional tensors (in x first)
c                   giving the values of the tensor at the centers of the cells
c                   in the region considered.
c   x,y,z - the coordinates of the cell centers.
c   nxh,nyh,nzh - the number of grid blocks in the coordinate directions
c   nxhr,nyhr,nzhr - the number of refinements to take on each grid block
c
c output
c
c   zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz - real values that are the
c                   effective or homogenized values in a constant tensor
c                   defined over the entire region
c
c                              [  zkxx    zkxy  zkxz  ]
c                          #   [                      ]
c                         K  = [  zkyx   zkyy   zkyz  ]
c                              [                      ]
c                              [  zkzx   zkzy   zkzz  ]
c
c                   where # is used as in the literature to denote the
c                   homogenized tensor.
c   zx,zy,zz - real values with the center of the homogenized cell returned.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/homog_common.h'
      real kxx(*),kxy(*),kxz(*)
      real kyx(*),kyy(*),kyz(*)
      real kzx(*),kzy(*),kzz(*)
      real x(*),y(*),z(*)
      real zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz
      real zx,zy,zz
c
c the matrix multiplication routine
c ---------------------------------
c
      common /hmatmlt3/ n1,n2,n3,n1r,n2r,n3r
      external hamlt3
c
c set some constants for use below
c --------------------------------
c
      data cutoff,cgeps,cgthrshl,cgthrshu
     1          / 0.0000001,0.00001,0.01,100.0 /
c
c check the number of heterogeneous grid blocks and set to at least one
c ---------------------------------------------------------------------
c
      if(nxh .le. 0) nxh = 1
      if(nyh .le. 0) nyh = 1
      if(nzh .le. 0) nzh = 1
      if(nxhr .le. 0) nxhr = 1
      if(nyhr .le. 0) nyhr = 1
      if(nzhr .le. 0) nzhr = 1
c
c set the scaling flag
c --------------------
c
      iscale = 0
c
c set the values for the multiplication routine
c --------------------------------------------- 
c 
      n1 = nxh 
      n2 = nyh 
      n3 = nzh 
      n1r = nxhr 
      n2r = nyhr 
      n3r = nzhr 
c
c compute the number of unknowns in the homogenization problem
c ------------------------------------------------------------
c
      nvalx = nxh * nxhr
      nvaly = nyh * nyhr
      nvalz = nzh * nzhr
      ntot = nxh * nyh * nzh
      nvar = nvalx * nvaly * nvalz
c
c compute the 2-d shifts for the 3-d case
c ---------------------------------------
c
      nvtemp = nvalx * nvaly
      nktemp = nxh * nyh
c
c compute the overall block size for use below
c --------------------------------------------
c
      if(nxh .eq. 1) then
        xvalm = 0.0
        xvalp = 1.0
      else
        xvalm = 1.5 * x(1) - 0.5 * x(2)
        xvalp = 1.5 * x(nxh) - 0.5 * x(nxh-1)
      end if
      if(nyh .eq. 1) then
        yvalm = 0.0
        yvalp = 1.0
      else
        yvalm = 1.5 * y(1) - 0.5 * y(2)
        yvalp = 1.5 * y(nyh) - 0.5 * y(nyh-1)
      end if
      if(nzh .eq. 1) then
        zvalm = 0.0
        zvalp = 1.0
      else
        zvalm = 1.5 * z(1) - 0.5 * z(2)
        zvalp = 1.5 * z(nzh) - 0.5 * z(nzh-1)
      end if
      cellsize = ( xvalp - xvalm ) * ( yvalp - yvalm )
     1               * ( zvalp - zvalm )
c
c compute the new cell center location
c ------------------------------------
c
      zx = 0.5 * ( xvalp + xvalm )
      zy = 0.5 * ( yvalp + yvalm )
      zz = 0.5 * ( zvalp + zvalm )
c
c get the maximum value in the arrays
c -----------------------------------
c
      call avgscal3(kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz,nxh,nyh,nzh
     1,eigmin,eigmax,scaleval)
c
c check for zero values in the diagonal entries
c ---------------------------------------------
c
      constant = 0.000001 * eigmax
      do 1 i=1,ntot
c
c sum up the absolute values of the entries
c -----------------------------------------
c
         sum = abs(kxx(i)) + abs(kxy(i)) + abs(kxz(i))
     1       + abs(kyx(i)) + abs(kyy(i)) + abs(kyz(i))
     1       + abs(kzx(i)) + abs(kzy(i)) + abs(kzz(i))
c
c check the sum
c -------------
c
         if(sum .lt. constant) then
           kxx(i) = constant
           kyy(i) = constant
           kzz(i) = constant
         end if
c
    1 continue
c
c scale the entries if necessary
c ------------------------------
c
      if(scaleval .le. .1 .or. scaleval .ge. 10.) then
        iscale = 1
        do 2 i=1,ntot
           kxx(i) = scaleval * kxx(i)
           kxy(i) = scaleval * kxy(i)
           kxz(i) = scaleval * kxz(i)
           kyx(i) = scaleval * kyx(i)
           kyy(i) = scaleval * kyy(i)
           kyz(i) = scaleval * kyz(i)
           kzx(i) = scaleval * kzx(i)
           kzy(i) = scaleval * kzy(i)
           kzz(i) = scaleval * kzz(i)
    2   continue
      end if
c
c now build the finite element matrix
c
c initialize the matrix
c ---------------------
c
      do 3 i=1,nvar
         hrhs(i,1) = 0.0
         hrhs(i,2) = 0.0
         hrhs(i,3) = 0.0
      do 3 j=1,27
         ha(i,j) = 0.0
    3 continue
c
c loop over the nodes in the third coordinate direction
c -----------------------------------------------------
c
      do 4 k=1,nvalz
         k2 = ( k - 1 ) * nvtemp
c
c get the third coordinate index location in the permeability grid
c ----------------------------------------------------------------
c
         indz = ( k + nzhr - 1 ) / nzhr
c
c compute the grid block size for the computational cell in z
c -----------------------------------------------------------
c
         if(nzh .eq. 1) then
           zvalm = 0.0
           zvalp = 1.0
         else
           if(indz .eq. 1) then
             zvalm = 1.5 * z(1) - 0.5 * z(2)
             zvalp = 0.5 * ( z(indz) + z(indz+1) )
           end if
           if(indz .gt. 1 .and. indz .lt. nzh) then
             zvalm = 0.5 * ( z(indz-1) + z(indz) )
             zvalp = 0.5 * ( z(indz) + z(indz+1) )
           end if
           if(indz .eq. nzh) then
             zvalm = 0.5 * ( z(indz-1) + z(indz) )
             zvalp = 1.5 * z(indz) - 0.5 * z(indz-1)
           end if
         end if
         delz = ( zvalp - zvalm ) / real(nzhr)
c
      do 4 j=1,nvaly
         j2 = ( j - 1 ) * nvalx
c
c get the second coordinate index location in the permeability grid
c -----------------------------------------------------------------
c
         indy = ( j + nyhr - 1 ) / nyhr
c
c compute the grid block size for the computational cell in y
c -----------------------------------------------------------
c
         if(nyh .eq. 1) then
           yvalm = 0.0
           yvalp = 1.0
         else
           if(indy .eq. 1) then
             yvalm = 1.5 * y(1) - 0.5 * y(2)
             yvalp = 0.5 * ( y(indy) + y(indy+1) )
           end if
           if(indy .gt. 1 .and. indy .lt. nyh) then
             yvalm = 0.5 * ( y(indy-1) + y(indy) )
             yvalp = 0.5 * ( y(indy) + y(indy+1) )
           end if
           if(indy .eq. nyh) then
             yvalm = 0.5 * ( y(indy-1) + y(indy) )
             yvalp = 1.5 * y(indy) - 0.5 * y(indy-1)
           end if
         end if
         dely = ( yvalp - yvalm ) / real(nyhr)
c
      do 4 i=1,nvalx
c
c get the first coordinate index location in the permeability grid
c ----------------------------------------------------------------
c
         indx = ( i + nxhr - 1 ) / nxhr
c
c compute the grid block size for the computational cell in x
c -----------------------------------------------------------
c
         if(nxh .eq. 1) then
           xvalm = 0.0
           xvalp = 1.0
         else
           if(indx .eq. 1) then
             xvalm = 1.5 * x(1) - 0.5 * x(2)
             xvalp = 0.5 * ( x(indx) + x(indx+1) )
           end if
           if(indx .gt. 1 .and. indx .lt. nxh) then
             xvalm = 0.5 * ( x(indx-1) + x(indx) )
             xvalp = 0.5 * ( x(indx) + x(indx+1) )
           end if
           if(indx .eq. nxh) then
             xvalm = 0.5 * ( x(indx-1) + x(indx) )
             xvalp = 1.5 * x(indx) - 0.5 * x(indx-1)
           end if
         end if
         delx = ( xvalp - xvalm ) / real(nxhr)
c
c assign the permeability values
c ------------------------------
c
         indprm = indx + ( indy - 1 ) * nxh + ( indz - 1 ) * nktemp
         rkxx = kxx(indprm)
         rkxy = kxy(indprm)
         rkxz = kxz(indprm)
         rkyx = kyx(indprm)
         rkyy = kyy(indprm)
         rkyz = kyz(indprm)
         rkzx = kzx(indprm)
         rkzy = kzy(indprm)
         rkzz = kzz(indprm)
c
c now compute the contribution to the diagonals for the cell
c
c compute the indices of the eight corners of the computational cell - the
c if statements are used to impose periodicity at the boundaries of the
c region
c ------
c
         ind1 = i + j2 + k2
         if(i .eq. nvalx) then
           ind2 = 1 + j2 + k2
         else
           ind2 = ind1 + 1
         end if
         if( j .eq. nvaly) then
           ind3 = i + k2
         else
           ind3 = ind1 + nvalx
         end if
         if(j .eq. nvaly) then
           if(i .eq. nvalx) then
             ind4 = 1 + k2
           else
             ind4 = i + 1 + k2
           end if
         else
           ind4 = ind2 + nvalx
         end if
         if(k .lt. nvalz) then
           ind5 = ind1 + nvtemp
           ind6 = ind2 + nvtemp
           ind7 = ind3 + nvtemp
           ind8 = ind4 + nvtemp
         else
           ind5 = i + j2
           if(i .eq. nvalx) then
             ind6 = 1 + j2
           else
             ind6 = ind5 + 1
           end if
           if(j .eq. nvaly) then
             ind7 = i
           else
             ind7 = ind5 + nvalx
           end if
           if(j .eq. nvaly) then
             if(i .eq. nvalx) then
               ind8 = 1
             else
               ind8 = i + 1
             end if
           else
             ind8 = ind6 + nvalx
           end if
         end if
c
c thirteenth sub-diagonal
c -----------------------
c
         ha(ind8,1) = ha(ind8,1)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c twelvth sub-diagonal
c --------------------
c
         ha(ind7,2) = ha(ind7,2)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind8,2) = ha(ind8,2)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c eleventh sub-diagonal
c ---------------------
c
         ha(ind7,3) = ha(ind7,3)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c tenth sub-diagonal
c ------------------
c
         ha(ind6,4) = ha(ind6,4)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind8,4) = ha(ind8,4)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c ninth sub-diagonal
c ------------------
c
         ha(ind5,5) = ha(ind5,5)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         ha(ind6,5) = ha(ind6,5)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         ha(ind7,5) = ha(ind7,5)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         ha(ind8,5) = ha(ind8,5)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
c eigth sub-diagonal
c ------------------
c
         ha(ind5,6) = ha(ind5,6)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind7,6) = ha(ind7,6)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c seventh sub-diagonal
c --------------------
c
         ha(ind6,7) = ha(ind6,7)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c sixth sub-diagonal
c ------------------
c
         ha(ind5,8) = ha(ind5,8)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind6,8) = ha(ind6,8)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c fifth sub-diagonal
c ------------------
c
         ha(ind5,9) = ha(ind5,9)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c fourth sub-diagonal
c -------------------
c
         ha(ind4,10) = ha(ind4,10)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
         ha(ind8,10) = ha(ind8,10)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c third sub-diagonal
c ------------------
c
         ha(ind3,11) = ha(ind3,11)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind4,11) = ha(ind4,11)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind7,11) = ha(ind7,11)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind8,11) = ha(ind8,11)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c second sub-diagonal
c -------------------
c
         ha(ind3,12) = ha(ind3,12)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
         ha(ind7,12) = ha(ind7,12)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c first sub-diagonal
c ------------------
c
         ha(ind2,13) = ha(ind2,13)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind4,13) = ha(ind4,13)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind6,13) = ha(ind6,13)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind8,13) = ha(ind8,13)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c main diagonal
c -------------
c
         ha(ind1,14) = ha(ind1,14)
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         ha(ind2,14) = ha(ind2,14) 
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         ha(ind3,14) = ha(ind3,14)
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         ha(ind4,14) = ha(ind4,14)
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         ha(ind5,14) = ha(ind5,14)
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         ha(ind6,14) = ha(ind6,14)
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         ha(ind7,14) = ha(ind7,14)
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         ha(ind8,14) = ha(ind8,14)
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
c first super-diagonal
c --------------------
c
         ha(ind1,15) = ha(ind1,15)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind3,15) = ha(ind3,15)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind5,15) = ha(ind5,15)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind7,15) = ha(ind7,15)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c second super-diagonal
c ---------------------
c
         ha(ind2,16) = ha(ind2,16)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
         ha(ind6,16) = ha(ind6,16)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c third super-diagonal
c --------------------
c
         ha(ind1,17) = ha(ind1,17)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind2,17) = ha(ind2,17)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind5,17) = ha(ind5,17)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind6,17) = ha(ind6,17)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c fourth super-diagonal
c ---------------------
c
         ha(ind1,18) = ha(ind1,18)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
         ha(ind5,18) = ha(ind5,18)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c fifth super-diagonal
c --------------------
c
         ha(ind4,19) = ha(ind4,19)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c sixth super-diagonal
c --------------------
c
         ha(ind3,20) = ha(ind3,20)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind4,20) = ha(ind4,20)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c seventh super-diagonal
c ----------------------
c
         ha(ind3,21) = ha(ind3,21)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c eigth super-diagonal
c --------------------
c
         ha(ind2,22) = ha(ind2,22)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind4,22) = ha(ind4,22)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c ninth super-diagonal
c --------------------
c
         ha(ind1,23) = ha(ind1,23)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         ha(ind2,23) = ha(ind2,23)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         ha(ind3,23) = ha(ind3,23)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         ha(ind4,23) = ha(ind4,23)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
c tenth super-diagonal
c --------------------
c
         ha(ind1,24) = ha(ind1,24)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         ha(ind3,24) = ha(ind3,24)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c eleventh super-diagonal
c -----------------------
c
         ha(ind2,25) = ha(ind2,25)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c twelvth super-diagonal
c ----------------------
c
         ha(ind1,26) = ha(ind1,26)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
         ha(ind2,26) = ha(ind2,26)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c thirteenth super-diagonal
c -------------------------
c
         ha(ind1,27) = ha(ind1,27)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c now get the two right hand side terms for the 24 effected equations
c -------------------------------------------------------------------
c
         hrhs(ind1,1) = hrhs(ind1,1)
     1         - ( - dely * delz * rkxx
     1             - delx * delz * rkyx
     1             - delx * dely * rkzx ) / 4.0
         hrhs(ind2,1) = hrhs(ind2,1)
     1         - (   dely * delz * rkxx
     1             - delx * delz * rkyx
     1             - delx * dely * rkzx ) / 4.0
         hrhs(ind3,1) = hrhs(ind3,1)
     1         - ( - dely * delz * rkxx
     1             + delx * delz * rkyx
     1             - delx * dely * rkzx ) / 4.0
         hrhs(ind4,1) = hrhs(ind4,1)
     1         - (   dely * delz * rkxx
     1             + delx * delz * rkyx
     1             - delx * dely * rkzx ) / 4.0
         hrhs(ind5,1) = hrhs(ind5,1)
     1         - ( - dely * delz * rkxx
     1             - delx * delz * rkyx
     1             + delx * dely * rkzx ) / 4.0
         hrhs(ind6,1) = hrhs(ind6,1)
     1         - (   dely * delz * rkxx
     1             - delx * delz * rkyx
     1             + delx * dely * rkzx ) / 4.0
         hrhs(ind7,1) = hrhs(ind7,1)
     1         - ( - dely * delz * rkxx
     1             + delx * delz * rkyx
     1             + delx * dely * rkzx ) / 4.0
         hrhs(ind8,1) = hrhs(ind8,1)
     1         - (   dely * delz * rkxx
     1             + delx * delz * rkyx
     1             + delx * dely * rkzx ) / 4.0
c
         hrhs(ind1,2) = hrhs(ind1,2)
     1         - ( - dely * delz * rkxy
     1             - delx * delz * rkyy
     1             - delx * dely * rkzy ) / 4.0
         hrhs(ind2,2) = hrhs(ind2,2)
     1         - (   dely * delz * rkxy
     1             - delx * delz * rkyy
     1             - delx * dely * rkzy ) / 4.0
         hrhs(ind3,2) = hrhs(ind3,2)
     1         - ( - dely * delz * rkxy
     1             + delx * delz * rkyy
     1             - delx * dely * rkzy ) / 4.0
         hrhs(ind4,2) = hrhs(ind4,2)
     1         - (   dely * delz * rkxy
     1             + delx * delz * rkyy
     1             - delx * dely * rkzy ) / 4.0
         hrhs(ind5,2) = hrhs(ind5,2)
     1         - ( - dely * delz * rkxy
     1             - delx * delz * rkyy
     1             + delx * dely * rkzy ) / 4.0
         hrhs(ind6,2) = hrhs(ind6,2)
     1         - (   dely * delz * rkxy
     1             - delx * delz * rkyy
     1             + delx * dely * rkzy ) / 4.0
         hrhs(ind7,2) = hrhs(ind7,2)
     1         - ( - dely * delz * rkxy
     1             + delx * delz * rkyy
     1             + delx * dely * rkzy ) / 4.0
         hrhs(ind8,2) = hrhs(ind8,2)
     1         - (   dely * delz * rkxy
     1             + delx * delz * rkyy
     1             + delx * dely * rkzy ) / 4.0
c
         hrhs(ind1,3) = hrhs(ind1,3)
     1         - ( - dely * delz * rkxz
     1             - delx * delz * rkyz
     1             - delx * dely * rkzz ) / 4.0
         hrhs(ind2,3) = hrhs(ind2,3)
     1         - (   dely * delz * rkxz
     1             - delx * delz * rkyz
     1             - delx * dely * rkzz ) / 4.0
         hrhs(ind3,3) = hrhs(ind3,3)
     1         - ( - dely * delz * rkxz
     1             + delx * delz * rkyz
     1             - delx * dely * rkzz ) / 4.0
         hrhs(ind4,3) = hrhs(ind4,3)
     1         - (   dely * delz * rkxz
     1             + delx * delz * rkyz
     1             - delx * dely * rkzz ) / 4.0
         hrhs(ind5,3) = hrhs(ind5,3)
     1         - ( - dely * delz * rkxz
     1             - delx * delz * rkyz
     1             + delx * dely * rkzz ) / 4.0
         hrhs(ind6,3) = hrhs(ind6,3)
     1         - (   dely * delz * rkxz
     1             - delx * delz * rkyz
     1             + delx * dely * rkzz ) / 4.0
         hrhs(ind7,3) = hrhs(ind7,3)
     1         - ( - dely * delz * rkxz
     1             + delx * delz * rkyz
     1             + delx * dely * rkzz ) / 4.0
         hrhs(ind8,3) = hrhs(ind8,3)
     1         - (   dely * delz * rkxz
     1             + delx * delz * rkyz
     1             + delx * dely * rkzz ) / 4.0
c
    4 continue
c
c process the matrix to make sure things close to zero are set to zero
c --------------------------------------------------------------------
c
      do 5 i=1,nvar
         if(abs(hrhs(i,1)) .lt. cutoff) hrhs(i,1) = 0.0
         if(abs(hrhs(i,2)) .lt. cutoff) hrhs(i,2) = 0.0
         if(abs(hrhs(i,3)) .lt. cutoff) hrhs(i,3) = 0.0
      do 5 j=1,27
         if(abs(ha(i,j)) .lt. cutoff) ha(i,j) = 0.0
    5 continue
c
c initialize the bit vector and initial guess for the iteration
c -------------------------------------------------------------
c
      do 6 i=1,nvar
         ibith(i) = 1
         h0(i) = 0.0
    6 continue
c
c solve the first system
c ----------------------
c
      call homcgmod(hamlt3,hx(1,1),h0,hrhs(1,1),nvar,ibith,cgeps
     1,cgthrshl,cgthrshu,ier)
c
c print an error message if the iterative method does not converge
c ----------------------------------------------------------------
c
      if(ier .eq. 102) then
        print *,' '
        print *,' ----- inside homogab3'
        print *,' '
        print *,' ***** maximum number of iterations has been exceeded'
        print *,' ***** in the iterative linear solver for the first '
        print *,' ***** linear system'
        print *,' '
        print *,' ----- '
        print *,' '
      end if
c
c reinitialize things
c -------------------
c
      do 7 i=1,nvar
         h0(i) = 0.0
    7 continue
c
c solve the second system
c -----------------------
c
      call homcgmod(hamlt3,hx(1,2),h0,hrhs(1,2),nvar,ibith,cgeps
     1,cgthrshl,cgthrshu,ier)
c
c print an error message if the iterative method does not converge
c ----------------------------------------------------------------
c
      if(ier .eq. 102) then
        print *,' '
        print *,' ----- inside homogab3'
        print *,' '
        print *,' ***** maximum number of iterations has been exceeded'
        print *,' ***** in the iterative linear solver for the second'
        print *,' ***** linear system'
        print *,' '
        print *,' ----- '
        print *,' '
      end if
c
c reinitialize things
c -------------------
c
      do 8 i=1,nvar
         h0(i) = 0.0
    8 continue
c
c solve the third system
c ----------------------
c
      call homcgmod(hamlt3,hx(1,3),h0,hrhs(1,3),nvar,ibith,cgeps
     1,cgthrshl,cgthrshu,ier)
c
c print an error message if the iterative method does not converge
c ----------------------------------------------------------------
c
      if(ier .eq. 102) then
        print *,' '
        print *,' ----- inside homogab3'
        print *,' '
        print *,' ***** maximum number of iterations has been exceeded'
        print *,' ***** in the iterative linear solver for the third'
        print *,' ***** linear system'
        print *,' '
        print *,' ----- '
        print *,' '
      end if
c
c check for only the solution process
c -----------------------------------
c
      if(iopt .ne. 0) return
c
c compute the average of the values using the energy method
c ---------------------------------------------------------
c
      call homavgorig(hx(1,1),hx(1,2),hx(1,3)
     1               ,kxx,kxy,kxz
     1               ,kyx,kyy,kyz
     1               ,kzx,kzy,kzz
     1               ,x,y,z
     1               ,nxh,nyh,nzh
     1               ,nxhr,nyhr,nzhr
     1               ,zkxx,zkxy,zkxz
     1               ,zkyx,zkyy,zkyz
     1               ,zkzx,zkzy,zkzz)
c
c check the symmetry of the output tensor - the code checks a relative error
c to the maximum eigenvalue of the tensors in the homogenization problem
c ----------------------------------------------------------------------
c
      isymmflag = 0
      if(abs(zkxy-zkyx) .gt. .000001 * eigmax) isymmflag = 1
      if(abs(zkxz-zkzx) .gt. .000001 * eigmax) isymmflag = 1
      if(abs(zkzy-zkyz) .gt. .000001 * eigmax) isymmflag = 1
      if(isymmflag .eq. 1) then
        print *,' '
        print *,' ----- inside homogab3' 
        print *,' '
        print *,' ***** symmetry has been lost in the output tensor'
        print *,' '
        print *,' ***** zkxy = ',zkxy
        print *,' ***** zkyx = ',zkyx
        print *,' '
        print *,' ***** zkxz = ',zkxz
        print *,' ***** zkzx = ',zkzx
        print *,' '
        print *,' ***** zkyz = ',zkyz
        print *,' ***** zkzy = ',zkzy
        print *,' '
        print *,' ----- '
        print *,' '
      end if
c
c this piece is just to force symmetry - as long as the error is not too bad
c --------------------------------------------------------------------------
c
      zkxy = 0.5 * ( zkxy + zkyx )
      zkyx = zkxy
      zkxz = 0.5 * ( zkxz + zkzx )
      zkzx = zkxz
      zkyz = 0.5 * ( zkyz + zkzy )
      zkzy = zkyz
c
c rescale the values
c ------------------
c
      if(iscale .eq. 1) then
c
c the output value
c ----------------
c
        zkxx = zkxx / scaleval
        zkxy = zkxy / scaleval
        zkxz = zkxz / scaleval
        zkyx = zkyx / scaleval
        zkyy = zkyy / scaleval
        zkyz = zkyz / scaleval
        zkzx = zkzx / scaleval
        zkzy = zkzy / scaleval
        zkzz = zkzz / scaleval
c
c the input values 
c ---------------- 
c
        do 11 i=1,ntot
           kxx(i) = kxx(i) / scaleval
           kxy(i) = kxy(i) / scaleval
           kxz(i) = kxz(i) / scaleval
           kyx(i) = kyx(i) / scaleval
           kyy(i) = kyy(i) / scaleval
           kyz(i) = kyz(i) / scaleval
           kzx(i) = kzx(i) / scaleval
           kzy(i) = kzy(i) / scaleval
           kzz(i) = kzz(i) / scaleval
   11   continue
c
      end if
c
      return
      end
      subroutine homogba3(kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz,x,y,z
     1,nxh,nyh,nzh,nxhr,nyhr,nzhr,zkxx,zkxy,zkxz,zkyx
     1,zkyy,zkyz,zkzx,zkzy,zkzz,zx,zy,zz,iopt)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine is a black box routine that takes nodal values of
c the arrays kxx, kxy, kxz, kyx, kyy, kyz, kzx, kzy, and kzz that are defined
c in some rectangular region in three-dimensional space and returns the
c homogenized value in the region.
c
c the arrays are tensor values in the 3-d tensor
c
c                 [  kxx    kxy   kxz  ]
c                 [                    ]
c             K = [  kyx    kyy   kyz  ]
c                 [                    ]
c                 [  kzx    kzy   kzz  ]
c
c the homogenization is that used in papers by Amaziane and Bourgeat
c
c input
c
c   kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz - one-dimensional tensors (in x first)
c                   giving the values of the tensor at the centers of the cells
c                   in the region considered.
c   x,y,z - the coordinates of the cell centers.
c   nxh,nyh,nzh - the number of grid blocks in the coordinate directions
c   nxhr,nyhr,nzhr - the number of refinements to take on each grid block
c
c output
c
c   zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz - real values that are the
c                   effective or homogenized values in a constant tensor
c                   defined over the entire region
c
c                              [  zkxx    zkxy  zkxz  ]
c                          #   [                      ]
c                         K  = [  zkyx   zkyy   zkyz  ]
c                              [                      ]
c                              [  zkzx   zkzy   zkzz  ]
c
c                   where # is used as in the literature to denote the
c                   homogenized tensor.
c   zx,zy,zz - real values with the center of the homogenized cell returned.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/homog_common.h'
      real kxx(*),kxy(*),kxz(*)
      real kyx(*),kyy(*),kyz(*)
      real kzx(*),kzy(*),kzz(*)
      real x(*),y(*),z(*)
      real zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz
      real zx,zy,zz
c
c the matrix multiplication routine
c ---------------------------------
c
      common /hmatmlt3/ n1,n2,n3,n1r,n2r,n3r
      external hamlt3
c
c set some constants for use below
c --------------------------------
c
      data cutoff,cgeps,cgthrshl,cgthrshu
     1          / 0.0000001,0.00001,0.01,100.0 /

c
c check the number of heterogeneous grid blocks and set to at least one
c ---------------------------------------------------------------------
c
      if(nxh .le. 0) nxh = 1
      if(nyh .le. 0) nyh = 1
      if(nzh .le. 0) nzh = 1
      if(nxhr .le. 0) nxhr = 1
      if(nyhr .le. 0) nyhr = 1
      if(nzhr .le. 0) nzhr = 1
c
c set the scaling flag
c --------------------
c
      iscale = 0
c
c set the values for the multiplication routine
c --------------------------------------------- 
c 
      n1 = nxh 
      n2 = nyh 
      n3 = nzh 
      n1r = nxhr 
      n2r = nyhr 
      n3r = nzhr 
c
c compute the number of unknowns in the homogenization problem
c ------------------------------------------------------------
c
      nvalx = nxh * nxhr
      nvaly = nyh * nyhr
      nvalz = nzh * nzhr
      ntot = nxh * nyh * nzh
      nvar = nvalx * nvaly * nvalz
c
c compute the 2-d shifts for the 3-d case
c ---------------------------------------
c
      nvtemp = nvalx * nvaly
      nktemp = nxh * nyh
c
c compute the overall block size for use below
c --------------------------------------------
c
      if(nxh .eq. 1) then
        xvalm = 0.0
        xvalp = 1.0
      else
        xvalm = 1.5 * x(1) - 0.5 * x(2)
        xvalp = 1.5 * x(nxh) - 0.5 * x(nxh-1)
      end if
      if(nyh .eq. 1) then
        yvalm = 0.0
        yvalp = 1.0
      else
        yvalm = 1.5 * y(1) - 0.5 * y(2)
        yvalp = 1.5 * y(nyh) - 0.5 * y(nyh-1)
      end if
      if(nzh .eq. 1) then
        zvalm = 0.0
        zvalp = 1.0
      else
        zvalm = 1.5 * z(1) - 0.5 * z(2)
        zvalp = 1.5 * z(nzh) - 0.5 * z(nzh-1)
      end if
      cellsize = ( xvalp - xvalm ) * ( yvalp - yvalm )
     1               * ( zvalp - zvalm )
c
c compute the new cell center location
c ------------------------------------
c
      zx = 0.5 * ( xvalp + xvalm )
      zy = 0.5 * ( yvalp + yvalm )
      zz = 0.5 * ( zvalp + zvalm )
c
c get the maximum value in the arrays
c -----------------------------------
c
      call avgscal3(kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz,nxh,nyh,nzh
     1,eigmin,eigmax,scaleval)
c
c check for zero values in the diagonal entries
c ---------------------------------------------
c
      constant = 0.000001 * eigmax
      do 1 i=1,ntot
c
c sum up the absolute values of the entries
c -----------------------------------------
c
         sum = abs(kxx(i)) + abs(kxy(i)) + abs(kxz(i))
     1       + abs(kyx(i)) + abs(kyy(i)) + abs(kyz(i))
     1       + abs(kzx(i)) + abs(kzy(i)) + abs(kzz(i))
c
c check the sum
c -------------
c
         if(sum .lt. constant) then
           kxx(i) = constant
           kyy(i) = constant
           kzz(i) = constant
         end if
c
    1 continue
c
c scale the entries if necessary
c ------------------------------
c
      if(scaleval .le. .1 .or. scaleval .ge. 10.) then
        iscale = 1
        do 2 i=1,ntot
           kxx(i) = scaleval * kxx(i)
           kxy(i) = scaleval * kxy(i)
           kxz(i) = scaleval * kxz(i)
           kyx(i) = scaleval * kyx(i)
           kyy(i) = scaleval * kyy(i)
           kyz(i) = scaleval * kyz(i)
           kzx(i) = scaleval * kzx(i)
           kzy(i) = scaleval * kzy(i)
           kzz(i) = scaleval * kzz(i)
    2   continue
      end if
c
c now build the finite element matrix
c
c initialize the matrix
c ---------------------
c
      do 3 i=1,nvar
         hrhs(i,1) = 0.0
         hrhs(i,2) = 0.0
         hrhs(i,3) = 0.0
      do 3 j=1,27
         ha(i,j) = 0.0
    3 continue
c
c loop over the nodes in the third coordinate direction
c -----------------------------------------------------
c
      do 4 k=1,nvalz
         k2 = ( k - 1 ) * nvtemp
c
c get the third coordinate index location in the permeability grid
c ----------------------------------------------------------------
c
         indz = ( k + nzhr - 1 ) / nzhr
c
c compute the grid block size for the computational cell in z
c -----------------------------------------------------------
c
         if(nzh .eq. 1) then
           zvalm = 0.0
           zvalp = 1.0
         else
           if(indz .eq. 1) then
             zvalm = 1.5 * z(1) - 0.5 * z(2)
             zvalp = 0.5 * ( z(indz) + z(indz+1) )
           end if
           if(indz .gt. 1 .and. indz .lt. nzh) then
             zvalm = 0.5 * ( z(indz-1) + z(indz) )
             zvalp = 0.5 * ( z(indz) + z(indz+1) )
           end if
           if(indz .eq. nzh) then
             zvalm = 0.5 * ( z(indz-1) + z(indz) )
             zvalp = 1.5 * z(indz) - 0.5 * z(indz-1)
           end if
         end if
         delz = ( zvalp - zvalm ) / real(nzhr)
c
      do 4 j=1,nvaly
         j2 = ( j - 1 ) * nvalx
c
c get the second coordinate index location in the permeability grid
c -----------------------------------------------------------------
c
         indy = ( j + nyhr - 1 ) / nyhr
c
c compute the grid block size for the computational cell in y
c -----------------------------------------------------------
c
         if(nyh .eq. 1) then
           yvalm = 0.0
           yvalp = 1.0
         else
           if(indy .eq. 1) then
             yvalm = 1.5 * y(1) - 0.5 * y(2)
             yvalp = 0.5 * ( y(indy) + y(indy+1) )
           end if
           if(indy .gt. 1 .and. indy .lt. nyh) then
             yvalm = 0.5 * ( y(indy-1) + y(indy) )
             yvalp = 0.5 * ( y(indy) + y(indy+1) )
           end if
           if(indy .eq. nyh) then
             yvalm = 0.5 * ( y(indy-1) + y(indy) )
             yvalp = 1.5 * y(indy) - 0.5 * y(indy-1)
           end if
         end if
         dely = ( yvalp - yvalm ) / real(nyhr)
c
      do 4 i=1,nvalx
c
c get the first coordinate index location in the permeability grid
c ----------------------------------------------------------------
c
         indx = ( i + nxhr - 1 ) / nxhr
c
c compute the grid block size for the computational cell in x
c -----------------------------------------------------------
c
         if(nxh .eq. 1) then
           xvalm = 0.0
           xvalp = 1.0
         else
           if(indx .eq. 1) then
             xvalm = 1.5 * x(1) - 0.5 * x(2)
             xvalp = 0.5 * ( x(indx) + x(indx+1) )
           end if
           if(indx .gt. 1 .and. indx .lt. nxh) then
             xvalm = 0.5 * ( x(indx-1) + x(indx) )
             xvalp = 0.5 * ( x(indx) + x(indx+1) )
           end if
           if(indx .eq. nxh) then
             xvalm = 0.5 * ( x(indx-1) + x(indx) )
             xvalp = 1.5 * x(indx) - 0.5 * x(indx-1)
           end if
         end if
         delx = ( xvalp - xvalm ) / real(nxhr)
c
c assign the permeability values
c ------------------------------
c
         indprm = indx + ( indy - 1 ) * nxh + ( indz - 1 ) * nktemp
         rkxx = kxx(indprm)
         rkxy = kxy(indprm)
         rkxz = kxz(indprm)
         rkyx = kyx(indprm)
         rkyy = kyy(indprm)
         rkyz = kyz(indprm)
         rkzx = kzx(indprm)
         rkzy = kzy(indprm)
         rkzz = kzz(indprm)
c
c now compute the contribution to the diagonals for the cell
c
c compute the indices of the eight corners of the computational cell - the
c if statements are used to impose periodicity at the boundaries of the
c region
c ------
c
         ind1 = i + j2 + k2
         if(i .eq. nvalx) then
           ind2 = 1 + j2 + k2
         else
           ind2 = ind1 + 1
         end if
         if( j .eq. nvaly) then
           ind3 = i + k2
         else
           ind3 = ind1 + nvalx
         end if
         if(j .eq. nvaly) then
           if(i .eq. nvalx) then
             ind4 = 1 + k2
           else
             ind4 = i + 1 + k2
           end if
         else
           ind4 = ind2 + nvalx
         end if
         if(k .lt. nvalz) then
           ind5 = ind1 + nvtemp
           ind6 = ind2 + nvtemp
           ind7 = ind3 + nvtemp
           ind8 = ind4 + nvtemp
         else
           ind5 = i + j2
           if(i .eq. nvalx) then
             ind6 = 1 + j2
           else
             ind6 = ind5 + 1
           end if
           if(j .eq. nvaly) then
             ind7 = i
           else
             ind7 = ind5 + nvalx
           end if
           if(j .eq. nvaly) then
             if(i .eq. nvalx) then
               ind8 = 1
             else
               ind8 = i + 1
             end if
           else
             ind8 = ind6 + nvalx
           end if
         end if
c
c thirteenth sub-diagonal
c -----------------------
c
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .lt. nvalz)
     1   ha(ind8,1) = ha(ind8,1)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c twelvth sub-diagonal
c --------------------
c
         if(i .gt. 1 .and. j .lt. nvaly .and. k .lt. nvalz)
     1   ha(ind7,2) = ha(ind7,2)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .lt. nvalz)
     1   ha(ind8,2) = ha(ind8,2)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c eleventh sub-diagonal
c ---------------------
c
         if(i .gt. 1 .and. j .lt. nvaly .and. k .lt. nvalz)
     1   ha(ind7,3) = ha(ind7,3)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c tenth sub-diagonal
c ------------------
c
         if(i .lt. nvalx .and. j .gt. 1 .and. k .lt. nvalz)
     1   ha(ind6,4) = ha(ind6,4)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .lt. nvalz)
     1   ha(ind8,4) = ha(ind8,4)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c ninth sub-diagonal
c ------------------
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .lt. nvalz)
     1   ha(ind5,5) = ha(ind5,5)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         if(i .lt. nvalx .and. j .gt. 1 .and. k .lt. nvalz)
     1   ha(ind6,5) = ha(ind6,5)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         if(i .gt. 1 .and. j .lt. nvaly .and. k .lt. nvalz)
     1   ha(ind7,5) = ha(ind7,5)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .lt. nvalz)
     1   ha(ind8,5) = ha(ind8,5)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
c eigth sub-diagonal
c ------------------
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .lt. nvalz)
     1   ha(ind5,6) = ha(ind5,6)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .gt. 1 .and. j .lt. nvaly .and. k .lt. nvalz)
     1   ha(ind7,6) = ha(ind7,6)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c seventh sub-diagonal
c --------------------
c
         if(i .lt. nvalx .and. j .gt. 1 .and. k .lt. nvalz)
     1   ha(ind6,7) = ha(ind6,7)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c sixth sub-diagonal
c ------------------
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .lt. nvalz)
     1   ha(ind5,8) = ha(ind5,8)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .lt. nvalx .and. j .gt. 1 .and. k .lt. nvalz)
     1   ha(ind6,8) = ha(ind6,8)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c fifth sub-diagonal
c ------------------
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .lt. nvalz)
     1   ha(ind5,9) = ha(ind5,9)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c fourth sub-diagonal
c -------------------
c
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .gt. 1)
     1   ha(ind4,10) = ha(ind4,10)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .lt. nvalz)
     1   ha(ind8,10) = ha(ind8,10)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c third sub-diagonal
c ------------------
c
         if(i .gt. 1 .and. j .lt. nvaly .and. k .gt. 1)
     1   ha(ind3,11) = ha(ind3,11)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .gt. 1)
     1   ha(ind4,11) = ha(ind4,11)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .gt. 1 .and. j .lt. nvaly .and. k .lt. nvalz)
     1   ha(ind7,11) = ha(ind7,11)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .lt. nvalz)
     1   ha(ind8,11) = ha(ind8,11)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c second sub-diagonal
c -------------------
c
         if(i .gt. 1 .and. j .lt. nvaly .and. k .gt. 1)
     1   ha(ind3,12) = ha(ind3,12)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
         if(i .gt. 1 .and. j .lt. nvaly .and. k .lt. nvalz)
     1   ha(ind7,12) = ha(ind7,12)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c first sub-diagonal
c ------------------
c
         if(i .lt. nvalx .and. j .gt. 1 .and. k .gt. 1)
     1   ha(ind2,13) = ha(ind2,13)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .gt. 1)
     1   ha(ind4,13) = ha(ind4,13)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .lt. nvalx .and. j .gt. 1 .and. k .lt. nvalz)
     1   ha(ind6,13) = ha(ind6,13)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .lt. nvalz)
     1   ha(ind8,13) = ha(ind8,13)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c main diagonal
c -------------
c
c         if(i .gt. 1 .and. j .gt. 1 .and. k .gt. 1)
         ha(ind1,14) = ha(ind1,14)
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
c         if(i .lt. nvalx .and. j .gt. 1 .and. k .gt. 1)
         ha(ind2,14) = ha(ind2,14) 
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
c         if(i .gt. 1 .and. j .lt. nvaly .and. k .gt. 1)
         ha(ind3,14) = ha(ind3,14)
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
c         if(i .lt. nvalx .and. j .lt. nvaly .and. k .gt. 1)
         ha(ind4,14) = ha(ind4,14)
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
c         if(i .gt. 1 .and. j .gt. 1 .and. k .lt. nvalz)
         ha(ind5,14) = ha(ind5,14)
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
c         if(i .lt. nvalx .and. j .gt. 1 .and. k .lt. nvalz)
         ha(ind6,14) = ha(ind6,14)
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
c         if(i .gt. 1 .and. j .lt. nvaly .and. k .lt. nvalz)
         ha(ind7,14) = ha(ind7,14)
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
c         if(i .lt. nvalx .and. j .lt. nvaly .and. k .lt. nvalz)
         ha(ind8,14) = ha(ind8,14)
     1         + ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
c first super-diagonal
c --------------------
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .gt. 1)
     1   ha(ind1,15) = ha(ind1,15)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .gt. 1 .and. j .lt. nvaly .and. k .gt. 1)
     1   ha(ind3,15) = ha(ind3,15)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .lt. nvalz)
     1   ha(ind5,15) = ha(ind5,15)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .gt. 1 .and. j .lt. nvaly .and. k .lt. nvalz)
     1   ha(ind7,15) = ha(ind7,15)
     1         - ( dely * delz * rkxx ) / ( 9.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 12.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c second super-diagonal
c ---------------------
c
         if(i .lt. nvalx .and. j .gt. 1 .and. k .gt. 1)
     1   ha(ind2,16) = ha(ind2,16)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
         if(i .lt. nvalx .and. j .gt. 1 .and. k .lt. nvalz)
     1   ha(ind6,16) = ha(ind6,16)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c third super-diagonal
c --------------------
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .gt. 1)
     1   ha(ind1,17) = ha(ind1,17)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .lt. nvalx .and. j .gt. 1 .and. k .gt. 1)
     1   ha(ind2,17) = ha(ind2,17)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .lt. nvalz)
     1   ha(ind5,17) = ha(ind5,17)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .lt. nvalx .and. j .gt. 1 .and. k .lt. nvalz)
     1   ha(ind6,17) = ha(ind6,17)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 9.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         + ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c fourth super-diagonal
c ---------------------
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .gt. 1)
     1   ha(ind1,18) = ha(ind1,18)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .lt. nvalz)
     1   ha(ind5,18) = ha(ind5,18)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 12.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 12.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         + ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c fifth super-diagonal
c --------------------
c
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .gt. 1)
     1   ha(ind4,19) = ha(ind4,19)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c sixth super-diagonal
c --------------------
c
         if(i .gt. 1 .and. j .lt. nvaly .and. k .gt. 1)
     1   ha(ind3,20) = ha(ind3,20)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .gt. 1)
     1   ha(ind4,20) = ha(ind4,20)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c seventh super-diagonal
c ----------------------
c
         if(i .gt. 1 .and. j .lt. nvaly .and. k .gt. 1)
     1   ha(ind3,21) = ha(ind3,21)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c eigth super-diagonal
c --------------------
c
         if(i .lt. nvalx .and. j .gt. 1 .and. k .gt. 1)
     1   ha(ind2,22) = ha(ind2,22)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .gt. 1)
     1   ha(ind4,22) = ha(ind4,22)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c ninth super-diagonal
c --------------------
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .gt. 1)
     1   ha(ind1,23) = ha(ind1,23)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         if(i .lt. nvalx .and. j .gt. 1 .and. k .gt. 1)
     1   ha(ind2,23) = ha(ind2,23)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         if(i .gt. 1 .and. j .lt. nvaly .and. k .gt. 1)
     1   ha(ind3,23) = ha(ind3,23)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .gt. 1)
     1   ha(ind4,23) = ha(ind4,23)
     1         + ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         + ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 9.0 * delz ) 
c
c tenth super-diagonal
c --------------------
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .gt. 1)
     1   ha(ind1,24) = ha(ind1,24)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         - ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         + ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
         if(i .gt. 1 .and. j .lt. nvaly .and. k .gt. 1)
     1   ha(ind3,24) = ha(ind3,24)
     1         - ( dely * delz * rkxx ) / ( 18.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 12.0
     1         + ( delz * rkyx ) / 24.0 
     1         + ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         + ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 12.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c eleventh super-diagonal
c -----------------------
c
         if(i .lt. nvalx .and. j .gt. 1 .and. k .gt. 1)
     1   ha(ind2,25) = ha(ind2,25)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c twelvth super-diagonal
c ----------------------
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .gt. 1)
     1   ha(ind1,26) = ha(ind1,26)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         + ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         + ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
         if(i .lt. nvalx .and. j .gt. 1 .and. k .gt. 1)
     1   ha(ind2,26) = ha(ind2,26)
     1         + ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         + ( delz * rkxy ) / 24.0
     1         + ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 18.0 * dely ) 
     1         - ( delx * rkyz ) / 12.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 12.0
     1         - ( delx * dely * rkzz ) / ( 18.0 * delz ) 
c
c thirteenth super-diagonal
c -------------------------
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .gt. 1)
     1   ha(ind1,27) = ha(ind1,27)
     1         - ( dely * delz * rkxx ) / ( 36.0 * delx ) 
     1         - ( delz * rkxy ) / 24.0
     1         - ( dely * rkxz ) / 24.0
     1         - ( delz * rkyx ) / 24.0 
     1         - ( delx * delz * rkyy ) / ( 36.0 * dely ) 
     1         - ( delx * rkyz ) / 24.0
     1         - ( dely * rkzx ) / 24.0
     1         - ( delx * rkzy ) / 24.0
     1         - ( delx * dely * rkzz ) / ( 36.0 * delz ) 
c
c now get the two right hand side terms for the 24 effected equations
c -------------------------------------------------------------------
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .gt. 1)
     1   hrhs(ind1,1) = hrhs(ind1,1)
     1         - ( - dely * delz * rkxx
     1             - delx * delz * rkyx
     1             - delx * dely * rkzx ) / 4.0
         if(i .lt. nvalx .and. j .gt. 1 .and. k .gt. 1)
     1   hrhs(ind2,1) = hrhs(ind2,1)
     1         - (   dely * delz * rkxx
     1             - delx * delz * rkyx
     1             - delx * dely * rkzx ) / 4.0
         if(i .gt. 1 .and. j .lt. nvaly .and. k .gt. 1)
     1   hrhs(ind3,1) = hrhs(ind3,1)
     1         - ( - dely * delz * rkxx
     1             + delx * delz * rkyx
     1             - delx * dely * rkzx ) / 4.0
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .gt. 1)
     1   hrhs(ind4,1) = hrhs(ind4,1)
     1         - (   dely * delz * rkxx
     1             + delx * delz * rkyx
     1             - delx * dely * rkzx ) / 4.0
         if(i .gt. 1 .and. j .gt. 1 .and. k .lt. nvalz)
     1   hrhs(ind5,1) = hrhs(ind5,1)
     1         - ( - dely * delz * rkxx
     1             - delx * delz * rkyx
     1             + delx * dely * rkzx ) / 4.0
         if(i .lt. nvalx .and. j .gt. 1 .and. k .lt. nvalz)
     1   hrhs(ind6,1) = hrhs(ind6,1)
     1         - (   dely * delz * rkxx
     1             - delx * delz * rkyx
     1             + delx * dely * rkzx ) / 4.0
         if(i .gt. 1 .and. j .lt. nvaly .and. k .lt. nvalz)
     1   hrhs(ind7,1) = hrhs(ind7,1)
     1         - ( - dely * delz * rkxx
     1             + delx * delz * rkyx
     1             + delx * dely * rkzx ) / 4.0
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .lt. nvalz)
     1   hrhs(ind8,1) = hrhs(ind8,1)
     1         - (   dely * delz * rkxx
     1             + delx * delz * rkyx
     1             + delx * dely * rkzx ) / 4.0
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .gt. 1)
     1   hrhs(ind1,2) = hrhs(ind1,2)
     1         - ( - dely * delz * rkxy
     1             - delx * delz * rkyy
     1             - delx * dely * rkzy ) / 4.0
         if(i .lt. nvalx .and. j .gt. 1 .and. k .gt. 1)
     1   hrhs(ind2,2) = hrhs(ind2,2)
     1         - (   dely * delz * rkxy
     1             - delx * delz * rkyy
     1             - delx * dely * rkzy ) / 4.0
         if(i .gt. 1 .and. j .lt. nvaly .and. k .gt. 1)
     1   hrhs(ind3,2) = hrhs(ind3,2)
     1         - ( - dely * delz * rkxy
     1             + delx * delz * rkyy
     1             - delx * dely * rkzy ) / 4.0
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .gt. 1)
     1   hrhs(ind4,2) = hrhs(ind4,2)
     1         - (   dely * delz * rkxy
     1             + delx * delz * rkyy
     1             - delx * dely * rkzy ) / 4.0
         if(i .gt. 1 .and. j .gt. 1 .and. k .lt. nvalz)
     1   hrhs(ind5,2) = hrhs(ind5,2)
     1         - ( - dely * delz * rkxy
     1             - delx * delz * rkyy
     1             + delx * dely * rkzy ) / 4.0
         if(i .lt. nvalx .and. j .gt. 1 .and. k .lt. nvalz)
     1   hrhs(ind6,2) = hrhs(ind6,2)
     1         - (   dely * delz * rkxy
     1             - delx * delz * rkyy
     1             + delx * dely * rkzy ) / 4.0
         if(i .gt. 1 .and. j .lt. nvaly .and. k .lt. nvalz)
     1   hrhs(ind7,2) = hrhs(ind7,2)
     1         - ( - dely * delz * rkxy
     1             + delx * delz * rkyy
     1             + delx * dely * rkzy ) / 4.0
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .lt. nvalz)
     1   hrhs(ind8,2) = hrhs(ind8,2)
     1         - (   dely * delz * rkxy
     1             + delx * delz * rkyy
     1             + delx * dely * rkzy ) / 4.0
c
         if(i .gt. 1 .and. j .gt. 1 .and. k .gt. 1)
     1   hrhs(ind1,3) = hrhs(ind1,3)
     1         - ( - dely * delz * rkxz
     1             - delx * delz * rkyz
     1             - delx * dely * rkzz ) / 4.0
         if(i .lt. nvalx .and. j .gt. 1 .and. k .gt. 1)
     1   hrhs(ind2,3) = hrhs(ind2,3)
     1         - (   dely * delz * rkxz
     1             - delx * delz * rkyz
     1             - delx * dely * rkzz ) / 4.0
         if(i .gt. 1 .and. j .lt. nvaly .and. k .gt. 1)
     1   hrhs(ind3,3) = hrhs(ind3,3)
     1         - ( - dely * delz * rkxz
     1             + delx * delz * rkyz
     1             - delx * dely * rkzz ) / 4.0
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .gt. 1)
     1   hrhs(ind4,3) = hrhs(ind4,3)
     1         - (   dely * delz * rkxz
     1             + delx * delz * rkyz
     1             - delx * dely * rkzz ) / 4.0
         if(i .gt. 1 .and. j .gt. 1 .and. k .lt. nvalz)
     1   hrhs(ind5,3) = hrhs(ind5,3)
     1         - ( - dely * delz * rkxz
     1             - delx * delz * rkyz
     1             + delx * dely * rkzz ) / 4.0
         if(i .lt. nvalx .and. j .gt. 1 .and. k .lt. nvalz)
     1   hrhs(ind6,3) = hrhs(ind6,3)
     1         - (   dely * delz * rkxz
     1             - delx * delz * rkyz
     1             + delx * dely * rkzz ) / 4.0
         if(i .gt. 1 .and. j .lt. nvaly .and. k .lt. nvalz)
     1   hrhs(ind7,3) = hrhs(ind7,3)
     1         - ( - dely * delz * rkxz
     1             + delx * delz * rkyz
     1             + delx * dely * rkzz ) / 4.0
         if(i .lt. nvalx .and. j .lt. nvaly .and. k .lt. nvalz)
     1   hrhs(ind8,3) = hrhs(ind8,3)
     1         - (   dely * delz * rkxz
     1             + delx * delz * rkyz
     1             + delx * dely * rkzz ) / 4.0
c
    4 continue
c
c process the matrix to make sure things close to zero are set to zero
c --------------------------------------------------------------------
c
      do 5 i=1,nvar
         if(abs(hrhs(i,1)) .lt. cutoff) hrhs(i,1) = 0.0
         if(abs(hrhs(i,2)) .lt. cutoff) hrhs(i,2) = 0.0
         if(abs(hrhs(i,3)) .lt. cutoff) hrhs(i,3) = 0.0
      do 5 j=1,27
         if(abs(ha(i,j)) .lt. cutoff) ha(i,j) = 0.0
    5 continue
c
c initialize the bit vector and initial guess for the iteration
c -------------------------------------------------------------
c
      do 6 i=1,nvar
         ibith(i) = 1
         h0(i) = 0.0
    6 continue
c
c solve the first system
c ----------------------
c
      call homcgmod(hamlt3,hx(1,1),h0,hrhs(1,1),nvar,ibith,cgeps
     1,cgthrshl,cgthrshu,ier)
c
c print an error message if the iterative method does not converge
c ----------------------------------------------------------------
c
      if(ier .eq. 102) then
        print *,' '
        print *,' ----- inside homogab3'
        print *,' '
        print *,' ***** maximum number of iterations has been exceeded'
        print *,' ***** in the iterative linear solver for the first '
        print *,' ***** linear system'
        print *,' '
        print *,' ----- '
        print *,' '
      end if
c
c reinitialize things
c -------------------
c
      do 7 i=1,nvar
         h0(i) = 0.0
    7 continue
c
c solve the second system
c -----------------------
c
      call homcgmod(hamlt3,hx(1,2),h0,hrhs(1,2),nvar,ibith,cgeps
     1,cgthrshl,cgthrshu,ier)
c
c print an error message if the iterative method does not converge
c ----------------------------------------------------------------
c
      if(ier .eq. 102) then
        print *,' '
        print *,' ----- inside homogab3'
        print *,' '
        print *,' ***** maximum number of iterations has been exceeded'
        print *,' ***** in the iterative linear solver for the second'
        print *,' ***** linear system'
        print *,' '
        print *,' ----- '
        print *,' '
      end if
c
c reinitialize things
c -------------------
c
      do 8 i=1,nvar
         h0(i) = 0.0
    8 continue
c
c solve the third system
c ----------------------
c
      call homcgmod(hamlt3,hx(1,3),h0,hrhs(1,3),nvar,ibith,cgeps
     1,cgthrshl,cgthrshu,ier)
c
c print an error message if the iterative method does not converge
c ----------------------------------------------------------------
c
      if(ier .eq. 102) then
        print *,' '
        print *,' ----- inside homogab3'
        print *,' '
        print *,' ***** maximum number of iterations has been exceeded'
        print *,' ***** in the iterative linear solver for the third'
        print *,' ***** linear system'
        print *,' '
        print *,' ----- '
        print *,' '
      end if
c
c check for only the solution process
c -----------------------------------
c
      if(iopt .ne. 0) return
c
c finally compute the average value based on the finite element solution
c
c initialize the equivalent values
c --------------------------------
c
      zkxx = 0.0
      zkxy = 0.0
      zkxz = 0.0
      zkyx = 0.0
      zkyy = 0.0
      zkyz = 0.0
      zkzx = 0.0
      zkzy = 0.0
      zkzz = 0.0
c
c loop over the third coordinate
c ------------------------------
c
      do 9 k=1,nvalz
         k2 = ( k - 1 ) * nvtemp
c
c get the third coordinate index location in the permeability grid
c ----------------------------------------------------------------
c
         indz = ( k + nzhr - 1 ) / nzhr
c
c compute the grid block size for the computational cell in z
c -----------------------------------------------------------
c
         if(nzh .eq. 1) then
           zvalm = 0.0
           zvalp = 1.0
         else
           if(indz .eq. 1) then
             zvalm = 1.5 * z(1) - 0.5 * z(2)
             zvalp = 0.5 * ( z(indz) + z(indz+1) )
           end if
           if(indz .gt. 1 .and. indz .lt. nzh) then
             zvalm = 0.5 * ( z(indz-1) + z(indz) )
             zvalp = 0.5 * ( z(indz) + z(indz+1) )
           end if
           if(indz .eq. nzh) then
             zvalm = 0.5 * ( z(indz-1) + z(indz) )
             zvalp = 1.5 * z(indz) - 0.5 * z(indz-1)
           end if
         end if
         delz = ( zvalp - zvalm ) / real(nzhr)
c
c loop over the second coordinate
c -------------------------------
c
      do 9 j=1,nvaly
         j2 = ( j - 1 ) * nvalx
c
c get the second coordinate index location in the permeability grid
c -----------------------------------------------------------------
c
         indy = ( j + nyhr - 1 ) / nyhr
c
c compute the grid block size for the computational cell in y
c -----------------------------------------------------------
c
         if(nyh .eq. 1) then
           yvalm = 0.0
           yvalp = 1.0
         else
           if(indy .eq. 1) then
             yvalm = 1.5 * y(1) - 0.5 * y(2)
             yvalp = 0.5 * ( y(indy) + y(indy+1) )
           end if
           if(indy .gt. 1 .and. indy .lt. nyh) then
             yvalm = 0.5 * ( y(indy-1) + y(indy) )
             yvalp = 0.5 * ( y(indy) + y(indy+1) )
           end if
           if(indy .eq. nyh) then
             yvalm = 0.5 * ( y(indy-1) + y(indy) )
             yvalp = 1.5 * y(indy) - 0.5 * y(indy-1)
           end if
         end if
         dely = ( yvalp - yvalm ) / real(nyhr)
c
      do 9 i=1,nvalx
c
c get the first coordinate index location in the permeability grid
c ----------------------------------------------------------------
c
         indx = ( i + nxhr - 1 ) / nxhr
c
c compute the grid block size for the computational cell in x
c -----------------------------------------------------------
c
         if(nxh .eq. 1) then
           xvalm = 0.0
           xvalp = 1.0
         else
           if(indx .eq. 1) then
             xvalm = 1.5 * x(1) - 0.5 * x(2)
             xvalp = 0.5 * ( x(indx) + x(indx+1) )
           end if
           if(indx .gt. 1 .and. indx .lt. nxh) then
             xvalm = 0.5 * ( x(indx-1) + x(indx) )
             xvalp = 0.5 * ( x(indx) + x(indx+1) )
           end if
           if(indx .eq. nxh) then
             xvalm = 0.5 * ( x(indx-1) + x(indx) )
             xvalp = 1.5 * x(indx) - 0.5 * x(indx-1)
           end if
         end if
         delx = ( xvalp - xvalm ) / real(nxhr)
c
c compute the volume of the current cell
c --------------------------------------
c
         del = delx * dely * delz
c
c assign the permeability values
c ------------------------------
c
         indprm = indx + ( indy - 1 ) * nxh + ( indz - 1 ) * nktemp
         rkxx = kxx(indprm)
         rkxy = kxy(indprm)
         rkxz = kxz(indprm)
         rkyx = kyx(indprm)
         rkyy = kyy(indprm)
         rkyz = kyz(indprm)
         rkzx = kzx(indprm)
         rkzy = kzy(indprm)
         rkzz = kzz(indprm)
c
c now compute the contribution to the diagonals for the cell
c
c compute the indices of the eight corners of the computational cell - the
c if statements are used to impose periodicity at the boundaries of the
c region
c ------
c
         ind1 = i + j2 + k2
         if(i .eq. nvalx) then
           ind2 = 1 + j2 + k2
         else
           ind2 = ind1 + 1
         end if
         if( j .eq. nvaly) then
           ind3 = i + k2
         else
           ind3 = ind1 + nvalx
         end if
         if(j .eq. nvaly) then
           if(i .eq. nvalx) then
             ind4 = 1 + k2
           else
             ind4 = i + 1 + k2
           end if
         else
           ind4 = ind2 + nvalx
         end if
         if(k .lt. nvalz) then
           ind5 = ind1 + nvtemp
           ind6 = ind2 + nvtemp
           ind7 = ind3 + nvtemp
           ind8 = ind4 + nvtemp
         else
           ind5 = i + j2
           if(i .eq. nvalx) then
             ind6 = 1 + j2
           else
             ind6 = ind5 + 1
           end if
           if(j .eq. nvaly) then
             ind7 = i
           else
             ind7 = ind5 + nvalx
           end if
           if(j .eq. nvaly) then
             if(i .eq. nvalx) then
               ind8 = 1
             else
               ind8 = i + 1
             end if
           else
             ind8 = ind6 + nvalx
           end if
         end if
c
c compute the simple average partial derivatives in the three component
c directions
c ----------
c
         dw1dx = 0.25 * ( hx(ind2,1) - hx(ind1,1)
     1                  + hx(ind4,1) - hx(ind3,1)
     1                  + hx(ind6,1) - hx(ind5,1)
     1                  + hx(ind8,1) - hx(ind7,1) ) / delx
         dw2dx = 0.25 * ( hx(ind2,2) - hx(ind1,2)
     1                  + hx(ind4,2) - hx(ind3,2)
     1                  + hx(ind6,2) - hx(ind5,2)
     1                  + hx(ind8,2) - hx(ind7,2) ) / delx
         dw3dx = 0.25 * ( hx(ind2,3) - hx(ind1,3)
     1                  + hx(ind4,3) - hx(ind3,3)
     1                  + hx(ind6,3) - hx(ind5,3)
     1                  + hx(ind8,3) - hx(ind7,3) ) / delx
c
         dw1dy = 0.25 * ( hx(ind3,1) - hx(ind1,1)
     1                  + hx(ind4,1) - hx(ind2,1)
     1                  + hx(ind7,1) - hx(ind5,1)
     1                  + hx(ind8,1) - hx(ind6,1) ) / dely
         dw2dy = 0.25 * ( hx(ind3,2) - hx(ind1,2)
     1                  + hx(ind4,2) - hx(ind2,2)
     1                  + hx(ind7,2) - hx(ind5,2)
     1                  + hx(ind8,2) - hx(ind6,2) ) / dely
         dw3dy = 0.25 * ( hx(ind3,3) - hx(ind1,3)
     1                  + hx(ind4,3) - hx(ind2,3)
     1                  + hx(ind7,3) - hx(ind5,3)
     1                  + hx(ind8,3) - hx(ind6,3) ) / dely
c
         dw1dz = 0.25 * ( hx(ind5,1) - hx(ind1,1)
     1                  + hx(ind6,1) - hx(ind2,1)
     1                  + hx(ind7,1) - hx(ind3,1)
     1                  + hx(ind8,1) - hx(ind4,1) ) / delz
         dw2dz = 0.25 * ( hx(ind5,2) - hx(ind1,2)
     1                  + hx(ind6,2) - hx(ind2,2)
     1                  + hx(ind7,2) - hx(ind3,2)
     1                  + hx(ind8,2) - hx(ind4,2) ) / delz
         dw3dz = 0.25 * ( hx(ind5,3) - hx(ind1,3)
     1                  + hx(ind6,3) - hx(ind2,3)
     1                  + hx(ind7,3) - hx(ind3,3)
     1                  + hx(ind8,3) - hx(ind4,3) ) / delz
c
c add to the respective terms
c ---------------------------
c
         zkxx = zkxx + del
     1         * ( rkxx + rkxx * dw1dx + rkxy * dw1dy + rkxz * dw1dz )
c
         zkyx = zkyx + del
     1         * ( rkyx + rkyx * dw1dx + rkyy * dw1dy + rkyz * dw1dz )
c
         zkzx = zkzx + del
     1         * ( rkzx + rkzx * dw1dx + rkzy * dw1dy + rkzz * dw1dz )
c
         zkxy = zkxy + del
     1         * ( rkxx * dw2dx + rkxy + rkxy * dw2dy + rkxz * dw2dz )
c
         zkyy = zkyy + del
     1         * ( rkyx * dw2dx + rkyy + rkyy * dw2dy + rkyz * dw2dz )
c
         zkzy = zkzy + del
     1         * ( rkzx * dw2dx + rkzy + rkzy * dw2dy + rkzz * dw2dz )
c
         zkxz = zkxz + del
     1         * ( rkxx * dw3dx + rkxy * dw3dy + rkxz + rkxz * dw3dz )
c
         zkyz = zkyz + del
     1         * ( rkyx * dw3dx + rkyy * dw3dy + rkyz + rkyz * dw3dz )
c
         zkzz = zkzz + del
     1         * ( rkzx * dw3dx + rkzy * dw3dy + rkzz + rkzz * dw3dz )
c
    9 continue
c
c divide through by the cell size
c -------------------------------
c
      zkxx = zkxx / cellsize
      zkxy = zkxy / cellsize
      zkxz = zkxz / cellsize
      zkyx = zkyx / cellsize
      zkyy = zkyy / cellsize
      zkyz = zkyz / cellsize
      zkzx = zkzx / cellsize
      zkzy = zkzy / cellsize
      zkzz = zkzz / cellsize
c
c check the symmetry of the output tensor - the code checks a relative error
c to the maximum eigenvalue of the tensors in the homogenization problem
c ----------------------------------------------------------------------
c
      isymmflag = 0
      if(abs(zkxy-zkyx) .gt. .000001 * eigmax) isymmflag = 1
      if(abs(zkxz-zkzx) .gt. .000001 * eigmax) isymmflag = 1
      if(abs(zkzy-zkyz) .gt. .000001 * eigmax) isymmflag = 1
      if(isymmflag .eq. 1) then
        print *,' '
        print *,' ----- inside homogab3' 
        print *,' '
        print *,' ***** symmetry has been lost in the output tensor'
        print *,' '
        print *,' ***** zkxy = ',zkxy
        print *,' ***** zkyx = ',zkyx
        print *,' '
        print *,' ***** zkxz = ',zkxz
        print *,' ***** zkzx = ',zkzx
        print *,' '
        print *,' ***** zkyz = ',zkyz
        print *,' ***** zkzy = ',zkzy
        print *,' '
        print *,' ----- '
        print *,' '
      end if
c
c this piece is just to force symmetry - as long as the error is not too bad
c --------------------------------------------------------------------------
c
      zkxy = 0.5 * ( zkxy + zkyx )
      zkyx = zkxy
      zkxz = 0.5 * ( zkxz + zkzx )
      zkzx = zkxz
      zkyz = 0.5 * ( zkyz + zkzy )
      zkzy = zkyz
c
c rescale the values
c ------------------
c
      if(iscale .eq. 1) then
c
c the output value
c ----------------
c
        zkxx = zkxx / scaleval
        zkxy = zkxy / scaleval
        zkxz = zkxz / scaleval
        zkyx = zkyx / scaleval
        zkyy = zkyy / scaleval
        zkyz = zkyz / scaleval
        zkzx = zkzx / scaleval
        zkzy = zkzy / scaleval
        zkzz = zkzz / scaleval
c
c the input values 
c ---------------- 
c
        do 11 i=1,ntot
           kxx(i) = kxx(i) / scaleval
           kxy(i) = kxy(i) / scaleval
           kxz(i) = kxz(i) / scaleval
           kyx(i) = kyx(i) / scaleval
           kyy(i) = kyy(i) / scaleval
           kyz(i) = kyz(i) / scaleval
           kzx(i) = kzx(i) / scaleval
           kzy(i) = kzy(i) / scaleval
           kzz(i) = kzz(i) / scaleval
   11   continue
c
      end if
c
      return
      end
      subroutine hommfeap3(kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz,x,y,z
     1,nxh,nyh,nzh,nxhr,nyhr,nzhr,zkxx,zkxy,zkxz,zkyx
     1,zkyy,zkyz,zkzx,zkzy,zkzz,zx,zy,zz,iopt)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c this the the mixed finite element method version of the homogenization
c stuff. the mfe code is used to handle internal boundary conditions where
c fluxes can be specified.
c
c written by: joe koebbe
c
c   this routine is a black box routine that takes nodal values of the arrays
c kxx, kxy, kxz, kyx, kyy, kyz, kzx, kzy, and kzz that are defined in some
c rectangular region in three-dimensional space and returns the homogenized
c value in the region.
c
c the arrays are tensor values in the 3-d tensor
c
c                 [  kxx    kxy   kxz  ]
c                 [                    ] 
c             K = [  kyx    kyy   kyz  ]
c                 [                    ] 
c                 [  kzx    kzy   kzz  ]
c
c the homogenization is that used in papers by Amaziane and Bourgeat
c
c input
c
c   kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz - one-dimensional tensors (in x first)
c                   giving the values of the tensor at the centers of the cells
c                   in the region considered.
c   x,y,z - the coordinates of the cell centers.
c   nxh,nyh,nzh - the number of grid blocks in the coordinate directions
c   nxhr,nyhr,nzhr - the number of refinements to take on each grid block
c
c output
c
c   zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz - real values that are the
c                   effective or homogenized values in a constant tensor
c                   defined over the entire region
c
c                              [  zkxx    zkxy  zkxz  ]
c                          #   [                      ]  
c                         K  = [  zkyx   zkyy   zkyz  ]
c                              [                      ]  
c                              [  zkzx   zkzy   zkzz  ]
c
c                   where # is used as in the literature to denote the
c                   homogenized tensor.
c   zx,zy,zz - real values with the center of the homogenized cell returned.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
c
c set up the local storage for the block of permeabilities
c --------------------------------------------------------
c
      real kxx(*),kxy(*),kxz(*)
      real kyx(*),kyy(*),kyz(*)
      real kzx(*),kzy(*),kzz(*)
      real x(*),y(*),z(*)
      real zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz
      real zx,zy,zz
c
c declare the external matrix multiplication routine
c --------------------------------------------------
c
      external hommfemmm
c
c translate the input information into the common blocks - the grid, refinements
c etc...
c
c number of grid blocks
c ---------------------
c
      nxhommfe = nxh
      nyhommfe = nyh
      nzhommfe = nzh
c
c compute the total number of homogenization blocks for temporary use here
c ------------------------------------------------------------------------
c
      nnhommfe = nxh * nyh * nzh
c
c cell centers
c ------------
c
      do 1 i=1,nxh
         xhommfe(i) = x(i)
    1 continue
      do 2 j=1,nyh
         yhommfe(j) = y(j)
    2 continue
      do 3 k=1,nzh
         zhommfe(k) = z(k)
    3 continue
c
c perm values
c -----------
c
      do 4 i=1,nnhommfe
         hommfekxx(i) = kxx(i)
         hommfekxy(i) = kxy(i)
         hommfekxz(i) = kxz(i)
         hommfekyx(i) = kyx(i)
         hommfekyy(i) = kyy(i)
         hommfekyz(i) = kyz(i)
         hommfekzx(i) = kzx(i)
         hommfekzy(i) = kzy(i)
         hommfekzz(i) = kzz(i)
    4 continue
c
c set up the grid for the cell
c ----------------------------
c
      call hommfemesh
c
c check for a refinement in one of the coordinate directions
c ----------------------------------------------------------
c
      if(nxhr .gt. 1 .or. nyhr .gt. 1 .or. nzhr .gt. 1)
     1                           call hommferef(nxhr,nyhr,nzhr)
c
c compute the fixed locations in the grid to be mapped out of the calculation
c ---------------------------------------------------------------------------
c
      call hommfeapfixed
c
c compute the matrix for the homogenization equations - note that as in the
c previous code using standard finite element methods the matrix only needs to
c be computed once.
c -----------------
c
      call hommfematrix
c
c go through each of the three solutions
c
c compute the right hand side for the first system of equations
c -------------------------------------------------------------
c
      call hommfeapbndrhs
c
c initialize the solution arrays
c ------------------------------
c
      do 5 i=1,nnhommfe
         w(i,1) = 0.0
         w(i,2) = 0.0
         w(i,3) = 0.0
    5 continue
      do 6 i=1,nnhommfevx
         hommfevelx(i,1) = 0.0
         hommfevelx(i,2) = 0.0
         hommfevelx(i,3) = 0.0
    6 continue
      do 7 i=1,nnhommfevy
         hommfevely(i,1) = 0.0
         hommfevely(i,2) = 0.0
         hommfevely(i,3) = 0.0
    7 continue
      do 8 i=1,nnhommfevz
         hommfevelz(i,1) = 0.0
         hommfevelz(i,2) = 0.0
         hommfevelz(i,3) = 0.0
    8 continue
c
c call the homogenization solution routine for the systems of equations
c ---------------------------------------------------------------------
c
      if(nxhommfe .gt. 1) call hommfeapsoln(1)
      if(nyhommfe .gt. 1) call hommfeapsoln(2)
      do 95 i=1,nnhommfe
      print *,i,w(i,1),w(i,2)
   95 continue
      print *,'solution in hommfeap3'
      read(5,*)
      if(nzhommfe .gt. 1) call hommfeapsoln(3)
c
c check for breaking out of the code before computing the averages
c ----------------------------------------------------------------
c
c      if(iopt .ne. 0) return
c
c compute the average of the values using the energy method
c ---------------------------------------------------------
c
      call homavggrad(kxx,kxy,kxz
     1               ,kyx,kyy,kyz
     1               ,kzx,kzy,kzz
     1               ,x,y,z
     1               ,nxh,nyh,nzh
     1               ,nxhr,nyhr,nzhr
     1               ,zkxx,zkxy,zkxz
     1               ,zkyx,zkyy,zkyz
     1               ,zkzx,zkzy,zkzz)
      print *,zkxx,zkxy,zkxz
      print *,zkyx,zkyy,zkyz
      print *,zkzx,zkzy,zkzz
      print *,'homavggrad'
      read(5,*)
      call homavggradap(kxx,kxy,kxz
     1               ,kyx,kyy,kyz
     1               ,kzx,kzy,kzz
     1               ,x,y,z
     1               ,nxh,nyh,nzh
     1               ,nxhr,nyhr,nzhr
     1               ,zkxx,zkxy,zkxz
     1               ,zkyx,zkyy,zkyz
     1               ,zkzx,zkzy,zkzz)
      print *,zkxx,zkxy,zkxz
      print *,zkyx,zkyy,zkyz
      print *,zkzx,zkzy,zkzz
      print *,'homavggradap'
      read(5,*)
c
      return
      end
      subroutine hrmncavg3(kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz,x,y,z
     1,nxh,nyh,nzh,zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz,zx,zy
     1,zz)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine is a black box routine that takes evenly spaced values of
c the arrays kxx, kxy, kxz, kyx, kyy, kyz, kzx, kzy, and kzz that are defined
c in some rectangular region in three-dimensional space and returns the
c harmonic average value in the region.
c
c the arrays are tensor values in the 3-d tensor
c
c                 [  kxx    kxy   kxz  ]
c                 [                    ]  
c             K = [  kyx    kyy   kyz  ]
c                 [                    ]  
c                 [  kzx    kzy   kzz  ]
c
c input  
c
c   kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz - one-dimensional tensors (in x first)
c                   giving the values of the tensor at the centers of the cells
c                   in the region considered.
c   x,y,z - the coordinates of the cell centers.
c
c output 
c
c   zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz - real values that are the
c                   effective or harmonic average values in a constant tensor
c                   defined over the entire region
c
c                              [  zkxx    zkxy  zkxz  ]
c                          H   [                      ]   
c                         K  = [  zkyx   zkyy   zkyz  ]
c                              [                      ]   
c                              [  zkzx   zkzy   zkzz  ]
c
c                   where # is used as in the literature to denote the
c                   averaged tensor.
c   zx,zy,zz - real values with the center of the homogenized cell returned.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/homog_common.h'
      real kxx(*),kxy(*),kxz(*)
      real kyx(*),kyy(*),kyz(*)
      real kzx(*),kzy(*),kzz(*)
      real x(*),y(*),z(*)
      real zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz
      real zx,zy,zz
c
c set some factors for later use
c ------------------------------
c
      facx = 1.0
      facxy = 1.0
      facxz = 1.0
      facyx = 1.0
      facy = 1.0
      facyz = 1.0
      faczx = 1.0
      faczy = 1.0
      facz = 1.0
c
c check the number of heterogeneous grid blocks and set to at least one
c ---------------------------------------------------------------------
c
      if(nxh .le. 0) nxh = 1
      if(nyh .le. 0) nyh = 1
      if(nzh .le. 0) nzh = 1
c
c compute the 2-d shifts for the 3-d case
c ---------------------------------------
c
      nvtemp = nxh * nyh
c
c compute the overall block size for use below
c --------------------------------------------
c
      if(nxh .eq. 1) then
        xvalm = 0.0
        xvalp = 1.0
      else
        xvalm = 1.5 * x(1) - 0.5 * x(2)
        xvalp = 1.5 * x(nxh) - 0.5 * x(nxh-1)
      end if
      if(nyh .eq. 1) then
        yvalm = 0.0
        yvalp = 1.0
      else
        yvalm = 1.5 * y(1) - 0.5 * y(2)
        yvalp = 1.5 * y(nyh) - 0.5 * y(nyh-1)
      end if
      if(nzh .eq. 1) then
        zvalm = 0.0
        zvalp = 1.0
      else
        zvalm = 1.5 * z(1) - 0.5 * z(2)
        zvalp = 1.5 * z(nzh) - 0.5 * z(nzh-1)
      end if
      cellsize = ( xvalp - xvalm ) * ( yvalp - yvalm )
     1               * ( zvalp - zvalm )
c
c compute the new cell center location
c ------------------------------------
c
      zx = 0.5 * ( xvalp + xvalm )
      zy = 0.5 * ( yvalp + yvalm )
      zz = 0.5 * ( zvalp + zvalm )
c
c add up the values
c -----------------
c
      sumxx = 0.0
      sumxy = 0.0
      sumxz = 0.0
      sumyx = 0.0
      sumyy = 0.0
      sumyz = 0.0
      sumzx = 0.0
      sumzy = 0.0
      sumzz = 0.0
c
c loop over the nodes in the third coordinate direction
c -----------------------------------------------------
c
      do 1 k=1,nzh
         k2 = ( k - 1 ) * nvtemp
c
c compute the grid block size for the computational cell in z
c -----------------------------------------------------------
c
         if(nzh .eq. 1) then
           zvalm = 0.0
           zvalp = 1.0
         else
           if(k .eq. 1) then
             zvalm = 1.5 * z(1) - 0.5 * z(2)
             zvalp = 0.5 * ( z(k) + z(k+1) )
           end if
           if(k .gt. 1 .and. k .lt. nzh) then
             zvalm = 0.5 * ( z(k-1) + z(k) )
             zvalp = 0.5 * ( z(k) + z(k+1) )
           end if
           if(k .eq. nzh) then
             zvalm = 0.5 * ( z(k-1) + z(k) )
             zvalp = 1.5 * z(k) - 0.5 * z(k-1)
           end if
         end if
         delz = ( zvalp - zvalm )
c
      do 1 j=1,nyh
         j2 = ( j - 1 ) * nxh + k2
c
c compute the grid block size for the computational cell in y
c -----------------------------------------------------------
c
         if(nyh .eq. 1) then
           yvalm = 0.0
           yvalp = 1.0
         else
           if(j .eq. 1) then
             yvalm = 1.5 * y(1) - 0.5 * y(2)
             yvalp = 0.5 * ( y(j) + y(j+1) )
           end if
           if(j .gt. 1 .and. j .lt. nyh) then
             yvalm = 0.5 * ( y(j-1) + y(j) )
             yvalp = 0.5 * ( y(j) + y(j+1) )
           end if
           if(j .eq. nyh) then
             yvalm = 0.5 * ( y(j-1) + y(j) )
             yvalp = 1.5 * y(j) - 0.5 * y(j-1)
           end if
         end if
         dely = ( yvalp - yvalm )
c
      do 1 i=1,nxh
         ind = i + j2
c
c compute the grid block size for the computational cell in x
c -----------------------------------------------------------
c
         if(nxh .eq. 1) then
           xvalm = 0.0
           xvalp = 1.0
         else
           if(i .eq. 1) then
             xvalm = 1.5 * x(1) - 0.5 * x(2)
             xvalp = 0.5 * ( x(i) + x(i+1) )
           end if
           if(i .gt. 1 .and. i .lt. nxh) then
             xvalm = 0.5 * ( x(i-1) + x(i) )
             xvalp = 0.5 * ( x(i) + x(i+1) )
           end if
           if(i .eq. nxh) then
             xvalm = 0.5 * ( x(i-1) + x(i) )
             xvalp = 1.5 * x(i) - 0.5 * x(i-1)
           end if
         end if
         delx = ( xvalp - xvalm )
c
c compute the cell block size
c ---------------------------
c
         blksize = delx * dely * delz
c
c check for a zero value
c ----------------------
c
         if(kxx(ind) .ne. 0.0) then
           sumxx = sumxx + blksize / kxx(ind)
         else
           facx = 0.0
         end if
c
         if(kxy(ind) .ne. 0.0) then
           sumxy = sumxy + blksize / kxy(ind)
         else
           facxy = 0.0
         end if
c
         if(kxz(ind) .ne. 0.0) then
           sumxz = sumxz + blksize / kxz(ind)
         else
           facxz = 0.0
         end if
c          
         if(kyx(ind) .ne. 0.0) then
           sumyx = sumyx + blksize / kyx(ind)
         else
           facyx = 0.0
         end if
c          
         if(kyy(ind) .ne. 0.0) then
           sumyy = sumyy + blksize / kyy(ind)
         else
           facy = 0.0
         end if
c          
         if(kyz(ind) .ne. 0.0) then
           sumyz = sumyz + blksize / kyz(ind)
         else
           facyz = 0.0
         end if
c          
         if(kzx(ind) .ne. 0.0) then
           sumzx = sumzx + blksize / kzx(ind)
         else
           faczx = 0.0
         end if
c          
         if(kzy(ind) .ne. 0.0) then
           sumzy = sumzy + blksize / kzy(ind)
         else
           faczy = 0.0
         end if
c          
         if(kzz(ind) .ne. 0.0) then
           sumzz = sumzz + blksize / kzz(ind)
         else
           facz = 0.0
         end if
c
    1 continue
c
c compute the averages
c --------------------
c
      if(facx .ne. 0) then
        zkxx  = cellsize / sumxx
      else
        zkxx = 0
      end if
      if(facxy .ne. 0) then
        zkxy = cellsize / sumxy
      else
        zkxy = 0
      end if
      if(facyx .ne. 0) then
        zkyx = cellsize / sumyx
      else
        zkyx = 0
      end if
      if(facxz .ne. 0) then
        zkxz = cellsize / sumxz
      else
        zkxz = 0
      end if
      if(facy .ne. 0) then
        zkyy = cellsize / sumyy
      else
        zkyy = 0
      end if
      if(facyz .ne. 0) then
        zkyz = cellsize / sumyz
      else
        zkyz = 0
      end if
      if(faczx .ne. 0) then
        zkzx  = cellsize / sumzx
      else
        zkzx = 0
      end if
      if(faczy .ne. 0) then
        zkzy  = cellsize / sumzy
      else
        zkzy = 0
      end if
      if(facz .ne. 0) then
        zkzz  = cellsize / sumzz
      else
        zkzz = 0
      end if
c
      return
      end
      subroutine homavgorig(w1,w2,w3,kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy
     1,kzz,x,y,z,nxh,nyh,nzh,nxhr,nyhr,nzhr,zkxx,zkxy,zkxz,zkyx,zkyy
     1,zkyz,zkzx,zkzy,zkzz)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine computes the average using the solution values in the mfe
c version of the homogenization code
c
c input
c
c   w1,w2,w3 - the nodal values of the three functions produced in the solution
c              of the system of elliptic equations in the homogenization.
c   kxx, etc. - the array of permeability values
c   x,y,z - the location of the cell centers in the mesh
c   nxh,nyh,nzh - the number of grid blocks in each direction
c   nxhr,nyhr,nzhr - the number of grid block refinements in each direction
c
c output
c
c   zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz - the average values for the
c            tensor.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
      real w1(*),w2(*),w3(*)
      real kxx(*),kxy(*),kxz(*)
      real kyx(*),kyy(*),kyz(*)
      real kzx(*),kzy(*),kzz(*)
      real x(*),y(*),z(*)
      real zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz
c
c finally compute the average value based on the finite element solution
c
c initialize the equivalent values
c --------------------------------
c
      zkxx = 0.0
      zkxy = 0.0
      zkxz = 0.0
      zkyx = 0.0
      zkyy = 0.0
      zkyz = 0.0
      zkzx = 0.0
      zkzy = 0.0
      zkzz = 0.0
c
c compute the overall block size for use below
c --------------------------------------------
c
      if(nxh .eq. 1) then
        xvalm = 0.0
        xvalp = 1.0
      else
        xvalm = 1.5 * x(1) - 0.5 * x(2)
        xvalp = 1.5 * x(nxh) - 0.5 * x(nxh-1)
      end if
      if(nyh .eq. 1) then
        yvalm = 0.0
        yvalp = 1.0
      else
        yvalm = 1.5 * y(1) - 0.5 * y(2)
        yvalp = 1.5 * y(nyh) - 0.5 * y(nyh-1)
      end if
      if(nzh .eq. 1) then
        zvalm = 0.0
        zvalp = 1.0
      else
        zvalm = 1.5 * z(1) - 0.5 * z(2)
        zvalp = 1.5 * z(nzh) - 0.5 * z(nzh-1)
      end if
      cellsize = ( xvalp - xvalm ) * ( yvalp - yvalm )
     1               * ( zvalp - zvalm )
c
c compute the number of unknowns in the homogenization problem
c ------------------------------------------------------------
c
      nvalx = nxh * nxhr
      nvaly = nyh * nyhr
      nvalz = nzh * nzhr
      ntot = nxh * nyh * nzh
      nvar = nvalx * nvaly * nvalz
c
c compute the 2-d shifts for the 3-d case
c ---------------------------------------
c
      nvtemp = nvalx * nvaly
      nktemp = nxh * nyh
c
c loop over the third coordinate
c ------------------------------
c
      do 9 k=1,nvalz
         k2 = ( k - 1 ) * nvtemp
c
c get the third coordinate index location in the permeability grid
c ----------------------------------------------------------------
c
         indz = ( k + nzhr - 1 ) / nzhr
c
c compute the grid block size for the computational cell in z
c -----------------------------------------------------------
c
         if(nzh .eq. 1) then
           zvalm = 0.0
           zvalp = 1.0
         else
           if(indz .eq. 1) then
             zvalm = 1.5 * z(1) - 0.5 * z(2)
             zvalp = 0.5 * ( z(indz) + z(indz+1) )
           end if
           if(indz .gt. 1 .and. indz .lt. nzh) then
             zvalm = 0.5 * ( z(indz-1) + z(indz) )
             zvalp = 0.5 * ( z(indz) + z(indz+1) )
           end if
           if(indz .eq. nzh) then
             zvalm = 0.5 * ( z(indz-1) + z(indz) )
             zvalp = 1.5 * z(indz) - 0.5 * z(indz-1)
           end if
         end if
         delz = ( zvalp - zvalm ) / real(nzhr)
c
c loop over the second coordinate
c -------------------------------
c
      do 9 j=1,nvaly
         j2 = ( j - 1 ) * nvalx
c
c get the second coordinate index location in the permeability grid
c -----------------------------------------------------------------
c
         indy = ( j + nyhr - 1 ) / nyhr
c
c compute the grid block size for the computational cell in y
c -----------------------------------------------------------
c
         if(nyh .eq. 1) then
           yvalm = 0.0
           yvalp = 1.0
         else
           if(indy .eq. 1) then
             yvalm = 1.5 * y(1) - 0.5 * y(2)
             yvalp = 0.5 * ( y(indy) + y(indy+1) )
           end if
           if(indy .gt. 1 .and. indy .lt. nyh) then
             yvalm = 0.5 * ( y(indy-1) + y(indy) )
             yvalp = 0.5 * ( y(indy) + y(indy+1) )
           end if
           if(indy .eq. nyh) then
             yvalm = 0.5 * ( y(indy-1) + y(indy) )
             yvalp = 1.5 * y(indy) - 0.5 * y(indy-1)
           end if
         end if
         dely = ( yvalp - yvalm ) / real(nyhr)
c
      do 9 i=1,nvalx
c
c get the first coordinate index location in the permeability grid
c ----------------------------------------------------------------
c
         indx = ( i + nxhr - 1 ) / nxhr
c
c compute the grid block size for the computational cell in x
c -----------------------------------------------------------
c
         if(nxh .eq. 1) then
           xvalm = 0.0
           xvalp = 1.0
         else
           if(indx .eq. 1) then
             xvalm = 1.5 * x(1) - 0.5 * x(2)
             xvalp = 0.5 * ( x(indx) + x(indx+1) )
           end if
           if(indx .gt. 1 .and. indx .lt. nxh) then
             xvalm = 0.5 * ( x(indx-1) + x(indx) )
             xvalp = 0.5 * ( x(indx) + x(indx+1) )
           end if
           if(indx .eq. nxh) then
             xvalm = 0.5 * ( x(indx-1) + x(indx) )
             xvalp = 1.5 * x(indx) - 0.5 * x(indx-1)
           end if
         end if
         delx = ( xvalp - xvalm ) / real(nxhr)
c
c compute the volume of the current cell
c --------------------------------------
c
         del = delx * dely * delz
c
c assign the permeability values
c ------------------------------
c
         indprm = indx + ( indy - 1 ) * nxh + ( indz - 1 ) * nktemp
         rkxx = kxx(indprm)
         rkxy = kxy(indprm)
         rkxz = kxz(indprm)
         rkyx = kyx(indprm)
         rkyy = kyy(indprm)
         rkyz = kyz(indprm)
         rkzx = kzx(indprm)
         rkzy = kzy(indprm)
         rkzz = kzz(indprm)
c
c now compute the contribution to the diagonals for the cell
c
c compute the indices of the eight corners of the computational cell - the
c if statements are used to impose periodicity at the boundaries of the
c region
c ------
c
         ind1 = i + j2 + k2
         if(i .eq. nvalx) then
           ind2 = 1 + j2 + k2
         else
           ind2 = ind1 + 1
         end if
         if( j .eq. nvaly) then
           ind3 = i + k2
         else
           ind3 = ind1 + nvalx
         end if
         if(j .eq. nvaly) then
           if(i .eq. nvalx) then
             ind4 = 1 + k2
           else
             ind4 = i + 1 + k2
           end if
         else
           ind4 = ind2 + nvalx
         end if
         if(k .lt. nvalz) then
           ind5 = ind1 + nvtemp
           ind6 = ind2 + nvtemp
           ind7 = ind3 + nvtemp
           ind8 = ind4 + nvtemp
         else
           ind5 = i + j2
           if(i .eq. nvalx) then
             ind6 = 1 + j2
           else
             ind6 = ind5 + 1
           end if
           if(j .eq. nvaly) then
             ind7 = i
           else
             ind7 = ind5 + nvalx
           end if
           if(j .eq. nvaly) then
             if(i .eq. nvalx) then
               ind8 = 1
             else
               ind8 = i + 1
             end if
           else
             ind8 = ind6 + nvalx
           end if
         end if
c
c compute the simple average partial derivatives in the three component
c directions
c ----------
c
         dw1dx = 0.25 * ( w1(ind2) - w1(ind1)
     1                  + w1(ind4) - w1(ind3)
     1                  + w1(ind6) - w1(ind5)
     1                  + w1(ind8) - w1(ind7) ) / delx
         dw2dx = 0.25 * ( w2(ind2) - w2(ind1)
     1                  + w2(ind4) - w2(ind3)
     1                  + w2(ind6) - w2(ind5)
     1                  + w2(ind8) - w2(ind7) ) / delx
         dw3dx = 0.25 * ( w3(ind2) - w3(ind1)
     1                  + w3(ind4) - w3(ind3)
     1                  + w3(ind6) - w3(ind5)
     1                  + w3(ind8) - w3(ind7) ) / delx
c
         dw1dy = 0.25 * ( w1(ind3) - w1(ind1)
     1                  + w1(ind4) - w1(ind2)
     1                  + w1(ind7) - w1(ind5)
     1                  + w1(ind8) - w1(ind6) ) / dely
         dw2dy = 0.25 * ( w2(ind3) - w2(ind1)
     1                  + w2(ind4) - w2(ind2)
     1                  + w2(ind7) - w2(ind5)
     1                  + w2(ind8) - w2(ind6) ) / dely
         dw3dy = 0.25 * ( w3(ind3) - w3(ind1)
     1                  + w3(ind4) - w3(ind2)
     1                  + w3(ind7) - w3(ind5)
     1                  + w3(ind8) - w3(ind6) ) / dely
c
         dw1dz = 0.25 * ( w1(ind5) - w1(ind1)
     1                  + w1(ind6) - w1(ind2)
     1                  + w1(ind7) - w1(ind3)
     1                  + w1(ind8) - w1(ind4) ) / delz
         dw2dz = 0.25 * ( w2(ind5) - w2(ind1)
     1                  + w2(ind6) - w2(ind2)
     1                  + w2(ind7) - w2(ind3)
     1                  + w2(ind8) - w2(ind4) ) / delz
         dw3dz = 0.25 * ( w3(ind5) - w3(ind1)
     1                  + w3(ind6) - w3(ind2)
     1                  + w3(ind7) - w3(ind3)
     1                  + w3(ind8) - w3(ind4) ) / delz
c
c add to the respective terms
c ---------------------------
c
         zkxx = zkxx + del
     1         * ( rkxx + rkxx * dw1dx + rkxy * dw1dy + rkxz * dw1dz )
c
         zkyx = zkyx + del
     1         * ( rkyx + rkyx * dw1dx + rkyy * dw1dy + rkyz * dw1dz )
c
         zkzx = zkzx + del
     1         * ( rkzx + rkzx * dw1dx + rkzy * dw1dy + rkzz * dw1dz )
c
         zkxy = zkxy + del
     1         * ( rkxx * dw2dx + rkxy + rkxy * dw2dy + rkxz * dw2dz )
c
         zkyy = zkyy + del
     1         * ( rkyx * dw2dx + rkyy + rkyy * dw2dy + rkyz * dw2dz )
c
         zkzy = zkzy + del
     1         * ( rkzx * dw2dx + rkzy + rkzy * dw2dy + rkzz * dw2dz )
c
         zkxz = zkxz + del
     1         * ( rkxx * dw3dx + rkxy * dw3dy + rkxz + rkxz * dw3dz )
c
         zkyz = zkyz + del
     1         * ( rkyx * dw3dx + rkyy * dw3dy + rkyz + rkyz * dw3dz )
c
         zkzz = zkzz + del
     1         * ( rkzx * dw3dx + rkzy * dw3dy + rkzz + rkzz * dw3dz )
c
    9 continue
c
c divide through by the cell size
c -------------------------------
c
      zkxx = zkxx / cellsize
      zkxy = zkxy / cellsize
      zkxz = zkxz / cellsize
      zkyx = zkyx / cellsize
      zkyy = zkyy / cellsize
      zkyz = zkyz / cellsize
      zkzx = zkzx / cellsize
      zkzy = zkzy / cellsize
      zkzz = zkzz / cellsize
c
      return
      end
      subroutine hommfematrix
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine computes the matrix entries for the homogenization equation.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
      include 'include/physical_constants.h'
c
c initialize the matrix storage
c -----------------------------
c
      call hommfematinit
c
c next compute the inverse of the permeability tensor - note that for the
c reduced mixed finite element method this inverse is computed in a special
c way
c ---
c
      call hommfeinvrt
c
c compute the matrix
c ------------------
c
      call hommfemat
c
      return
      end
      subroutine hommfeapbndrhs
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine computes the contribution of the boundary term in the
c aperiodic problem using the mixed finite element method. This computes the
c contribution for all three elliptic systems in the homogenization problem 
c 
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
c
c compute the shift parameters for the velocity components
c --------------------------------------------------------
c
        nvxtemp = nxhommfep1 * nyhommfe
        nvytemp = nyhommfep1 * nzhommfe
        nvztemp = nzhommfep1 * nxhommfe
c
c compute the contribution on the two faces perpendicular to the first
c coordinate axes
c ---------------
c
      if(nxhommfe .gt. 1) then
        xleft = xgrhommfe(0)
        xright = xgrhommfe(nxhommfe)
        do 1 k=1,nzhommfe
           k1 = ( k - 1 ) * nvxtemp
        do 1 j=1,nyhommfe
           j1 = ( j - 1 ) * nxhommfep1 + k1
           indl = 1 + j1
           indr = nxhommfep1 + j1
           rhshomvx(indl,1) =   xleft * dyhommfe(j) * dzhommfe(k)
           rhshomvx(indr,1) = - xright * dyhommfe(j) * dzhommfe(k)
    1   continue
      end if
      if(nyhommfe .gt. 1) then
        do 2 i=1,nxhommfe
           i1 = ( i - 1 ) * nvytemp
        do 2 k=1,nzhommfe
           k1 = ( k - 1 ) * nyhommfep1 + i1
           indl = 1 + k1
           indr = nyhommfep1 + k1
           xntgrl = 0.5 * ( xgrhommfe(i) * xgrhommfe(i)
     1                    - xgrhommfe(i-1) * xgrhommfe(i-1) )
           rhshomvy(indl,1) =   xntgrl * dzhommfe(k)
           rhshomvy(indr,1) = - xntgrl * dzhommfe(k)
    2   continue
      end if
      if(nzhommfe .gt. 1) then
        do 3 j=1,nyhommfe
           j1 = ( j - 1 ) * nvztemp
        do 3 i=1,nxhommfe
           i1 = ( i - 1 ) * nzhommfep1 + j1
           indl = 1 + i1
           indr = nzhommfep1 + i1
           xntgrl = 0.5 * ( xgrhommfe(i) * xgrhommfe(i)
     1                    - xgrhommfe(i-1) * xgrhommfe(i-1) )
           rhshomvz(indl,1) =   xntgrl * dyhommfe(j)
           rhshomvz(indr,1) = - xntgrl * dyhommfe(j)
    3   continue
      end if
c
c compute the contribution on the two faces perpendicular to the second
c coordinate axes
c ---------------
c
      if(nxhommfe .gt. 1) then
        do 4 k=1,nzhommfe
           k1 = ( k - 1 ) * nvxtemp
        do 4 j=1,nyhommfe
           j1 = ( j - 1 ) * nxhommfep1 + k1
           indl = 1 + j1
           indr = nxhommfep1 + j1
           yntgrl = 0.5 * ( ygrhommfe(j) * ygrhommfe(j)
     1                    - ygrhommfe(j-1) * ygrhommfe(j-1) )
           rhshomvx(indl,2) =   yntgrl * dzhommfe(k)
           rhshomvx(indr,2) = - yntgrl * dzhommfe(k)
    4   continue
      end if
      if(nyhommfe .gt. 1) then
        yleft = ygrhommfe(0)
        yright = ygrhommfe(nyhommfe)
        do 5 i=1,nxhommfe
           i1 = ( i - 1 ) * nvytemp
        do 5 k=1,nzhommfe
           k1 = ( k - 1 ) * nyhommfep1 + i1
           indl = 1 + k1
           indr = nyhommfep1 + k1
           rhshomvy(indl,2) =   yleft * dxhommfe(i) * dzhommfe(k)
           rhshomvy(indr,2) = - yright * dxhommfe(i) * dzhommfe(k)
    5   continue
      end if
      if(nzhommfe .gt. 1) then
        do 6 j=1,nyhommfe
           j1 = ( j - 1 ) * nvztemp
        do 6 i=1,nxhommfe
           i1 = ( i - 1 ) * nzhommfep1 + j1
           indl = 1 + i1
           indr = nzhommfep1 + i1
           yntgrl = 0.5 * ( ygrhommfe(j) * ygrhommfe(j)
     1                    - ygrhommfe(j-1) * ygrhommfe(j-1) )
           rhshomvz(indl,2) =   yntgrl * dyhommfe(j)
           rhshomvz(indr,2) = - yntgrl * dyhommfe(j)
    6   continue
      end if
c
c compute the contribution on the two faces perpendicular to the third
c coordinate axes
c ---------------
c
      if(nxhommfe .gt. 1) then
        do 7 k=1,nzhommfe
           k1 = ( k - 1 ) * nvxtemp
        do 7 j=1,nyhommfe
           j1 = ( j - 1 ) * nxhommfep1 + k1
           indl = 1 + j1
           indr = nxhommfep1 + j1
           zntgrl = 0.5 * ( zgrhommfe(k) * zgrhommfe(k)
     1                    - zgrhommfe(k-1) * zgrhommfe(k-1) )
           rhshomvx(indl,3) =   zntgrl * dyhommfe(k)
           rhshomvx(indr,3) = - zntgrl * dyhommfe(k)
    7   continue
      end if
      if(nyhommfe .gt. 1) then
        do 8 i=1,nxhommfe
           i1 = ( i - 1 ) * nvytemp
        do 8 k=1,nzhommfe
           k1 = ( k - 1 ) * nyhommfep1 + i1
           indl = 1 + k1
           indr = nyhommfep1 + k1
           zntgrl = 0.5 * ( zgrhommfe(k) * zgrhommfe(k)
     1                    - zgrhommfe(k-1) * zgrhommfe(k-1) )
           rhshomvy(indl,3) =   zntgrl * dxhommfe(k)
           rhshomvy(indr,3) = - zntgrl * dxhommfe(k)
    8   continue
      end if
      if(nzhommfe .gt. 1) then
        zleft = zgrhommfe(0)
        zright = zgrhommfe(nzhommfe)
        do 9 j=1,nyhommfe
           j1 = ( j - 1 ) * nvztemp
        do 9 i=1,nxhommfe
           i1 = ( i - 1 ) * nzhommfep1 + j1
           indl = 1 + i1
           indr = nzhommfep1 + i1
           rhshomvz(indl,3) =   zleft * dxhommfe(i) * dyhommfe(j)
           rhshomvz(indr,3) = - zright * dxhommfe(i) * dyhommfe(j)
    9   continue
      end if
c
      return
      end
      subroutine homcgmod(matmlt,xnew,xold,rhs,nval,ibit,cgeps
     1,cgthrshl,cgthrshu,ier)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine applies a conjugate gradient method for the solution of the
c system of equations defined by the matrix in the routine matmlt and the right
c hand side in the array rhs.
c
c input
c
c   matmlt - the matrix multiplication to be used in the algorithm
c   xold - the initial guess
c   rhs - the right hand side of the equation
c   nval - the number of unknowns solved for
c   ibit - vector containing the flags for known and unknown nodes
c          ibit(i) = 1; the node is an unknown
c          ibit(i) = 0; the node is an fixed
c   cgeps - the tolerance for the method
c
c output
c
c   xnew - the solution returned
c   ier - error flag
c         ier=101; zero initial residual
c         ier=102; maximum number of iterations exceeded
c         ier=103; norm of the search direction vector is too small to continue
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/homog_common.h'
      real xnew(*),xold(*),rhs(*)
      real ptemp(nodhet),c(nodhet),r(nodhet),q(nodhet),ansbst(nodhet)
      real*8 rw,qw,rwold,a,b,error,errbst,temp
      integer ibit(*)
      external matmlt
c
      errbst = 1000000000.d0
      lower = 0
      lupper = 0
c
c initialize the temporary storage vectors - note that q is set equal
c to r and ptemp is set to xold
c -----------------------------
c
      do 1 i=1,nval
         r(i) = 0.0
         c(i) = 0.0
    1 continue
c
c store the maximum number of iterations based on the number of unknowns
c ----------------------------------------------------------------------
c
      maxiter = 20 * nval
c
c calculate the initial residual. note that the old value of the pressure is
c taken as the initial value.
c ---------------------------
c
      call matmlt(xold,r)
c
c initialize the residual, r, and the initial direction vector, q. also compute
c the norm of the original direction vector in qq to allow a relative error
c comparison
c ----------
c
      do 2 i=1,nval
         r(i) = ( rhs(i) - r(i) ) * ibit(i)
         xnew(i) = xold(i)
         ptemp(i) = xnew(i)
         q(i) = r(i)
    2 continue
      rw = 0.d0
      do 3 i=1,nval
         rw = rw + dble(r(i)) * dble(r(i))
    3 continue
c
c check for a zero initial residual
c ---------------------------------
c
      if(rw .eq. 0.) then
        ier = 101
        return
      end if
c
c initialize the iteration counter
c --------------------------------
c
      iter = 1
c
c start of the conjugate gradient iterations
c ------------------------------------------
c
    4 rwold = rw
c
c matrix multiply
c ---------------
c
      call matmlt(q,c)
c
c compute the inner product of the direction and the matrix times the direction
c -----------------------------------------------------------------------------
c
      qw = 0.d0
      do 5 i=1,nval
         qw = qw + dble(q(i)) * dble(c(i))
    5 continue
c
c compute the length multiplier for the new iterate
c -------------------------------------------------
c
      if(qw .eq. 0.0) then
        a = rwold
      else
        a = dble( rwold / qw )
      end if
c
c compute the new iterate and residual
c ------------------------------------
c
      do 6 i=1,nval
         xnew(i) = xnew(i) + a * q(i)
         r(i) = r(i) - a * c(i)
    6 continue
c
c compute the norm of the new residual
c ------------------------------------
c
      rw = 0.d0
      error = 0.d0
      do 7 i=1,nval
         rw = rw + dble(r(i)) * dble(r(i))
         temp = dabs(dble(xnew(i)) - dble(ptemp(i)))
         error = error + temp * temp
    7 continue
      error = dsqrt( dble( error ) )
c
c check for an error below the lower threshold
c --------------------------------------------
c
      if(error .lt. dble(cgthrshl)) lower = 1
      if(lower .eq. 1) then
        if(error .gt. dble(cgthrshu)) lupper = 1
      end if
c
c check for a best error
c ----------------------
c
      if(error .lt. errbst) then
        errbst = error
        do 8 i=1,nval
           ansbst(i) = xnew(i)
   8   continue
      end if
c
c check for convergence
c ---------------------
c
c      print *,'iter ',iter,error,cgeps
      if((error .lt. cgeps) .or. (iter .ge. maxiter) .or.
     1              (lupper .eq. 1)) then
        if(iter .ge. maxiter .or. lupper .eq. 1) then
          ier = 102
c
c copy the best answer into the returned array
c --------------------------------------------
c
          do 9 i=1,nval
             xnew(i) = ansbst(i)
    9     continue
          error = errbst
c
c write an error mesage to the log file
c -------------------------------------
c
          print *,' ***** '
          print *,' ***** error tol. not met in homcgmod'
          print *,' ***** iter = ',iter
          print *,' ***** error = ',error
          print *,' ***** '
c
        end if
c
        return
c
      end if
c
c update the iteration counter
c ----------------------------
c
      iter = iter + 1
c
c compute the length multiplier for the new direction
c ---------------------------------------------------
c
      b = dble( rw / rwold )
c
c compute the new direction
c -------------------------
c
      do 11 i=1,nval
         q(i) = r(i) + b * q(i)
         ptemp(i) = xnew(i)
   11 continue
c
c check for a zero search vector - no shit this can really
c happen
c ------
c
      qw = 0.d0
      do 12 i=1,nval
         qw = qw + dble(q(i)) * dble(q(i))
   12 continue
      qw = dsqrt(qw)
      if(qw .lt. .0000000001) then
        ier = 103
        return
      end if
c
c go back for another iteration
c -----------------------------
c
      go to 4
c
      end
      subroutine hommfemesh
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine computes parameters and the grid for the homogenization
c solution code.
c
c the code expects that the domain extent in each dimension, the number of
c grid blocks in each direction, and the node locations input from the calling
c arguments in higher level routines. this routine just computes the auxiliary
c parameters associated with the grid.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
c
c compute the cell centered nodes
c -------------------------------
c
      if(nxhommfe .lt. 2) then
        xgrhommfe(0) = 0.0
      else
        xgrhommfe(0) = 0.5 * ( 3.0 * xhommfe(1) - xhommfe(2) )
      end if
      xhommfe(0) = xgrhommfe(0)
      do 1 i=1,nxhommfe-1
         xgrhommfe(i) = 0.5 * ( xhommfe(i) + xhommfe(i+1) )
    1 continue
      if(nxhommfe .lt. 2) then
        xgrhommfe(nxhommfe) = 2.0 * xhommfe(1)
      else
        xgrhommfe(nxhommfe) = 0.5 * ( 3.0 * xhommfe(nxhommfe)
     1                      - xhommfe(nxhommfe-1) )
      end if
      xhommfe(nxhommfe+1) = xgrhommfe(nxhommfe)
c
      if(nyhommfe .lt. 2) then
        ygrhommfe(0) = 0.0
      else
        ygrhommfe(0) = 0.5 * ( 3.0 * yhommfe(1) - yhommfe(2) )
      end if
      yhommfe(0) = ygrhommfe(0)
      do 2 j=1,nyhommfe-1
         ygrhommfe(j) = 0.5 * ( yhommfe(j) + yhommfe(j+1) )
    2 continue
      if(nyhommfe .lt. 2) then
        ygrhommfe(nyhommfe) = 2.0 * yhommfe(1)
      else
        ygrhommfe(nyhommfe) = 0.5 * ( 3.0 * yhommfe(nyhommfe)
     1                      - yhommfe(nyhommfe-1) )
      end if
      yhommfe(nyhommfe+1) = ygrhommfe(nyhommfe)
c
      if(nzhommfe .lt. 2) then
        zgrhommfe(0) = 0.0
      else
        zgrhommfe(0) = 0.5 * ( 3.0 * zhommfe(1) - zhommfe(2) )
      end if
      zhommfe(0) = zgrhommfe(0)
      do 3 k=1,nzhommfe-1
         zgrhommfe(k) = 0.5 * ( zhommfe(k) + zhommfe(k+1) )
    3 continue
      if(nzhommfe .lt. 2) then
        zgrhommfe(nzhommfe) = 2.0 * zhommfe(1)
      else
        zgrhommfe(nzhommfe) = 0.5 * ( 3.0 * zhommfe(nzhommfe)
     1                      - zhommfe(nzhommfe-1) )
      end if
      zhommfe(nzhommfe+1) = zgrhommfe(nzhommfe)
c
c compute the interval lengths
c ----------------------------
c
      do 4 i=1,nxhommfe
         dxhommfe(i) = xgrhommfe(i) - xgrhommfe(i-1)
    4 continue
      do 5 j=1,nyhommfe
         dyhommfe(j) = ygrhommfe(j) - ygrhommfe(j-1)
    5 continue
      do 6 k=1,nzhommfe
         dzhommfe(k) = zgrhommfe(k) - zgrhommfe(k-1)
    6 continue
c
c compute some integer grid parameters
c ------------------------------------
c
      nxhommfep1 = nxhommfe + 1
      nyhommfep1 = nyhommfe + 1
      nzhommfep1 = nzhommfe + 1
      nxhommfem1 = nxhommfe - 1
      nyhommfem1 = nyhommfe - 1
      nzhommfem1 = nzhommfe - 1
      nnhommfevx = nxhommfep1 * nyhommfe * nzhommfe
      nnhommfevy = nxhommfe * nyhommfep1 * nzhommfe
      nnhommfevz = nxhommfe * nyhommfe * nzhommfep1
      nnhommfe = nxhommfe * nyhommfe * nzhommfe
      nhvtot = nnhommfevx + nnhommfevy + nnhommfevz + nnhommfe
      nnhommfe2d = nxhommfe * nyhommfe
      nnhommfevx2d = nxhommfep1 * nyhommfe
      nnhommfevy2d = nyhommfep1 * nzhommfe
      nnhommfevz2d = nxhommfe * nzhommfep1
      nxnyhommfe = nxhommfe * nyhommfe
      nxnzhommfe = nxhommfe * nzhommfe
      nynzhommfe = nyhommfe * nzhommfe
c
c compute some parameters - these are left over in some of the older code and
c are left in for convenience
c ---------------------------
c
      nshftv2 = nnhommfevx
      nshftv3 = nshftv2 + nnhommfevy
      nshftp  = nshftv3 + nnhommfevz
c
c determine the original boundary locations - this is only needed if pressure
c conditions are specified on the boundary which makes the code put in an
c extra pressure node on the boundary in each coordinate strip. thus the
c computational boundary gets moved
c ---------------------------------
c
      hommfexleft = xgrhommfe(0)
      if(ihommfebndyzl .ge. 3 .and. ihommfebndyzl .le. 5)
     1        hommfexleft = xhommfe(1)
c
      hommfexright = xgrhommfe(nxhommfe)
      if(ihommfebndyzr .ge. 3 .and. ihommfebndyzr .le. 5)
     1        hommfexright = xhommfe(nxhommfe)
c
      hommfeyleft = ygrhommfe(0)
      if(ihommfebndxzl .ge. 3 .and. ihommfebndxzl .le. 5)
     1        hommfeyleft = yhommfe(1)
c
      hommfeyright = ygrhommfe(nyhommfe)
      if(ihommfebndxzr .ge. 3 .and. ihommfebndxzr .le. 5) 
     1        hommfeyright = yhommfe(nyhommfe)
c
      hommfezleft = zgrhommfe(0)
      if(ihommfebndxyl .ge. 3 .and. ihommfebndxyl .le. 5)
     1        hommfezleft = zhommfe(1)
c
      hommfezright = zgrhommfe(nzhommfe)
      if(ihommfebndxyr .ge. 3 .and. ihommfebndxyr .le. 5)
     1        hommfezright = zhommfe(nzhommfe)
c
      return
      end
      subroutine hamlt3(t,q)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine performs the matrix multiplication for the 9 banded matric
c due to the discretization in the solution of the elliptic equations in the
c homogenization
c
c input
c
c   t - vector to perform the matrix multiplication on.
c
c output
c
c   q - result from the matrix multiplication.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/homog_common.h'
      common /hmatmlt3/ n1,n2,n3,n1r,n2r,n3r
      real t(nodhet),t1(2*nodhet),q(nodhet)
c
c compute the total number of values and the shift in the blcoks due to the
c first coordinate
c ----------------
c
      nvalx = n1 * n1r
      nvaly = n2 * n2r
      nvalz = n3 * n3r
      nvar = nvalx * nvaly * nvalz
      nvtemp = nvalx * nvaly
c
c first create a padded 1-d array for the periodicity in the problem
c
c compute the number of entries in the coordinate directions in the padded
c arrays
c ------
c
      nvalx1 = nvalx + 2
      nvaly1 = nvaly + 2
      nvalz1 = nvalz + 2
      nvar1 = nvalx1 * nvaly1 * nvalz1
      nvtemp1 = nvalx1 * nvaly1
c
c put in the interior of the domain
c ---------------------------------
c
      do 1 k=1,nvalz
         k2 = ( k - 1 ) * nvtemp
         k22 = k * nvtemp1
      do 1 j=1,nvaly
         j2 = ( j - 1 ) * nvalx + k2
         j22 = j * nvalx1 + k22
      do 1 i=1,nvalx
         ind = i + j2
         indd = i + 1 + j22
         t1(indd) = t(ind)
    1 continue
c
c do the two faces parallel to the x-y plane
c ------------------------------------------
c
      k2 = ( nvalz - 1 ) * nvtemp
      k22 = ( nvalz1 - 1 ) * nvtemp1
      do 2 j=1,nvaly
         j2 = ( j - 1 ) * nvalx
         j22 = j * nvalx1
      do 2 i=1,nvalx
         ind = i + j2
         indd = i + 1 + j22 + k22
         t1(indd) = t(ind)
         ind = i + j2 + k2
         indd = i + 1 + j22
         t1(indd) = t(ind)
    2 continue
c
c do the two faces parallel to the x-z plane
c ------------------------------------------
c
      j2 = ( nvaly - 1 ) * nvalx
      j22 = ( nvaly1 - 1 ) * nvalx1
      do 3 k=1,nvalz
         k2 = ( k - 1 ) * nvtemp
         k22 = k * nvtemp1
      do 3 i=1,nvalx
         ind = i + k2
         indd = i + 1 + k22 + j22
         t1(indd) = t(ind)
         ind = i + k2 + j2
         indd = i + 1 + k22
         t1(indd) = t(ind)
    3 continue
c
c do the two faces parallel to the y-z plane
c ------------------------------------------
c
      do 4 k=1,nvalz
         k2 = ( k - 1 ) * nvtemp
         k22 = k * nvtemp1
      do 4 j=1,nvaly
         ind = 1 + ( j - 1 ) * nvalx + k2
         indd = nvalx1 + j * nvalx1 + k22
         t1(indd) = t(ind)
         ind = nvalx + ( j - 1 ) * nvalx + k2
         indd = 1 + j * nvalx1 + k22
         t1(indd) = t(ind)
    4 continue
c
c define the corner indices in y and z for use in the rest of the definitions
c for the padding
c ---------------
c
      k2 = ( nvalz - 1 ) * nvtemp
      k22 = ( nvalz1 - 1 ) * nvtemp1
      j2 = ( nvaly - 1 ) * nvalx
      j22 = ( nvaly1 - 1 ) * nvalx1
c
c do the four lines parallel to the x axis
c ----------------------------------------
c
      do 5 i=1,nvalx
         ind = i 
         indd = i + 1 + j22 + k22
         t1(indd) = t(ind)
         ind = i + j2 + k2
         indd = i + 1
         t1(indd) = t(ind)
         ind = i + j2
         indd = i + 1 + k22
         t1(indd) = t(ind)
         ind = i + k2
         indd = i + 1 + j22
         t1(indd) = t(ind)
    5 continue
c
c do the four lines parallel to the y axis
c ----------------------------------------
c
      do 6 j=1,nvaly
         ind = 1 + ( j - 1 ) * nvalx
         indd = ( j + 1 ) * nvalx1 + k22
         t1(indd) = t(ind)
         ind = j * nvalx + k2
         indd = 1 + j * nvalx1
         t1(indd) = t(ind)
         ind = nvalx + ( j - 1 ) * nvalx
         indd = 1 + j * nvalx1 + k22
         t1(indd) = t(ind)
         ind = 1 + ( j - 1 ) * nvalx + k2
         indd = ( j + 1 ) * nvalx1
         t1(indd) = t(ind)
    6 continue
c
c do the four lines parallel to the z axis
c ----------------------------------------
c
      do 7 k=1,nvalz
         ind = 1 + ( k - 1 ) * nvtemp 
         indd = nvalx1 + j22 + k * nvtemp1
         t1(indd) = t(ind)
         ind = nvalx + j2 + ( k - 1 ) * nvtemp
         indd = 1 + k * nvtemp1
         t1(indd) = t(ind)
         ind = nvalx + ( k - 1 ) * nvtemp 
         indd = 1 + j22 + k * nvtemp1
         t1(indd) = t(ind)
         ind = 1 + j2 + ( k - 1 ) * nvtemp
         indd = nvalx1 + k * nvtemp1
         t1(indd) = t(ind)
    7 continue
c
c pad the corners
c ---------------
c
      t1(1) = t(nvar)
      t1(nvar1) = t(1)
      t1(nvalx1) = t(1+j2+k2)
      t1(1+j22+k22) = t(nvalx)
      t1(1+j22) = t(nvalx+k2)
      t1(nvalx1+k22) = t(1+j2)
      t1(nvtemp1) = t(1+k2)
      t1(1+k22) = t(nvtemp)
c
c now rip through the multiplication using the padded array as the input for
c the multiplication and the vector 1 which is the same size as the original
c input as output
c ---------------
c
      do 8 i=1,nvar
         q(i) = ha(i,14) * t(i)
    8 continue
c
c do the other bands
c ------------------
c
      do 9 k=1,nvalz
         k2 = ( k - 1 ) * nvtemp
         k22 = k * nvtemp1
      do 9 j=1,nvaly
         j2 = ( j - 1 ) * nvalx + k2
         j22 = j * nvalx1 + k22
      do 9 i=1,nvalx
         ind = i + j2
         indd = i + 1 + j22
c
c first super and subdiagonals
c ----------------------------
c
         q(ind) = q(ind) + ha(ind,13) * t1(indd-1)
         q(ind) = q(ind) + ha(ind,15) * t1(indd+1)
c
c second super and subdiagonals
c -----------------------------
c
         q(ind) = q(ind) + ha(ind,12) * t1(indd-nvalx1+1)
         q(ind) = q(ind) + ha(ind,16) * t1(indd+nvalx1-1)
c
c third super and subdiagonals
c ----------------------------
c
         q(ind) = q(ind) + ha(ind,11) * t1(indd-nvalx1)
         q(ind) = q(ind) + ha(ind,17) * t1(indd+nvalx1)
c
c fourth super and subdiagonals
c -----------------------------
c
         q(ind) = q(ind) + ha(ind,10) * t1(indd-nvalx1-1)
         q(ind) = q(ind) + ha(ind,18) * t1(indd+nvalx1+1)
c
c fifth super and subdiagonals
c ----------------------------
c
         q(ind) = q(ind) + ha(ind,9) * t1(indd+nvalx1+1-nvtemp1)
         q(ind) = q(ind) + ha(ind,19) * t1(indd-nvalx1-1+nvtemp1)
c
c sixth super and subdiagonals
c ----------------------------
c
         q(ind) = q(ind) + ha(ind,8) * t1(indd+nvalx1-nvtemp1)
         q(ind) = q(ind) + ha(ind,20) * t1(indd-nvalx1+nvtemp1)
c
c seventh super and subdiagonals
c ------------------------------
c
         q(ind) = q(ind) + ha(ind,7) * t1(indd+nvalx1-1-nvtemp1)
         q(ind) = q(ind) + ha(ind,21) * t1(indd-nvalx1+1+nvtemp1)
c
c eight super and subdiagonals
c ----------------------------
c
         q(ind) = q(ind) + ha(ind,6) * t1(indd+1-nvtemp1)
         q(ind) = q(ind) + ha(ind,22) * t1(indd-1+nvtemp1)
c
c ninth super and subdiagonals
c ----------------------------
c
         q(ind) = q(ind) + ha(ind,5) * t1(indd-nvtemp1)
         q(ind) = q(ind) + ha(ind,23) * t1(indd+nvtemp1)
c
c tenth super and subdiagonals
c ----------------------------
c
         q(ind) = q(ind) + ha(ind,4) * t1(indd-1-nvtemp1)
         q(ind) = q(ind) + ha(ind,24) * t1(indd+1+nvtemp1)
c
c eleventh super and subdiagonals
c -------------------------------
c
         q(ind) = q(ind) + ha(ind,3) * t1(indd-nvalx1+1-nvtemp1)
         q(ind) = q(ind) + ha(ind,25) * t1(indd+nvalx1-1+nvtemp1)
c
c twelfth super and subdiagonals
c ------------------------------
c
         q(ind) = q(ind) + ha(ind,2) * t1(indd-nvalx1-nvtemp1)
         q(ind) = q(ind) + ha(ind,26) * t1(indd+nvalx1+nvtemp1)
c
c thirteenth super and subdiagonals
c ---------------------------------
c
         q(ind) = q(ind) + ha(ind,1) * t1(indd-1-nvalx1-nvtemp1)
         q(ind) = q(ind) + ha(ind,27) * t1(indd+1+nvalx1+nvtemp1)
c
    9 continue
c
      return
      end
      subroutine hommfesoln(isystem)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine performs a solution of the system of linear equations in the
c discretization of the pressure equation when the permeability tensor is
c full and the system is to be reduced.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
      include 'include/physical_constants.h'
      real xnew(nnhomvar),xold(nnhomvar),wrk(nnhomvar),rhs(nnhomvar)
      real vx(nhomvelx),vy(nhomvely),vz(nhomvelz)
      data cgeps,cgthrshl,cgthrshu / 0.0000001,0.001,10000.0 /
c
c matrix multiplication routine for use in the iterative solver
c -------------------------------------------------------------
c
      external hommfemmm
c
c check for internal fixed nodes which will be considered as interior neumann
c boundary conditions which modify the right hand side of the equations and
c the diagonal part of the velocity
c
c note that this must be done before the matrix is reduced to ensure the
c appropriate communication between cells
c ---------------------------------------
c
c NOTE THAT THIS IS COMMENTED OUT IN THE ORIGINAL CODE - NEED TO DO SOME
c WORK HERE
c      call neubci
c
c generate the right hand side of the pressure equation - the idea is that all
c the right hand side values for the velocity and pressure are passed in and
c the result of the operations is to modify rhshommfe for use in the solver.
c -----------------------------------------------------------------------
c
      call hommfemodrhs(isystem)
c
c store the old pressure values in the beginning of the array - note that the
c pressure values are in the first nnhommfe entries of the array instead of the
c last nnhommfe entries in the solution of the full system. also, store the
c modified right hand side information in the appropriate place.
c --------------------------------------------------------------
c
      do 5 i=1,nnhommfe
         xold(i) = 0.0
         rhs(i) = rhshommfe(i,isystem)
       if(abs(rhs(i)) .lt. 0.00001) rhs(i) = .0 
    5 continue
c
c solve the modified system
c -------------------------
c
c      call homcgmod(hommfemmm,xnew,xold,rhs,nnhommfe,ibithommfe
c     1,cgeps,cgthrshl,cgthrshu,error,ier)
      call homcgmod(hommfemmm,xnew,xold,rhs,nnhommfe,ibithommfe
     1,cgeps,cgthrshl,cgthrshu,ier)
c      call homcgsmod(hommfemmm,xnew,xold,rhs,nnhommfe,ibithommfe
c     1,hommfecgeps,hommfecgthrshl,hommfecgthrshu
c     1,error,ier)
c
c restore the new pressures
c -------------------------
c
      do 6 i=1,nnhommfe
         w(i,isystem) = xnew(i)
    6 continue
c
c get the velocities from the pressure
c ------------------------------------
c
      call hommfemmm(xnew,xold)
c
c compute the right hand side piece
c ---------------------------------
c
      call lusolfull(am11d,am11s,rhshomvx(1,isystem),vx,nxhommfe
     1,nyhommfe,nzhommfe,nxhommfep1,wrk)
      call lusolfull(am22d,am22s,rhshomvy(1,isystem),vy,nyhommfe
     1,nzhommfe,nxhommfe,nyhommfep1,wrk)
      call lusolfull(am33d,am33s,rhshomvz(1,isystem),vz,nzhommfe
     1,nxhommfe,nyhommfe,nzhommfep1,wrk)
c
c restore the new velocity from an array
c --------------------------------------
c
      ind = nnhommfe
      do 7 i=1,nnhommfevx
         if(ibithomvx(i) .eq. 1)
     1        hommfevelx(i,isystem) = xold(i+ind) + vx(i)
    7 continue
      ind = ind + nnhommfevx
      do 8 j=1,nnhommfevy
         if(ibithomvy(j) .eq. 1)
     1        hommfevely(j,isystem) = xold(j+ind) + vy(j)
    8 continue
      ind = ind + nnhommfevy
      do 9 k=1,nnhommfevz
         if(ibithomvz(k) .eq. 1)
     1        hommfevelz(k,isystem) = xold(k+ind) + vz(k)
    9 continue
c
      return
      end
      subroutine hommfeapfixed
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine looks for any cells to be masked out of the calculations. in
c particular, if the permeability is zero in a cell, the routine will used the
c boundary as an internal boundary with a zero flux value.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
c
c initialize the number of computational nodes
c --------------------------------------------
c
      nnhommfec = nnhommfe
c
c set the bit vector for the node
c -------------------------------
c
      do 1 i=1,nnhommfe
         ibithommfe(i) = 1
    1 continue
c
c initialize the bit vector for the gradient at the cell boundaries
c -----------------------------------------------------------------
c
      do 2 i=1,nnhommfevx
         ibithomvx(i) = 1
    2 continue
      do 3 j=1,nnhommfevy
         ibithomvy(j) = 1
    3 continue
      do 4 k=1,nnhommfevz
         ibithomvz(k) = 1
    4 continue
c
c check for a zero permeability to fix the velocities on cell boundaries
c ----------------------------------------------------------------------
c
      ntemp = nxhommfe * nyhommfe
      do 5 k=1,nzhommfe
         k2 = ( k - 1 ) * ntemp
      do 5 j=1,nyhommfe
         j2 = ( j - 1 ) * nxhommfe + k2
      do 5 i=1,nxhommfe
         indp = i + j2
c
c check the entries
c -----------------
c
         izero = 0
         if(hommfekxx(indp) .ne. 0.0) izero = 1
         if(hommfekxy(indp) .ne. 0.0) izero = 1
         if(hommfekxz(indp) .ne. 0.0) izero = 1
         if(hommfekyx(indp) .ne. 0.0) izero = 1
         if(hommfekyy(indp) .ne. 0.0) izero = 1
         if(hommfekyz(indp) .ne. 0.0) izero = 1
         if(hommfekzx(indp) .ne. 0.0) izero = 1
         if(hommfekzy(indp) .ne. 0.0) izero = 1
         if(hommfekzz(indp) .ne. 0.0) izero = 1
c
c if all are zero, set the array bit vector mask entry to zero since
c there should be no change to this cell
c --------------------------------------
c
         if(izero .eq. 0) then
c
c do the nodal values of the variable
c -----------------------------------
c
           ibithommfe(indp) = 0
           nnhommfec = nnhommfec - 1
c
c compute the velocity indices - this is done here since this part of the code
c will only be executed 'rarely'
c ------------------------------
c
           indvx1 = i + nxhommfep1 * ( j - 1 + ( k - 1 ) * nyhommfe ) 
           indvx2 = indvx1 + 1
           indvy1 = j + nyhommfep1 * ( k - 1 + ( i - 1 ) * nzhommfe )
           indvy2 = indvy1 + 1
           indvz1 = k + nzhommfep1 * ( i - 1 + ( j - 1 ) * nxhommfe )
           indvz2 = indvz1 + 1
c
c set the bit entries to zero
c ---------------------------
c
           ibithomvx(indvx1) = 0
           ibithomvx(indvx2) = 0
           ibithomvy(indvy1) = 0
           ibithomvy(indvy2) = 0
           ibithomvz(indvz1) = 0
           ibithomvz(indvz2) = 0
c
         end if
c
    5 continue
c
c check for interior masked out nodes
c -----------------------------------
c
      do 6 i=1,nnhommfe
         if(maskhommfe(i) .eq. 1) then
           ibithommfe(i) = 0
           nnhommfec = nnhommfec - 1
         end if
    6 continue
c
c see if there are any fixed nodes
c --------------------------------
c
      ival = 0
      do 7 i=1,nnhommfe
         if(ibithommfe(i) .eq. 0) ival = 1
    7 continue
c
c check for pressure boundary conditions which will fix the pressures along a
c given boundary plane of the domain
c ----------------------------------
c
c      call hommfefixbnd
c
c check for the case with no fixed nodes
c --------------------------------------
c
      if(ival .eq. 0) then
c
c fix the nodal value
c -------------------
c
        w(1,1) = 0.0
        w(1,2) = 0.0
        w(1,3) = 0.0
c
c set the bit vector entry
c ------------------------
c
        ibithommfe(1) = 0
c
c update the number of computational nodes in the domain
c ------------------------------------------------------
c
        nnhommfec = nnhommfec - 1
c
      end if
c
      return
      end
      subroutine hommferhs
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine does the computation of the right hand side of the
c homogenization equation for the mixed finite element version of the solution.
c the trick is that a projection onto the appropriate space must be done first.
c then the projected value is used in the usual way on the right hand side.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
      real vxi(nhomvelx),vxo(nhomvelx)
      real vyi(nhomvely),vyo(nhomvely)
      real vzi(nhomvelz),vzo(nhomvelz)
      real wrk(nnhomvar)
c
c compute the mass matrix for the grid - note that the mass matrices are all
c reduced or factored for use in the inversion routine lusol
c ----------------------------------------------------------
c
      call mssmtrx(nxhommfe,nyhommfe,nzhommfe,dxhommfe,dyhommfe,dzhommfe
     1,ibithomvx,1,admssx,asmssx)
      call mssmtrx(nyhommfe,nzhommfe,nxhommfe,dyhommfe,dzhommfe,dxhommfe
     1,ibithomvy,1,admssy,asmssy)
      call mssmtrx(nzhommfe,nxhommfe,nyhommfe,dzhommfe,dxhommfe,dyhommfe
     1,ibithomvz,1,admssz,asmssz)
c
c now set up the right hand side for the first equation in the system of
c homogenization equation
c
c contributions for the first component of the velocity space functions
c ---------------------------------------------------------------------
c
      do 1 k=1,nzhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         k1 = ( k - 1 ) * nnhommfevx2d
         k2 = ( k - 1 ) * nxnyhommfe
c
c initialize the integration factor
c ---------------------------------
c
         factor1 = 0.5 * dzhommfe(k)
c
      do 1 j=1,nyhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         j1 = ( j - 1 ) * nxhommfep1 + k1
         j2 = ( j - 1 ) * nxhommfe + k2
c
c update the factor
c -----------------
c
         factor2 = factor1 * dyhommfe(j)
c
c do the first cell
c -----------------
c
         ind = 1 + j2
         val = hommfekxx(ind)
         vxi(1+j1) = val * dxhommfe(1) * factor2
c
c do the interior grid lines
c --------------------------
c
         do 2 i=2,nxhommfe
c
c compute the indices for the support of the basis function
c ---------------------------------------------------------
c
            indp = i + j2
            indm = indp - 1
            indvo = i + j1
c
c get the two constant pieces of the tensor on the cells
c ------------------------------------------------------
c
            valm = hommfekxx(indm)
            valp = hommfekxx(indp)
c
c compute the integral value
c --------------------------
c
            vxi(indvo) = ( valm * dxhommfe(i-1)
     1                   + valp * dxhommfe(i) ) * factor2
c
    2    continue
c
c do the right boundary grid line
c -------------------------------
c
         ind = nxhommfe + j2
         val = hommfekxx(ind)
         vxi(nxhommfep1+j1) = val * dxhommfe(nxhommfe) * factor2
c
    1 continue
c
c contributions for the second component of the velocity space functions
c ----------------------------------------------------------------------
c
      do 3 i=1,nxhommfe
         i1 = ( i - 1 ) * nnhommfevy2d
         i2 = i
         factor1 = 0.5 * dxhommfe(i)
      do 3 k=1,nzhommfe
         k1 = ( k - 1 ) * nyhommfep1 + i1
         k2 = ( k - 1 ) * nxnyhommfe + i2
         factor2 = factor1 * dzhommfe(k)
c
c do the first cell
c -----------------
c
         ind = k2
         val = hommfekyx(ind)
         vyi(1+k1) = val * dyhommfe(1) * factor2
c
c do the interior grid lines
c --------------------------
c
         do 4 j=2,nyhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
            indp = ( j - 1 ) * nxhommfe + k2
            indm = indp - nxhommfe
            indvo = j + k1
c
c get the two constant pieces of the tensor on the cells
c ------------------------------------------------------
c
            valm = hommfekyx(indm)
            valp = hommfekyx(indp)
c
c compute the integral value
c --------------------------
c
            vyi(indvo) = ( valm * dyhommfe(j-1)
     1                   + valp * dyhommfe(j) ) * factor2
c
    4    continue
c
c do the right boundary grid line
c -------------------------------
c
         ind = nxnyhommfe - nxhommfe + k2
         val = hommfekyx(ind)
         vyi(nyhommfep1+k1) = val * dyhommfe(nyhommfe) * factor2
c
    3 continue
c
c contributions for the third component of the velocity space functions
c ---------------------------------------------------------------------
c
      do 5 j=1,nyhommfe
         j1 = ( j - 1 ) * nnhommfevz2d
         j2 = ( j - 1 ) * nxhommfe
         factor1 = 0.5 * dyhommfe(j)
      do 5 i=1,nxhommfe
         i1 = ( i - 1 ) * nzhommfep1 + j1
         i2 = i + j2
         factor2 = factor1 * dxhommfe(i)
c
c do the first cell
c -----------------
c
         ind = i2
         val = hommfekzx(ind)
         vzi(1+i1) = val * dzhommfe(1) * factor2
c
c do the interior grid lines
c --------------------------
c
         do 6 k=2,nzhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
            indp = ( k - 1 ) * nxnyhommfe + i2
            indm = indp - nxnyhommfe
            indvo = k + i1
c
c get the two constant pieces of the tensor on the cells
c ------------------------------------------------------
c
            valm = hommfekzx(indm)
            valp = hommfekzx(indp)
c
c compute the contribution at this location
c -----------------------------------------
c
            vzi(indvo) = ( valm * dzhommfe(k-1)
     1                   + valp * dzhommfe(k) ) * factor2
c
    6    continue
c
c do the right boundary grid line
c -------------------------------
c
         ind = nnhommfe - nxnyhommfe + i2
         val = hommfekzx(ind)
         vzi(nzhommfep1+i1) = val * dzhommfe(nzhommfe) * factor2
c
    5 continue
c
c invert the mass matrices into the right hand sides of the projections
c ---------------------------------------------------------------------
c
      call lusolfull(admssx,asmssx,vxi,vxo,nxhommfe,nyhommfe,nzhommfe
     1          ,nxhommfep1,wrk)
      call lusolfull(admssy,asmssy,vyi,vyo,nyhommfe,nzhommfe,nxhommfe
     1          ,nyhommfep1,wrk)
      call lusolfull(admssz,asmssz,vzi,vzo,nzhommfe,nxhommfe,nyhommfe
     1          ,nzhommfep1,wrk)
c
c now compute the right hand side for the homogenization equations for the
c three pieces
c ------------
c
      call ntmlta(vxo,vyo,vzo,rhshommfe(1,1))
c
c now set up the right hand side for the second equation in the system of
c homogenization equation
c
c contributions for the first component of the velocity space functions
c ---------------------------------------------------------------------
c
      do 7 k=1,nzhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         k1 = ( k - 1 ) * nnhommfevx2d
         k2 = ( k - 1 ) * nxnyhommfe
c
c initialize the integration factor
c ---------------------------------
c
         factor1 = 0.5 * dzhommfe(k)
c
      do 7 j=1,nyhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         j1 = ( j - 1 ) * nxhommfep1 + k1
         j2 = ( j - 1 ) * nxhommfe + k2
c
c update the factor
c -----------------
c
         factor2 = factor1 * dyhommfe(j)
c
c do the first cell
c -----------------
c
         ind = 1 + j2
         val = hommfekxy(ind)
         vxi(1+j1) = val * dxhommfe(1) * factor2
c
c do the interior grid lines
c --------------------------
c
         do 8 i=2,nxhommfe
c
c compute the indices for the support of the basis function
c ---------------------------------------------------------
c
            indp = i + j2
            indm = indp - 1
            indvo = i + j1
c
c get the two constant pieces of the tensor on the cells
c ------------------------------------------------------
c
            valm = hommfekxy(indm)
            valp = hommfekxy(indp)
c
c compute the integral value
c --------------------------
c
            vxi(indvo) = ( valm * dxhommfe(i-1)
     1                   + valp * dxhommfe(i) ) * factor2
c
    8    continue
c
c do the right boundary grid line
c -------------------------------
c
         ind = nxhommfe + j2
         val = hommfekxy(ind)
         vxi(nxhommfep1+j1) = val * dxhommfe(nxhommfe) * factor2
c
    7 continue
c
c contributions for the second component of the velocity space functions
c ----------------------------------------------------------------------
c
      do 9 i=1,nxhommfe
         i1 = ( i - 1 ) * nnhommfevy2d
         i2 = i
         factor1 = 0.5 * dxhommfe(i)
      do 9 k=1,nzhommfe
         k1 = ( k - 1 ) * nyhommfep1 + i1
         k2 = ( k - 1 ) * nxnyhommfe + i2
         factor2 = factor1 * dzhommfe(k)
c
c do the first cell
c -----------------
c
         ind = k2
         val = hommfekyy(ind)
         vyi(1+k1) = val * dyhommfe(1) * factor2
c
c do the interior grid lines
c --------------------------
c
         do 11 j=2,nyhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
            indp = ( j - 1 ) * nxhommfe + k2
            indm = indp - nxhommfe
            indvo = j + k1
c
c get the two constant pieces of the tensor on the cells
c ------------------------------------------------------
c
            valm = hommfekyy(indm)
            valp = hommfekyy(indp)
c
c compute the integral value
c --------------------------
c
            vyi(indvo) = ( valm * dyhommfe(j-1)
     1                   + valp * dyhommfe(j) ) * factor2
c
   11    continue
c
c do the right boundary grid line
c -------------------------------
c
         ind = nxnyhommfe - nxhommfe + k2
         val = hommfekyy(ind)
         vyi(nyhommfep1+k1) = val * dyhommfe(nyhommfe) * factor2
c
    9 continue
c
c contributions for the third component of the velocity space functions
c ---------------------------------------------------------------------
c
      do 12 j=1,nyhommfe
         j1 = ( j - 1 ) * nnhommfevz2d
         j2 = ( j - 1 ) * nxhommfe
         factor1 = 0.5 * dyhommfe(j)
      do 12 i=1,nxhommfe
         i1 = ( i - 1 ) * nzhommfep1 + j1
         i2 = i + j2
         factor2 = factor1 * dxhommfe(i)
c
c do the first cell
c -----------------
c
         ind = i2
         val = hommfekzy(ind)
         vzi(1+i1) = val * dzhommfe(1) * factor2
c
c do the interior grid lines
c --------------------------
c
         do 13 k=2,nzhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
            indp = ( k - 1 ) * nxnyhommfe + i2
            indm = indp - nxnyhommfe
            indvo = k + i1
c
c get the two constant pieces of the tensor on the cells
c ------------------------------------------------------
c
            valm = hommfekzy(indm)
            valp = hommfekzy(indp)
c
c compute the contribution at this location
c -----------------------------------------
c
            vzi(indvo) = ( valm * dzhommfe(k-1)
     1                   + valp * dzhommfe(k) ) * factor2
c
   13    continue
c
c do the right boundary grid line
c -------------------------------
c
         ind = nnhommfe - nxnyhommfe + i2
         val = hommfekzy(ind)
         vzi(nzhommfep1+i1) = val * dzhommfe(nzhommfe) * factor2
c
   12 continue
c
c invert the mass matrices into the right hand sides of the projections
c ---------------------------------------------------------------------
c
      call lusolfull(admssx,asmssx,vxi,vxo,nxhommfe,nyhommfe,nzhommfe
     1          ,nxhommfep1,wrk)
      call lusolfull(admssy,asmssy,vyi,vyo,nyhommfe,nzhommfe,nxhommfe
     1          ,nyhommfep1,wrk)
      call lusolfull(admssz,asmssz,vzi,vzo,nzhommfe,nxhommfe,nyhommfe
     1          ,nzhommfep1,wrk)
c
c now compute the right hand side for the homogenization equations for the
c three pieces
c ------------
c
      call ntmlta(vxo,vyo,vzo,rhshommfe(1,2))
c
c now set up the right hand side for the third equation in the system of
c homogenization equation
c
c contributions for the first component of the velocity space functions
c ---------------------------------------------------------------------
c
      do 14 k=1,nzhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         k1 = ( k - 1 ) * nnhommfevx2d
         k2 = ( k - 1 ) * nxnyhommfe
c
c initialize the integration factor
c ---------------------------------
c
         factor1 = 0.5 * dzhommfe(k)
c
      do 14 j=1,nyhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         j1 = ( j - 1 ) * nxhommfep1 + k1
         j2 = ( j - 1 ) * nxhommfe + k2
c
c update the factor
c -----------------
c
         factor2 = factor1 * dyhommfe(j)
c
c do the first cell
c -----------------
c
         ind = 1 + j2
         val = hommfekxz(ind)
         vxi(1+j1) = val * dxhommfe(1) * factor2
c
c do the interior grid lines
c --------------------------
c
         do 15 i=2,nxhommfe
c
c compute the indices for the support of the basis function
c ---------------------------------------------------------
c
            indp = i + j2
            indm = indp - 1
            indvo = i + j1
c
c get the two constant pieces of the tensor on the cells
c ------------------------------------------------------
c
            valm = hommfekxz(indm)
            valp = hommfekxz(indp)
c
c compute the integral value
c --------------------------
c
            vxi(indvo) = ( valm * dxhommfe(i-1)
     1                   + valp * dxhommfe(i) ) * factor2
c
   15    continue
c
c do the right boundary grid line
c -------------------------------
c
         ind = nxhommfe + j2
         val = hommfekxz(ind)
         vxi(nxhommfep1+j1) = val * dxhommfe(nxhommfe) * factor2
c
   14 continue
c
c contributions for the second component of the velocity space functions
c ----------------------------------------------------------------------
c
      do 16 i=1,nxhommfe
         i1 = ( i - 1 ) * nnhommfevy2d
         i2 = i
         factor1 = 0.5 * dxhommfe(i)
      do 16 k=1,nzhommfe
         k1 = ( k - 1 ) * nyhommfep1 + i1
         k2 = ( k - 1 ) * nxnyhommfe + i2
         factor2 = factor1 * dzhommfe(k)
c
c do the first cell
c -----------------
c
         ind = k2
         val = hommfekyz(ind)
         vyi(1+k1) = val * dyhommfe(1) * factor2
c
c do the interior grid lines
c --------------------------
c
         do 17 j=2,nyhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
            indp = ( j - 1 ) * nxhommfe + k2
            indm = indp - nxhommfe
            indvo = j + k1
c
c get the two constant pieces of the tensor on the cells
c ------------------------------------------------------
c
            valm = hommfekyz(indm)
            valp = hommfekyz(indp)
c
c compute the integral value
c --------------------------
c
            vyi(indvo) = ( valm * dyhommfe(j-1)
     1                   + valp * dyhommfe(j) ) * factor2
c
   17    continue
c
c do the right boundary grid line
c -------------------------------
c
         ind = nxnyhommfe - nxhommfe + k2
         val = hommfekyz(ind)
         vyi(nyhommfep1+k1) = val * dyhommfe(nyhommfe) * factor2
c
   16 continue
c
c contributions for the third component of the velocity space functions
c ---------------------------------------------------------------------
c
      do 18 j=1,nyhommfe
         j1 = ( j - 1 ) * nnhommfevz2d
         j2 = ( j - 1 ) * nxhommfe
         factor1 = 0.5 * dyhommfe(j)
      do 18 i=1,nxhommfe
         i1 = ( i - 1 ) * nzhommfep1 + j1
         i2 = i + j2
         factor2 = factor1 * dxhommfe(i)
c
c do the first cell
c -----------------
c
         ind = i2
         val = hommfekzz(ind)
         vzi(1+i1) = val * dzhommfe(1) * factor2
c
c do the interior grid lines
c --------------------------
c
         do 19 k=2,nzhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
            indp = ( k - 1 ) * nxnyhommfe + i2
            indm = indp - nxnyhommfe
            indvo = k + i1
c
c get the two constant pieces of the tensor on the cells
c ------------------------------------------------------
c
            valm = hommfekzz(indm)
            valp = hommfekzz(indp)
c
c compute the contribution at this location
c -----------------------------------------
c
            vzi(indvo) = ( valm * dzhommfe(k-1)
     1                   + valp * dzhommfe(k) ) * factor2
c
   19    continue
c
c do the right boundary grid line
c -------------------------------
c
         ind = nnhommfe - nxnyhommfe + i2
         val = hommfekzz(ind)
         vzi(nzhommfep1+i1) = val * dzhommfe(nzhommfe) * factor2
c
   18 continue
c
c invert the mass matrices into the right hand sides of the projections
c ---------------------------------------------------------------------
c
      call lusolfull(admssx,asmssx,vxi,vxo,nxhommfe,nyhommfe,nzhommfe
     1          ,nxhommfep1,wrk)
      call lusolfull(admssy,asmssy,vyi,vyo,nyhommfe,nzhommfe,nxhommfe
     1          ,nyhommfep1,wrk)
      call lusolfull(admssz,asmssz,vzi,vzo,nzhommfe,nxhommfe,nyhommfe
     1          ,nzhommfep1,wrk)
c
c now compute the right hand side for the homogenization equations for the
c three pieces
c ------------
c
      call ntmlta(vxo,vyo,vzo,rhshommfe(1,3))
c
      return
      end
      subroutine hommfeavg(zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy
     1,zkzz)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine computes the average using the solution values in the mfe
c version of the homogenization code
c
c output
c
c   zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz - the average values for the
c            tensor.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
      real zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz
c
c finally compute the average value based on the finite element solution
c
c initialize the equivalent values
c --------------------------------
c
      zkxx = 0.0
      zkxy = 0.0
      zkxz = 0.0
      zkyx = 0.0
      zkyy = 0.0
      zkyz = 0.0
      zkzx = 0.0
      zkzy = 0.0
      zkzz = 0.0
c
c compute the overall block size for use below
c --------------------------------------------
c
      if(nxhommfe .eq. 1) then
        celldelx = 1.0
      else
        celldelx = xgrhommfe(nxhommfe) - xgrhommfe(0)
      end if
      if(nyhommfe .eq. 1) then
        celldely = 1.0
      else
        celldely = ygrhommfe(nyhommfe) - ygrhommfe(0)
      end if
      if(nzhommfe .eq. 1) then
        celldelz = 1.0
      else
        celldelz = zgrhommfe(nzhommfe) - zgrhommfe(0)
      end if
      cellsize = celldelx * celldely * celldelz
c
c compute the arithmetic average
c ------------------------------
c
      call arithavg3(hommfekxx,hommfekxy,hommfekxz,hommfekyx,hommfekyy
     1,hommfekyz,hommfekzx,hommfekzy,hommfekzz,xhommfe(1),yhommfe(1)
     1,zhommfe(1),nxhommfe,nyhommfe,nzhommfe,akxx,akxy,akxz,akyx,akyy
     1,akyz,akzx,akzy,akzz,ax,ay,az)
c
c loop over the nodes
c -------------------
c
      do 1 k=1,nzhommfe
         k2 = ( k - 1 ) * nxnyhommfe
         zcntr = zhommfe(k)
         delz = dzhommfe(k)
      do 1 j=1,nyhommfe
         j2 = ( j - 1 ) * nxhommfe + k2
         ycntr = yhommfe(j)
         dely = dyhommfe(j)
      do 1 i=1,nxhommfe
         indprm = i + j2
         xcntr = xhommfe(i)
         delx = dxhommfe(i)
c
c compute the volume of the current cell
c --------------------------------------
c
         del = delx * dely * delz
c
c assign the permeability values
c ------------------------------
c
         rkxx = hommfekxx(indprm)
         rkxy = hommfekxy(indprm)
         rkxz = hommfekxz(indprm)
         rkyx = hommfekyx(indprm)
         rkyy = hommfekyy(indprm)
         rkyz = hommfekyz(indprm)
         rkzx = hommfekzx(indprm)
         rkzy = hommfekzy(indprm)
         rkzz = hommfekzz(indprm)
c
c compute the inverse of the tensor at the point
c ----------------------------------------------
c
         invrtform = 0
         ifullchk = 0
         if(rkxy .ne. 0.0) ifullchk = 1
         if(rkxz .ne. 0.0) ifullchk = 1
         if(rkyx .ne. 0.0) ifullchk = 1
         if(rkyz .ne. 0.0) ifullchk = 1
         if(rkzx .ne. 0.0) ifullchk = 1
         if(rkzy .ne. 0.0) ifullchk = 1
         if(ifullchk .eq. 1) invrtform = 1
         call invrt3x3(rkxx,rkxy,rkxz
     1                ,rkyx,rkyy,rkyz
     1                ,rkzx,rkzy,rkzz
     1                ,invrtform)
c
c compute the indices of the grid lines on the boundary of the grid block
c -----------------------------------------------------------------------
c
         indvxm = locvelindxm(xcntr,ycntr,zcntr,ier)
         indvxp = locvelindxp(xcntr,ycntr,zcntr,ier)
         indvym = locvelindym(xcntr,ycntr,zcntr,ier)
         indvyp = locvelindyp(xcntr,ycntr,zcntr,ier)
         indvzm = locvelindzm(xcntr,ycntr,zcntr,ier)
         indvzp = locvelindzp(xcntr,ycntr,zcntr,ier)
c
c get the values of the various gradient variables at the cell centers
c --------------------------------------------------------------------
c
         f1x = 0.5 * ( hommfevelx(indvxm,1) + hommfevelx(indvxp,1) )
         f1y = 0.5 * ( hommfevely(indvym,1) + hommfevely(indvyp,1) )
         f1z = 0.5 * ( hommfevelz(indvzm,1) + hommfevelz(indvzp,1) )
c
         f2x = 0.5 * ( hommfevelx(indvxm,2) + hommfevelx(indvxp,2) )
         f2y = 0.5 * ( hommfevely(indvym,2) + hommfevely(indvyp,2) )
         f2z = 0.5 * ( hommfevelz(indvzm,2) + hommfevelz(indvzp,2) )
c
         f3x = 0.5 * ( hommfevelx(indvxm,3) + hommfevelx(indvxp,3) )
         f3y = 0.5 * ( hommfevely(indvym,3) + hommfevely(indvyp,3) )
         f3z = 0.5 * ( hommfevelz(indvzm,3) + hommfevelz(indvzp,3) )
c
c add to the respective terms
c ---------------------------
c
      ich = 1
      if(ich .eq. 0) then
      print *,'the hard way'
         zkxx = zkxx + del * 
     1     ( ( rkxx * f1x + rkxy * f1y + rkxz * f1z ) * f1x
     1     + ( rkyx * f1x + rkyy * f1y + rkyz * f1z ) * f1y
     1     + ( rkzx * f1x + rkzy * f1y + rkzz * f1z ) * f1z )
c
         zkxy = zkxy + del * 
     1     ( ( rkxx * f1x + rkxy * f1y + rkxz * f1z ) * f2x
     1     + ( rkyx * f1x + rkyy * f1y + rkyz * f1z ) * f2y
     1     + ( rkzx * f1x + rkzy * f1y + rkzz * f1z ) * f2z )
c
         zkxz = zkxz + del * 
     1     ( ( rkxx * f1x + rkxy * f1y + rkxz * f1z ) * f3x
     1     + ( rkyx * f1x + rkyy * f1y + rkyz * f1z ) * f3y
     1     + ( rkzx * f1x + rkzy * f1y + rkzz * f1z ) * f3z )
c
         zkyx = zkyx + del * 
     1     ( ( rkxx * f2x + rkxy * f2y + rkxz * f2z ) * f1x
     1     + ( rkyx * f2x + rkyy * f2y + rkyz * f2z ) * f1y
     1     + ( rkzx * f2x + rkzy * f2y + rkzz * f2z ) * f1z )
c
         zkyy = zkyy + del * 
     1     ( ( rkxx * f2x + rkxy * f2y + rkxz * f2z ) * f2x
     1     + ( rkyx * f2x + rkyy * f2y + rkyz * f2z ) * f2y
     1     + ( rkzx * f2x + rkzy * f2y + rkzz * f2z ) * f2z )
c
         zkyz = zkyz + del * 
     1     ( ( rkxx * f2x + rkxy * f2y + rkxz * f2z ) * f3x
     1     + ( rkyx * f2x + rkyy * f2y + rkyz * f2z ) * f3y
     1     + ( rkzx * f2x + rkzy * f2y + rkzz * f2z ) * f3z )
c
         zkzx = zkzx + del * 
     1     ( ( rkxx * f3x + rkxy * f3y + rkxz * f3z ) * f1x
     1     + ( rkyx * f3x + rkyy * f3y + rkyz * f3z ) * f1y
     1     + ( rkzx * f3x + rkzy * f3y + rkzz * f3z ) * f1z )
c
         zkzy = zkzy + del * 
     1     ( ( rkxx * f3x + rkxy * f3y + rkxz * f3z ) * f2x
     1     + ( rkyx * f3x + rkyy * f3y + rkyz * f3z ) * f2y
     1     + ( rkzx * f3x + rkzy * f3y + rkzz * f3z ) * f2z )
c
         zkzy = zkzy + del * 
     1     ( ( rkxx * f3x + rkxy * f3y + rkxz * f3z ) * f3x
     1     + ( rkyx * f3x + rkyy * f3y + rkyz * f3z ) * f3y
     1     + ( rkzx * f3x + rkzy * f3y + rkzz * f3z ) * f3z )
      else
      print *,'the easy way'
c
         zkxx = zkxx - del * f1x
c
         zkxy = zkxy - del * f2x
c
         zkxz = zkxz - del * f3x
c
         zkyx = zkyx - del * f1y
c
         zkyy = zkyy - del * f2y
c
         zkyz = zkzy - del * f3y
c
         zkzx = zkxz - del * f1z
c
         zkzy = zkyz - del * f2z
c
         zkzz = zkzz - del * f3z
      end if
c
    1 continue
c
c divide through by the cell size
c -------------------------------
c
      zkxx = akxx - zkxx / cellsize
      zkxy = akxy - zkxy / cellsize
      zkxz = akxz - zkxz / cellsize
      zkyx = akyx - zkyx / cellsize
      zkyy = akyy - zkyy / cellsize
      zkyz = akyz - zkyz / cellsize
      zkzx = akzx - zkzx / cellsize
      zkzy = akzy - zkzy / cellsize
      zkzz = akzz - zkzz / cellsize
c
      return
      end
      subroutine hommferef(nxhr,nyhr,nzhr)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine will refine the computational grid for the numerical solution
c
c input
c
c   nxhr - the refinement in the first coordindate direction
c   nyhr - the refinement in the second coordindate direction
c   nzhr - the refinement in the third coordindate direction
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      real tmpgrdx(0:nodehommfe+1)
      real tmpgrdy(0:nodehommfe+1)
      real tmpgrdz(0:nodehommfe+1)
c
c set the refinement to 1 if there is only one grid block in the coordinate
c directions
c ----------
c
      if(nxhommfe .eq. 1) nxhr = 1
      if(nyhommfe .eq. 1) nyhr = 1
      if(nzhommfe .eq. 1) nzhr = 1
c
c check the first coordinate direction for refinement
c ---------------------------------------------------
c
      if(nxhommfe .gt. 1 .and. nxhr .gt. 1) then
c
c reset the grid line locations
c -----------------------------
c
        icnt = 0
        tmpgrdx(0) = xgrhommfe(0)
        do 1 i=1,nxhommfe
c
c divide the cell evenly using the refinement value
c -------------------------------------------------
c
           delx = dxhommfe(i) / real(nxhr)
c
c loop over the the interior grid line in the cell
c ------------------------------------------------
c 
           do 2 ii = 1,nxhr
              icnt = icnt + 1
              tmpgrdx(icnt) = tmpgrdx(icnt-1) + delx
    2      continue
c
    1   continue
c
c enforce a strict match at the right boundary
c --------------------------------------------
c
        tmpgrdx(icnt) = xgrhommfe(nxhommfe)
c
c compute the cell centers
c ------------------------
c
        xhommfe(0) = tmpgrdx(0)
        do 3 i=1,nxhr*nxhommfe
           xhommfe(i) = 0.5 * ( tmpgrdx(i) + tmpgrdx(i-1) )
    3   continue
        xhommfe(nxhr*nxhommfe+1) = tmpgrdx(nxhr*nxhommfe)
c
      end if
c
c check the second coordinate direction for refinement
c ----------------------------------------------------
c
      if(nyhommfe .gt. 1 .and. nyhr .gt. 1) then
c
c reset the grid line locations
c -----------------------------
c
        jcnt = 0
        tmpgrdy(0) = ygrhommfe(0)
        do 4 j=1,nyhommfe
c
c divide the cell evenly using the refinement value
c -------------------------------------------------
c
           dely = dyhommfe(j) / real(nyhr)
c
c loop over the the interior grid line in the cell
c ------------------------------------------------
c 
           do 5 jj = 1,nyhr
              jcnt = jcnt + 1
              tmpgrdy(jcnt) = tmpgrdy(jcnt-1) + dely
    5      continue
c
    4   continue
c
c enforce a strict match at the right boundary
c --------------------------------------------
c
        tmpgrdy(jcnt) = ygrhommfe(nyhommfe)
c
c compute the cell centers
c ------------------------
c
        yhommfe(0) = tmpgrdy(0)
        do 6 j=1,nyhr*nyhommfe
           yhommfe(j) = 0.5 * ( tmpgrdy(j) + tmpgrdy(j-1) )
    6   continue
        yhommfe(nyhr*nyhommfe+1) = tmpgrdy(nyhr*nyhommfe)
c
      end if
c
c check the third coordinate direction for refinement
c ---------------------------------------------------
c
      if(nzhommfe .gt. 1 .and. nzhr .gt. 1) then
c
c reset the grid line locations
c -----------------------------
c
        kcnt = 0
        tmpgrdz(0) = zgrhommfe(0)
        do 8 k=1,nzhommfe
c
c divide the cell evenly using the refinement value
c -------------------------------------------------
c
           delz = dzhommfe(k) / real(nzhr)
c
c loop over the the interior grid line in the cell
c ------------------------------------------------
c 
           do 7 kk = 1,nzhr
              kcnt = kcnt + 1
              tmpgrdz(kcnt) = tmpgrdz(kcnt-1) + delz
    7      continue
c
    8   continue
c
c enforce a strict match at the right boundary
c --------------------------------------------
c
        tmpgrdz(kcnt) = zgrhommfe(nzhommfe)
c
c compute the cell centers
c ------------------------
c
        zhommfe(0) = tmpgrdz(0)
        do 9 k=1,nzhr*nzhommfe
           zhommfe(k) = 0.5 * ( tmpgrdz(k) + tmpgrdz(k-1) )
    9   continue
        zhommfe(nxhr*nzhommfe+1) = tmpgrdz(nxhr*nzhommfe)
c
      end if
c
c finally, get the permeability values at the cell centers using the index
c location stuff
c --------------
c
      ntemp = nxhr * nxhommfe * nyhr * nyhommfe
      nxtemp = nxhr * nxhommfe
      do 11 k=1,nzhr*nzhommfe
         k2 = ( k - 1 ) * ntemp
         zval = zhommfe(k)
      do 11 j=1,nyhr*nyhommfe
         j2 = ( j - 1 ) * nxtemp + k2
         yval = yhommfe(j)
      do 11 i=1,nxhr*nxhommfe
         indp = i + j2
         xval = xhommfe(i)
         indo = lochommfeind(xval,yval,zval,ier) 
         t1homkxx(indp) = hommfekxx(indo)
         t1homkxy(indp) = hommfekxy(indo)
         t1homkxz(indp) = hommfekxz(indo)
         t1homkyx(indp) = hommfekyx(indo)
         t1homkyy(indp) = hommfekyy(indo)
         t1homkyz(indp) = hommfekyz(indo)
         t1homkzx(indp) = hommfekzx(indo)
         t1homkzy(indp) = hommfekzy(indo)
         t1homkzz(indp) = hommfekzz(indo)
   11 continue
c
c reset the number of grid blocks
c -------------------------------
c
      if(nxhommfe .gt. 1 .and. nxhr .gt. 1) nxhommfe = nxhr * nxhommfe
      if(nyhommfe .gt. 1 .and. nyhr .gt. 1) nyhommfe = nyhr * nyhommfe
      if(nzhommfe .gt. 1 .and. nzhr .gt. 1) nzhommfe = nzhr * nzhommfe
c
c compute some integer grid parameters
c ------------------------------------
c
      nxhommfep1 = nxhommfe + 1
      nyhommfep1 = nyhommfe + 1
      nzhommfep1 = nzhommfe + 1
      nxhommfem1 = nxhommfe - 1
      nyhommfem1 = nyhommfe - 1
      nzhommfem1 = nzhommfe - 1
      nnhommfevx = nxhommfep1 * nyhommfe * nzhommfe
      nnhommfevy = nxhommfe * nyhommfep1 * nzhommfe
      nnhommfevz = nxhommfe * nyhommfe * nzhommfep1
      nnhommfe = nxhommfe * nyhommfe * nzhommfe
      nhvtot = nnhommfevx + nnhommfevy + nnhommfevz + nnhommfe
      nnhommfe2d = nxhommfe * nyhommfe
      nnhommfevx2d = nxhommfep1 * nyhommfe
      nnhommfevy2d = nyhommfep1 * nzhommfe
      nnhommfevz2d = nxhommfe * nzhommfep1
      nxnyhommfe = nxhommfe * nyhommfe
      nxnzhommfe = nxhommfe * nzhommfe
      nynzhommfe = nyhommfe * nzhommfe
c
c compute some parameters - these are left over in some of the older code and
c are left in for convenience
c ---------------------------
c
      nshftv2 = nnhommfevx
      nshftv3 = nshftv2 + nnhommfevy
      nshftp  = nshftv3 + nnhommfevz
c
c restore the grid line values
c ----------------------------
c
      if(nxhommfe .gt. 1) then
        do 12 i=0,nxhommfe
           xgrhommfe(i) = tmpgrdx(i)
   12   continue
      end if
      if(nyhommfe .gt. 1) then
        do 13 j=0,nyhommfe
           ygrhommfe(j) = tmpgrdy(j)
   13   continue
      end if
      if(nzhommfe .gt. 1) then
        do 14 k=0,nzhommfe
           zgrhommfe(k) = tmpgrdz(k)
   14   continue
      end if
c
c compute the interval lengths
c ----------------------------
c
      if(nxhommfe .gt. 1) then
        do 15 i=1,nxhommfe
           dxhommfe(i) = xgrhommfe(i) - xgrhommfe(i-1)
   15   continue
      end if
      if(nyhommfe .gt. 1) then
        do 16 j=1,nyhommfe
           dyhommfe(j) = ygrhommfe(j) - ygrhommfe(j-1)
   16   continue
      end if
      if(nzhommfe .gt. 1) then
        do 17 k=1,nzhommfe
           dzhommfe(k) = zgrhommfe(k) - zgrhommfe(k-1)
   17   continue
      end if
c
c restore the refined permeabilities
c ----------------------------------
c
      do 18 i=1,nnhommfe
         hommfekxx(i) = t1homkxx(i)
         hommfekxy(i) = t1homkxy(i)
         hommfekxz(i) = t1homkxz(i)
         hommfekyx(i) = t1homkyx(i)
         hommfekyy(i) = t1homkyy(i)
         hommfekyz(i) = t1homkyz(i)
         hommfekzx(i) = t1homkzx(i)
         hommfekzy(i) = t1homkzy(i)
         hommfekzz(i) = t1homkzz(i)
   18 continue
c
c determine the original boundary locations - this is only needed if pressure
c conditions are specified on the boundary which makes the code put in an
c extra pressure node on the boundary in each coordinate strip. thus the
c computational boundary gets moved
c ---------------------------------
c
      hommfexleft = xgrhommfe(0)
      if(ihommfebndyzl .ge. 3 .and. ihommfebndyzl .le. 5)
     1        hommfexleft = xhommfe(1)
c
      hommfexright = xgrhommfe(nxhommfe)
      if(ihommfebndyzr .ge. 3 .and. ihommfebndyzr .le. 5)
     1        hommfexright = xhommfe(nxhommfe)
c
      hommfeyleft = ygrhommfe(0)
      if(ihommfebndxzl .ge. 3 .and. ihommfebndxzl .le. 5)
     1        hommfeyleft = yhommfe(1)
c
      hommfeyright = ygrhommfe(nyhommfe)
      if(ihommfebndxzr .ge. 3 .and. ihommfebndxzr .le. 5) 
     1        hommfeyright = yhommfe(nyhommfe)
c
      hommfezleft = zgrhommfe(0)
      if(ihommfebndxyl .ge. 3 .and. ihommfebndxyl .le. 5)
     1        hommfezleft = zhommfe(1)
c
      hommfezright = zgrhommfe(nzhommfe)
      if(ihommfebndxyr .ge. 3 .and. ihommfebndxyr .le. 5)
     1        hommfezright = zhommfe(nzhommfe)
c
      return
      end
      subroutine homavggradap(kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz
     1,x,y,z,nxh,nyh,nzh,nxhr,nyhr,nzhr,zkxx,zkxy,zkxz,zkyx,zkyy
     1,zkyz,zkzx,zkzy,zkzz)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine computes the average using the solution values in the mfe
c version of the homogenization code
c
c input
c
c   kxx, etc. - the array of permeability values
c   x,y,z - the location of the cell centers in the mesh
c   nxh,nyh,nzh - the number of grid blocks in each direction
c   nxhr,nyhr,nzhr - the number of grid block refinements in each direction
c
c output
c
c   zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz - the average values for the
c            tensor.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
      real kxx(*),kxy(*),kxz(*)
      real kyx(*),kyy(*),kyz(*)
      real kzx(*),kzy(*),kzz(*)
      real x(*),y(*),z(*)
      real zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz
c
c finally compute the average value based on the finite element solution
c
c initialize the equivalent values
c --------------------------------
c
      zkxx = 0.0
      zkxy = 0.0
      zkxz = 0.0
      zkyx = 0.0
      zkyy = 0.0
      zkyz = 0.0
      zkzx = 0.0
      zkzy = 0.0
      zkzz = 0.0
c
c compute the overall block size for use below
c --------------------------------------------
c
      if(nxh .eq. 1) then
        xvalm = 0.0
        xvalp = 1.0
      else
        xvalm = 1.5 * x(1) - 0.5 * x(2)
        xvalp = 1.5 * x(nxh) - 0.5 * x(nxh-1)
      end if
      if(nyh .eq. 1) then
        yvalm = 0.0
        yvalp = 1.0
      else
        yvalm = 1.5 * y(1) - 0.5 * y(2)
        yvalp = 1.5 * y(nyh) - 0.5 * y(nyh-1)
      end if
      if(nzh .eq. 1) then
        zvalm = 0.0
        zvalp = 1.0
      else
        zvalm = 1.5 * z(1) - 0.5 * z(2)
        zvalp = 1.5 * z(nzh) - 0.5 * z(nzh-1)
      end if
      cellsize = ( xvalp - xvalm ) * ( yvalp - yvalm )
     1               * ( zvalp - zvalm )
c
c compute the number of unknowns in the homogenization problem
c ------------------------------------------------------------
c
      nvalx = nxh * nxhr
      nvaly = nyh * nyhr
      nvalz = nzh * nzhr
      ntot = nxh * nyh * nzh
      nvar = nvalx * nvaly * nvalz
c
c compute the 2-d shifts for the 3-d case
c ---------------------------------------
c
      nvtemp = nvalx * nvaly
      nktemp = nxh * nyh
c
c loop over the third coordinate
c ------------------------------
c
      do 9 k=1,nvalz
         k2 = ( k - 1 ) * nvtemp
c
c get the third coordinate index location in the permeability grid
c ----------------------------------------------------------------
c
         indz = ( k + nzhr - 1 ) / nzhr
c
c compute the grid block size for the computational cell in z
c -----------------------------------------------------------
c
         if(nzh .eq. 1) then
           zvalm = 0.0
           zvalp = 1.0
         else
           if(indz .eq. 1) then
             zvalm = 1.5 * z(1) - 0.5 * z(2)
             zvalp = 0.5 * ( z(indz) + z(indz+1) )
           end if
           if(indz .gt. 1 .and. indz .lt. nzh) then
             zvalm = 0.5 * ( z(indz-1) + z(indz) )
             zvalp = 0.5 * ( z(indz) + z(indz+1) )
           end if
           if(indz .eq. nzh) then
             zvalm = 0.5 * ( z(indz-1) + z(indz) )
             zvalp = 1.5 * z(indz) - 0.5 * z(indz-1)
           end if
         end if
         delz = ( zvalp - zvalm ) / real(nzhr)
c
c compute the center of the computational cell
c --------------------------------------------
c
         zcntr = 0.5 * ( zvalm + zvalp )
c
c loop over the second coordinate
c -------------------------------
c
      do 9 j=1,nvaly
         j2 = ( j - 1 ) * nvalx
c
c get the second coordinate index location in the permeability grid
c -----------------------------------------------------------------
c
         indy = ( j + nyhr - 1 ) / nyhr
c
c compute the grid block size for the computational cell in y
c -----------------------------------------------------------
c
         if(nyh .eq. 1) then
           yvalm = 0.0
           yvalp = 1.0
         else
           if(indy .eq. 1) then
             yvalm = 1.5 * y(1) - 0.5 * y(2)
             yvalp = 0.5 * ( y(indy) + y(indy+1) )
           end if
           if(indy .gt. 1 .and. indy .lt. nyh) then
             yvalm = 0.5 * ( y(indy-1) + y(indy) )
             yvalp = 0.5 * ( y(indy) + y(indy+1) )
           end if
           if(indy .eq. nyh) then
             yvalm = 0.5 * ( y(indy-1) + y(indy) )
             yvalp = 1.5 * y(indy) - 0.5 * y(indy-1)
           end if
         end if
         dely = ( yvalp - yvalm ) / real(nyhr)
c
c compute the center of the computational cell
c --------------------------------------------
c
         ycntr = 0.5 * ( yvalm + yvalp )
c
      do 9 i=1,nvalx
c
c get the first coordinate index location in the permeability grid
c ----------------------------------------------------------------
c
         indx = ( i + nxhr - 1 ) / nxhr
c
c compute the grid block size for the computational cell in x
c -----------------------------------------------------------
c
         if(nxh .eq. 1) then
           xvalm = 0.0
           xvalp = 1.0
         else
           if(indx .eq. 1) then
             xvalm = 1.5 * x(1) - 0.5 * x(2)
             xvalp = 0.5 * ( x(indx) + x(indx+1) )
           end if
           if(indx .gt. 1 .and. indx .lt. nxh) then
             xvalm = 0.5 * ( x(indx-1) + x(indx) )
             xvalp = 0.5 * ( x(indx) + x(indx+1) )
           end if
           if(indx .eq. nxh) then
             xvalm = 0.5 * ( x(indx-1) + x(indx) )
             xvalp = 1.5 * x(indx) - 0.5 * x(indx-1)
           end if
         end if
         delx = ( xvalp - xvalm ) / real(nxhr)
c
c compute the center of the computational cell
c --------------------------------------------
c
         xcntr = 0.5 * ( xvalm + xvalp )
c
c compute the volume of the current cell
c --------------------------------------
c
         del = delx * dely * delz
c
c assign the permeability values
c ------------------------------
c
         indprm = indx + ( indy - 1 ) * nxh + ( indz - 1 ) * nktemp
         rkxx = kxx(indprm)
         rkxy = kxy(indprm)
         rkxz = kxz(indprm)
         rkyx = kyx(indprm)
         rkyy = kyy(indprm)
         rkyz = kyz(indprm)
         rkzx = kzx(indprm)
         rkzy = kzy(indprm)
         rkzz = kzz(indprm)
c
c compute the inverse of the tensor at the point
c ----------------------------------------------
c
         invrtform = 0
         ifullchk = 0
         if(rkxy .ne. 0.0) ifullchk = 1
         if(rkxz .ne. 0.0) ifullchk = 1
         if(rkyx .ne. 0.0) ifullchk = 1
         if(rkyz .ne. 0.0) ifullchk = 1
         if(rkzx .ne. 0.0) ifullchk = 1
         if(rkzy .ne. 0.0) ifullchk = 1
         if(ifullchk .eq. 1) invrtform = 1
         call invrt3x3(rkxx,rkxy,rkxz
     1                ,rkyx,rkyy,rkyz
     1                ,rkzx,rkzy,rkzz
     1                ,invrtform)
c
c compute the indices of the grid lines on the boundary of the grid block
c -----------------------------------------------------------------------
c
         indvxm = locvelindxm(xcntr,ycntr,zcntr,ier)
         indvxp = locvelindxp(xcntr,ycntr,zcntr,ier)
         indvym = locvelindym(xcntr,ycntr,zcntr,ier)
         indvyp = locvelindyp(xcntr,ycntr,zcntr,ier)
         indvzm = locvelindzm(xcntr,ycntr,zcntr,ier)
         indvzp = locvelindzp(xcntr,ycntr,zcntr,ier)
         q1x = 0.5 * ( hommfevelx(indvxm,1) + hommfevelx(indvxp,1) )
         q1y = 0.5 * ( hommfevely(indvym,1) + hommfevely(indvyp,1) )
         q1z = 0.5 * ( hommfevelz(indvzm,1) + hommfevelz(indvzp,1) )
c
         q2x = 0.5 * ( hommfevelx(indvxm,2) + hommfevelx(indvxp,2) )
         q2y = 0.5 * ( hommfevely(indvym,2) + hommfevely(indvyp,2) )
         q2z = 0.5 * ( hommfevelz(indvzm,2) + hommfevelz(indvzp,2) )
c
         q3x = 0.5 * ( hommfevelx(indvxm,3) + hommfevelx(indvxp,3) )
         q3y = 0.5 * ( hommfevely(indvym,3) + hommfevely(indvyp,3) )
         q3z = 0.5 * ( hommfevelz(indvzm,3) + hommfevelz(indvzp,3) )
c
c grab the six velocities on the facies of the block
c --------------------------------------------------
c
         vxm1 = hommfevelx(indvxm,1)
         vxm2 = hommfevelx(indvxm,2)
         vxm3 = hommfevelx(indvxm,3)
         vxp1 = hommfevelx(indvxp,1)
         vxp2 = hommfevelx(indvxp,2)
         vxp3 = hommfevelx(indvxp,3)
         print *,vxm1,vxm2,vxm3,vxp1,vxp2,vxp3
         print *,q1x,q2x,q3x
        read(5,*)
c
         vym1 = hommfevely(indvym,1)
         vym2 = hommfevely(indvym,2)
         vym3 = hommfevely(indvym,3)
         vyp1 = hommfevely(indvyp,1)
         vyp2 = hommfevely(indvyp,2)
         vyp3 = hommfevely(indvyp,3)
c
         vzm1 = hommfevelz(indvzm,1)
         vzm2 = hommfevelz(indvzm,2)
         vzm3 = hommfevelz(indvzm,3)
         vzp1 = hommfevelz(indvzp,1)
         vzp2 = hommfevelz(indvzp,2)
         vzp3 = hommfevelz(indvzp,3)
c stuff
c        (dx*dy*dz*(2*rkxx*(vxmi*(2*vxmj + vxpj) + vxpi*(vxmj + 2*vxpj)) +
c     -      3*rkxy*vxmi*vymj + 3*rkxy*vxpi*vymj + 4*rkyy*vymi*vymj +
c     -      2*rkyy*vymj*vypi + 3*rkyx*(vxmj + vxpj)*(vymi + vypi) +
c     -      3*rkxy*vxmi*vypj + 3*rkxy*vxpi*vypj + 2*rkyy*vymi*vypj +
c     -      4*rkyy*vypi*vypj + 3*rkzx*vxmj*vzmi + 3*rkzx*vxpj*vzmi +
c     -      3*rkzy*vymj*vzmi + 3*rkzy*vypj*vzmi + 3*rkxz*vxmi*vzmj +
c     -      3*rkxz*vxpi*vzmj + 3*rkyz*vymi*vzmj + 3*rkyz*vypi*vzmj +
c     -      4*rkzz*vzmi*vzmj + 3*rkzx*vxmj*vzpi + 3*rkzx*vxpj*vzpi +
c     -      3*rkzy*vymj*vzpi + 3*rkzy*vypj*vzpi + 2*rkzz*vzmj*vzpi +
c     -      3*rkxz*vxmi*vzpj + 3*rkxz*vxpi*vzpj + 3*rkyz*vymi*vzpj +
c     -      3*rkyz*vypi*vzpj + 2*rkzz*vzmi*vzpj + 4*rkzz*vzpi*vzpj))/
c     -  11.9999999999999
c
c add to the respective terms - note that the values in rk-- below are the
c entries in the inverse of the tensor
c ------------------------------------
c
         if(nxhommfe .gt. 1) then
           zkxx = zkxx + del * (
     1     2*rkxx*(vxm1*(2*vxm1 + vxp1) + vxp1*( vxm1 + 2*vxp1 ) ) +
     1      3*rkxy*vxm1*vym1 + 3*rkxy*vxp1*vym1 + 4*rkyy*vym1*vym1 +
     1      2*rkyy*vym1*vyp1 + 3*rkyx*(vxm1 + vxp1)*(vym1 + vyp1) +
     1      3*rkxy*vxm1*vyp1 + 3*rkxy*vxp1*vyp1 + 2*rkyy*vym1*vyp1 +
     1      4*rkyy*vyp1*vyp1 + 3*rkzx*vxm1*vzm1 + 3*rkzx*vxp1*vzm1 +
     1      3*rkzy*vym1*vzm1 + 3*rkzy*vyp1*vzm1 + 3*rkxz*vxm1*vzm1 +
     1      3*rkxz*vxp1*vzm1 + 3*rkyz*vym1*vzm1 + 3*rkyz*vyp1*vzm1 +
     1      4*rkzz*vzm1*vzm1 + 3*rkzx*vxm1*vzp1 + 3*rkzx*vxp1*vzp1 +
     1      3*rkzy*vym1*vzp1 + 3*rkzy*vyp1*vzp1 + 2*rkzz*vzm1*vzp1 +
     1      3*rkxz*vxm1*vzp1 + 3*rkxz*vxp1*vzp1 + 3*rkyz*vym1*vzp1 +
     1      3*rkyz*vyp1*vzp1 + 2*rkzz*vzm1*vzp1 + 4*rkzz*vzp1*vzp1 ) /
     1      12.0 
         else
c this assumes the perms are inverted above
           zkxx = zkxx + del / rkxx
         end if
c
         zkxy = zkxy + del * (
     1     2*rkxx*(vxm1*(2*vxm2 + vxp2) + vxp1*( vxm2 + 2*vxp2 ) ) +
     1      3*rkxy*vxm1*vym2 + 3*rkxy*vxp1*vym2 + 4*rkyy*vym1*vym2 +
     1      2*rkyy*vym2*vyp1 + 3*rkyx*(vxm2 + vxp2)*(vym1 + vyp1) +
     1      3*rkxy*vxm1*vyp2 + 3*rkxy*vxp1*vyp2 + 2*rkyy*vym1*vyp2 +
     1      4*rkyy*vyp1*vyp2 + 3*rkzx*vxm2*vzm1 + 3*rkzx*vxp2*vzm1 +
     1      3*rkzy*vym2*vzm1 + 3*rkzy*vyp2*vzm1 + 3*rkxz*vxm1*vzm2 +
     1      3*rkxz*vxp1*vzm2 + 3*rkyz*vym1*vzm2 + 3*rkyz*vyp1*vzm2 +
     1      4*rkzz*vzm1*vzm2 + 3*rkzx*vxm2*vzp1 + 3*rkzx*vxp2*vzp1 +
     1      3*rkzy*vym2*vzp1 + 3*rkzy*vyp2*vzp1 + 2*rkzz*vzm2*vzp1 +
     1      3*rkxz*vxm1*vzp2 + 3*rkxz*vxp1*vzp2 + 3*rkyz*vym1*vzp2 +
     1      3*rkyz*vyp1*vzp2 + 2*rkzz*vzm1*vzp2 + 4*rkzz*vzp1*vzp2 ) /
     1      12.0 
c
         zkxz = zkxz + del * (
     1     2*rkxx*(vxm1*(2*vxm3 + vxp3) + vxp1*( vxm3 + 2*vxp3 ) ) +
     1      3*rkxy*vxm1*vym3 + 3*rkxy*vxp1*vym3 + 4*rkyy*vym1*vym3 +
     1      2*rkyy*vym3*vyp1 + 3*rkyx*(vxm3 + vxp3)*(vym1 + vyp1) +
     1      3*rkxy*vxm1*vyp3 + 3*rkxy*vxp1*vyp3 + 2*rkyy*vym1*vyp3 +
     1      4*rkyy*vyp1*vyp3 + 3*rkzx*vxm3*vzm1 + 3*rkzx*vxp3*vzm1 +
     1      3*rkzy*vym3*vzm1 + 3*rkzy*vyp3*vzm1 + 3*rkxz*vxm1*vzm3 +
     1      3*rkxz*vxp1*vzm3 + 3*rkyz*vym1*vzm3 + 3*rkyz*vyp1*vzm3 +
     1      4*rkzz*vzm1*vzm3 + 3*rkzx*vxm3*vzp1 + 3*rkzx*vxp3*vzp1 +
     1      3*rkzy*vym3*vzp1 + 3*rkzy*vyp3*vzp1 + 2*rkzz*vzm3*vzp1 +
     1      3*rkxz*vxm1*vzp3 + 3*rkxz*vxp1*vzp3 + 3*rkyz*vym1*vzp3 +
     1      3*rkyz*vyp1*vzp3 + 2*rkzz*vzm1*vzp3 + 4*rkzz*vzp1*vzp3 ) /
     1      12.0 
c
         zkyx = zkyx + del * (
     1     2*rkxx*(vxm2*(2*vxm1 + vxp1) + vxp2*( vxm1 + 2*vxp1 ) ) +
     1      3*rkxy*vxm2*vym1 + 3*rkxy*vxp2*vym1 + 4*rkyy*vym2*vym1 +
     1      2*rkyy*vym1*vyp2 + 3*rkyx*(vxm1 + vxp1)*(vym2 + vyp2) +
     1      3*rkxy*vxm2*vyp1 + 3*rkxy*vxp2*vyp1 + 2*rkyy*vym2*vyp1 +
     1      4*rkyy*vyp2*vyp1 + 3*rkzx*vxm1*vzm2 + 3*rkzx*vxp1*vzm2 +
     1      3*rkzy*vym1*vzm2 + 3*rkzy*vyp1*vzm2 + 3*rkxz*vxm2*vzm1 +
     1      3*rkxz*vxp2*vzm1 + 3*rkyz*vym2*vzm1 + 3*rkyz*vyp2*vzm1 +
     1      4*rkzz*vzm2*vzm1 + 3*rkzx*vxm1*vzp2 + 3*rkzx*vxp1*vzp2 +
     1      3*rkzy*vym1*vzp2 + 3*rkzy*vyp1*vzp2 + 2*rkzz*vzm1*vzp2 +
     1      3*rkxz*vxm2*vzp1 + 3*rkxz*vxp2*vzp1 + 3*rkyz*vym2*vzp1 +
     1      3*rkyz*vyp2*vzp1 + 2*rkzz*vzm2*vzp1 + 4*rkzz*vzp2*vzp1 ) /
     1      12.0 
c
         if(nyhommfe .gt. 1) then
           zkyy = zkyy + del * (
     1     2*rkxx*(vxm2*(2*vxm2 + vxp2) + vxp2*( vxm2 + 2*vxp2 ) ) +
     1      3*rkxy*vxm2*vym2 + 3*rkxy*vxp2*vym2 + 4*rkyy*vym2*vym2 +
     1      2*rkyy*vym2*vyp2 + 3*rkyx*(vxm2 + vxp2)*(vym2 + vyp2) +
     1      3*rkxy*vxm2*vyp2 + 3*rkxy*vxp2*vyp2 + 2*rkyy*vym2*vyp2 +
     1      4*rkyy*vyp2*vyp2 + 3*rkzx*vxm2*vzm2 + 3*rkzx*vxp2*vzm2 +
     1      3*rkzy*vym2*vzm2 + 3*rkzy*vyp2*vzm2 + 3*rkxz*vxm2*vzm2 +
     1      3*rkxz*vxp2*vzm2 + 3*rkyz*vym2*vzm2 + 3*rkyz*vyp2*vzm2 +
     1      4*rkzz*vzm2*vzm2 + 3*rkzx*vxm2*vzp2 + 3*rkzx*vxp2*vzp2 +
     1      3*rkzy*vym2*vzp2 + 3*rkzy*vyp2*vzp2 + 2*rkzz*vzm2*vzp2 +
     1      3*rkxz*vxm2*vzp2 + 3*rkxz*vxp2*vzp2 + 3*rkyz*vym2*vzp2 +
     1      3*rkyz*vyp2*vzp2 + 2*rkzz*vzm2*vzp2 + 4*rkzz*vzp2*vzp2 ) /
     1      12.0 
         else
c this assumes the perms are inverted above
           zkyy = zkyy + del / rkyy
         end if
c
         zkyz = zkyz + del * (
     1     2*rkxx*(vxm2*(2*vxm3 + vxp3) + vxp2*( vxm3 + 2*vxp3 ) ) +
     1      3*rkxy*vxm2*vym3 + 3*rkxy*vxp2*vym3 + 4*rkyy*vym2*vym3 +
     1      2*rkyy*vym3*vyp2 + 3*rkyx*(vxm3 + vxp3)*(vym2 + vyp2) +
     1      3*rkxy*vxm2*vyp3 + 3*rkxy*vxp2*vyp3 + 2*rkyy*vym2*vyp3 +
     1      4*rkyy*vyp2*vyp3 + 3*rkzx*vxm3*vzm2 + 3*rkzx*vxp3*vzm2 +
     1      3*rkzy*vym3*vzm2 + 3*rkzy*vyp3*vzm2 + 3*rkxz*vxm2*vzm3 +
     1      3*rkxz*vxp2*vzm3 + 3*rkyz*vym2*vzm3 + 3*rkyz*vyp2*vzm3 +
     1      4*rkzz*vzm2*vzm3 + 3*rkzx*vxm3*vzp2 + 3*rkzx*vxp3*vzp2 +
     1      3*rkzy*vym3*vzp2 + 3*rkzy*vyp3*vzp2 + 2*rkzz*vzm3*vzp2 +
     1      3*rkxz*vxm2*vzp3 + 3*rkxz*vxp2*vzp3 + 3*rkyz*vym2*vzp3 +
     1      3*rkyz*vyp2*vzp3 + 2*rkzz*vzm2*vzp3 + 4*rkzz*vzp2*vzp3 ) /
     1      12.0 
c
         zkzx = zkzx + del * (
     1     2*rkxx*(vxm3*(2*vxm1 + vxp1) + vxp3*( vxm1 + 2*vxp1 ) ) +
     1      3*rkxy*vxm3*vym1 + 3*rkxy*vxp3*vym1 + 4*rkyy*vym3*vym1 +
     1      2*rkyy*vym1*vyp3 + 3*rkyx*(vxm1 + vxp1)*(vym3 + vyp3) +
     1      3*rkxy*vxm3*vyp1 + 3*rkxy*vxp3*vyp1 + 2*rkyy*vym3*vyp1 +
     1      4*rkyy*vyp3*vyp1 + 3*rkzx*vxm1*vzm3 + 3*rkzx*vxp1*vzm3 +
     1      3*rkzy*vym1*vzm3 + 3*rkzy*vyp1*vzm3 + 3*rkxz*vxm3*vzm1 +
     1      3*rkxz*vxp3*vzm1 + 3*rkyz*vym3*vzm1 + 3*rkyz*vyp3*vzm1 +
     1      4*rkzz*vzm3*vzm1 + 3*rkzx*vxm1*vzp3 + 3*rkzx*vxp1*vzp3 +
     1      3*rkzy*vym1*vzp3 + 3*rkzy*vyp1*vzp3 + 2*rkzz*vzm1*vzp3 +
     1      3*rkxz*vxm3*vzp1 + 3*rkxz*vxp3*vzp1 + 3*rkyz*vym3*vzp1 +
     1      3*rkyz*vyp3*vzp1 + 2*rkzz*vzm3*vzp1 + 4*rkzz*vzp3*vzp1 ) /
     1      12.0 
c
         zkzy = zkzy + del * (
     1     2*rkxx*(vxm3*(2*vxm2 + vxp2) + vxp3*( vxm2 + 2*vxp2 ) ) +
     1      3*rkxy*vxm3*vym2 + 3*rkxy*vxp3*vym2 + 4*rkyy*vym3*vym2 +
     1      2*rkyy*vym2*vyp3 + 3*rkyx*(vxm2 + vxp2)*(vym3 + vyp3) +
     1      3*rkxy*vxm3*vyp2 + 3*rkxy*vxp3*vyp2 + 2*rkyy*vym3*vyp2 +
     1      4*rkyy*vyp3*vyp2 + 3*rkzx*vxm2*vzm3 + 3*rkzx*vxp2*vzm3 +
     1      3*rkzy*vym2*vzm3 + 3*rkzy*vyp2*vzm3 + 3*rkxz*vxm3*vzm2 +
     1      3*rkxz*vxp3*vzm2 + 3*rkyz*vym3*vzm2 + 3*rkyz*vyp3*vzm2 +
     1      4*rkzz*vzm3*vzm2 + 3*rkzx*vxm2*vzp3 + 3*rkzx*vxp2*vzp3 +
     1      3*rkzy*vym2*vzp3 + 3*rkzy*vyp2*vzp3 + 2*rkzz*vzm2*vzp3 +
     1      3*rkxz*vxm3*vzp2 + 3*rkxz*vxp3*vzp2 + 3*rkyz*vym3*vzp2 +
     1      3*rkyz*vyp3*vzp2 + 2*rkzz*vzm3*vzp2 + 4*rkzz*vzp3*vzp2 ) /
     1      12.0 
c
         if(nzhommfe .gt. 1) then
           zkzz = zkzz + del * (
     1     2*rkxx*(vxm3*(2*vxm3 + vxp3) + vxp3*( vxm3 + 2*vxp3 ) ) +
     1      3*rkxy*vxm3*vym3 + 3*rkxy*vxp3*vym3 + 4*rkyy*vym3*vym3 +
     1      2*rkyy*vym3*vyp3 + 3*rkyx*(vxm3 + vxp3)*(vym3 + vyp3) +
     1      3*rkxy*vxm3*vyp3 + 3*rkxy*vxp3*vyp3 + 2*rkyy*vym3*vyp3 +
     1      4*rkyy*vyp3*vyp3 + 3*rkzx*vxm3*vzm3 + 3*rkzx*vxp3*vzm3 +
     1      3*rkzy*vym3*vzm3 + 3*rkzy*vyp3*vzm3 + 3*rkxz*vxm3*vzm3 +
     1      3*rkxz*vxp3*vzm3 + 3*rkyz*vym3*vzm3 + 3*rkyz*vyp3*vzm3 +
     1      4*rkzz*vzm3*vzm3 + 3*rkzx*vxm3*vzp3 + 3*rkzx*vxp3*vzp3 +
     1      3*rkzy*vym3*vzp3 + 3*rkzy*vyp3*vzp3 + 2*rkzz*vzm3*vzp3 +
     1      3*rkxz*vxm3*vzp3 + 3*rkxz*vxp3*vzp3 + 3*rkyz*vym3*vzp3 +
     1      3*rkyz*vyp3*vzp3 + 2*rkzz*vzm3*vzp3 + 4*rkzz*vzp3*vzp3 ) /
     1      12.0 
         else
c this assumes the perms are inverted above
           zkzz = zkzz + del / rkzz
         end if
c
    9 continue
c
c divide through by the cell size
c -------------------------------
c
      zkxx = zkxx / cellsize
      zkxy = zkxy / cellsize
      zkxz = zkxz / cellsize
      zkyx = zkyx / cellsize
      zkyy = zkyy / cellsize
      zkyz = zkyz / cellsize
      zkzx = zkzx / cellsize
      zkzy = zkzy / cellsize
      zkzz = zkzz / cellsize
c
c note that if the code is doing a 2-d or 1-d problem, the other dimensions
c should be fixed to the arithmetic average
c -----------------------------------------
c
      if(nxhommfe .eq. 1) call arithavg1(kxx,x,nxh,arithval,zx)
c
      return
      end
      subroutine hommfeapsoln(isystem)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine performs a solution of the system of linear equations in the
c discretization of the pressure equation when the permeability tensor is
c full and the system is to be reduced.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
      include 'include/physical_constants.h'
      real xnew(nnhomvar),xold(nnhomvar),wrk(nnhomvar),rhs(nnhomvar)
      real vx(nhomvelx),vy(nhomvely),vz(nhomvelz)
      data cgeps,cgthrshl,cgthrshu / 0.0000001,0.001,10000.0 /
c
c matrix multiplication routine for use in the iterative solver
c -------------------------------------------------------------
c
      external hommfeapmmm
c
c generate the right hand side of the pressure equation - the idea is that all
c the right hand side values for the velocity and pressure are passed in and
c the result of the operations is to modify rhshommfe for use in the solver.
c -----------------------------------------------------------------------
c
      do 55 i=1,nnhommfe
       print *,i,rhshommfe(i,isystem),rhshomvx(i,isystem)
     1,rhshomvy(i,isystem)
   55 continue
      print *,'into mod routine'
      read(5,*)
      call hommfeapmodrhs(isystem)
c
c store the old pressure values in the beginning of the array - note that the
c pressure values are in the first nnhommfe entries of the array instead of the
c last nnhommfe entries in the solution of the full system. also, store the
c modified right hand side information in the appropriate place.
c --------------------------------------------------------------
c
      do 5 i=1,nnhommfe
         xold(i) = 0.0
         rhs(i) = rhshommfe(i,isystem)
       print *,i,rhs(i)
    5 continue
      print *,'solution rt'
      read(5,*)
c
c solve the modified system
c -------------------------
c
c      call homcgmod(hommfeapmmm,xnew,xold,rhs,nnhommfe,ibithommfe
c     1,cgeps,cgthrshl,cgthrshu,error,ier)
      call homcgmod(hommfeapmmm,xnew,xold,rhs,nnhommfe,ibithommfe
     1,cgeps,cgthrshl,cgthrshu,ier)
c      call homcgsmod(hommfeapmmm,xnew,xold,rhs,nnhommfe,ibithommfe
c     1,hommfecgeps,hommfecgthrshl,hommfecgthrshu
c     1,error,ier)
c
c restore the new pressures
c -------------------------
c
      do 6 i=1,nnhommfe
         w(i,isystem) = xnew(i)
    6 continue
c
c get the velocities from the pressure
c ------------------------------------
c
      call nmltap(w(1,isystem),vx,vy,vz,isystem)
c
c compute the right hand side piece
c ---------------------------------
c
      call lusolfull(am11d,am11s,vx,hommfevelx(1,isystem),nxhommfe
     1,nyhommfe,nzhommfe,nxhommfep1,wrk)
      call lusolfull(am22d,am22s,vy,hommfevely(1,isystem),nyhommfe
     1,nzhommfe,nxhommfe,nyhommfep1,wrk)
      call lusolfull(am33d,am33s,vz,hommfevelz(1,isystem),nzhommfe
     1,nxhommfe,nyhommfe,nzhommfep1,wrk)
c
      return
      end
      integer function locvelindym(xpt,ypt,zpt,ierror)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine just computes the velocity index to the left of the node given
c a spatial location in the domain
c
c input
c
c   xpt - the first coordinate of the point where the value of the density
c         is to be computed.
c   ypt - the second coordinate of the point where the value of the density
c         is to be computed.
c   zpt - the third coordinate of the point where the value of the density 
c         is to be computed.
c
c output
c
c   ierror - an error flag
c            ierror=0; all went well
c            ierror=1; the poitn is outside the domain
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
c
c set the error value
c -------------------
c
      ierror = 0
c
c determine the location of the x grid block
c ------------------------------------------
c
      do 1 i=1,nxhommfe
       if((xpt .ge. xgrhommfe(i-1)) .and. (xpt .lt. xgrhommfe(i))) then
           ix = i
           go to 2
       end if
    1 continue
c
c check the last end point
c ------------------------
c
      if(xpt .eq. xgrhommfe(nxhommfe)) then
        ix = nxhommfe
        go to 2
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 1
c
c determine the location of the y grid block
c ------------------------------------------
c
    2 do 3 j=1,nyhommfe
       if((ypt .ge. ygrhommfe(j-1)) .and. (ypt .lt. ygrhommfe(j))) then
           jy = j
           go to 4
       end if
    3 continue
c
c check the last end point
c ------------------------
c
      if(ypt .eq. ygrhommfe(nyhommfe)) then
        jy = nyhommfe
        go to 4
      end if 
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 2
c
c determine the location of the z grid block
c ------------------------------------------
c
    4 do 5 k=1,nzhommfe
       if((zpt .ge. zgrhommfe(k-1)) .and. (zpt .lt. zgrhommfe(k))) then
           kz = k
           go to 6
       end if
    5 continue
c
c check the last end point
c ------------------------
c
      if(zpt .eq. zgrhommfe(nzhommfe)) then
        kz = nzhommfe
        go to 6
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 3
c
c compute the index in the linear pressure array
c ----------------------------------------------
c
    6 locvelindym = ( ix - 1 ) * nyhommfep1 * nzhommfe + jy
     1                  + ( kz - 1 ) * nyhommfep1
c
      return
      end
      integer function locvelindyp(xpt,ypt,zpt,ierror)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine just computes the velocity index to the left of the node given
c a spatial location in the domain
c
c input
c
c   xpt - the first coordinate of the point where the value of the density
c         is to be computed.
c   ypt - the second coordinate of the point where the value of the density
c         is to be computed.
c   zpt - the third coordinate of the point where the value of the density 
c         is to be computed.
c
c output
c
c   ierror - an error flag
c            ierror=0; all went well
c            ierror=1; the poitn is outside the domain
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
c
c set the error value
c -------------------
c
      ierror = 0
c
c determine the location of the x grid block
c ------------------------------------------
c
      do 1 i=1,nxhommfe
       if((xpt .ge. xgrhommfe(i-1)) .and. (xpt .lt. xgrhommfe(i))) then
           ix = i
           go to 2
       end if
    1 continue
c
c check the last end point
c ------------------------
c
      if(xpt .eq. xgrhommfe(nxhommfe)) then
        ix = nxhommfe
        go to 2
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 1
c
c determine the location of the y grid block
c ------------------------------------------
c
    2 do 3 j=1,nyhommfe
       if((ypt .ge. ygrhommfe(j-1)) .and. (ypt .lt. ygrhommfe(j))) then
           jy = j + 1
           go to 4
       end if
    3 continue
c
c check the last end point
c ------------------------
c
      if(ypt .eq. ygrhommfe(nyhommfe)) then
        jy = nyhommfep1
        go to 4
      end if 
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 2
c
c determine the location of the z grid block
c ------------------------------------------
c
    4 do 5 k=1,nzhommfe
       if((zpt .ge. zgrhommfe(k-1)) .and. (zpt .lt. zgrhommfe(k))) then
           kz = k
           go to 6
       end if
    5 continue
c
c check the last end point
c ------------------------
c
      if(zpt .eq. zgrhommfe(nzhommfe)) then
        kz = nzhommfe
        go to 6
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 3
c
c compute the index in the linear pressure array
c ----------------------------------------------
c
    6 locvelindyp = ( ix - 1 ) * nyhommfep1 * nzhommfe + jy
     1                  + ( kz - 1 ) * nyhommfep1
c
      return
      end
      subroutine hommfeapmodrhs(isystem)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine modifies the right hand side for a full system solve to the
c solution for only the pressure variable in the modified tensor approach.
c
c input
c
c   isystem - the system index for which the right hand side is being
c             modified - isystem must be 1, 2, or 3.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
      real r(nhommfe),wrk(nnhomvar)
      real vx1(nhomvelx),vy1(nhomvely),vz1(nhomvelz)
c
c check the system index
c ----------------------
c
      if(isystem .lt. 1 .or. isystem .gt. 3) then
        print *,' '
        print *,' ----- inside hommfemodrhs'
        print *,' '
        print *,' ***** the system number must be between 1 and 3'
        print *,' ***** input value - isystem = ',isystem
        print *,' '
        print *,' ----- exiting the simulation'
        print *,' '
        stop
      end if
c
c compute the modification due to the velocity term
c
c apply the inverse of the diagonal tensor contribution
c -----------------------------------------------------
c
      call lusolfull(am11d,am11s,rhshomvx(1,isystem),vx1,nxhommfe
     1,nyhommfe,nzhommfe,nxhommfep1,wrk)
      call lusolfull(am22d,am22s,rhshomvy(1,isystem),vy1,nyhommfe
     1,nzhommfe,nxhommfe,nyhommfep1,wrk)
      call lusolfull(am33d,am33s,rhshomvz(1,isystem),vz1,nzhommfe
     1,nxhommfe,nyhommfe,nzhommfep1,wrk)
c
c apply the finite differencing matrix
c ------------------------------------
c
      call ntmlt(vx1,vy1,vz1,r)
c
c compute the new right hand side for the pressure equation - note that the
c original velocity right hand sides are destroyed in this
c --------------------------------------------------------
c
      do 1 i=1,nnhommfe
         rhshommfe(i,isystem) = rhshommfe(i,isystem) + r(i)
    1 continue
c
      return
      end
      subroutine mssmtrx(nx,ny,nz,dx,dy,dz,ibit,irdc,ad,as)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine computes mass matrix for one of the three 'diagonal' velocoty
c function spaces in the lowest order mfe. the routine will reduce the matrix 
c if requested the only thing to not is that one of the entries in the process
c can be c masked out of the process. the mask vector is ibit and is described
c below.
c
c input
c
c   nx - the number of nodes in the "diagonal coordinate" direction
c   ny - the number of nodes second coordinate direction
c   nz - the number of nodes third coordinate direction
c   dx - the sizes of the grid blocks in the main coordinate direction
c   dy - the sizes of the grid blocks in the second coordinate direction
c   dz - the sizes of the grid blocks in the third coordinate direction
c   irdc - parameter to tell the code whether or not to reduce the system
c          for inverse application
c          irdc == 1; reduce the tridiagonal matrix
c          irdc != 1; do not reduce the tridiagonal matrix
c   ibit - bit vector to identify fixed velocity nodes
c          ibit(i)=0; the diagonal entry is masked out and should be removed
c          ibit(i)=1; the diagonal entry is not masked out
c
c output
c
c   ad - the main diagonal of the symmetric mass matrix
c   as - the super diagonal (or subdiagonal) of the tridiagonal matrix.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      real ad(*),as(*),dx(*),dy(*),dz(*)
      integer ibit(*)
c
c compute the number of values plus one
c -------------------------------------
c
      nxp1 = nx + 1
c
c compute the mass matrix
c -----------------------
c
      ntemp = nxp1 * ny
      do 1 k=1,nz
         k1 = ( k - 1 ) * ntemp
         factor1 = dz(k)
      do 1 j=1,ny
         j1 = ( j - 1 ) * nxp1 + k1
         factor2 = factor1 * dy(j)
         ad(1+j1) = factor2 * dx(1) / 3.0
         as(1+j1) = factor2 * dx(1) / 6.0
      do 2 i=2,nx
         indv = i + j1
         ad(indv) = factor2 * ( dx(i-1) + dx(i) ) / 3.0
         as(indv) = factor2 * dx(i) / 6.0
    2 continue
         ad(nxp1+j1) = factor2 * dx(nx) / 3.0
         as(nxp1+j1) = 0.0
    1 continue
c
c factor the matrix for later use
c -------------------------------
c
      if(irdc .eq. 1)
     1    call reducefull(ad,as,nx,ny,nz,nxp1,ibit)
c
      return
      end
      subroutine homavggrad(kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz
     1,x,y,z,nxh,nyh,nzh,nxhr,nyhr,nzhr,zkxx,zkxy,zkxz,zkyx,zkyy
     1,zkyz,zkzx,zkzy,zkzz)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine computes the average using the solution values in the mfe
c version of the homogenization code
c
c input
c
c   kxx, etc. - the array of permeability values
c   x,y,z - the location of the cell centers in the mesh
c   nxh,nyh,nzh - the number of grid blocks in each direction
c   nxhr,nyhr,nzhr - the number of grid block refinements in each direction
c
c output
c
c   zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz - the average values for the
c            tensor.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
      real kxx(*),kxy(*),kxz(*)
      real kyx(*),kyy(*),kyz(*)
      real kzx(*),kzy(*),kzz(*)
      real x(*),y(*),z(*)
      real zkxx,zkxy,zkxz,zkyx,zkyy,zkyz,zkzx,zkzy,zkzz
c
c finally compute the average value based on the finite element solution
c
c initialize the equivalent values
c --------------------------------
c
      zkxx = 0.0
      zkxy = 0.0
      zkxz = 0.0
      zkyx = 0.0
      zkyy = 0.0
      zkyz = 0.0
      zkzx = 0.0
      zkzy = 0.0
      zkzz = 0.0
c
c compute the overall block size for use below
c --------------------------------------------
c
      if(nxh .eq. 1) then
        xvalm = 0.0
        xvalp = 1.0
      else
        xvalm = 1.5 * x(1) - 0.5 * x(2)
        xvalp = 1.5 * x(nxh) - 0.5 * x(nxh-1)
      end if
      if(nyh .eq. 1) then
        yvalm = 0.0
        yvalp = 1.0
      else
        yvalm = 1.5 * y(1) - 0.5 * y(2)
        yvalp = 1.5 * y(nyh) - 0.5 * y(nyh-1)
      end if
      if(nzh .eq. 1) then
        zvalm = 0.0
        zvalp = 1.0
      else
        zvalm = 1.5 * z(1) - 0.5 * z(2)
        zvalp = 1.5 * z(nzh) - 0.5 * z(nzh-1)
      end if
      cellsize = ( xvalp - xvalm ) * ( yvalp - yvalm )
     1               * ( zvalp - zvalm )
c
c compute the number of unknowns in the homogenization problem
c ------------------------------------------------------------
c
      nvalx = nxh * nxhr
      nvaly = nyh * nyhr
      nvalz = nzh * nzhr
      ntot = nxh * nyh * nzh
      nvar = nvalx * nvaly * nvalz
c
c compute the 2-d shifts for the 3-d case
c ---------------------------------------
c
      nvtemp = nvalx * nvaly
      nktemp = nxh * nyh
c
c loop over the third coordinate
c ------------------------------
c
      do 9 k=1,nvalz
         k2 = ( k - 1 ) * nvtemp
c
c get the third coordinate index location in the permeability grid
c ----------------------------------------------------------------
c
         indz = ( k + nzhr - 1 ) / nzhr
c
c compute the grid block size for the computational cell in z
c -----------------------------------------------------------
c
         if(nzh .eq. 1) then
           zvalm = 0.0
           zvalp = 1.0
         else
           if(indz .eq. 1) then
             zvalm = 1.5 * z(1) - 0.5 * z(2)
             zvalp = 0.5 * ( z(indz) + z(indz+1) )
           end if
           if(indz .gt. 1 .and. indz .lt. nzh) then
             zvalm = 0.5 * ( z(indz-1) + z(indz) )
             zvalp = 0.5 * ( z(indz) + z(indz+1) )
           end if
           if(indz .eq. nzh) then
             zvalm = 0.5 * ( z(indz-1) + z(indz) )
             zvalp = 1.5 * z(indz) - 0.5 * z(indz-1)
           end if
         end if
         delz = ( zvalp - zvalm ) / real(nzhr)
c
c compute the center of the computational cell
c --------------------------------------------
c
         zcntr = 0.5 * ( zvalm + zvalp )
c
c loop over the second coordinate
c -------------------------------
c
      do 9 j=1,nvaly
         j2 = ( j - 1 ) * nvalx
c
c get the second coordinate index location in the permeability grid
c -----------------------------------------------------------------
c
         indy = ( j + nyhr - 1 ) / nyhr
c
c compute the grid block size for the computational cell in y
c -----------------------------------------------------------
c
         if(nyh .eq. 1) then
           yvalm = 0.0
           yvalp = 1.0
         else
           if(indy .eq. 1) then
             yvalm = 1.5 * y(1) - 0.5 * y(2)
             yvalp = 0.5 * ( y(indy) + y(indy+1) )
           end if
           if(indy .gt. 1 .and. indy .lt. nyh) then
             yvalm = 0.5 * ( y(indy-1) + y(indy) )
             yvalp = 0.5 * ( y(indy) + y(indy+1) )
           end if
           if(indy .eq. nyh) then
             yvalm = 0.5 * ( y(indy-1) + y(indy) )
             yvalp = 1.5 * y(indy) - 0.5 * y(indy-1)
           end if
         end if
         dely = ( yvalp - yvalm ) / real(nyhr)
c
c compute the center of the computational cell
c --------------------------------------------
c
         ycntr = 0.5 * ( yvalm + yvalp )
c
      do 9 i=1,nvalx
c
c get the first coordinate index location in the permeability grid
c ----------------------------------------------------------------
c
         indx = ( i + nxhr - 1 ) / nxhr
c
c compute the grid block size for the computational cell in x
c -----------------------------------------------------------
c
         if(nxh .eq. 1) then
           xvalm = 0.0
           xvalp = 1.0
         else
           if(indx .eq. 1) then
             xvalm = 1.5 * x(1) - 0.5 * x(2)
             xvalp = 0.5 * ( x(indx) + x(indx+1) )
           end if
           if(indx .gt. 1 .and. indx .lt. nxh) then
             xvalm = 0.5 * ( x(indx-1) + x(indx) )
             xvalp = 0.5 * ( x(indx) + x(indx+1) )
           end if
           if(indx .eq. nxh) then
             xvalm = 0.5 * ( x(indx-1) + x(indx) )
             xvalp = 1.5 * x(indx) - 0.5 * x(indx-1)
           end if
         end if
         delx = ( xvalp - xvalm ) / real(nxhr)
c
c compute the center of the computational cell
c --------------------------------------------
c
         xcntr = 0.5 * ( xvalm + xvalp )
c
c compute the volume of the current cell
c --------------------------------------
c
         del = delx * dely * delz
c
c assign the permeability values
c ------------------------------
c
         indprm = indx + ( indy - 1 ) * nxh + ( indz - 1 ) * nktemp
         rkxx = kxx(indprm)
         rkxy = kxy(indprm)
         rkxz = kxz(indprm)
         rkyx = kyx(indprm)
         rkyy = kyy(indprm)
         rkyz = kyz(indprm)
         rkzx = kzx(indprm)
         rkzy = kzy(indprm)
         rkzz = kzz(indprm)
c
c compute the inverse of the tensor at the point
c ----------------------------------------------
c
         invrtform = 0
         ifullchk = 0
         if(rkxy .ne. 0.0) ifullchk = 1
         if(rkxz .ne. 0.0) ifullchk = 1
         if(rkyx .ne. 0.0) ifullchk = 1
         if(rkyz .ne. 0.0) ifullchk = 1
         if(rkzx .ne. 0.0) ifullchk = 1
         if(rkzy .ne. 0.0) ifullchk = 1
         if(ifullchk .eq. 1) invrtform = 1
         call invrt3x3(rkxx,rkxy,rkxz
     1                ,rkyx,rkyy,rkyz
     1                ,rkzx,rkzy,rkzz
     1                ,invrtform)
c
c compute the indices of the grid lines on the boundary of the grid block
c -----------------------------------------------------------------------
c
         indvxm = locvelindxm(xcntr,ycntr,zcntr,ier)
         indvxp = locvelindxp(xcntr,ycntr,zcntr,ier)
         indvym = locvelindym(xcntr,ycntr,zcntr,ier)
         indvyp = locvelindyp(xcntr,ycntr,zcntr,ier)
         indvzm = locvelindzm(xcntr,ycntr,zcntr,ier)
         indvzp = locvelindzp(xcntr,ycntr,zcntr,ier)
c
c get the values of the various gradient variables at the cell centers
c --------------------------------------------------------------------
c
         q1x = 0.5 * ( hommfevelx(indvxm,1) + hommfevelx(indvxp,1) )
         q1y = 0.5 * ( hommfevely(indvym,1) + hommfevely(indvyp,1) )
         q1z = 0.5 * ( hommfevelz(indvzm,1) + hommfevelz(indvzp,1) )
c
         q2x = 0.5 * ( hommfevelx(indvxm,2) + hommfevelx(indvxp,2) )
         q2y = 0.5 * ( hommfevely(indvym,2) + hommfevely(indvyp,2) )
         q2z = 0.5 * ( hommfevelz(indvzm,2) + hommfevelz(indvzp,2) )
c
         q3x = 0.5 * ( hommfevelx(indvxm,3) + hommfevelx(indvxp,3) )
         q3y = 0.5 * ( hommfevely(indvym,3) + hommfevely(indvyp,3) )
         q3z = 0.5 * ( hommfevelz(indvzm,3) + hommfevelz(indvzp,3) )
c
c add to the respective terms - note that the values in rk-- below are the
c entries in the inverse of the tensor
c ------------------------------------
c
         if(nxhommfe .gt. 1) then
           zkxx = zkxx + del * (
     1           ( q1x * rkxx + q1y * rkyx + q1z * rkzx ) * q1x
     1         + ( q1x * rkxy + q1y * rkyy + q1z * rkzy ) * q1y
     1         + ( q1x * rkxz + q1y * rkyz + q1z * rkzz ) * q1z )
         else
c this assumes the perms are inverted above
           zkxx = zkxx + del / rkxx
         end if
c
         zkxy = zkxy + del * (
     1         ( q1x * rkxx + q1y * rkyx + q1z * rkzx ) * q2x
     1       + ( q1x * rkxy + q1y * rkyy + q1z * rkzy ) * q2y
     1       + ( q1x * rkxz + q1y * rkyz + q1z * rkzz ) * q2z )
c
         zkxz = zkxz + del * (
     1         ( q1x * rkxx + q1y * rkyx + q1z * rkzx ) * q3x
     1       + ( q1x * rkxy + q1y * rkyy + q1z * rkzy ) * q3y
     1       + ( q1x * rkxz + q1y * rkyz + q1z * rkzz ) * q3z )
c
         zkyx = zkyx + del * (
     1         ( q2x * rkxx + q2y * rkyx + q2z * rkzx ) * q1x
     1       + ( q2x * rkxy + q2y * rkyy + q2z * rkzy ) * q1y
     1       + ( q2x * rkxz + q2y * rkyz + q2z * rkzz ) * q1z )
c
         if(nyhommfe .gt. 1) then
           zkyy = zkyy + del * (
     1           ( q2x * rkxx + q2y * rkyx + q2z * rkzx ) * q2x
     1         + ( q2x * rkxy + q2y * rkyy + q2z * rkzy ) * q2y
     1         + ( q2x * rkxz + q2y * rkyz + q2z * rkzz ) * q2z )
         else
c this assumes the perms are inverted above
           zkyy = zkyy + del / rkyy
         end if
c
         zkyz = zkyz + del * (
     1         ( q2x * rkxx + q2y * rkyx + q2z * rkzx ) * q3x
     1       + ( q2x * rkxy + q2y * rkyy + q2z * rkzy ) * q3y
     1       + ( q2x * rkxz + q2y * rkyz + q2z * rkzz ) * q3z )
c
         zkzx = zkzx + del * (
     1         ( q3x * rkxx + q3y * rkyx + q3z * rkzx ) * q1x
     1       + ( q3x * rkxy + q3y * rkyy + q3z * rkzy ) * q1y
     1       + ( q3x * rkxz + q3y * rkyz + q3z * rkzz ) * q1z )
c
         zkzy = zkzy + del * (
     1         ( q3x * rkxx + q3y * rkyx + q3z * rkzx ) * q2x
     1       + ( q3x * rkxy + q3y * rkyy + q3z * rkzy ) * q2y
     1       + ( q3x * rkxz + q3y * rkyz + q3z * rkzz ) * q2z )
c
         if(nzhommfe .gt. 1) then
           zkzz = zkzz + del * (
     1           ( q3x * rkxx + q3y * rkyx + q3z * rkzx ) * q3x
     1         + ( q3x * rkxy + q3y * rkyy + q3z * rkzy ) * q3y
     1         + ( q3x * rkxz + q3y * rkyz + q3z * rkzz ) * q3z )
         else
c this assumes the perms are inverted above
           zkzz = zkzz + del / rkzz
         end if
c
    9 continue
c
c divide through by the cell size
c -------------------------------
c
      zkxx = zkxx / cellsize
      zkxy = zkxy / cellsize
      zkxz = zkxz / cellsize
      zkyx = zkyx / cellsize
      zkyy = zkyy / cellsize
      zkyz = zkyz / cellsize
      zkzx = zkzx / cellsize
      zkzy = zkzy / cellsize
      zkzz = zkzz / cellsize
c
c note that if the code is doing a 2-d or 1-d problem, the other dimensions
c should be fixed to the arithmetic average
c -----------------------------------------
c
      if(nxhommfe .eq. 1) call arithavg1(kxx,x,nxh,arithval,zx)
c
      return
      end
      subroutine hommfemmm(t,q)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine performs the matrix multiplication for the modified mixed
c finite element matrix for the lowest order method. that is,
c
c          -1        -1
c   [ N   M   ( I + T   S  ) N +  D   ] [ p  ]   =   Rhs
c
c input
c
c   t - vector to perform the matrix multiplication on.
c
c output
c
c   q - result from the matrix multiplication.
c
c note that the vectors t, q, have extra storage for the intermediate velocity
c entries in the computation
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
      real t(nnhomvar),q(nnhomvar),r(nhommfe),wrk(nnhomvar)
      real sx(nhomvelx),sy(nhomvely),sz(nhomvelz)
      real qx(nhomvelx),qy(nhomvely),qz(nhomvelz)
c
c flush the output array
c ----------------------
c
      do 1 i=1,nhvtot
         q(i) = 0.0
    1 continue
c
c compute shift indices for use below
c -----------------------------------
c
      ind1 = nnhommfe
      ind2 = ind1 + nnhommfevx
      ind3 = ind2 + nnhommfevy
c
c grab the components
c -------------------
c
      do 2 i=1,nnhommfevx
         qx(i) = t(i+ind1)
    2 continue  
      do 3 j=1,nnhommfevy
         qy(j) = t(j+ind2)
    3 continue  
      do 4 k=1,nnhommfevz
         qz(k) = t(k+ind3)
    4 continue  
c
c do the part of the multiplication due to the pressure difference - the
c result is three vectors used in the block additions below
c ---------------------------------------------------------
c
      call nmlt(t(1),qx,qy,qz)
c
c invert the diagonal part of the tensor for the diagonal velocity definition
c ---------------------------------------------------------------------------
c
      call lusolfull(am11d,am11s,qx,sx,nxhommfe,nyhommfe,nzhommfe
     1          ,nxhommfep1,wrk)
      call lusolfull(am22d,am22s,qy,sy,nyhommfe,nzhommfe,nxhommfe
     1          ,nyhommfep1,wrk)
      call lusolfull(am33d,am33s,qz,sz,nzhommfe,nxhommfe,nyhommfe
     1          ,nzhommfep1,wrk)
c
c compute the modification matrix multiply
c ----------------------------------------
c
      call ndmmod(sx,sy,sz,qx,qy,qz)
c
c do the part of the multiplication due to the velocity differencing - the
c result is a single vector of the dimensions of the pressure
c -----------------------------------------------------------
c
      call ntmlt(qx,qy,qz,r)
c
c do the part of the multiplication due to the time dependent term in the
c pressure equation - the result is the rest of the pressure type vector
c ----------------------------------------------------------------------
c
      do 5 i=1,nnhommfe
         q(i) = - r(i) + ibithommfe(i) * diaghommfe(i) * t(i)
    5 continue
c
c it is worthwhile to keep track of the velocity components, so store them
c into the output array
c ---------------------
c
      do 6 i=1,nnhommfevx
         q(i+ind1) = qx(i)
    6 continue  
      do 7 j=1,nnhommfevy
         q(j+ind2) = qy(j)
    7 continue  
      do 8 k=1,nnhommfevz
         q(k+ind3) = qz(k)
    8 continue  
c
      return
      end
      subroutine hommfemat
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine computes the approximation of the average pressure and total
c fluid velocity foor the simulator via the lowest order mixed finite element
c method.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
c
c call the integration routine once for each component of the velocity. note
c the calls are symmetric with respect to x, y and z.
c ---------------------------------------------------
c
      call fecoefdt(am11d,am11s,nxhommfe,nyhommfe,nzhommfe,nxhommfep1
     1,nnhommfevx,t1homkxx,dxhommfe,dyhommfe,dzhommfe)
      call fecoefdt(am22d,am22s,nyhommfe,nzhommfe,nxhommfe,nyhommfep1
     1,nnhommfevy,t1homkyy,dyhommfe,dzhommfe,dxhommfe)
      call fecoefdt(am33d,am33s,nzhommfe,nxhommfe,nyhommfe,nzhommfep1
     1,nnhommfevz,t1homkzz,dzhommfe,dxhommfe,dyhommfe)
c
c factor the velocity coefficient matrices if the system of equations is to be
c formally reduced - this is only done if the mfe matrix has been recomputed
c --------------------------------------------------------------------------
c
      call reducefull(am11d,am11s,nxhommfe,nyhommfe,nzhommfe,nxhommfep1
     1,ibithomvx)
      call reducefull(am22d,am22s,nyhommfe,nzhommfe,nxhommfe,nyhommfep1
     1,ibithomvy)
      call reducefull(am33d,am33s,nzhommfe,nxhommfe,nyhommfe,nzhommfep1
     1,ibithomvz)
c
      return
      end
      subroutine nmlt(hom,vx,vy,vz)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine performs the differencing of the pressure type array to form
c in an integrated gradient vector.
c
c input:
c
c   p - array of pressures to be differenced
c
c output:
c
c   vx - x component of the difference vector
c   vy - y component of the difference vector
c   vz - z component of the difference vector
c
c   this routine only uses the unknown values in the computation. if pressure
c and or velocity nodes have been masked out these are not included in the
c 'multiplication'
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      real hom(*),vx(*),vy(*),vz(*),ht(nhommfe)
c
c modify the temporary vector with the appropriate zero entries
c -------------------------------------------------------------
c
      do 1 i=1,nnhommfe
         ht(i) = ibithommfe(i) * hom(i)
    1 continue
c
c first do the x component of the velocity.
c -----------------------------------------
c
      if(nxhommfe .gt. 1) then
        ntemp1 = nxhommfep1 * nyhommfe
        ntemp2 = nxhommfe * nyhommfe
        do 2 k=1,nzhommfe
           k1 = ( k - 1 ) * ntemp1
           k2 = ( k - 1 ) * ntemp2
        do 2 j=1,nyhommfe
           indvt = k1 + ( j - 1 ) * nxhommfep1
           indht = k2 + ( j - 1 ) * nxhommfe
           factor = dyhommfe(j) * dzhommfe(k)
           vx(1+indvt) = - ibithomvx(1+indvt) * ht(1+indht) * factor
           do 3 i=2,nxhommfe
              indp = i + indht
              indv = i + indvt
              vx(indv) = ibithomvx(indv)
     1                 * ( ht(indp-1) - ht(indp) ) * factor
    3      continue
           vx(nxhommfep1+indvt) = ibithomvx(nxhommfep1+indvt)
     1                          * ht(nxhommfe+indht) * factor
    2   continue
      end if
c
c now the y component:
c --------------------
c
      if(nyhommfe .gt. 1) then
        ntemp1 = nyhommfep1 * nzhommfe
        do 4 i=1,nxhommfe
           i1 = ( i - 1 ) * ntemp1
        do 4 k=1,nzhommfe
           indvt = i1 + ( k - 1 ) * nyhommfep1
           indht = i + ( k - 1 ) * ntemp2
           factor = dxhommfe(i) * dzhommfe(k)
           vy(1+indvt) = - ibithomvy(1+indvt) * ht(indht) * factor
           do 5 j=2,nyhommfe
              indp = indht + ( j - 1 ) * nxhommfe
              indv = j + indvt
              vy(indv) = ibithomvy(indv)
     1                    * ( ht(indp-nxhommfe) - ht(indp) ) * factor
    5      continue
           vy(nyhommfep1+indvt) = ibithomvy(nyhommfep1+indvt)
     1                     * ht(nxnyhommfe-nxhommfe+indht) * factor
    4   continue
      end if
c
c now the z component:
c --------------------
c
      if(nzhommfe .gt. 1) then
        ntemp1 = nzhommfep1 * nxhommfe
        do 6 j=1,nyhommfe
           j1 = ( j - 1 ) * ntemp1
           j2 = ( j - 1 ) * nxhommfe
        do 6 i=1,nxhommfe
           indvt = j1 + ( i - 1 ) * nzhommfep1
           indht = i + j2
           factor = dxhommfe(i) * dyhommfe(j)
           vz(1+indvt) = -ibithomvz(1+indvt) * ht(indht) * factor
           do 7 k=2,nzhommfe
              indp = indht + ( k - 1 ) * ntemp2
              indv = k + indvt
              vz(indv) = ibithomvz(indv)
     1                 * ( ht(indp-ntemp2) - ht(indp) ) * factor
    7      continue
           vz(nzhommfep1+indvt) = ibithomvz(nzhommfep1+indvt)
     1             * ht(nnhommfe-nxnyhommfe+indht) * factor
    6   continue
      end if
c
      return
      end
      subroutine nmltap(hom,vx,vy,vz,isystem)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine performs the differencing of the pressure type array to form
c in an integrated gradient vector.
c
c input:
c
c   p - array of pressures to be differenced
c
c output:
c
c   vx - x component of the difference vector
c   vy - y component of the difference vector
c   vz - z component of the difference vector
c
c   this routine only uses the unknown values in the computation. if pressure
c and or velocity nodes have been masked out these are not included in the
c 'multiplication'
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      real hom(*),vx(*),vy(*),vz(*),ht(nhommfe)
c
c modify the temporary vector with the appropriate zero entries
c -------------------------------------------------------------
c
      do 1 i=1,nnhommfe
         ht(i) = ibithommfe(i) * hom(i)
    1 continue
c
c first do the x component of the velocity.
c -----------------------------------------
c
      if(nxhommfe .gt. 1) then
        ntemp1 = nxhommfep1 * nyhommfe
        ntemp2 = nxhommfe * nyhommfe
        if(isystem .eq. 1) then
          hleft = xgrhommfe(0)
          hright = xgrhommfe(nxhommfe)
        end if
        do 2 k=1,nzhommfe
           k1 = ( k - 1 ) * ntemp1
           k2 = ( k - 1 ) * ntemp2
           if(isystem .eq. 3) then
             hleft = zhommfe(k)
             hright = hleft
           end if
        do 2 j=1,nyhommfe
           indvt = k1 + ( j - 1 ) * nxhommfep1
           indht = k2 + ( j - 1 ) * nxhommfe
           factor = dyhommfe(j) * dzhommfe(k)
           if(isystem .eq. 2) then
             hleft = yhommfe(j)
             hright = hleft
           end if
           vx(1+indvt) = ibithomvx(1+indvt)
     1                 * ( hleft - ht(1+indht) ) * factor
c     1                 * 2.0 * ( hleft - ht(1+indht) ) * factor
           do 3 i=2,nxhommfe
              indp = i + indht
              indv = i + indvt
              vx(indv) = ibithomvx(indv)
     1                 * ( ht(indp-1) - ht(indp) ) * factor
    3      continue
           vx(nxhommfep1+indvt) = ibithomvx(nxhommfep1+indvt)
     1                 * ( ht(nxhommfe+indht) - hright ) * factor
c     1                 * 2.0 * ( ht(nxhommfe+indht) - hright ) * factor
    2   continue
      end if
c
c now the y component:
c --------------------
c
      if(nyhommfe .gt. 1) then
        if(isystem .eq. 2) then
          hleft = ygrhommfe(0)
          hright = ygrhommfe(nyhommfe)
        end if
        ntemp1 = nyhommfep1 * nzhommfe
        do 4 i=1,nxhommfe
           i1 = ( i - 1 ) * ntemp1
           if(isystem .eq. 1) then
             hleft = xhommfe(i)
             hright = hleft
           end if
        do 4 k=1,nzhommfe
           indvt = i1 + ( k - 1 ) * nyhommfep1
           indht = i + ( k - 1 ) * ntemp2
           factor = dxhommfe(i) * dzhommfe(k)
           if(isystem .eq. 3) then
             hleft = zhommfe(k)
             hright = hleft
           end if
           vy(1+indvt) = ibithomvy(1+indvt)
     1                 * ( hleft - ht(indht) ) * factor
c     1                 * 2.0 * ( hleft - ht(indht) ) * factor
           do 5 j=2,nyhommfe
              indp = indht + ( j - 1 ) * nxhommfe
              indv = j + indvt
              vy(indv) = ibithomvy(indv)
     1                    * ( ht(indp-nxhommfe) - ht(indp) ) * factor
    5      continue
           vy(nyhommfep1+indvt) = ibithomvy(nyhommfep1+indvt)
     1       * ( ht(nxnyhommfe-nxhommfe+indht) - hright )* factor
c     1       * 2.0 * ( ht(nxnyhommfe-nxhommfe+indht) - hright )* factor
    4   continue
      end if
c
c now the z component:
c --------------------
c
      if(nzhommfe .gt. 1) then
        if(isystem .eq. 3) then
          hleft = zgrhommfe(0)
          hright = zgrhommfe(nzhommfe)
        end if
        ntemp1 = nzhommfep1 * nxhommfe
        do 6 j=1,nyhommfe
           j1 = ( j - 1 ) * ntemp1
           j2 = ( j - 1 ) * nxhommfe
           if(isystem .eq. 2) then
             hleft = yhommfe(j)
             hright = hleft
           end if
        do 6 i=1,nxhommfe
           indvt = j1 + ( i - 1 ) * nzhommfep1
           indht = i + j2
           factor = dxhommfe(i) * dyhommfe(j)
           if(isystem .eq. 1) then
             hleft = xhommfe(i)
             hright = hleft
           end if
           vz(1+indvt) = ibithomvz(1+indvt)
     1                 * ( hleft - ht(indht) ) * factor
c     1                 * 2.0 * ( hleft - ht(indht) ) * factor
           do 7 k=2,nzhommfe
              indp = indht + ( k - 1 ) * ntemp2
              indv = k + indvt
              vz(indv) = ibithomvz(indv)
     1                 * ( ht(indp-ntemp2) - ht(indp) ) * factor
    7      continue
           vz(nzhommfep1+indvt) = ibithomvz(nzhommfep1+indvt)
     1      * ( ht(nnhommfe-nxnyhommfe+indht) - hright ) * factor
c     1      * 2.0 * ( ht(nnhommfe-nxnyhommfe+indht) - hright ) * factor
    6   continue
      end if
c
      return
      end
      subroutine nmltf(hom,vx,vy,vz)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine performs the differencing of the pressure type array to form
c in an integrated gradient vector.
c
c input:
c
c   p - array of pressures to be differenced
c
c output:
c
c   vx - x component of the difference vector
c   vy - y component of the difference vector
c   vz - z component of the difference vector
c
c   this routine only uses the unknown values in the computation. if pressure
c and or velocity nodes have been masked out these are the only values included
c in the 'multiplication'
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      real hom(*),vx(*),vy(*),vz(*),ht(nhommfe)
c
c modify the temporary vector with the appropriate zero entries
c -------------------------------------------------------------
c
      do 1 i=1,nnhommfe
         ht(i) = ( 1.0 - ibithommfe(i) ) * hom(i)
    1 continue
c
c first do the x component of the velocity.
c -----------------------------------------
c
      if(nxhommfe .gt. 1) then
        ntemp1 = nxhommfep1 * nyhommfe
        ntemp2 = nxhommfe * nyhommfe
        do 2 k=1,nzhommfe
           k1 = ( k - 1 ) * ntemp1
           k2 = ( k - 1 ) * ntemp2
        do 2 j=1,nyhommfe
           indvt = k1 + ( j - 1 ) * nxhommfep1
           indht = k2 + ( j - 1 ) * nxhommfe
           factor = dyhommfe(j) * dzhommfe(k)
           vx(1+indvt) = - ibithomvx(1+indvt) * ht(1+indht) * factor
           do 3 i=2,nxhommfe
              indp = i + indht
              indv = i + indvt
              vx(indv) = ibithomvx(indv)
     1                 * ( ht(indp-1) - ht(indp) ) * factor
    3      continue
           vx(nxhommfep1+indvt) = ibithomvx(nxhommfep1+indvt)
     1                          * ht(nxhommfe+indht) * factor
    2   continue
      end if
c
c now the y component:
c --------------------
c
      if(nyhommfe .gt. 1) then
        ntemp1 = nyhommfep1 * nzhommfe
        do 4 i=1,nxhommfe
           i1 = ( i - 1 ) * ntemp1
        do 4 k=1,nzhommfe
           indvt = i1 + ( k - 1 ) * nyhommfep1
           indht = i + ( k - 1 ) * ntemp2
           factor = dxhommfe(i) * dzhommfe(k)
           vy(1+indvt) = - ibithomvy(1+indvt) * ht(indht) * factor
           do 5 j=2,nyhommfe
              indp = indht + ( j - 1 ) * nxhommfe
              indv = j + indvt
              vy(indv) = ibithomvy(indv)
     1                    * ( ht(indp-nxhommfe) - ht(indp) ) * factor
    5      continue
           vy(nyhommfep1+indvt) = ibithomvy(nyhommfep1+indvt)
     1                     * ht(nxnyhommfe-nxhommfe+indht) * factor
    4   continue
      end if
c
c now the z component:
c --------------------
c
      if(nzhommfe .gt. 1) then
        ntemp1 = nzhommfep1 * nxhommfe
        do 6 j=1,nyhommfe
           j1 = ( j - 1 ) * ntemp1
           j2 = ( j - 1 ) * nxhommfe
        do 6 i=1,nxhommfe
           indvt = j1 + ( i - 1 ) * nzhommfep1
           indht = i + j2
           factor = dxhommfe(i) * dyhommfe(j)
           vz(1+indvt) = -ibithomvz(1+indvt) * ht(indht) * factor
           do 7 k=2,nzhommfe
              indp = indht + ( k - 1 ) * ntemp2
              indv = k + indvt
              vz(indv) = ibithomvz(indv)
     1                 * ( ht(indp-ntemp2) - ht(indp) ) * factor
    7      continue
           vz(nzhommfep1+indvt) = ibithomvz(nzhommfep1+indvt)
     1             * ht(nnhommfe-nxnyhommfe+indht) * factor
    6   continue
      end if
c
      return
      end
      integer function locvelindzm(xpt,ypt,zpt,ierror)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine just computes the velocity index to the left of the node given
c a spatial location in the domain
c
c input
c
c   xpt - the first coordinate of the point where the value of the density
c         is to be computed.
c   ypt - the second coordinate of the point where the value of the density
c         is to be computed.
c   zpt - the third coordinate of the point where the value of the density 
c         is to be computed.
c
c output
c
c   ierror - an error flag
c            ierror=0; all went well
c            ierror=1; the poitn is outside the domain
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
c
c set the error value
c -------------------
c
      ierror = 0
c
c determine the location of the x grid block
c ------------------------------------------
c
      do 1 i=1,nxhommfe
       if((xpt .ge. xgrhommfe(i-1)) .and. (xpt .lt. xgrhommfe(i))) then
           ix = i
           go to 2
       end if
    1 continue
c
c check the last end point
c ------------------------
c
      if(xpt .eq. xgrhommfe(nxhommfe)) then
        ix = nxhommfe
        go to 2
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 1
c
c determine the location of the y grid block
c ------------------------------------------
c
    2 do 3 j=1,nyhommfe
       if((ypt .ge. ygrhommfe(j-1)) .and. (ypt .lt. ygrhommfe(j))) then
           jy = j
           go to 4
       end if
    3 continue
c
c check the last end point
c ------------------------
c
      if(ypt .eq. ygrhommfe(nyhommfe)) then
        jy = nyhommfe
        go to 4
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 2
c
c determine the location of the z grid block
c ------------------------------------------
c
    4 do 5 k=1,nzhommfe
       if((zpt .ge. zgrhommfe(k-1)) .and. (zpt .lt. zgrhommfe(k))) then
           kz = k
           go to 6
       end if
    5 continue
c 
c check the last end point 
c ------------------------ 
c 
      if(zpt .eq. zgrhommfe(nzhommfe)) then 
        kz = nzhommfe 
        go to 6 
      end if  
c 
c if the code gets to here the first coordinate value is out of range 
c ------------------------------------------------------------------- 
c 
      ierror = 3
c
c compute the index in the linear pressure array
c ----------------------------------------------
c
    6 locvelindzm = ( ix - 1 ) * nzhommfep1
     1            + ( jy - 1 ) * nxhommfe * nzhommfep1 + kz
c
      return
      end
      integer function locvelindzp(xpt,ypt,zpt,ierror)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine just computes the velocity index to the left of the node given
c a spatial location in the domain
c
c input
c
c   xpt - the first coordinate of the point where the value of the density
c         is to be computed.
c   ypt - the second coordinate of the point where the value of the density
c         is to be computed.
c   zpt - the third coordinate of the point where the value of the density 
c         is to be computed.
c
c output
c
c   ierror - an error flag
c            ierror=0; all went well
c            ierror=1; the poitn is outside the domain
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
c
c set the error value
c -------------------
c
      ierror = 0
c
c determine the location of the x grid block
c ------------------------------------------
c
      do 1 i=1,nxhommfe
       if((xpt .ge. xgrhommfe(i-1)) .and. (xpt .lt. xgrhommfe(i))) then
           ix = i
           go to 2
       end if
    1 continue
c
c check the last end point
c ------------------------
c
      if(xpt .eq. xgrhommfe(nxhommfe)) then
        ix = nxhommfe
        go to 2
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 1
c
c determine the location of the y grid block
c ------------------------------------------
c
    2 do 3 j=1,nyhommfe
       if((ypt .ge. ygrhommfe(j-1)) .and. (ypt .lt. ygrhommfe(j))) then
           jy = j
           go to 4
       end if
    3 continue
c
c check the last end point
c ------------------------
c
      if(ypt .eq. ygrhommfe(nyhommfe)) then
        jy = nyhommfe
        go to 4
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 2
c
c determine the location of the z grid block
c ------------------------------------------
c
    4 do 5 k=1,nzhommfe
       if((zpt .ge. zgrhommfe(k-1)) .and. (zpt .lt. zgrhommfe(k))) then
           kz = k + 1
           go to 6
       end if
    5 continue
c 
c check the last end point 
c ------------------------ 
c 
      if(zpt .eq. zgrhommfe(nzhommfe)) then 
        kz = nzhommfep1 
        go to 6 
      end if  
c 
c if the code gets to here the first coordinate value is out of range 
c ------------------------------------------------------------------- 
c 
      ierror = 3
c
c compute the index in the linear pressure array
c ----------------------------------------------
c
    6 locvelindzp = ( ix - 1 ) * nzhommfep1
     1            + ( jy - 1 ) * nxhommfe * nzhommfep1 + kz
c
      return
      end
      subroutine prmgrdout
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine overwrites the default permeability grid file for the
c simulator input
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c common blocks
c -------------
c
      include 'include/ioprm_common.h'
      include 'include/prm_common.h'
      include 'include/iounit.h'
c
c open the default input file
c ---------------------------
c
      open(unit=iunit,file='prmgrdinit.inp')
c
c rewind the file
c ---------------
c
      rewind iunit
c
c write the number of nodes in each coordinate direction in the pressure grid
c ---------------------------------------------------------------------------
c
      write(iunit,10) nxprm
      write(iunit,20) nyprm
      write(iunit,30) nzprm
c
c get the domain bounds
c ---------------------
c
      write(iunit,40) (xgrprm(i),i=0,nxprm)
      write(iunit,40) (ygrprm(j),j=0,nyprm)
      write(iunit,40) (zgrprm(k),k=0,nzprm)
c 
c close the unit 
c -------------- 
c 
      close(unit=iunit)
c
c formats
c -------
c
   10 format(i6,10x,'*** number of grid block in first coordinate')
   20 format(i6,10x,'*** number of grid block in second coordinate')
   30 format(i6,10x,'*** number of grid block in third coordinate')
   40 format(5e16.8)
c
      return
      end
      subroutine hommfematinit
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine initializes the matrix for the system of equations.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
c
c initialize the right hand side
c ------------------------------
c
      do 1 l=1,3
      do 1 i=1,nnhommfe
         rhshommfe(i,l) = 0.
    1 continue
      do 2 l=1,3
      do 2 i=1,nnhommfevx
         rhshomvx(i,l) = 0.
    2 continue
      do 3 l=1,3
      do 3 j=1,nnhommfevy
         rhshomvy(j,l) = 0.
    3 continue
      do 4 l=1,3
      do 4 k=1,nnhommfevz
         rhshomvz(k,l) = 0.
    4 continue
c
      return
      end
      subroutine hommfeinvrt
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine inverts the permeability in each grid block. the tensor is of
c the form
c
c           [  kx    kxy    kxz  ]
c           [                    ]
c       k = [  kyx    ky    kyz  ]
c           [                    ]
c           [  kzx    kzy    kz  ]
c
c the entries of the matrix are destroyed upon return so the original values
c which may be needed in other places are stored into a set of temporary
c arraays which are the ones that have the modified data.
c
c   for the mixed finite element method that is used here the inversion is
c done in a special way due to the decomposition of the partial differential
c operator that is used to make the system easier to invert. see the comments
c in invert3x3.f to get an idea of how the inverse is computed.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
c
c loop through the grid blocks
c ----------------------------
c
      do 1 k=1,nzhommfe
         k22 = ( k - 1 ) * nxnyhommfe
         k2 = ( k - 1 ) * nyhommfe
      do 1 j=1,nyhommfe
         j22 = k + ( j - 1 ) * nxnzhommfe
         j2 = ( j - 1 ) * nxhommfe + k22
         j3 = j + k2
      do 1 i=1,nxhommfe
         ind = i + j2
         jnd = j3 + ( i - 1 ) * nynzhommfe
         knd = ( i - 1 ) * nzhommfe + j22
c
c initialize the inversion to the easiest case - a diagonal tensor
c ----------------------------------------------------------------
c
         invrtform = 0
c
c check to see if the off diagonal entries have nonzero values - check for a
c full tensor
c -----------
c
         ifullchk = 0
         if(hommfekxy(ind) .ne. 0.0) ifullchk = 1
         if(hommfekxz(ind) .ne. 0.0) ifullchk = 1
         if(hommfekyx(ind) .ne. 0.0) ifullchk = 1
         if(hommfekyz(ind) .ne. 0.0) ifullchk = 1
         if(hommfekzx(ind) .ne. 0.0) ifullchk = 1
         if(hommfekzy(ind) .ne. 0.0) ifullchk = 1
c
c if the tensor is not a diagonal tensor then a full inversion or reduced form
c inversion must be done
c ----------------------
c
         if(ifullchk .eq. 1) invrtform = 2
c
c set the inversion values
c ------------------------
c
         rkxx = hommfekxx(ind)
         rkxy = hommfekxy(ind)
         rkxz = hommfekxz(ind)
         rkyx = hommfekyx(ind)
         rkyy = hommfekyy(ind)
         rkyz = hommfekyz(ind)
         rkzx = hommfekzx(ind)
         rkzy = hommfekzy(ind)
         rkzz = hommfekzz(ind)
c
c if the tensor has a zero value on the diagonal it will cause problems in all
c but the case when the tesnors is fully inverted.
c ------------------------------------------------
c
         izero = 0
         if(rkxx .ne. 0.0) izero = 1
         if(rkyy .ne. 0.0) izero = 1
         if(rkzz .ne. 0.0) izero = 1
c
c check for a masked out cell - it is assumed that the permeability is zero or
c for all practical purposes the permeability is zero
c ---------------------------------------------------
c
         if(maskhommfe(ind) .ne. 0) izero = 0
c
c call the inversion routine
c --------------------------
c
         if(izero .eq. 1)
     1     call invrt3x3(rkxx,rkxy,rkxz
     1                  ,rkyx,rkyy,rkyz
     1                  ,rkzx,rkzy,rkzz
     1                  ,invrtform)
c
c store the inverted values in the appropriate locations
c ------------------------------------------------------
c
         t1homkxx(ind) = rkxx
         t1homkxy(jnd) = rkxy
         t1homkxz(knd) = rkxz
         t1homkyx(ind) = rkyx
         t1homkyy(jnd) = rkyy
         t1homkyz(knd) = rkyz
         t1homkzx(ind) = rkzx
         t1homkzy(jnd) = rkzy
         t1homkzz(knd) = rkzz
c
    1 continue
c
      return
      end
      integer function locvelindxm(xpt,ypt,zpt,ierror)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine just computes the velocity index to the left of the node given
c a spatial location in the domain
c
c input
c
c   xpt - the first coordinate of the point where the value of the density
c         is to be computed.
c   ypt - the second coordinate of the point where the value of the density
c         is to be computed.
c   zpt - the third coordinate of the point where the value of the density 
c         is to be computed.
c
c output
c
c   ierror - an error flag
c            ierror=0; all went well
c            ierror=1; the poitn is outside the domain
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
c
c set the error value
c -------------------
c
      ierror = 0
c
c determine the location of the x grid block
c ------------------------------------------
c
      do 1 i=1,nxhommfe
       if((xpt .ge. xgrhommfe(i-1)) .and. (xpt .lt. xgrhommfe(i))) then
           ix = i
           go to 2
       end if
    1 continue
c 
c check the last end point 
c ------------------------ 
c 
      if(xpt .eq. xgrhommfe(nxhommfe)) then
        ix = nxhommfe
        go to 2 
      end if 
c 
c if the code gets to here the first coordinate value is out of range 
c ------------------------------------------------------------------- 
c 
      ierror = 1
c
c determine the location of the y grid block
c ------------------------------------------
c
    2 do 3 j=1,nyhommfe
       if((ypt .ge. ygrhommfe(j-1)) .and. (ypt .lt. ygrhommfe(j))) then
           jy = j
           go to 4
       end if
    3 continue
c
c check the last end point
c ------------------------
c
      if(ypt .eq. ygrhommfe(nyhommfe)) then
        jy = nyhommfe
        go to 4
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 2
c
c determine the location of the z grid block
c ------------------------------------------
c
    4 do 5 k=1,nzhommfe
       if((zpt .ge. zgrhommfe(k-1)) .and. (zpt .lt. zgrhommfe(k))) then
           kz = k
           go to 6
       end if
    5 continue
c
c check the last end point
c ------------------------
c
      if(zpt .eq. zgrhommfe(nzhommfe)) then
        kz = nzhommfe
        go to 6
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 3
c
c compute the index in the linear pressure array
c ----------------------------------------------
c
    6 locvelindxm = ix + ( jy - 1 ) * nxhommfep1
     1                  + ( kz - 1 ) * nxhommfep1 * nyhommfe
c
      return
      end
      integer function locvelindxp(xpt,ypt,zpt,ierror)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine just computes the velocity index to the right of the node given
c a spatial location in the domain
c
c input
c
c   xpt - the first coordinate of the point where the value of the density
c         is to be computed.
c   ypt - the second coordinate of the point where the value of the density
c         is to be computed.
c   zpt - the third coordinate of the point where the value of the density 
c         is to be computed.
c
c output
c
c   ierror - an error flag
c            ierror=0; all went well
c            ierror=1; the poitn is outside the domain
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
c
c set the error value
c -------------------
c
      ierror = 0
c
c determine the location of the x grid block
c ------------------------------------------
c
      do 1 i=1,nxhommfe
       if((xpt .ge. xgrhommfe(i-1)) .and. (xpt .lt. xgrhommfe(i))) then
           ix = i + 1
           go to 2
       end if
    1 continue
c 
c check the last end point 
c ------------------------ 
c 
      if(xpt .eq. xgrhommfe(nxhommfe)) then
        ix = nxhommfep1
        go to 2 
      end if 
c 
c if the code gets to here the first coordinate value is out of range 
c ------------------------------------------------------------------- 
c 
      ierror = 1
c
c determine the location of the y grid block
c ------------------------------------------
c
    2 do 3 j=1,nyhommfe
       if((ypt .ge. ygrhommfe(j-1)) .and. (ypt .lt. ygrhommfe(j))) then
           jy = j
           go to 4
       end if
    3 continue
c
c check the last end point
c ------------------------
c
      if(ypt .eq. ygrhommfe(nyhommfe)) then
        jy = nyhommfe
        go to 4
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 2
c
c determine the location of the z grid block
c ------------------------------------------
c
    4 do 5 k=1,nzhommfe
       if((zpt .ge. zgrhommfe(k-1)) .and. (zpt .lt. zgrhommfe(k))) then
           kz = k
           go to 6
       end if
    5 continue
c
c check the last end point
c ------------------------
c
      if(zpt .eq. zgrhommfe(nzhommfe)) then
        kz = nzhommfe
        go to 6
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 3
c
c compute the index in the linear pressure array
c ----------------------------------------------
c
    6 locvelindxp = ix + ( jy - 1 ) * nxhommfep1
     1                  + ( kz - 1 ) * nxhommfep1 * nyhommfe
c
      return
      end
      subroutine hommfefixed
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine looks for any cells to be masked out of the calculations. in
c particular, if the permeability is zero in a cell, the routine will used the
c boundary as an internal boundary with a zero flux value.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
c
c initialize the number of computational nodes
c --------------------------------------------
c
      nnhommfec = nnhommfe
c
c set the bit vector for the node
c -------------------------------
c
      do 1 i=1,nnhommfe
         ibithommfe(i) = 1
    1 continue
c
c initialize the bit vector for the gradient at the cell boundaries
c -----------------------------------------------------------------
c
      do 2 i=1,nnhommfevx
         ibithomvx(i) = 1
    2 continue
      do 3 j=1,nnhommfevy
         ibithomvy(j) = 1
    3 continue
      do 4 k=1,nnhommfevz
         ibithomvz(k) = 1
    4 continue
c
c check for a zero permeability to fix the velocities on cell boundaries
c ----------------------------------------------------------------------
c
      ntemp = nxhommfe * nyhommfe
      do 5 k=1,nzhommfe
         k2 = ( k - 1 ) * ntemp
      do 5 j=1,nyhommfe
         j2 = ( j - 1 ) * nxhommfe + k2
      do 5 i=1,nxhommfe
         indp = i + j2
c
c check the entries
c -----------------
c
         izero = 0
         if(hommfekxx(indp) .ne. 0.0) izero = 1
         if(hommfekxy(indp) .ne. 0.0) izero = 1
         if(hommfekxz(indp) .ne. 0.0) izero = 1
         if(hommfekyx(indp) .ne. 0.0) izero = 1
         if(hommfekyy(indp) .ne. 0.0) izero = 1
         if(hommfekyz(indp) .ne. 0.0) izero = 1
         if(hommfekzx(indp) .ne. 0.0) izero = 1
         if(hommfekzy(indp) .ne. 0.0) izero = 1
         if(hommfekzz(indp) .ne. 0.0) izero = 1
c
c if all are zero, set the array bit vector mask entry to zero since
c there should be no change to this cell
c --------------------------------------
c
         if(izero .eq. 0) then
c
c do the nodal values of the variable
c -----------------------------------
c
           ibithommfe(indp) = 0
           nnhommfec = nnhommfec - 1
c
c compute the velocity indices - this is done here since this part of the code
c will only be executed 'rarely'
c ------------------------------
c
           indvx1 = i + nxhommfep1 * ( j - 1 + ( k - 1 ) * nyhommfe ) 
           indvx2 = indvx1 + 1
           indvy1 = j + nyhommfep1 * ( k - 1 + ( i - 1 ) * nzhommfe )
           indvy2 = indvy1 + 1
           indvz1 = k + nzhommfep1 * ( i - 1 + ( j - 1 ) * nxhommfe )
           indvz2 = indvz1 + 1
c
c set the bit entries to zero
c ---------------------------
c
           ibithomvx(indvx1) = 0
           ibithomvx(indvx2) = 0
           ibithomvy(indvy1) = 0
           ibithomvy(indvy2) = 0
           ibithomvz(indvz1) = 0
           ibithomvz(indvz2) = 0
c
         end if
c
    5 continue
c
c check for interior masked out nodes
c -----------------------------------
c
      do 6 i=1,nnhommfe
         if(maskhommfe(i) .eq. 1) then
           ibithommfe(i) = 0
           nnhommfec = nnhommfec - 1
         end if
    6 continue
c
c see if there are any fixed nodes
c --------------------------------
c
      ival = 0
      do 7 i=1,nnhommfe
         if(ibithommfe(i) .eq. 0) ival = 1
    7 continue
c
c check for pressure boundary conditions which will fix the pressures along a
c given boundary plane of the domain
c ----------------------------------
c
c      call hommfefixbnd
c
c check for the case with no fixed nodes
c --------------------------------------
c
      if(ival .eq. 0) then
c
c fix the nodal value
c -------------------
c
        w(1,1) = 0.0
        w(1,2) = 0.0
        w(1,3) = 0.0
c
c set the bit vector entry
c ------------------------
c
        ibithommfe(1) = 0
c
c update the number of computational nodes in the domain
c ------------------------------------------------------
c
        nnhommfec = nnhommfec - 1
c
      end if
c
      return
      end
      subroutine invrt3x3(a11,a12,a13,a21,a22,a23,a31,a32,a33
     1,invrtform)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine inverts a 3x3 matrix given by
c
c           [  a11   a12    a13  ]
c           [                    ]
c       A = [  a21   a22    a23  ]
c           [                    ]
c           [  a31   a32    a33  ]
c
c the entries of the matrix are destroyed upon return
c
c input
c
c   k- the first 9 entries are shown above
c   invrtform - tells the code whether or not the tensor s diagonal
c         invrtform = 0; diagonal tensor - only invert the diagonal part of the
c                    tensor since the extra computations are not necessary
c         invrtform = 1; full inversion of the full tensor - in this case the
c                    inverse of the 3x3 is returned
c         invrtform = 2; full tensor, but the tensor is assumed to be decomposed
c                    into a diagonal and off diagonal. thus the diagonal part
c                    is inverted and the off diagonal parts are multiplied by
c                    the inverse for later use.
c
c the second option, invrtform=2, can be explained as taking the tensor A and
c rewriting the thing as
c
c       [  a11   a12    a13  ]     [ a11   0    0  ]   [   0   a12  a13  ]
c       [                    ]     [               ]   [                 ]
c   A = [  a21   a22    a23  ]  =  [  0   a22   0  ] + [  a21   0   a23  ]
c       [                    ]     [               ]   [                 ]
c       [  a31   a32    a33  ]     [  0    0   a33 ]   [  a31  a32   0   ]
c
c     = AD + AUL
c
c then the inverse and its application are computed so that the returned
c argument is
c
c        -1      -1
c       AD   +  AD * AUL
c                          -1
c the diagonal entries of AD  are stored in the three diagonal entries and the
c other six entries of the returned 3x3 contain the values in the second term
c above.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      real a11,a12,a13,a21,a22,a23,a31,a32,a33
      integer invrtform
c
c check for a diagonal tensor
c ---------------------------
c
      if(invrtform .eq. 0) then
c
c invert the diagonal entries
c ---------------------------
c
        a11 = 1.0 / a11
        a22 = 1.0 / a22
        a33 = 1.0 / a33
c
        return
c
      end if
c
c full matrix inversion
c ---------------------
c
      if(invrtform .eq. 1) then
c
c copmute some common factors in the entries
c ------------------------------------------
c
        div1 = a12 * ( a23 * a31 - a21 * a33 )
        div2 = a11 * ( a22 * a33 - a23 * a32 )
        div3 = a13 * ( a21 * a32 - a22 * a31 )
        divsum = div1 + div2 + div3
c
c compute the components 1x1
c --------------------------
c
        t11 = ( a22 * a33 - a23 * a32 ) / divsum
        t12 = ( a13 * a32 - a12 * a33 ) / divsum
        t13 = ( a12 * a23 - a13 * a22 ) / divsum
        t21 = ( a23 * a31 - a21 * a33 ) / divsum
        t22 = ( a11 * a33 - a13 * a31 ) / divsum
        t23 = ( a13 * a21 - a11 * a23 ) / divsum
        t31 = ( a21 * a32 - a22 * a31 ) / divsum
        t32 = ( a12 * a31 - a11 * a32 ) / divsum
        t33 = ( a11 * a22 - a12 * a21 ) / divsum
c
c destroy the old values
c ----------------------
c
        a11 = t11
        a12 = t12
        a13 = t13
        a21 = t21
        a22 = t22
        a23 = t23
        a31 = t31
        a32 = t32
        a33 = t33
c
        return
c
      end if
c
c full tensor with diagonal velocity matrix inversion - the diagonal entries
c are inverted and the effect of the multiplication of the inverted diagonal
c into the rest of the matrix (the off diagonal entries) is stored in the
c rest of the tensor - this is used in the reduced form of the mixed finite
c element method when a full tensor is encountered 
c ------------------------------------------------
c
      if(invrtform .eq. 2) then
c
c invert the diagonal entries
c ---------------------------
c
        a11 = 1.0 / a11
        a22 = 1.0 / a22
        a33 = 1.0 / a33
c
c store the nondiagonal entries with the diagonal inverted into them - note
c that the diagonal has already been inverted -> multiplication
c -------------------------------------------------------------
c
        a12 = a12 * a22
        a13 = a13 * a33
        a21 = a21 * a11
        a23 = a23 * a33
        a31 = a31 * a11
        a32 = a32 * a22
c
        return
c
      end if
c
      end
      subroutine ntmlt(vx,vy,vz,hom)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine does the second difference in the mixed finite element method
c from velocity type arrays to pressure type arrays
c
c input:
c
c   vx - x component of the differenced vector
c   vy - y component of the differenced vector
c   vz - z component of the differenced vector
c
c output:
c
c   p - array of pressures from the differing
c
c   this routine only uses the unknown values in the computation. if pressure
c and or velocity nodes have been masked out these are not included in the
c 'multiplication'
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      real hom(*),vx(*),vy(*),vz(*)
c
c compute the shift in the pressure array
c ---------------------------------------
c
      ntemp2 = nxhommfe * nyhommfe
c
c difference the x component first:
c ---------------------------------
c
      ntemp1 = nxhommfep1 * nyhommfe
      do 1 k=1,nzhommfe
         k1 = ( k - 1 ) * ntemp1
         k2 = ( k - 1 ) * ntemp2
      do 1 j=1,nyhommfe
         indht = k2 + ( j - 1 ) * nxhommfe
         indvt = k1 + ( j - 1 ) * nxhommfep1
         factor = dyhommfe(j) * dzhommfe(k)
      do 1 i=1,nxhommfe
         indp = i + indht
         indv = i + indvt
         hom(indp) = ibithommfe(indp)
     1              * ( vx(indv+1) - vx(indv) ) * factor
    1 continue
c
c now add the differncing in the y direction, since this represents a the
c application of a divergence operator.
c -------------------------------------
c
      ntemp1 = nyhommfep1 * nzhommfe
      do 2 i=1,nxhommfe
         i1 = ( i - 1 ) * ntemp1
      do 2 k=1,nzhommfe
         indht = i + ( k - 1 ) * ntemp2
         indvt = i1 + ( k - 1 ) * nyhommfep1
         factor = dxhommfe(i) * dzhommfe(k)
      do 2 j=1,nyhommfe
         indv = j + indvt
         indp = indht + ( j - 1 ) * nxhommfe
         hom(indp) = hom(indp) + ibithommfe(indp)
     1               * ( vy(indv+1) - vy(indv) ) * factor
    2 continue
c
c now add the differncing in the z direction, since this represents a the
c application of a divergence operator.
c -------------------------------------
c
      ntemp1 = nzhommfep1 * nxhommfe
      do 3 j=1,nyhommfe
         j1 = ( j - 1 ) * ntemp1
         j2 = ( j - 1 ) * nxhommfe
      do 3 i=1,nxhommfe
         indht = i + j2
         indvt = j1 + ( i - 1 ) * nzhommfep1
         factor = dxhommfe(i) * dyhommfe(j)
      do 3 k=1,nzhommfe
         indv = k + indvt
         indp = indht + ( k - 1 ) * ntemp2
         hom(indp) = hom(indp) + ibithommfe(indp)
     1               * ( vz(indv+1) - vz(indv) ) * factor
    3 continue
c
      return
      end
         
      subroutine ntmlta(vx,vy,vz,hom)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine does the second difference in the mixed finite element method
c from velocity type arrays to pressure type arrays
c
c input:
c
c   vx - x component of the differenced vector
c   vy - y component of the differenced vector
c   vz - z component of the differenced vector
c
c output:
c
c   p - array of pressures from the differing
c
c   this routine only uses the unknown values in the computation. if pressure
c and or velocity nodes have been masked out these are not included in the
c 'multiplication'
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      real hom(*),vx(*),vy(*),vz(*)
c
c compute the shift in the pressure array
c ---------------------------------------
c
      ntemp2 = nxhommfe * nyhommfe
c
c difference the x component first:
c ---------------------------------
c
      ntemp1 = nxhommfep1 * nyhommfe
      do 1 k=1,nzhommfe
         k1 = ( k - 1 ) * ntemp1
         k2 = ( k - 1 ) * ntemp2
      do 1 j=1,nyhommfe
         indht = k2 + ( j - 1 ) * nxhommfe
         indvt = k1 + ( j - 1 ) * nxhommfep1
         factor = dyhommfe(j) * dzhommfe(k)
      do 1 i=1,nxhommfe
         indp = i + indht
         indv = i + indvt
         hom(indp) = ( vx(indv+1) - vx(indv) ) * factor
    1 continue
c
c now add the differncing in the y direction, since this represents a the
c application of a divergence operator.
c -------------------------------------
c
      ntemp1 = nyhommfep1 * nzhommfe
      do 2 i=1,nxhommfe
         i1 = ( i - 1 ) * ntemp1
      do 2 k=1,nzhommfe
         indht = i + ( k - 1 ) * ntemp2
         indvt = i1 + ( k - 1 ) * nyhommfep1
         factor = dxhommfe(i) * dzhommfe(k)
      do 2 j=1,nyhommfe
         indv = j + indvt
         indp = indht + ( j - 1 ) * nxhommfe
         hom(indp) = hom(indp) + ( vy(indv+1) - vy(indv) ) * factor
    2 continue
c
c now add the differncing in the z direction, since this represents a the
c application of a divergence operator.
c -------------------------------------
c
      ntemp1 = nzhommfep1 * nxhommfe
      do 3 j=1,nyhommfe
         j1 = ( j - 1 ) * ntemp1
         j2 = ( j - 1 ) * nxhommfe
      do 3 i=1,nxhommfe
         indht = i + j2
         indvt = j1 + ( i - 1 ) * nzhommfep1
         factor = dxhommfe(i) * dyhommfe(j)
      do 3 k=1,nzhommfe
         indv = k + indvt
         indp = indht + ( k - 1 ) * ntemp2
         hom(indp) = hom(indp) + ( vz(indv+1) - vz(indv) ) * factor
    3 continue
c
      return
      end
         
      subroutine ntmltf(vx,vy,vz,hom)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine does the second difference in the mixed finite element method
c from velocity type arrays to pressure type arrays
c
c input:
c
c   vx - x component of the differenced vector
c   vy - y component of the differenced vector
c   vz - z component of the differenced vector
c
c output:
c
c   p - array of pressures from the differing
c
c   this routine only uses the unknown values in the computation. if pressure
c and or velocity nodes have been masked out these are the only values included
c in the 'multiplication'
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      real hom(*),vx(*),vy(*),vz(*)
      real v1(nhomvelx),v2(nhomvely),v3(nhomvelz)
c
c compute the shift in the pressure array
c ---------------------------------------
c
      ntemp2 = nxhommfe * nyhommfe
c
c set the nonfixed values
c -----------------------
c
      do 1 i=1,nnhommfevx
         v1(i) = ( 1.0 - ibithomvx(i) ) * vx(i)
    1 continue
      do 2 j=1,nnhommfevy
         v2(j) = ( 1.0 - ibithomvy(j) ) * vy(j)
    2 continue
      do 3 k=1,nnhommfevz
         v3(k) = ( 1.0 - ibithomvz(k) ) * vz(k)
    3 continue
c
c difference the x component first:
c ---------------------------------
c
      ntemp1 = nxhommfep1 * nyhommfe
      do 4 k=1,nzhommfe
         k1 = ( k - 1 ) * ntemp1
         k2 = ( k - 1 ) * ntemp2
      do 4 j=1,nyhommfe
         indht = k2 + ( j - 1 ) * nxhommfe
         indvt = k1 + ( j - 1 ) * nxhommfep1
         factor = dyhommfe(j) * dzhommfe(k)
      do 4 i=1,nxhommfe
         indp = i + indht
         indv = i + indvt
         hom(indp) = ibithommfe(indp)
     1              * ( v1(indv+1) - v1(indv) ) * factor
    4 continue
c
c now add the differncing in the y direction, since this represents a the
c application of a divergence operator.
c -------------------------------------
c
      ntemp1 = nyhommfep1 * nzhommfe
      do 5 i=1,nxhommfe
         i1 = ( i - 1 ) * ntemp1
      do 5 k=1,nzhommfe
         indht = i + ( k - 1 ) * ntemp2
         indvt = i1 + ( k - 1 ) * nyhommfep1
         factor = dxhommfe(i) * dzhommfe(k)
      do 5 j=1,nyhommfe
         indv = j + indvt
         indp = indht + ( j - 1 ) * nxhommfe
         hom(indp) = hom(indp) + ibithommfe(indp)
     1               * ( v2(indv+1) - v2(indv) ) * factor
    5 continue
c
c now add the differncing in the z direction, since this represents a the
c application of a divergence operator.
c -------------------------------------
c
      ntemp1 = nzhommfep1 * nxhommfe
      do 6 j=1,nyhommfe
         j1 = ( j - 1 ) * ntemp1
         j2 = ( j - 1 ) * nxhommfe
      do 6 i=1,nxhommfe
         indht = i + j2
         indvt = j1 + ( i - 1 ) * nzhommfep1
         factor = dxhommfe(i) * dyhommfe(j)
      do 6 k=1,nzhommfe
         indv = k + indvt
         indp = indht + ( k - 1 ) * ntemp2
         hom(indp) = hom(indp) + ibithommfe(indp)
     1               * ( v3(indv+1) - v3(indv) ) * factor
c
    6 continue
c
      return
      end
      subroutine hommfemodrhs(isystem)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine modifies the right hand side for a full system solve to the
c solution for only the pressure variable in the modified tensor approach.
c
c input
c
c   isystem - the system index for which the right hand side is being
c             modified - isystem must be 1, 2, or 3.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
      real r(nhommfe),wrk(nnhomvar)
      real vx1(nhomvelx),vx2(nhomvelx)
      real vy1(nhomvely),vy2(nhomvely)
      real vz1(nhomvelz),vz2(nhomvelz)
c
c check the system index
c ----------------------
c
      if(isystem .lt. 1 .or. isystem .gt. 3) then
        print *,' '
        print *,' ----- inside hommfemodrhs'
        print *,' '
        print *,' ***** the system number must be between 1 and 3'
        print *,' ***** input value - isystem = ',isystem
        print *,' '
        print *,' ----- exiting the simulation'
        print *,' '
        stop
      end if
c
c compute the modification due to the velocity term
c
c apply the inverse of the diagonal tensor contribution
c -----------------------------------------------------
c
      call lusolfull(am11d,am11s,rhshomvx(1,isystem),vx1,nxhommfe
     1,nyhommfe,nzhommfe,nxhommfep1,wrk)
      call lusolfull(am22d,am22s,rhshomvy(1,isystem),vy1,nyhommfe
     1,nzhommfe,nxhommfe,nyhommfep1,wrk)
      call lusolfull(am33d,am33s,rhshomvz(1,isystem),vz1,nzhommfe
     1,nxhommfe,nyhommfe,nzhommfep1,wrk)
c
c apply the modification matrix multiplication
c --------------------------------------------
c
      call ndmmod(vx1,vy1,vz1,vx2,vy2,vz2)
c
c apply the finite differencing matrix
c ------------------------------------
c
      call ntmlt(vx2,vy2,vz2,r)
c
c compute the new right hand side for the pressure equation - note that the
c original velocity right hand sides are destroyed in this
c --------------------------------------------------------
c
      do 1 i=1,nnhommfe
         rhshommfe(i,isystem) = rhshommfe(i,isystem) + r(i)
    1 continue
c
      return
      end
      subroutine hommfeapmmm(t,q)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine performs the matrix multiplication for the modified mixed
c finite element matrix for the lowest order method. that is,
c
c          -1        -1
c   [ N   M   ( I + T   S  ) N +  D   ] [ p  ]   =   Rhs
c
c input
c
c   t - vector to perform the matrix multiplication on.
c
c output
c
c   q - result from the matrix multiplication.
c
c note that the vectors t, q, have extra storage for the intermediate velocity
c entries in the computation
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
      real t(nnhomvar),q(nnhomvar),r(nhommfe),wrk(nnhomvar)
      real sx(nhomvelx),sy(nhomvely),sz(nhomvelz)
      real qx(nhomvelx),qy(nhomvely),qz(nhomvelz)
c
c flush the output array
c ----------------------
c
      do 1 i=1,nhvtot
         q(i) = 0.0
    1 continue
c
c compute shift indices for use below
c -----------------------------------
c
      ind1 = nnhommfe
      ind2 = ind1 + nnhommfevx
      ind3 = ind2 + nnhommfevy
c
c grab the components
c -------------------
c
      do 2 i=1,nnhommfevx
         qx(i) = t(i+ind1)
    2 continue  
      do 3 j=1,nnhommfevy
         qy(j) = t(j+ind2)
    3 continue  
      do 4 k=1,nnhommfevz
         qz(k) = t(k+ind3)
    4 continue  
c
c do the part of the multiplication due to the pressure difference - the
c result is three vectors used in the block additions below
c ---------------------------------------------------------
c
      call nmlt(t(1),qx,qy,qz)
c
c invert the diagonal part of the tensor for the diagonal velocity definition
c ---------------------------------------------------------------------------
c
      call lusolfull(am11d,am11s,qx,sx,nxhommfe,nyhommfe,nzhommfe
     1          ,nxhommfep1,wrk)
      call lusolfull(am22d,am22s,qy,sy,nyhommfe,nzhommfe,nxhommfe
     1          ,nyhommfep1,wrk)
      call lusolfull(am33d,am33s,qz,sz,nzhommfe,nxhommfe,nyhommfe
     1          ,nzhommfep1,wrk)
c
c compute the modification matrix multiply
c ----------------------------------------
c
c      call ndmmod(sx,sy,sz,qx,qy,qz)
c
c do the part of the multiplication due to the velocity differencing - the
c result is a single vector of the dimensions of the pressure
c -----------------------------------------------------------
c
c      call ntmlt(qx,qy,qz,r)
      call ntmlt(sx,sy,sz,r)
c
c do the part of the multiplication due to the time dependent term in the
c pressure equation - the result is the rest of the pressure type vector
c ----------------------------------------------------------------------
c
      do 5 i=1,nnhommfe
         q(i) = - r(i) + ibithommfe(i) * diaghommfe(i) * t(i)
    5 continue
c
c it is worthwhile to keep track of the velocity components, so store them
c into the output array
c ---------------------
c
      do 6 i=1,nnhommfevx
         q(i+ind1) = qx(i)
    6 continue  
      do 7 j=1,nnhommfevy
         q(j+ind2) = qy(j)
    7 continue  
      do 8 k=1,nnhommfevz
         q(k+ind3) = qz(k)
    8 continue  
c
      return
      end
      subroutine lusol(ad,as,rhs,ans,nx,ny,nz,nxp1,wrk)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine is the companion routine to reduce. it performs a forward
c elimination and back substitution using the lu decomposition formed in the
c other routine. again this routine uses the structure of the matrix to do a
c block by block algorithm for vectorization. the same comments in reduce about
c index conventions, the lu decomposition, and the two calls for the components
c are true in this routine.
c
c input:
c
c   ad - main diagonal of the reduced tridiagonal matrix
c   as - first super diagonal of the reduced tridiagonal matrix
c   rhs - right hand side of the tridiagonal system of equations
c   nx - number of nodes in the current coordinate direction
c   ny - number of nodes in the off coordinate direction
c   nz - number of nodes in the third coordinate direction
c   nxp1 - nx + 1
c   wrk - a work array for the elimination - this must be provided by the
c         calling routine
c
c output:
c
c   ans - result of the inversion of the system
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      real ad(*),as(*),rhs(*),ans(*),wrk(*)
c
c kill the stuff in the work array
c --------------------------------
c
      do 1 i=1,nxp1*ny*nz
         wrk(i) = 0.0
    1 continue
c
c forward elimination
c
c first element in each block
c ---------------------------
c
      if(nx .gt. 1) then
        ntemp = nxp1 * ny
        do 2 k=1,nz
           k1 = ( k - 1 ) * ntemp
        do 2 j=1,ny
           ind = ( j - 1 ) * nxp1 + k1
           wrk(ind+2) = rhs(ind+2)
    2   continue
      end if
c
c the rest of each blocks
c -----------------------
c
      do 3 i=3,nx
c
      do 3 k=1,nz
         k1 = ( k - 1 ) * ntemp
      do 3 j=1,ny
         ind = ( j - 1 ) * nxp1 + k1
         wrk(ind+i) = rhs(ind+i)
     1           - wrk(ind+i-1) * as(ind+i-1)
    3 continue
c
c back substitution
c
c last element of each block
c --------------------------
c
      if(nx .gt. 1) then
        do 4 k=1,nz
           k1 = ( k - 1 ) * ntemp
        do 4 j=1,ny
           ind = ( j - 1 ) * nxp1 + k1
           ans(ind+nx) = wrk(ind+nx) / ad(ind+nx)
    4   continue
      end if
c
c the rest of each blocks
c -----------------------
c
      nxm1 = nx - 1
      do 5 i=nxm1,2,-1
      do 5 k=1,nz
         k1 = ( k - 1 ) * ntemp
      do 5 j=1,ny
         ind = ( j - 1 ) * nxp1 + k1
         ans(ind+i) = wrk(ind+i) / ad(ind+i)
     1             - as(ind+i) * ans(ind+i+1)
    5 continue
c
      return
      end
      subroutine lusolfull(ad,as,rhs,ans,nx,ny,nz,nxp1,wrk)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine is the companion routine to reduce. it performs a forward
c elimination and back substitution using the lu decomposition formed in the
c other routine. again this routine uses the structure of the matrix to do a
c block by block algorithm for vectorization. the same comments in reduce about
c index conventions, the lu decomposition, and the two calls for the components
c are true in this routine.
c
c input:
c
c   ad - main diagonal of the reduced tridiagonal matrix
c   as - first super diagonal of the reduced tridiagonal matrix
c   rhs - right hand side of the tridiagonal system of equations
c   nx - number of nodes in the current coordinate direction
c   ny - number of nodes in the off coordinate direction
c   nz - number of nodes in the third coordinate direction
c   nxp1 - nx + 1
c   wrk - a work array for the elimination - this must be provided by the
c         calling routine
c
c output:
c
c   ans - result of the inversion of the system
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      real ad(*),as(*),rhs(*),ans(*),wrk(*)
c
c kill the stuff in the work array
c --------------------------------
c
      do 1 i=1,nxp1*ny*nz
         wrk(i) = 0.0
    1 continue
c
c forward elimination
c
c first element in each block
c ---------------------------
c
      if(nx .gt. 1) then
        ntemp = nxp1 * ny
        do 2 k=1,nz
           k1 = ( k - 1 ) * ntemp
        do 2 j=1,ny
           ind = ( j - 1 ) * nxp1 + k1
           wrk(ind+1) = rhs(ind+1)
    2   continue
      end if
c
c the rest of each blocks
c -----------------------
c
      do 3 i=2,nxp1
c
      do 3 k=1,nz
         k1 = ( k - 1 ) * ntemp
      do 3 j=1,ny
         ind = ( j - 1 ) * nxp1 + k1
         wrk(ind+i) = rhs(ind+i)
     1           - wrk(ind+i-1) * as(ind+i-1)
    3 continue
c
c back substitution
c
c last element of each block
c --------------------------
c
      if(nx .gt. 1) then
        do 4 k=1,nz
           k1 = ( k - 1 ) * ntemp
        do 4 j=1,ny
           ind = ( j - 1 ) * nxp1 + k1
           ans(ind+nxp1) = wrk(ind+nxp1) / ad(ind+nxp1)
    4   continue
      end if
c
c the rest of each blocks
c -----------------------
c
      nxm1 = nx - 1
      do 5 i=nx,1,-1
      do 5 k=1,nz
         k1 = ( k - 1 ) * ntemp
      do 5 j=1,ny
         ind = ( j - 1 ) * nxp1 + k1
         ans(ind+i) = wrk(ind+i) / ad(ind+i)
     1             - as(ind+i) * ans(ind+i+1)
    5 continue
c
      return
      end
      subroutine arithavg1(kxx,x,nxh,arithval,zx)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by joe koebbe
c
c   this routine computes the arithmetic average of the single input array in 
c the first argument
c
c input
c
c   kxx - the array of values to use in the arithmetic average
c   x - the array of nodal locations for the array
c   nxh - the number of entries to use in the computation of the arithmetic
c           average
c
c output
c
c   arithval - the arithmetic average
c   zx - the new cell center location
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      real kxx(*),x(*)
c
c initialize the value
c --------------------
c
      arithval = 0.0
c
c compute the overall cell size
c -----------------------------
c
      if(nxh .eq. 1) then
        xvalm = 0.0
        xvalp = 1.0
      else
        xvalm = 1.5 * x(1) - 0.5 * x(2)
        xvalp = 1.5 * x(nxh) - 0.5 * x(nxh-1)
      end if
      cellsize = ( xvalp - xvalm )
c
c compute the new cell center
c ---------------------------
c
      zx = 0.5 * ( xvalm + xvalp )
c
c start by computing the arithmetic average
c -----------------------------------------
c
      sum = 0.0
      do 1 i=1,nxh
c
c compute the grid block size for the computational cell in x
c -----------------------------------------------------------
c
         if(nxh .eq. 1) then
           xvalm = 0.0
           xvalp = 1.0
         else
           if(i .eq. 1) then
             xvalm = 1.5 * x(1) - 0.5 * x(2)
             xvalp = 0.5 * ( x(i) + x(i+1) )
           end if
           if(i .gt. 1 .and. i .lt. nxh) then
             xvalm = 0.5 * ( x(i-1) + x(i) )
             xvalp = 0.5 * ( x(i) + x(i+1) )
           end if
           if(i .eq. nxh) then
             xvalm = 0.5 * ( x(i-1) + x(i) )
             xvalp = 1.5 * x(i) - 0.5 * x(i-1)
           end if
         end if
         delx = xvalp - xvalm
c
c check for a zero value
c ----------------------
c
         sum = sum + kxx(i) * delx
c
    1 continue
c
c compute the value using the given sum
c -------------------------------------
c
      arithval = sum / cellsize
c
      return
      end
      subroutine ndmmod(vxi,vyi,vzi,vxo,vyo,vzo)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine performs the multiplication of the matrix which occurs in
c the modified scheme due to the off-diagonal entries in the mobility tensor.
c
c input
c
c   vxi - the x component input vector in the multiplication
c   vyi - the y component input vector in the multiplication
c   vzi - the z component input vector in the multiplication
c
c output
c
c   vxo - the x component output vector in the multiplication
c   vyo - the y component output vector in the multiplication
c   vzo - the z component output vector in the multiplication
c
c NOTE: the order of storage in this routine is the pressure variable first
c and then the velocity nodes. this is different than in the full system. this
c may be a little confusing.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      include 'include/hommfelineq_common.h'
      real vxi(*),vxo(*),vx1(nhomvelx)
      real vyi(*),vyo(*),vy1(nhomvely)
      real vzi(*),vzo(*),vz1(nhomvelz)
      real wrk(nnhomvar)
c
c perform the projection of the off-direction gradients onto the velocity
c space
c -----
c
      call vnprjct(vxi,vyi,vzi,vx1,vy1,vz1)
c
c compute the new vector passed through the mass matrix
c -----------------------------------------------------
c
      call lusolfull(admssx,asmssx,vx1,vxo,nxhommfe,nyhommfe,nzhommfe
     1          ,nxhommfep1,wrk)
      call lusolfull(admssy,asmssy,vy1,vyo,nyhommfe,nzhommfe,nxhommfe
     1          ,nyhommfep1,wrk)
      call lusolfull(admssz,asmssz,vy1,vzo,nzhommfe,nxhommfe,nyhommfe
     1          ,nzhommfep1,wrk)
c
c add in the identity - note that nshftp = nnhommfevx+nnhommfevy+nnhommfevz
c -------------------------------------------------------------------------
c
      do 1 i=1,nnhommfevx
         vxo(i) = vxi(i) + vxo(i)
    1 continue
      do 2 j=1,nnhommfevy
         vyo(j) = vyi(j) + vyo(j)
    2 continue
      do 3 k=1,nnhommfevz
         vzo(k) = vzi(k) + vzo(k)
    3 continue
c
      return
      end
      subroutine reduce(ad,as,nx,ny,nz,nxp1,ibit)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine reduces the tridiagonal matrix from the lowest order mixed
c finite element method representation of the velocity by doing a block lu
c decomposition. this is done in order to vectorize the routine and uses the
c structure of the matrix very heavily. in particular, each of the velocity
c component matrices has a block structure due to the basis functions not
c seeing the next level in the other component direction. thus each row in a
c direction will form a block which is used in this routine to break up the
c work. the advantage will come forth in a parallel archetecture.
c    the routine basically does an tridiagonal decomposition of one of the
c component matrices on each call, with lower triangular piece will have 1's on
c the diagonal. again the routine must be called for each component of the
c velocity.
c   also, to be in agreement with the other routines, the index convention of
c starting with 2 is again observed, as seen below.
c
c input:
c
c   ad - main diagonal of the tridiagonal matrix
c   as - first super diagonal of the tridiagonal matrix
c   nx - number of nodes in the current coordinate direction
c   ny - number of nodes in the off coordinate direction
c   nz - number of nodes in the third coordinate direction
c   nxp1 - nx + 1
c   ibit - bit vector to identify fixed velocity nodes
c
c output:
c
c   ad - reduced main diagonal of the tridiagonal matrix
c   as - reduced first super diagonal of the tridiagonal matrix
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      real ad(*),as(*)
      integer ibit(*)
c
c check for fixed nodes
c ---------------------
c
      ntemp = nxp1 * ny
      do 1 k=1,nz
         k1 = ( k - 1 ) * ntemp
      do 1 j=1,ny
         j1 = ( j - 1 ) * nxp1 + k1
      do 1 i=2,nx
         indv = i + j1
         if(ibit(indv) .eq. 0) then
           ad(indv) = 1.0
           as(indv-1) = 0.0
           as(indv) = 0.0
         end if
    1 continue
c
c first do the first super diagonal element in each block:
c --------------------------------------------------------
c
      if(nx .gt. 1) then
        ntemp = nxp1 * ny
        do 2 k=1,nz
           k1 = ( k - 1 ) * ntemp
        do 2 j=1,ny
           ind = ( j - 1 ) * nxp1 + k1 + 2
           as(ind) = as(ind) / ad(ind)
    2   continue
      end if
c
c now do the rest of each blocks
c ------------------------------
c
      do 3 i=3,nx
c
      do 4 k=1,nz
         k1 = ( k - 1 ) * ntemp
      do 4 j=1,ny
         ind = ( j - 1 ) * nxp1 + k1
         ad(ind+i) = ad(ind+i)
     1            - as(ind+i-1) * ad(ind+i-1)
     1                                  * as(ind+i-1)
    4 continue
      do 5 k=1,nz
         k1 = ( k - 1 ) * ntemp
      do 5 j=1,ny
         ind = ( j - 1 ) * nxp1 + k1
         as(ind+i) = as(ind+i) / ad(ind+i)
    5 continue
c
    3 continue
c
      return
      end
      subroutine reducefull(ad,as,nx,ny,nz,nxp1,ibit)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine reduces the tridiagonal matrix from the lowest order mixed
c finite element method representation of the velocity by doing a block lu
c decomposition. this is done in order to vectorize the routine and uses the
c structure of the matrix very heavily. in particular, each of the velocity
c component matrices has a block structure due to the basis functions not
c seeing the next level in the other component direction. thus each row in a
c direction will form a block which is used in this routine to break up the
c work. the advantage will come forth in a parallel archetecture.
c    the routine basically does an tridiagonal decomposition of one of the
c component matrices on each call, with lower triangular piece will have 1's on
c the diagonal. again the routine must be called for each component of the
c velocity.
c   also, to be in agreement with the other routines, the index convention of
c starting with 2 is again observed, as seen below.
c
c input:
c
c   ad - main diagonal of the tridiagonal matrix
c   as - first super diagonal of the tridiagonal matrix
c   nx - number of nodes in the current coordinate direction
c   ny - number of nodes in the off coordinate direction
c   nz - number of nodes in the third coordinate direction
c   nxp1 - nx + 1
c   ibit - bit vector to identify fixed velocity nodes
c
c output:
c
c   ad - reduced main diagonal of the tridiagonal matrix
c   as - reduced first super diagonal of the tridiagonal matrix
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      real ad(*),as(*)
      integer ibit(*)
c
c check for fixed nodes
c ---------------------
c
      ntemp = nxp1 * ny
      do 1 k=1,nz
         k1 = ( k - 1 ) * ntemp
      do 1 j=1,ny
         j1 = ( j - 1 ) * nxp1 + k1
      do 1 i=1,nxp1
         indv = i + j1
         if(ibit(indv) .eq. 0) then
           ad(indv) = 1.0
           as(indv-1) = 0.0
           as(indv) = 0.0
         end if
    1 continue
c
c first do the first super diagonal element in each block:
c --------------------------------------------------------
c
      if(nx .gt. 1) then
        ntemp = nxp1 * ny
        do 2 k=1,nz
           k1 = ( k - 1 ) * ntemp
        do 2 j=1,ny
           ind = ( j - 1 ) * nxp1 + k1 + 1
           as(ind) = as(ind) / ad(ind)
    2   continue
      end if
c
c now do the rest of each blocks
c ------------------------------
c
      do 3 i=2,nxp1
c
      do 4 k=1,nz
         k1 = ( k - 1 ) * ntemp
      do 4 j=1,ny
         ind = ( j - 1 ) * nxp1 + k1
         ad(ind+i) = ad(ind+i)
     1            - as(ind+i-1) * ad(ind+i-1)
     1                                  * as(ind+i-1)
    4 continue
      do 5 k=1,nz
         k1 = ( k - 1 ) * ntemp
      do 5 j=1,ny
         ind = ( j - 1 ) * nxp1 + k1
         as(ind+i) = as(ind+i) / ad(ind+i)
    5 continue
c
    3 continue
c
      return
      end
      subroutine fecoefdt(adx,asx,nx,ny,nz,nxp1,nnvx,coef,dx,dy,dz)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine forms the standard mass matrix obtained when the chapeau basis
c is used in a finite element method. the routine expects the coefficient array
c to be a cell centered quantity and uses the array as a multiplicative factor.
c   the routine does one component of the velocity at a time and thus must be
c called once for each component as mentioned in the routine feprs.
c   it should be noted that the storage in the array adx and asx starts with
c the same index. if the boundary elements are not included in the formulation
c the beginnins index added to the pointer is 2. this is done in order to keep
c the code flexible enough to handle dirichlet boundary conditions. note that
c the rest of the subroutines follow this index convention.
c
c input:
c
c   nx - number of nodes in the current coordinate direction
c   ny,nz - number of nodes in the off coordinates direction
c   nxp1 - nx + 1
c   coef - array containing the coefficients of the equation
c   dx - array of intervals in the coordinate direction ( x direction )
c   dy,dz - array of intervals in the off-coordinates direction ( y direction )
c
c output:
c
c   adx - main diagonal of the tridiagonal matrix
c   asx - first super diagonal of the tridiagonal matrix
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      real adx(*),asx(*),coef(*),dx(*),dy(*),dz(*),sig(2)
c
c integration is done by a 2x2 gauss quadrature and so the following data
c stores the 2 gauss points necessary for the quadrature evaluation.
c ------------------------------------------------------------------
c
      data sig / .2113248654052,.7886751345948 /
c
c initialize the vectors to 0. this is done to allow the vectorization of the
c longer inner loop of the matrix formulation.
c --------------------------------------------
c
      do 1 i=1,nnvx
         asx(i) = 0.
         adx(i) = 0.
    1 continue
c
c loop through all of the grid blocks with the next two loops. note that the
c loop through the gauss points is on the outside so that the longer loop
c through the grid blocks can be vectorized.
c ------------------------------------------
c
      do 3 l=1,2
c
c start building up the integration factors only due to the outter loops
c ----------------------------------------------------------------------
c
         factor1 = 0.5 * sig(l) * sig(l)
         factor2 = 0.5 * ( 1. - sig(l) ) * ( 1. - sig(l) )
         factor3 = 0.5 * sig(l) * ( 1. - sig(l) )
c
      ntempv = nxp1 * ny
      ntempp = nx * ny
      do 3 k=1,nz
         k1 = ( k - 1 ) * ntempv
         k2 = ( k - 1 ) * ntempp
c
c update the factors
c ------------------
c
         factor4 = factor1 * dz(k)
         factor5 = factor2 * dz(k)
         factor6 = factor3 * dz(k)
c
      do 3 j=1,ny
         j1 = ( j - 1 ) * nxp1
         j2 = ( j - 1 ) * nx
c
c get the computational array indices
c -----------------------------------
c
         indvt = j1 + k1
         indpt = j2 + k2
c
c update the factors again
c ------------------------
c
         factor7 = factor4 * dy(j)
         factor8 = factor5 * dy(j)
         factor9 = factor6 * dy(j)
c
c do the first grid line
c ----------------------
c
         adx(1+indvt) = adx(1+indvt) + factor8 * coef(1+indpt) * dx(1)
         asx(1+indvt) = asx(1+indvt) + factor9 * coef(1+indpt) * dx(1)
c
c note that the beginning index of the array is 2.
c ------------------------------------------------
c
      do 4 i=2,nx
c
c update the indices
c ------------------
c
         indv = i + indvt
         indp = i + indpt
c
c diagonal element
c ----------------
c
         adx(indv) = adx(indv)
c
c contribution due to the i,j,k grid block
c ----------------------------------------
c
     1     + factor7 * coef(indp-1) * dx(i-1)
c
c contribution due to the i+1,j,k grid block
c ------------------------------------------
c
     1     + factor8 * coef(indp) * dx(i)
c
c super diagonal entry, which is the same as the subdiagonal due to symmetry of
c the variational formulation.
c ----------------------------
c
         asx(indv) = asx(indv) + factor9 * coef(indp) * dx(i)
c
    4 continue
c
c do the last grid line
c ----------------------
c
         adx(nxp1+indvt) = adx(nxp1+indvt)
     1                   + factor7 * coef(nx+indpt) * dx(nx)
c
c zero out the appropriate super diagonal element
c -----------------------------------------------
c
         asx(nxp1+indvt) = 0.
c
    3 continue
c
      return
      end
      integer function lochommfeind(xpt,ypt,zpt,ierror)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine just computes the pressure index given a spatial location in
c the domain
c
c input
c
c   xpt - the first coordinate of the point where the value of the density
c         is to be computed.
c   ypt - the second coordinate of the point where the value of the density
c         is to be computed.
c   zpt - the third coordinate of the point where the value of the density 
c         is to be computed.
c
c output
c
c   ierror - an error flag
c            ierror=0; all went well
c            ierror=1; the poitn is outside the domain
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
c
c set the error value
c -------------------
c
      ierror = 0
c
c determine the location of the x grid block
c ------------------------------------------
c
      do 1 i=1,nxhommfe
         if((xpt .ge. xgrhommfe(i-1))
     1           .and. (xpt .lt. xgrhommfe(i))) then
           ix = i
           go to 2
         end if
    1 continue
c
c check the last end point
c ------------------------
c
      if(xpt .eq. xgrhommfe(nxhommfe)) then
        ix = nxhommfe
        go to 2
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 1
c
c determine the location of the y grid block
c ------------------------------------------
c
    2 do 3 j=1,nyhommfe
         if((ypt .ge. ygrhommfe(j-1))
     1           .and. (ypt .lt. ygrhommfe(j))) then
           jy = j
           go to 4
         end if
    3 continue
c
c check the last end point
c ------------------------
c
      if(ypt .eq. ygrhommfe(nyhommfe)) then
        jy = nyhommfe
        go to 4
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 2
c
c determine the location of the z grid block
c ------------------------------------------
c
    4 do 5 k=1,nzhommfe
         if((zpt .ge. zgrhommfe(k-1))
     1           .and. (zpt .lt. zgrhommfe(k))) then
           kz = k
           go to 6
         end if
    5 continue
c
c check the last end point
c ------------------------
c
      if(zpt .eq. zgrhommfe(nzhommfe)) then
        kz = nzhommfe
        go to 6
      end if
c
c if the code gets to here the first coordinate value is out of range
c -------------------------------------------------------------------
c
      ierror = 3
c
c if the code gets to here the third coordinate value is out of range
c -------------------------------------------------------------------
c
      if(ierror .ne. 0) then
        ierror = 1
        return
      end if
c
c compute the index in the linear pressure array
c ----------------------------------------------
c
    6 lochommfeind = ix + ( jy - 1 ) * nxhommfe
     1                  + ( kz - 1 ) * nxhommfe * nyhommfe
c
      return
      end
      subroutine vnprjct(vxi,vyi,vzi,vxo,vyo,vzo)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine computes the projection of the nondiagonal tensor contribution
c into the velocity space
c
c input
c
c   vxi - the x component of the input vector in the multiplication
c   vyi - the y component of the input vector in the multiplication
c   vzi - the z component of the input vector in the multiplication
c
c output
c
c   vxo - the x component of the output vector in the multiplication
c   vyo - the y component of the output vector in the multiplication
c   vzo - the z component of the output vector in the multiplication
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/hommfe_common.h'
      real vxi(nhomvelx),vxo(nhomvelx)
      real vyi(nhomvely),vyo(nhomvely)
      real vzi(nhomvelz),vzo(nhomvelz)
c
c contributions due to the nondiagonal entries of the first row of the tensor
c ---------------------------------------------------------------------------
c
      ntemp1 = nxhommfep1 * nyhommfe
      ntemp2 = nxhommfe * nyhommfe
      ntemp3 = nyhommfep1 * nzhommfe
c
      do 1 k=1,nzhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         k1 = ( k - 1 ) * ntemp1
         k2 = ( k - 1 ) * ntemp2
c
c compute the index for the y component of the velocity
c -----------------------------------------------------
c
         k11 = ( k - 1 ) * nyhommfep1
c
c initialize the integration factor
c ---------------------------------
c
         factor1 = 0.125 * dzhommfe(k)
c
      do 1 j=1,nyhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         j1 = ( j - 1 ) * nxhommfep1 + k1
         j2 = ( j - 1 ) * nxhommfe + k2
c
c compute the index for the y component of the velocity
c -----------------------------------------------------
c
         j11 = j + k11
c
c update the factor
c -----------------
c
         factor2 = factor1 * dyhommfe(j)
c
      do 1 i=2,nxhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         indp = i + j2
         indvo = i + j1
c
c compute the indices for the y component of the velocity
c -------------------------------------------------------
c
         indvi1 = j11 + ( i - 2 ) * ntemp3
         indvi2 = indvi1 + 1
         indvi3 = indvi1 + ntemp3
         indvi4 = indvi3 + 1
c
c compute the contribution at this location
c -----------------------------------------
c
         vxo(indvo) =
     1   ( hommfekxy(indp-1) * ( vyi(indvi1) + vyi(indvi2) )
     1   * dxhommfe(i-1)
     1   + hommfekxy(indp) * ( vyi(indvi3) + vyi(indvi4) )
     1   * dxhommfe(i) )
     1   * factor2
c
    1 continue
c
c contributions due to the nondiagonal entries of the first row of the tensor
c ---------------------------------------------------------------------------
c
      ntemp3 = nzhommfep1 * nxhommfe
c
      do 2 k=1,nzhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         k1 = ( k - 1 ) * ntemp1
         k2 = ( k - 1 ) * ntemp2
c
c compute the shifted input index
c -------------------------------
c
         k11 = k
c
c initialize the integration factor
c ---------------------------------
c
         factor1 = 0.125 * dzhommfe(k)
c
      do 2 j=1,nyhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         j1 = ( j - 1 ) * nxhommfep1 + k1
         j2 = ( j - 1 ) * nxhommfe + k2
c
c compute the index for the z component of the velocity
c -----------------------------------------------------
c
         j11 = k11 + ( j - 1 ) * ntemp3
c
c update the factor
c -----------------
c
         factor2 = factor1 * dyhommfe(j)
c
      do 2 i=2,nxhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         indp = i + j2
         indvo = i + j1
c
c compute the indices for the z component of the velocity
c -------------------------------------------------------
c
         indvi1 = ( i - 2 ) * nzhommfep1 + j11
         indvi2 = indvi1 + 1
         indvi3 = indvi1 + nzhommfep1
         indvi4 = indvi3 + 1
c
c compute the contribution at this location
c -----------------------------------------
c
         vxo(indvo) = vxo(indvo) + ( hommfekxz(indp-1)
     1    * ( vzi(indvi1) + vzi(indvi2) ) * dxhommfe(i-1)
     1    + hommfekxz(indp) * ( vzi(indvi3) + vzi(indvi4) )
     1   * dxhommfe(i) )
     1    * factor2
c
    2 continue
c
c contributions due to the nondiagonal entries of the first row of the tensor
c ---------------------------------------------------------------------------
c
      ntemp1 = nyhommfep1 * nzhommfe
      ntemp2 = nyhommfe * nzhommfe
      ntemp3 = nxhommfep1 * nyhommfe
c
      do 3 k=1,nzhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         k1 = ( k - 1 ) * nyhommfep1
         k2 = ( k - 1 ) * nyhommfe
c
c compute the index for the x component of the velocity
c -----------------------------------------------------
c
         k11 = ( k - 1 ) * ntemp3
c
c initialize the integration factor
c ---------------------------------
c
         factor1 = 0.125 * dzhommfe(k)
c
      do 3 j=2,nyhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         j1 = j + k1
         j2 = j + k2
c
c compute the index for the y component of the velocity
c -----------------------------------------------------
c
         j11 = ( j - 2 ) * nxhommfep1 + k11
c
c compute a couple of factors
c ---------------------------
c
         factor21 = factor1 * dyhommfe(j-1)
         factor22 = factor1 * dyhommfe(j)
c
      do 3 i=1,nxhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         indp = ( i - 1 ) * ntemp2 + j2
         indvo = ( i - 1 ) * ntemp1 + j1
c
c compute the indices for the y component of the velocity
c -------------------------------------------------------
c
         indvi1 = i + j11
         indvi2 = indvi1 + 1
         indvi3 = indvi1 + nxhommfep1
         indvi4 = indvi3 + 1
c
c compute the contribution at this location
c -----------------------------------------
c
         vyo(indvo) =
     1   ( hommfekyx(indp-1) * ( vxi(indvi1) + vxi(indvi2) ) * factor21
     1   + hommfekyx(indp) * ( vxi(indvi3) + vxi(indvi4) ) * factor22 )
     1   * dxhommfe(i)
c
    3 continue
c
c contributions due to the nondiagonal entries of the first row of the tensor
c ---------------------------------------------------------------------------
c
      ntemp3 = nzhommfep1 * nxhommfe
c
      do 4 k=1,nzhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         k1 = ( k - 1 ) * nyhommfep1
         k2 = ( k - 1 ) * nyhommfe
c
c compute a shifted index
c -----------------------
c
         k11 = k
c
c initialize the integration factor
c ---------------------------------
c
         factor1 = 0.125 * dzhommfe(k)
c
      do 4 j=2,nyhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         j1 = j + k1
         j2 = j + k2
c
c compute the index for the y component of the velocity
c -----------------------------------------------------
c
         j11 = k11 + ( j - 2 ) * ntemp3
c
c compute a couple of factors
c ---------------------------
c
         factor21 = factor1 * dyhommfe(j-1)
         factor22 = factor1 * dyhommfe(j)
c
      do 4 i=1,nxhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         indp = ( i - 1 ) * ntemp2 + j2
         indvo = ( i - 1 ) * ntemp1 + j1
c
c compute the indices for the y component of the velocity
c -------------------------------------------------------
c
         indvi1 = ( i - 1 ) * nzhommfep1 + j11
         indvi2 = indvi1 + 1
         indvi3 = indvi1 + ntemp3
         indvi4 = indvi3 + 1
c
c compute the contribution at this location
c -----------------------------------------
c
         vyo(indvo) = vyo(indvo) +
     1   ( hommfekyz(indp-1) * ( vzi(indvi1) + vzi(indvi2) ) * factor21
     1   + hommfekyz(indp) * ( vzi(indvi3) + vzi(indvi4) ) * factor22 )
     1   * dxhommfe(i)
c
    4 continue
c
c contributions due to the nondiagonal entries of the first row of the tensor
c ---------------------------------------------------------------------------
c
      ntemp1 = nzhommfep1 * nxhommfe
      ntemp2 = nxhommfe * nzhommfe
      ntemp3 = nxhommfep1 * nyhommfe
c
      do 5 k=2,nzhommfe
c
c compute the shifted index
c -------------------------
c
         k1 = k
c
c compute the index for the x component of the velocity
c -----------------------------------------------------
c
         k11 = ( k - 2 ) * ntemp3
c
c store the factors
c -----------------
c
         factor11 = 0.125 * dzhommfe(k-1)
         factor12 = 0.125 * dzhommfe(k)
c
      do 5 j=1,nyhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         j1 = k1 + ( j - 1 ) * ntemp1
         j2 = k + ( j - 1 ) * ntemp2
c
c compute the index for the y component of the velocity
c -----------------------------------------------------
c
         j11 = ( j - 1 ) * nxhommfep1 + k11
c
c compute a couple of factors
c ---------------------------
c
         factor21 = factor12 * dyhommfe(j)
         factor22 = factor12 * dyhommfe(j)
c
      do 5 i=1,nxhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         indp = ( i - 1 ) * nzhommfe + j2
         indvo = ( i - 1 ) * nzhommfep1 + j1
c
c compute the indices for the y component of the velocity
c -------------------------------------------------------
c
         indvi1 = i + j11
         indvi2 = indvi1 + 1
         indvi3 = indvi1 + ntemp3
         indvi4 = indvi3 + 1
c
c compute the contribution at this location
c -----------------------------------------
c
         vzo(indvo) =
     1   ( hommfekzx(indp-1) * ( vxi(indvi1) + vxi(indvi2) ) * factor21
     1   + hommfekzx(indp) * ( vxi(indvi3) + vxi(indvi4) ) * factor22 )
     1   * dxhommfe(i)
c
    5 continue
c
c contributions due to the nondiagonal entries of the first row of the tensor
c ---------------------------------------------------------------------------
c
      ntemp3 = nyhommfep1 * nzhommfe
c
      do 6 k=2,nzhommfe
c
c compute the shifted index
c -------------------------
c
         k1 = k
c
c compute the index for the x component of the velocity
c -----------------------------------------------------
c
         k11 = ( k - 2 ) * nyhommfep1
c
c store the factors
c -----------------
c
         factor11 = 0.125 * dzhommfe(k-1)
         factor12 = 0.125 * dzhommfe(k)
c
      do 6 j=1,nyhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         j1 = k1 + ( j - 1 ) * ntemp1
         j2 = k + ( j - 1 ) * ntemp2
c
c compute the index for the y component of the velocity
c -----------------------------------------------------
c
         j11 = j + k11
c
c compute a couple of factors
c ---------------------------
c
         factor21 = factor12 * dyhommfe(j)
         factor22 = factor12 * dyhommfe(j)
c
      do 6 i=1,nxhommfe
c
c compute the indices for the coordinate direction of the test function
c ---------------------------------------------------------------------
c
         indp = ( i - 1 ) * nzhommfe + j2
         indvo = ( i - 1 ) * nzhommfep1 + j1
c
c compute the indices for the y component of the velocity
c -------------------------------------------------------
c
         indvi1 = ( i - 1 ) * ntemp3 + j11
         indvi2 = indvi1 + 1
         indvi3 = indvi1 + nyhommfep1
         indvi4 = indvi3 + 1
c
c compute the contribution at this location
c -----------------------------------------
c
         vzo(indvo) =  vzo(indvo) +
     1    ( hommfekzy(indp-1) * ( vyi(indvi1) + vyi(indvi2) ) * factor21
     1    + hommfekzy(indp) * ( vyi(indvi3) + vyi(indvi4) ) * factor22 )
     1    * dxhommfe(i)
c
    6 continue
c
c
      return
      end
      subroutine avgscal3(kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz,nxh,nyh
     1,nzh,eigmin,eigmax,scaleval)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c
c   this routine is a routine that computes the scaling information for the
c input array in the two dimensional averaging rouitnes
c
c the arrays are tensor values in the 3-d tensor
c
c                 [  kxx    kxy  ]
c             K = [              ]
c                 [  kyx    kyy  ]
c
c the homogenization is that used in papers by Amaziane and Bourgeat
c
c input
c
c   k**- one-dimensional tensors (in x first) giving the values of the tensor
c        at the centers of the cells in the region considered.
c   nxh, nyh, nzh - the number of grid blocks in the coordinate directions
c
c output
c
c   eigmin - the minimum value of the absolute permeability
c   eigmax - the maximum value of the absolute permeability
c   scaleval - the scaling factor that can be used to scale the input values 
c              to that the average order of magnitude is 1.
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      include 'include/homog_common.h'
      real kxx(*),kxy(*),kxz(*)
      real kyx(*),kyy(*),kyz(*)
      real kzx(*),kzy(*),kzz(*)
c
c check the number of heterogeneous grid blocks and set to at least one
c ---------------------------------------------------------------------
c
      if(nxh .le. 0) return
      if(nyh .le. 0) return
      if(nzh .le. 0) return
      ntot = nxh * nyh
c
c get the maximum value in the arrays
c -----------------------------------
c
      call avgeign3(kxx(1),kxy(1),kxz(1),kyx(1),kyy(1),kyz(1),kzx(1)
     1,kzy(1),kzz(1),xlam1,xlam2,xlam3)
      eigmin = xlam1
      eigmax = xlam1
      if(eigmin .gt. xlam2) eigmin = xlam2
      if(eigmax .lt. xlam2) eigmax = xlam2
      if(eigmin .gt. xlam3) eigmin = xlam3
      if(eigmax .lt. xlam3) eigmax = xlam3
      do 1 i=2,ntot
         call avgeign3(kxx(i),kxy(i),kxz(i),kyx(i),kyy(i),kyz(i),kzx(i)
     1   ,kzy(i),kzz(i),xlam1,xlam2,xlam3)
         if(eigmin .gt. xlam1) eigmin = xlam1
         if(eigmax .lt. xlam1) eigmax = xlam1
         if(eigmin .gt. xlam2) eigmin = xlam2
         if(eigmax .lt. xlam2) eigmax = xlam2
         if(eigmin .gt. xlam3) eigmin = xlam3
         if(eigmax .lt. xlam3) eigmax = xlam3
    1 continue
c
c compute the scaling factor that can be used by the calling routine
c ------------------------------------------------------------------
c
      if(eigmin .gt. 0.0) then
        xlogmin = alog10(eigmin)
      else
        xlogmin = alog10(0.000001*eigmax)
      end if
      xlogmax = alog10(eigmax)
      avg = 0.5 * ( xlogmax + xlogmin )
      iavg = int(avg)
      scaleval = 10.**(-iavg)
c
      return
      end
      subroutine avgeign3(kxx,kxy,kxz,kyx,kyy,kyz,kzx,kzy,kzz
     1,xlam1,xlam2,xlam3)
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c written by: joe koebbe
c
c   this routine computes the eigenvalues of the permeability tensor at a
c given node.
c
c input
c
c   k** - the nine permeability tensor entries
c
c output
c
c   xlam1 - eigenvalue #1
c   xlam2 - eigenvalue #2
c   xlam3 - eigenvalue #3
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      real kxx,kxy,kxz
      real kyx,kyy,kyz
      real kzx,kzy,kzz
      integer iolog
      iolog = 38
c
c check for a diagonal value
c --------------------------
c
      ichk = 0
      if(kxy .ne. 0.0) ichk = 1
      if(kxz .ne. 0.0) ichk = 1
      if(kyx .ne. 0.0) ichk = 1
      if(kyz .ne. 0.0) ichk = 1
      if(kzx .ne. 0.0) ichk = 1
      if(kzy .ne. 0.0) ichk = 1
c
      if(ichk .eq. 0) then
        xlam1 = kxx
        xlam2 = kyy
        xlam3 = kzz
        return
      end if
c
c set the number of iterations to 0
c ---------------------------------
c
      iter = 0
c
c compute the coefficients of the polynomials
c -------------------------------------------
c
      a0 = kxx * kyy * kzz + kxy * kyz * kzx + kxz * kyx * kzy
     1     - kxz * kyy * kzx - kyz * kzy * kxx - kxy * kyx * kzz
      a1 = - kxx * kyy - kxx * kzz - kyy * kzz - kxz * kzx
     1     - kyz * kzy - kxy * kyx
      a2 = - kxx - kyy - kzz
      a3 = 1.0
c
c compute the derivative coefficients for the characteristic polynomial
c ---------------------------------------------------------------------
c
      b0 = a1
      b1 = 2.0 * a2
      b2 = 3.0 * a3
c
c find the first eigenvalue using newton's method
c -----------------------------------------------
c
      xlam0 = kxx
      xavg = ( kxx + kyy + kzz ) / 3.0
c
c compute the next polynomial value
c ---------------------------------
c
    1 xlsq = xlam0
      xlcu = xlam0 * xlsq
      pval = a0 + xa1 * xlam0 + a2 * xlsq + a3 * xlcu
      dval = b0 + b1 * xlam0 + b2 * xlsq
c
c make sure the derivative is nonzero - this should never be a problem
c --------------------------------------------------------------------
c
      if(dval .eq. 0.0) then
        write(iolog,*) ' ***** '
        write(iolog,*) ' ***** the derivative value in prmeign is 0'
        write(iolog,*) ' ***** the index number is id = ',id
        write(iolog,*) ' ***** '
        stop
      end if
c
c compute the next iterate
c ------------------------
c
      xlam1 = xlam0 - pval / dval
c
      iter = iter + 1
c
c check for convergence
c ---------------------
c
      error = abs( ( xlam1 - xlam0 ) / xavg )
      if(error .lt. .0001) go to 2
c
c check for too many iterations
c -----------------------------
c
      if(iter .gt. 25) then
        write(iolog,*) ' ***** '
        write(iolog,*) ' ***** number of iterations in prmeign is'
        write(iolog,*) ' ***** greater than 25 - error = ',error
        write(iolog,*) ' ***** '
      end if
c
c compute the other two eigenvalues from the left over quadratic
c --------------------------------------------------------------
c
    2 c2 = a3
      c1 = a2 + c2 * xlam1
      c0 = a1 + c1 * xlam1
c
      discr = c1 * c1 - 4.0 * c0 * c2
c
c check the discriminant
c ----------------------
c
      if(discr .lt. 0.0) then
        write(iolog,*) ' ***** '
        write(iolog,*) ' ***** discriminant is less than zero in'
        write(iolog,*) ' ***** prmeign - discr = ',discr
        write(iolog,*) ' ***** '
        if(abs(discr) .gt. .00001) stop
        discr = 0.0
      end if
c
c copmute the two values
c ----------------------
c
      d0 = 2.0 * c2
      discr = sqrt(discr)
      xlam2 = ( - c1 + discr ) / d0
      xlam3 = ( - c1 - discr ) / d0
c
      return
      end
